#ifndef use16f1824
 error "falsches File"
#endif

;CONST_RAM equ h'80' 

 __CONFIG _CONFIG1,_FCMEN_OFF & _IESO_OFF & _CLKOUTEN_OFF & _BOREN_ON & _CPD_OFF & _CP_OFF & _MCLRE_OFF & _PWRTE_ON & _WDTE_ON & _FOSC_INTOSC

;__CONFIG _CONFIG1, b'00111110011100'          ; Programmer-Configuration
;             +--------------- #13 FCMEN: Fail Clock Monitor Enabled bit
;              |||||||||||         1 = Fail-Safe Clock Monitor is enabled
;              |||||||||||        >0 = Fail-Safe Clock Monitor is disabled
;             +--------------- #12 IESO: Internal External Switchover bit
;              |||||||||||         1 = Internal/External Switchover mode is enabled
;              |||||||||||        >0 = Internal/External Switchover mode is disabled
;             +--------------- #11 CLKOUTEN: Clock Out Enable bit
;              |||||||||||        >1 = CLKOUT function is disabled. I/O function on the CLKOUT pin.
;              |||||||||||         0 = CLKOUT function is enabled on the CLKOUT pin
;               ++------------ #10-9 BOREN<1:0>: Brown-out Reset Enable bits
;                 ||||||||        >11 = BOD enabled
;                 ||||||||         10 = BOD enabled during operation and disabled in SLEEP
;                 ||||||||         01 = BOD controlled by SBODEN bit (PCON<4>)
;                 ||||||||         00 = BOD disabled
;                 +----------- #8: CPD: Data Code Protection bit(2)
;                  |||||||        >1 = Data memory code protection is disabled
;                  |||||||         0 = Data memory code protection is enabled
;                 +----------- #7: CP: Code Protection bit
;                  |||||||        >1 = Program memory code protection is disabled
;                  |||||||         0 = Program memory code protection is enabled
;                  +---------- #6: MCLRE: RA3/MCLR/V PP Pin Function Select bit
;                   ||||||         1 = MCLR/V PP pin function is MCLR; Weak pull-up enabled.
;                   ||||||        >0 = MCLR/V PP pin function is digital input; MCLR internally disabled; Weak pull-up under control of WPUA register
;                   +--------- #5: PWRTE: Power-up Timer Enable bit
;                    |||||         1 = PWRT disabled
;                    |||||        >0 = PWRT enabled
;                    ++------- #4-3: WDTE<1:0>: Watchdog Timer Enable bit
;                      |||        >11 = WDT enabled
;                      |||         10 = WDT enabled while running and disabled in Sleep
;                      |||         01 = WDT controlled by the SWDTEN bit in the WDTCON register
;                      |||         00 = WDT disabled
;                      +++---- #2-#0: FOSC2:FOSC0: Oscillator Selection bits
;                                  111 = ECH: External Clock, High-Power mode (4-32 MHz): device clock supplied to CLKIN pin
;                                  110 = ECM: External Clock, Medium-Power mode (0.5-4 MHz): device clock supplied to CLKIN 
;                                  101 = ECL: External Clock, Low-Power mode (0-0.5 MHz): device clock supplied to CLKIN pin
;                                 >100 = INTOSC oscillator: I/O function on CLKIN pin
;                                  011 = EXTRC oscillator: External RC circuit connected to CLKIN pin
;                                  010 = HS oscillator: High-speed crystal/resonator connected between OSC1 and OSC2 pins
;                                  001 = XT oscillator: Crystal/resonator connected between OSC1 and OSC2 pins
;                                  000 = LP oscillator: Low-power crystal connected between OSC1 and OSC2 pins

;                                 >100 = INTOSC oscillator: I/O function on GP4/OSC2/CLKOUT pin,
;                                        I/O function on GP5/OSC1/CLKIN

 __CONFIG _CONFIG2,_PLLEN_OFF & _LVP_OFF & _WRT_OFF

;__CONFIG _CONFIG2,b'01000000000011'          ; Programmer-Configuration
;            +---------------- #13 LVP: Low-Voltage Programming Enable bit
;             |||||||||||||        1 = Low-voltage programming enabled
;             |||||||||||||       >0 = High-voltage on MCLR must be used for programming
;             +--------------- #12 DEBUG: In-Circuit Debugger Mode bi
;              ||||||||||||       >1 = 1 = In-Circuit Debugger disabled, ICSPCLK and ICSPDAT are general purpose I/O pins
;              ||||||||||||        0 = In-Circuit Debugger enabled, ICSPCLK and ICSPDAT are dedicated to the debugger
;              +-------------- #11 Unimplemented: Read as ?1
;               +------------- #10 BORV: Brown-out Reset Voltage Selection bit
;                ||||||||||        1 = Brown-out Reset voltage (Vbor), low trip point selected
;                ||||||||||       >0 = Brown-out Reset voltage (Vbor), high trip point selected
;                +-------------- #9 STVREN: Stack Overflow/Underflow Reset Enable bit
;                 |||||||||        1 = Stack Overflow or Underflow will cause a Reset
;                 |||||||||       >0 = Stack Overflow or Underflow will not cause a Reset
;                 +----------- #8 PLLEN: PLL Enable bit
;                  ||||||||        1 = 4xPLL enabled
;                  ||||||||       >0 = 4xPLL disabled
;                  +++-------- #7-5 Unimplemented: Read as ?1?
;                     +------- #4: Reserved: This location should be programmed to a ?1
;                      ||||        1 = PWRT disabled
;                      ||||       >0 = PWRT enabled
;                      ++----- #3-2 Unimplemented: Read as ?1
;                        ++--- #1-0 WRT<1:0>: Flash Memory Self-Write Protection bits
;                                 >11 = Write protection off
;                                  10 = 000h to 1FFh write-protected, 200h to FFFh may be modified by EECON control
;                                  01 = 000h to 7FFh write-protected, 800h to FFFh may be modified by EECON control
;                                  >00 = 000h to FFFh write-protected, no addresses may be modified by EECON control

; ****************************************************************************
; **  Konfiguration CMxCON0 COMPARATOR CONFIGURATION REGISTER               ** 
; ****************************************************************************
        movlw   B'00000000'
;                 +--------- #7: C2OUT: Comparator 2 Output bit
;                  |||||||       When C2INV = 0:
;                  |||||||       1 = C2 VIN+ > C2 VIN-
;                  |||||||       0 = C2 VIN+ < C2 VINWhen
;                  |||||||       C2INV = 1:
;                  |||||||       1 = C2 VIN+ < C2 VIN-
;                  |||||||       0 = C2 VIN+ > C2
;                  +-------- #6: C1OUT: Comparator 1 Output bit
;                   ||||||       When C1INV = 0:
;                   ||||||       1 = C1 VIN+ > C1 VIN-
;                   ||||||       0 = C1 VIN+ < C1 VINWhen
;                   ||||||       C1INV = 1:
;                   ||||||       1 = C1 VIN+ < C1 VIN-
;                   ||||||       0 = C1 VIN+ > C1 VINbit
;                   +------- #5: C2INV: Comparator 2 Output Inversion bit
;                    |||||       1 = C2 output inverted
;                    |||||       0 = C2 output not inverted
;                    +------- #4: C1INV: Comparator 1 Output Inversion bit
;                     ||||       1 = C1 Output inverted
;                     ||||       0 = C1 Output not inverted
;                     +------ #3: CIS: Comparator Input Switch bit
;                      |||       When CM<2:0> = 010:
;                      |||       1 = C1IN+ connects to C1 VIN-
;                      |||       C2IN+ connects to C2 VIN-
;                      |||       0 = C1IN- connects to C1 VIN-
;                      |||       C2IN- connects to C2 VINWhen
;                      |||       CM<2:0> = 001:
;                      |||       1 = C1IN+ connects to C1 VIN-
;                      |||       0 = C1IN- connects to C1
;                      +++--- #2-0:  CM<2:0>: Comparator Mode bits (See Figure 8-5)
;                                000 = Comparators off. CxIN pins are configured as analog
;                                001 = Three inputs multiplexed to two comparators
;                                010 = Four inputs multiplexed to two comparators
;                                011 = Two common reference comparators
;                                100 = Two independent comparators
;                                101 = One independent comparator
;                                110 = Two common reference comparators with outputs
;                               >111 = Comparators off. CxIN pins are configured as digital I/O

        banksel CM1CON0
        clrf CM1CON0                    ; CMxCON0-Reg. konfigurieren
        clrf CM2CON0                    ; CMxCON0-Reg. konfigurieren


; ****************************************************************
; **  Konfiguration PCON: POWER CONTROL REGISTER (ADDRESS: 8Eh) **
; ****************************************************************
        movlw   B'00000000'
;                 +--------- #7: STKOVF: Stack Overflow Flag bit
;                                1 = A Stack Overflow occurred
;                  +-------- #6: STKUNF: Stack Underflow Flag bit
;                                1 = A Stack Underflow occurred
;                   +------- #5: Unimplemented: Read as 0
;                    +------ #4: Unimplemented: Read as 0
;                     +----- #3: RMCLR: MCLR Reset Flag bit
;                     +----- #2: RI: RESET Instruction Flag bit
;                        |       1 = A RESET instruction has not been executed or set to 1 by firmwared
;                        |      >0 = A RESET instruction has been executed (set to 0 in hardware upon executing a RESET instruction)
;                       +--- #1: POR: Power-on Reset STATUS bit
;                        |       1 = No Power-on Reset occurred
;                        |      >0 = A Power-on Reset occurred (must be set in software after a Power-on Reset occurs)
;                        +-- #0: BOD: Brown-out Detect STATUS bit
;                                1 = No Brown-out Detect occurred
;                               >0 = A Brown-out Detect occurred 
;                                    (must be set in software after a Brown-out Detect occurs)

        banksel PCON                   ; -> BANK 1
        movwf PCON                     ; PCON-Reg. konfigurieren

; ************************************************************************
; **  Konfiguration OSCCON: OSCILLATOR CONTROL REGISTER (ADDRESS: 99h)  **
; ************************************************************************
; 32MHz, see 5.2.2.6
        movlw   B'11110000'
;                 +--------- #7: SPLLEN: Software PLL Enable bit
;                  ++++----- #6-#3: IRCF<3:0>: Internal Oscillator Frequency Select bits
;                     ||||      >1110 = 8 MHz or 32 MHz HF(see Section 5.2.2.1 ?HFINTOSC?)
;                      +---- #2: Unimplemented: Read as ?0?
;                       ++-- #1-#0: SCS<1:0>: System Clock Select bits
;                                1x = Internal oscillator block
;                                01 = Timer1 oscillator
;                               >00 = Clock determined by FOSC<2:0> in Configuration Word 1 

        banksel OSCCON                 ; -> BANK 1
        movwf OSCCON                   ; OSCCON-Reg. konfigurieren

; ********************************************************
; **  Konfiguration AD-Ports                            **
; ********************************************************
        movlw   B'00000000'
;                 ++++++++-- #7-#0: 

        banksel ADCON0                 ; -> BANK 1
        movwf ADCON0                   ; ADCON0-Reg. konfigurieren
        banksel ADCON1                 ; -> BANK 1
        movwf ADCON1                   ; ADCON1-Reg. konfigurieren

; ********************************************************
; **  Konfiguration Port A                              **
; ********************************************************
        movlw   B'00000000'
;                 ---+-+++-- #4-#0: ANSA4 <2:0> Analog Select between Analog or Digital Function on pins RA<2:0>, respectively
;                                   0 = Digital I/O. Pin is assigned to port or digital special function
;                                   1 = Analog input. Pin is assigned as analog input (1) . Digital input buffer disabled
        banksel ANSELA                 ; -> BANK 1
        movwf ANSELA                   ; ANSELA-Reg. konfigurieren

        movlw   B'00000000'
;                 --++-+++-- #5-#0: LATA<5:4> <2:0> Output Latch Value bits
;                                   0 = Digital I/O. Pin is assigned to port or digital special function
;                                   1 = Analog input. Pin is assigned as analog input (1) . Digital input buffer disabled
        banksel LATA                 ; -> BANK 1
        movwf LATA                   ; LATA-Reg. konfigurieren

        movlw   B'00000000'
;                 --++++++-- #5-#0: WPUA<5:0>: Weak Pull-up Register bits
;                                   1 = Pull-up enabled
;                                   0 = Pull-up disable
        banksel WPUA                 ; -> BANK 1
        movwf WPUA                   ; WPUA-Reg. konfigurieren

        movlw   B'00000000'
;                 --++++++-- #5-#0: INLVLA<5:0>: PORTA Input Level Select bits
;                                   1 = ST input used for PORT reads and interrupt-on-change
;                                   0 = TTL input used for PORT reads and interrupt-on-change
        banksel INLVLA                 ; -> BANK 1
        movwf INLVLA                   ; INLVLA-Reg. konfigurieren

; ********************************************************
; **  Konfiguration Port C                              **
; ********************************************************
        movlw   B'00000000'
;                 ++++++++-- #7-#0: Analog Select between Analog or Digital Function on pins RC<7:0>
;                                   bit 5-4 Unimplemented: Read as ?0?
;                                   0 = Digital I/O. Pin is assigned to port or digital special function
;                                   1 = Analog input. Pin is assigned as analog input (1) . Digital input buffer disabled
        banksel ANSELC                 ; -> BANK 1
        movwf ANSELC                   ; ANSELC-Reg. konfigurieren

        movlw   B'00000000'
;                 ++++++++-- #7-#0: LATC<7:0> Output Latch Value bits
;                                   0 = Digital I/O. Pin is assigned to port or digital special function
;                                   1 = Analog input. Pin is assigned as analog input (1) . Digital input buffer disabled
        banksel LATC                 ; -> BANK 1
        movwf LATC                   ; LATC-Reg. konfigurieren

        movlw   B'00000000'
;                 ++++++++-- #7-#0: WPUCS<5:0>: Weak Pull-up Register bits
;                                   1 = Pull-up enabled
;                                   0 = Pull-up disable
        banksel WPUC                 ; -> BANK 1
        movwf WPUC                   ; WPUC-Reg. konfigurieren

        movlw   B'00000000'
;                 ++++++++-- #7-#0: INLVLC<7:0>: PORTC Input Level Select bits
;                                   1 = ST input used for PORT reads and interrupt-on-change
;                                   0 = TTL input used for PORT reads and interrupt-on-change
        banksel INLVLC                 ; -> BANK 1
        movwf INLVLC                   ; INLVLC-Reg. konfigurieren

; ********************************************************
; **  Konfiguration TIMER / WDT / Pull-Ups              **
; ********************************************************
        movlw   B'11000001'
;                 +--------- #7: WPUEN: Weak Pull-up Enable bit
;                  ||||| |      >1 = All weak pull-ups are disabled (except MCLR, if it is enabled)
;                  ||||| |       0 = Weak pull-ups are enabled by individual WPUx latch values
;                  +-------- #6: INTEDG: Interrupt Edge Select bit
;                   |||| |      >1 = Interrupt on rising edge of INT pin
;                   |||| |       0 = Interrupt on falling edge of INT pin
;                   +------- #5: TMR0CS: Timer0 Clock Source Select bit
;                    ||| |       1 = Transition on T0CKI pin
;                    ||| |      >0 = Internal instruction cycle clock (F OSC /4
;                    +------ #4: TMR0SE: Timer0 Source Edge Select bit
;                     || |       1 = Increment on high-to-low transition on T0CKI pin
;                     || |      >0 = Increment on low-to-high transition on T0CKI pin
;                     +----- #3: PSA: Prescaler Assignment bit
;                      | |       1 = Prescaler is not assigned to the Timer0 module
;                      | |      >0 = Prescaler is assigned to the Timer0 module
;                      +++-- #2-#0: PS2:PS0: Prescaler Rate Select bits
;                                 Bit |TMR0 Rate|        
;                                 ----+---------+--------
;                                 000 | 1 : 2   |      
;                               > 001 | 1 : 4   |      
;                                 010 | 1 : 8   |        
;                                 011 | 1 : 16  | 
;                                 100 | 1 : 32  | 
;                                 101 | 1 : 64  | 
;                                 110 | 1 : 128 | 
;                                 111 | 1 : 256 | 

        banksel OPTION_REG             ; -> BANK 1
        movwf OPTION_REG               ; OPTION_REG konfigurieren

#ifdef timer1_is_ir ;TMR1 IR verwendet fr PWM, Prescaler 1:1
        movlw   B'00000001'
#endif

#ifndef timer1_is_ir ;ohne TMR1 IR
        movlw   B'00110001'
#endif
;                 +--------- #7-#6: TMR1CS<1:0>: Timer1 Clock Source Select bits
;                  +--------     11 = Timer1 clock source is Capacitive Sensing Oscillator (CAPOSC
;                   |||| |       10 = Timer1 clock source is pin or oscillator
;                   |||| |              If T1OSCEN = 0: External clock from T1CKI pin (on the rising edge
;                   |||| |              If T1OSCEN = 1: Crystal oscillator on T1OSI/T1OSO pins
;                   |||| |       01 = Timer1 clock source is system clock (F OSC )
;                   |||| |       00 = Timer1 clock source is instruction clock (F OSC /4)
;                   ++------ #5-#4: T1CKPS<1:0>: Timer1 Input Clock Prescale Select bits
;                    ||| |      >11 = 1:8 Prescale Value
;                    ||| |       10 = 1:4 Prescale Value
;                    ||| |       01 = 1:2 Prescale Valueue
;                    ||| |       00 = 1:1 Prescale Value
;                     +----- #3: T1OSCEN: LP Oscillator Enable Control bit
;                      | |       1 = Dedicated Timer1 oscillator circuit enabled
;                      | |      >0 = Dedicated Timer1 oscillator circuit disabled
;                      +---- #2: T1SYNC: Timer1 Synchronization Control bit
;                       ||      >1 = Do not synchronize synchronous clock input
;                       ||      >0 = Synchronize asynchronous clock input with system clock (F OSC )
;                       +--- #1: Unimplemented: Read as 0
;                        |       1 = External clock from T1OSO/T1CKI pin (on the rising edge)
;                        |      >0 = Internal clock (FOSC/4)
;                        +-- #0: TMR1ON: Timer1 On bit
;                               >1 = Enables Timer1
;                                0 = Stops Timer1

        banksel T1CON                  ; -> BANK
        movwf T1CON                    ; T1CON-Reg. konfigurieren

; ********************************************************
; **  Konfiguration USART                               **
; ********************************************************
#ifdef use_lissy ; PORTC,4 -> TX mit 120kBaud, aber kein RX
        movlw   B'10100110'
;                 +--------- #7: CSRC: Clock Source Select bit
;                  |||||||       Asynchronous mode:                                   
;                  |||||||       Don't care                                           
;                  |||||||       Synchronous mode:                                    
;                  |||||||      >1 = Master mode (clock generated internally from BRG)
;                  |||||||       0 = Slave mode (clock from external source)          
;                  +-------- #6: TX9: 9-bit Transmit Enable bit
;                   ||||||       1 = Selects 9-bit transmission
;                   ||||||      >0 = Selects 8-bit transmission
;                   +------- #5: TXEN: Transmit Enable bit(1)
;                    |||||      >1 = Transmit enabled        
;                    |||||       0 = Transmit disabled       
;                    +------ #4: SYNC: EUSART Mode Select bit
;                     ||||       1 = Synchronous mode        
;                     ||||      >0 = Asynchronous mode       
;                     +----- #3: SENDB: Send Break Character bit                                               
;                      |||       Asynchronous mode:                                                            
;                      |||       1 = Send Sync Break on next transmission (cleared by hardware upon completion)
;                      |||      >0 = Sync Break transmission completed                                         
;                      |||       Synchronous mode:                                                             
;                      |||       Don?t care                                                                    
;                      +---- #2: BRGH: High Baud Rate Select bit
;                       ||       Asynchronous mode:             
;                       ||      >1 = High speed                 
;                       ||       0 = Low speed                  
;                       ||       Synchronous mode:              
;                       ||       Unused in this mode            
;                       +--- #1: TRMT: Transmit Shift Register Status bit 
;                        |      >1 = TSR empty                           
;                        |       0 = TSR full                            
;                        +-- #0: TX9D: Ninth bit of Transmit Data
;                                Can be address/data bit or a parity bit.

        banksel TXSTA                 ; -> BANK 3
        movwf TXSTA                   ; TXSTA-Reg. konfigurieren

        movlw   B'10000000'
;                 +--------- #7: SPEN: Serial Port Enable bit
;                  |||||||      >1 = Serial port enabled (configures RX/DT and TX/CK pins as serial port pins)
;                  |||||||       0 = Serial port disabled (held in Reset)                                     
;                  +-------- #6: RX9: 9-bit Receive Enable bit
;                   ||||||       1 = Selects 9-bit reception  
;                   ||||||      >0 = Selects 8-bit reception  
;                   +------- #5: SREN: Single Receive Enable bit                 
;                    |||||       Asynchronous mode:                              
;                    |||||       Don't care                                      
;                    |||||       Synchronous mode - Master:                      
;                    |||||       1 = Enables single receive                      
;                    |||||      >0 = Disables single receive                     
;                    |||||       This bit is cleared after reception is complete.
;                    |||||       Synchronous mode - Slave                        
;                    |||||       Don't care                                      
;                    +------ #4: CREN: Continuous Receive Enable bit                                                  
;                     ||||       Asynchronous mode:                                                                   
;                     ||||       1 = Enables receiver                                                                              
;                     ||||      >0 = Disables receiver                                                                             
;                     ||||       Synchronous mode:                                                                                 
;                     ||||       1 = Enables continuous receive until enable bit CREN is cleared (CREN overrides SREN)             
;                     ||||       0 = Disables continuous receive                                                                   
;                     +----- #3: ADDEN: Address Detect Enable bit                                                              
;                      |||       Asynchronous mode 9-bit (RX9 = 1):                                                            
;                      |||       1 = Enables address detection, enable interrupt and load the receive buffer when RSR<8> is set
;                      |||      >0 = Disables address detection, all bytes are received and ninth bit can be used as parity bit
;                      |||       Asynchronous mode 8-bit (RX9 = 0):                                                            
;                      |||       Don?t care                                                                                    
;                      +---- #2: FERR: Framing Error bit                                                                 
;                       ||       1 = Framing error (can be updated by reading RCREG register and receive next valid byte)
;                       ||       0 = No framing error                                                                    
;                       +--- #1: OERR: Overrun Error bit                                
;                        |       1 = Overrun error (can be cleared by clearing bit CREN)
;                        |       0 = No overrun error                                   
;                        +-- #0: RX9D: Ninth bit of Received Data
;                                This can be address/data bit or a parity bit and must be calculated by user firmware.
        banksel RCSTA                 ; -> BANK 3
        movwf RCSTA                   ; RCSTA-Reg. konfigurieren

        movlw   B'00011000'
;                 +--------- #7: ABDOVF: Auto-Baud Detect Overflow bit
;                  |||||||       Asynchronous mode:                   
;                  |||||||       1 = Auto-baud timer overflowed       
;                  |||||||       0 = Auto-baud timer did not overflow 
;                  |||||||       Synchronous mode:                    
;                  +-------- #6: RCIDL: Receive Idle Flag bit                                 
;                   ||||||       Asynchronous mode:                                           
;                   ||||||       1 = Receiver is Idle                                         
;                   ||||||       0 = Start bit has been received and the receiver is receiving
;                   ||||||       Synchronous mode:                                            
;                   ||||||       Don't care                                                   
;                   +------- #5: Unimplemented: Read as 0                  
;                    +------ #4: SCKP: Synchronous Clock Polarity Select bit        
;                     ||||       Asynchronous mode:                                 
;                     ||||      >1 = Transmit inverted data to the RB7/TX/CK pin                 
;                     ||||       0 = Transmit non-inverted data to the RB7/TX/CK pin             
;                     ||||       Synchronous mode:                                               
;                     ||||       1 = Data is clocked on rising edge of the clock                 
;                     ||||       0 = Data is clocked on falling edge of the clock   
;                     +----- #3: BRG16: 16-bit Baud Rate Generator bit 
;                      |||      >1 = 16-bit Baud Rate Generator is used
;                      |||       0 = 8-bit Baud Rate Generator is used 
;                      +---- #2: Unimplemented: Read as 0                                                               
;                       +--- #1: WUE: Wake-up Enable bit                                                                                  
;                        |       Asynchronous mode:                                                                                       
;                        |       1 = Receiver is waiting for a falling edge. No character will be received byte RCIF will be set. WUE will
;                        |       automatically clear after RCIF is set.                                                                   
;                        |       0 = Receiver is operating normally                                                                       
;                        |       Synchronous mode:                                                                                        
;                        |       Don?t care                                                                                               
;                        +-- #0: ABDEN: Auto-Baud Detect Enable bit                                      
;                                Asynchronous mode:                                                      
;                                1 = Auto-Baud Detect mode is enabled (clears when auto-baud is complete)
;                                0 = Auto-Baud Detect mode is disabled                                   
;                                Synchronous mode:                                                       
;                                Don't care                                                              
        banksel BAUDCON                 ; -> BANK 3
        movwf BAUDCON                   ; BAUDCON-Reg. konfigurieren


        movlw   d'66'          ; 120 kBaud @ 32 MHz, Tabelle (SYNC = 0, BRGH = 1, BRG16 = 1)
                               ; 8.3 us / Bit = 66.4 us / Byte 
                               ; SPBRG = (32MHz/(BAUD*4))-1
        banksel SPBRG                 ; -> BANK 3
        movwf SPBRG
#else
        banksel RCSTA                 ; -> BANK 3
        clrf RCSTA                    ; RCSTA-Reg. konfigurieren -> UART abschalten 
                                      ; #7: SPEN: Serial Port Enable bit -> 0 = Serial port disabled (held in Reset)
#endif

; ********************************************************
; **  Konfiguration INTERRUPT                           **
; ********************************************************
#ifdef timer1_is_ir ;TMR1 IR verwendet fr PWM
        movlw   B'00000001'
#endif

#ifndef timer1_is_ir ;ohne TMR1 IR
        movlw   B'00000000'
#endif
;                 +--------- #7: TMR1GIE: Timer1 Gate Interrupt Enable bit
;                  |||||||       1 = Enables the Timer1 Gate Acquisition interrupt
;                  |||||||      >0 = Disables the Timer1 Gate Acquisition interrup
;                  +-------- #6: ADIE: A/D Converter (ADC) Interrupt Enable bit
;                   ||||||       1 = Enables the A/D converter interrupt
;                   ||||||      >0 = Disables the A/D converter interrupt
;                   +------- #5: RCIE: USART Receive Interrupt Enable bit
;                    +------ #4: TXIE: USART Transmit Interrupt Enable bit
;                     +----- #3: SSP1IE: Synchronous Serial Port (MSSP) Interrupt Enable bit
;                                1 = Enables the MSSP interrupt
;                               >0 = Disables the MSSP interrupt
;                      +---- #2: CCP1IE: CCP1 Interrupt Enable bit
;                       +--- #1: TMR2IE: TMR2 to PR2 Match Interrupt Enable bit
;                        +-- #0: TMR1IE: TMR1 Overflow Interrupt Enable bit
;                             (>)1 = Enables the TMR1 overflow interrupt
;                               >0 = Disables the TMR1 overflow interrupt

        banksel PIE1                   ; -> BANK 1
        movwf PIE1

        movlw   B'00000000'
;                 +--------- #7: OSFIE: Oscillator Fail Interrupt Enable bit
;                  |||||||       1 = Enables the Oscillator Fail interrupt
;                  |||||||      >0 = Disables the Oscillator Fail interrupt
;                  +-------- #6: C2IE: Comparator C2 Interrupt Enable bit
;                   ||||||       1 = Enables 
;                   ||||||      >0 = Disables
;                   +------- #5: C1IE: Comparator C1 Interrupt Enable bi
;                                1 = Enables
;                               >0 = Disables
;                    +------ #4: EEIE: EEPROM Write Completion Interrupt Enable bit
;                                1 = Enables
;                               >0 = Disables
;                     +----- #3: BCL1IE: MSSP Bus Collision Interrupt Enable bitt
;                                1 = Enables
;                               >0 = Disables
;                      +---- #2: Unimplemented: Read as ?0?
;                       +--- #1: Unimplemented: Read as ?0?t
;                        +-- #0: CCP2IE: CCP2 Interrupt Enable bit
;                                1 = Enables
;                               >0 = Disables

        banksel PIE2                   ; -> BANK 1
        movwf PIE2

        movlw   B'00000000'
;                 +--------- #7: Unimplemented: Read as ?0?
;                  +-------- #6: Unimplemented: Read as ?0?
;                   +------- #5: CCP4IE: CCP4 Interrupt Enable bit
;                                1 = Enables
;                               >0 = Disables
;                    +------ #4: CCP3IE: CCP3 Interrupt Enable bit
;                                1 = Enables
;                               >0 = Disables
;                     +----- #3: TMR6IE: TMR6 to PR6 Match Interrupt Enable bit
;                                1 = Enables
;                               >0 = Disables
;                      +---- #2: Unimplemented: Read as ?0?
;                       +--- #1: TMR4IE: TMR4 to PR4 Match Interrupt Enable bit
;                                1 = Enables
;                               >0 = Disables
;                        +-- #0: Unimplemented: Read as ?0?

        banksel PIE3                   ; -> BANK 1
        movwf PIE3

        movlw   B'00010000'
;                 +--------- #7: GIE: Global Interrupt Enable bit
;                  |||||||       1 = Enables all un-masked interrupts
;                  |||||||      >0 = Disables all interrupts, enable later
;                  +-------- #6: PEIE: Peripherial Interrupt Enable bit
;                   ||||||       1 = Enables all unmasked peripherial interrupts
;                   ||||||      >0 = Disables all peripherial interrupts
;                   +------- #5: TMR0IE: TMR0 Overflow Interrupt Enable bit
;                    |||||       1 = Enables the TMR0 interrupt
;                    |||||      >0 = Disables the TMR0 interrupt
;                    +------ #4: INTE: GP2/INT External Interrupt Enable bit
;                     ||||      >1 = Enables the GP2/INT external interrupt
;                     ||||       0 = Disables the GP2/INT external interrupt
;                     +----- #3: IOCIE: PortA Change Interrupt Enable bit
;                      |||       1 = Enables the interrupt-on-change
;                      |||      >0 = Disables the interrupt-on-change
;                      +---- #2: TMR0IF: TMR0 overflow interrupt flag bit
;                       ||       1 = TMR0 has overflowed (must be cleared in software)
;                       ||      >0 = TMR0 did not overflow
;                       +--- #1: INTF: GP2/INT External Interrupt Flag bit
;                        |       1 = The GP2/INT external interrupt occurred (must be cleared in software)
;                        |      >0 = The GP2/INT external interrupt did not occur
;                        +-- #0: IOCIF:  Interrupt-on-Change Interrupt Flag bit
;                                1 = When at least one of the interrupt-on-change pins changed state
;                                    (must be cleared in software)
;                               >0 = None of the interrupt-on-change pins have changed state

        banksel INTCON                 ; -> BANK 0
        movwf INTCON
        bank_0                         ; -> BANK 0
