#ifndef use16f183x4
 error "falsches File"
#endif

;CONST_RAM equ h'80' 

; kein CLK Output, 32 MHz INT OSC, 
 __CONFIG _CONFIG1,_FCMEN_OFF  & _CSWEN_OFF & _CLKOUTEN_OFF & _RSTOSC_HFINT32 & _FEXTOSC_OFF

 __CONFIG _CONFIG2,_DEBUG_OFF & _STVREN_OFF & _PPS1WAY_OFF & _BORV_HIGH & _BOREN_ON & _LPBOREN_OFF & _WDTE_ON & _PWRTE_ON & _MCLRE_OFF

 __CONFIG _CONFIG3,_LVP_OFF & _WRT_OFF

 __CONFIG _CONFIG4,_CPD_OFF & _CP_OFF

; ****************************************************************************
; **  Konfiguration CMxCON0 COMPARATOR CONFIGURATION REGISTER               ** 
; ****************************************************************************
        movlw   B'00000000'
;                 +--------- #7: C2OUT: Comparator 2 Output bit
;                  |||||||       When C2INV = 0:
;                  |||||||       1 = C2 VIN+ > C2 VIN-
;                  |||||||       0 = C2 VIN+ < C2 VINWhen
;                  |||||||       C2INV = 1:
;                  |||||||       1 = C2 VIN+ < C2 VIN-
;                  |||||||       0 = C2 VIN+ > C2
;                  +-------- #6: C1OUT: Comparator 1 Output bit
;                   ||||||       When C1INV = 0:
;                   ||||||       1 = C1 VIN+ > C1 VIN-
;                   ||||||       0 = C1 VIN+ < C1 VINWhen
;                   ||||||       C1INV = 1:
;                   ||||||       1 = C1 VIN+ < C1 VIN-
;                   ||||||       0 = C1 VIN+ > C1 VINbit
;                   +------- #5: C2INV: Comparator 2 Output Inversion bit
;                    |||||       1 = C2 output inverted
;                    |||||       0 = C2 output not inverted
;                    +------- #4: C1INV: Comparator 1 Output Inversion bit
;                     ||||       1 = C1 Output inverted
;                     ||||       0 = C1 Output not inverted
;                     +------ #3: CIS: Comparator Input Switch bit
;                      |||       When CM<2:0> = 010:
;                      |||       1 = C1IN+ connects to C1 VIN-
;                      |||       C2IN+ connects to C2 VIN-
;                      |||       0 = C1IN- connects to C1 VIN-
;                      |||       C2IN- connects to C2 VINWhen
;                      |||       CM<2:0> = 001:
;                      |||       1 = C1IN+ connects to C1 VIN-
;                      |||       0 = C1IN- connects to C1
;                      +++--- #2-0:  CM<2:0>: Comparator Mode bits (See Figure 8-5)
;                                000 = Comparators off. CxIN pins are configured as analog
;                                001 = Three inputs multiplexed to two comparators
;                                010 = Four inputs multiplexed to two comparators
;                                011 = Two common reference comparators
;                                100 = Two independent comparators
;                                101 = One independent comparator
;                                110 = Two common reference comparators with outputs
;                               >111 = Comparators off. CxIN pins are configured as digital I/O

        banksel CM1CON0
        clrf CM1CON0                    ; CMxCON0-Reg. konfigurieren
        clrf CM2CON0                    ; CMxCON0-Reg. konfigurieren


; ****************************************************************
; **  Konfiguration PCON: POWER CONTROL REGISTER (ADDRESS: 8Eh) **
; ****************************************************************
        movlw   B'00000000'
;                 +--------- #7: STKOVF: Stack Overflow Flag bit
;                                1 = A Stack Overflow occurred
;                  +-------- #6: STKUNF: Stack Underflow Flag bit
;                                1 = A Stack Underflow occurred
;                   +------- #5: Unimplemented: Read as 0
;                    +------ #4: RWDT: Watchdog Timer Reset Flag bit
;                                1 = A Watchdog Timer Reset has not occurred or set to ?1? by firmware
;                                0 = A Watchdog Timer Reset has occurred (cleared by hardware)
;                     +----- #3: RMCLR: MCLR Reset Flag bit
;                                1 = A MCLR Reset has not occurred or set to ?1? by firmware
;                                0 = A MCLR Reset has occurred (cleared by hardware)
;                     +----- #2: RI: RESET Instruction Flag bit
;                        |       1 = A RESET instruction has not been executed or set to '1' by firmwared
;                        |      >0 =  A RESET instruction has been executed (cleared by hardware)
;                       +--- #1: POR: Power-on Reset STATUS bit
;                        |       1 = No Power-on Reset occurred
;                        |      >0 = A Power-on Reset occurred (must be set in software after a Power-on Reset occurs)
;                        +-- #0: BOR: Brown-out Reset Status bit
;                                1 = No Brown-out Reset occurred
;                                0 = A Brown-out Reset occurred (must be set in software after a Power-on Reset or Brown-out Reset
;                                occurs)

        banksel PCON0                  ; -> BANK x
        movwf PCON0                    ; PCON-Reg. konfigurieren

; ************************************************************************
; **  Konfiguration OSCCON: OSCILLATOR CONTROL REGISTER (ADDRESS: 99h)  **
; ************************************************************************
; 32MHz, see 7.5

; ********************************************************
; **  Konfiguration AD-Ports                            **
; ********************************************************
        movlw   B'00000000'
;                 ++++++++-- #7-#0: 

        banksel ADCON0                 ; -> BANK 1
        movwf ADCON0                   ; ADCON0-Reg. konfigurieren
        banksel ADCON1                 ; -> BANK 1
        movwf ADCON1                   ; ADCON1-Reg. konfigurieren

; ********************************************************
; **  Konfiguration Port A                              **
; ********************************************************
        movlw   B'00000000'
;                 ---+-+++-- #4-#0: ANSA4 <2:0> Analog Select between Analog or Digital Function on pins RA<2:0>, respectively
;                                   0 = Digital I/O. Pin is assigned to port or digital special function
;                                   1 = Analog input. Pin is assigned as analog input (1) . Digital input buffer disabled
        banksel ANSELA                 ; -> BANK 1
        movwf ANSELA                   ; ANSELA-Reg. konfigurieren

        movlw   B'00000000'
;                 --++-+++-- #5-#0: LATA<5:4> <2:0> Output Latch Value bits
;                                   0 = Digital I/O. Pin is assigned to port or digital special function
;                                   1 = Analog input. Pin is assigned as analog input (1) . Digital input buffer disabled
        banksel LATA                 ; -> BANK 1
        movwf LATA                   ; LATA-Reg. konfigurieren

        movlw   B'00000000'
;                 --++++++-- #5-#0: WPUA<5:0>: Weak Pull-up Register bits
;                                   1 = Pull-up enabled
;                                   0 = Pull-up disable
        banksel WPUA                 ; -> BANK 1
        movwf WPUA                   ; WPUA-Reg. konfigurieren

        movlw   B'00000000'
;                 --++++++-- #5-#0: INLVLA<5:0>: PORTA Input Level Select bits
;                                   1 = ST input used for PORT reads and interrupt-on-change
;                                   0 = TTL input used for PORT reads and interrupt-on-change
        banksel INLVLA                 ; -> BANK 1
        movwf INLVLA                   ; INLVLA-Reg. konfigurieren

#ifndef test
#ifdef pcb_fipps
	movlw   B'00001111';   = RA0 source is CCP4
        banksel RA0PPS                 ; -> BANK 1
        movwf RA0PPS                   ; RA5PPS-Reg. konfigurieren

	movlw   B'00001110';   = RA1 source is CCP3
        banksel RA1PPS                 ; -> BANK 1
        movwf RA1PPS                   ; RA5PPS-Reg. konfigurieren

	movlw   B'00001101';   = RA4 source is CCP2
        banksel RA4PPS                 ; -> BANK 1
        movwf RA4PPS                   ; RA5PPS-Reg. konfigurieren

	movlw   B'00001100';   = RA5 source is CCP1
        banksel RA5PPS                 ; -> BANK 1
        movwf RA5PPS                   ; RA5PPS-Reg. konfigurieren
#endif ; pcb_fipps
#ifdef pcb_wald
	movlw   B'00000010';   = RA5 source is PWM5
        banksel RA5PPS                 ; -> BANK 1
        movwf RA5PPS                   ; RA5PPS-Reg. konfigurieren
#endif ; pcb_wald
#endif ; test

; ********************************************************
; **  Konfiguration Port C                              **
; ********************************************************
        movlw   B'00000000'
;                 ++++++++-- #7-#0: Analog Select between Analog or Digital Function on pins RC<7:0>
;                                   bit 5-4 Unimplemented: Read as '0'
;                                   0 = Digital I/O. Pin is assigned to port or digital special function
;                                   1 = Analog input. Pin is assigned as analog input (1) . Digital input buffer disabled
        banksel ANSELC                 ; -> BANK 1
        movwf ANSELC                   ; ANSELC-Reg. konfigurieren

        movlw   B'00000000'
;                 ++++++++-- #7-#0: LATC<7:0> Output Latch Value bits
;                                   0 = Digital I/O. Pin is assigned to port or digital special function
;                                   1 = Analog input. Pin is assigned as analog input (1) . Digital input buffer disabled
        banksel LATC                 ; -> BANK 1
        movwf LATC                   ; LATC-Reg. konfigurieren

        movlw   B'00000000'
;                 ++++++++-- #7-#0: WPUC<5:0>: Weak Pull-up Register bits
;                                   1 = Pull-up enabled
;                                   0 = Pull-up disable
        banksel WPUC                 ; -> BANK 1
        movwf WPUC                   ; WPUC-Reg. konfigurieren

        movlw   B'00000000'
;                 ++++++++-- #7-#0: INLVLC<7:0>: PORTC Input Level Select bits
;                                   1 = ST input used for PORT reads and interrupt-on-change
;                                   0 = TTL input used for PORT reads and interrupt-on-change
        banksel INLVLC                 ; -> BANK 1
        movwf INLVLC                   ; INLVLC-Reg. konfigurieren

#ifndef test
#ifdef pcb_fipps
        ; RC0 = 60 mA
        ;movlw   B'00000011';   = RC0 source is PWM6
        ;banksel RC0PPS                 ; -> BANK 1
        ;movwf RC0PPS                   ; RC0PPS-Reg. konfigurieren

        movlw   B'00000010';   = RC1 source is PWM5
        banksel RC1PPS                 ; -> BANK 1
        movwf RC1PPS                   ; RC1PPS-Reg. konfigurieren

        movlw   B'00000011';   = RC2 source is PWM6
        banksel RC2PPS                 ; -> BANK 1
        movwf RC2PPS                   ; RC2PPS-Reg. konfigurieren

        movlw   B'00010100';   = RC4 source is TX/CK
        banksel RC4PPS                 ; -> BANK 1
        movwf RC4PPS                   ; RC4PPS-Reg. konfigurieren

        ;movlw   B'00001100';   = RC5 source is CCP1
        ;banksel RC5PPS                 ; -> BANK 1
        ;movwf RC5PPS                   ; RC5PPS-Reg. konfigurieren
#endif ; pcb_fipps
#ifdef pcb_wald
        movlw   B'00000011';   = RC0 source is PWM6
        banksel RC0PPS                 ; -> BANK 1
        movwf RC0PPS                   ; RC0PPS-Reg. konfigurieren

        movlw   B'00001101';   = RC1 source is CCP2
        banksel RC1PPS                 ; -> BANK 1
        movwf RC1PPS                   ; RC1PPS-Reg. konfigurieren

        movlw   B'00001110';   = RC2 source is CCP3
        banksel RC2PPS                 ; -> BANK 1
        movwf RC2PPS                   ; RC2PPS-Reg. konfigurieren

        movlw   B'00001111';   = RC3 source is CCP4
        banksel RC3PPS                 ; -> BANK 1
        movwf RC3PPS                   ; RC3PPS-Reg. konfigurieren

        movlw   B'00010100';   = RC4 source is TX/CK
        banksel RC4PPS                 ; -> BANK 1
        movwf RC4PPS                   ; RC4PPS-Reg. konfigurieren

        movlw   B'00001100';   = RC5 source is CCP1
        banksel RC5PPS                 ; -> BANK 1
        movwf RC5PPS                   ; RC5PPS-Reg. konfigurieren
#endif ; pcb_wald
#endif ; test

        movlw   B'11111111';   = zunchst alles INPUT konfigurieren
        banksel TRISC                  ; -> BANK 1
        movwf TRISC                   ; TRISC-Reg. konfigurieren

; ********************************************************
; **  Konfiguration TIMER 0 = 128 us (125ns * 256 * 4)
; ********************************************************
        movlw   B'10000011'
;                 +--------- #7: T0EN:TMR0 Enable bit
;                  |||||||      >1 = The module is enabled and operating
;                  |||||||       0 = The module is disabled and in the lowest power mode
;                  +-------- #6 Unimplemented: Read as '0'
;                   +------- #5: T0OUT:TMR0 Output (read-only)
;                    +------ #4: T016BIT: TMR0 Operating as 16-bit Timer Select bit
;                     ||||       1 = TMR0 is a 16-bit timer
;                     ||||      >0 = TMR0 is an 8-bit timer
;                     ++++-- #3-#0: PS2:PS0: Postscaler Rate Select bits
;                                 Bit |TMR0 Rate          
;                                 ----+---------          
;                                 0000 | 1 : 1   Postscaler
;                                 0001 | 1 : 2   Postscaler
;                                 0010 | 1 : 3   Postscaler
;                               > 0011 | 1 : 4   Postscaler 
;                                 0100 | 1 : 5   Postscaler 
;                                 0101 | 1 : 6   Postscaler
;                                 0110 | 1 : 7   Postscaler 
;                                 0111 | 1 : 8   Postscaler 
;                                 1000 | 1 : 9   Postscaler
;                                 1001 | 1 : 10  Postscaler
;                                 1010 | 1 : 11  Postscaler
;                                 1011 | 1 : 12  Postscaler 
;                                 1100 | 1 : 13  Postscaler 
;                                 1101 | 1 : 14  Postscaler
;                                 1110 | 1 : 15  Postscaler 
;                                 1111 | 1 : 16  Postscaler 
        banksel T0CON0             ; -> BANK 1
        movwf T0CON0               ; T0CON0 konfigurieren

        movlw   B'01000000'
;                 +++------- #7-5: T0CS<2:0>:Timer0 Clock Source Select bits
;                    |             010 = F OSC /4
;                    +------ #4: T0ASYNC: TMR0 Input Asynchronization Enable bit
;                     ||||       1 = The input to the TMR0 counter is not synchronized to system clocks
;                     ||||      >0 = The input to the TMR0 counter is synchronized to F OSC /4
;                     ++++-- #3-#0: T0CKPS<3:0>: Prescaler Rate Select bit
;                                 Bit |TMR0 Rate          
;                                 ----+---------          
;                               > 0000 | 1 : 1   
;                                 0001 | 1 : 2   
;                                 0010 | 1 : 4 
;                                 0011 | 1 : 8    
;                                 0100 | 1 : 18   
;                                 0101 | 1 : 32  
;                                 0110 | 1 : 64   
;                                 0111 | 1 : 128  
;                                 1000 | 1 : 256 
;                                 1001 | 1 : 512 
;                                 1010 | 1 : 1024
;                                 1011 | 1 : 2048 
;                                 1100 | 1 : 4096 
;                                 1101 | 1 : 8192 
;                                 1110 | 1 : 16384
;                                 1111 | 1 : 32768
        banksel T0CON1             ; -> BANK 1
        movwf T0CON1               ; T0CON1 konfigurieren

; ********************************************************
; **  Konfiguration TIMER 1/3/5 (16 Bit, Gate Control, INT on overflow)
; ** Timer 1 = 8182 us (125ns * 256 * 256)
; ** Timer 3 = 8182 us (125ns * 256 * 256)
; ** Timer 5 = 8182 us (125ns * 256 * 256)
; ********************************************************
#ifdef timer1_is_ir ;TMR1 IR verwendet fr PWM, Prescaler 1:1
        movlw   B'00000001'
#endif

#ifndef timer1_is_ir ;ohne TMR1 IR -> Timer1 trotzdem bentigt (z.B. 60mA Impuls, TimeOut)
        movlw   B'00000001'
#endif
;                 ++-------- #bit 7-6 TMRxCS<1:0>: Timerx Clock Source Select bits
;                                 #11 = Timerx clock Source is LFINTOSC
;                                 10 = Timerx clock source is pin or oscillator:
;                                 If TxSOSC = 0:
;                                 External clock from TxCKIPPS pin (on the rising edge)
;                                 If TxSOSC = 1:
;                                 Clock from SOSC, either crystal oscillator on TxSOSCI/TxSOSCO pins, or SOSCIN input
;                                 01 = Timerx clock source is system clock (F OSC )
;                               > 00 = Timerx clock source is instruction clock (F OSC /4)
;                   ++------ #bit 5-4 TxCKPS<1:0>: Timerx Input Clock Prescale Select bits
;                                 11 = 1:8 Prescale value
;                                 10 = 1:4 Prescale value
;                                 01 = 1:2 Prescale value
;                               > 00 = 1:1 Prescale value
;                     +----- #bit 3 TxSOSC: LP Oscillator Enable Control bit
;                                 1 = SOSC requested as the clock source
;                               > 0 = TxCKI enabled as the clock source
;                      +---- #bit 2 TxSYNC: Timerx Synchronization Control bit
;                                 TMRxCS<1:0> = 1x
;                                 1 = Do not synchronize external clock input
;                               > 0 = Synchronize external clock input with system clock
;                                 TMRxCS<1:0> = 0x
;                                 This bit is ignored. Timerx uses the internal clock and no additional synchronization is performed.
;                       +--- #bit 1 Unimplemented: Read as '0'
;                        +-- #bit 0 TMRxON: Timerx On bit
;                               > 1 = Enables Timerx
;                                 0 = Stops Timerx and clears Timerx gate flip-flop
        banksel T1CON                   ; -> BANK x
        movwf T1CON

        movlw   B'00000000'
;                 +--------- #7: Timerx Gate Enable bit (If TMRxON = 1)
;                  |||||||       1 = Timerx counting is controlled by the Timerx gate function
;                  |||||||      >0 = Timerx is always counting
;                  +-------- #6: TxGPOL: Timerx Gate Polarity bit
;                                1 = Timerx gate is active-high (Timerx counts when gate is high)
;                               >0 = Timerx gate is active-low (Timerx counts when gate is low)
;                   +------- #5: TxGTM: Timerx Gate Toggle Mode bit
;                                1 = Timerx Gate Toggle mode is enabled
;                               >0 = Timerx Gate Toggle mode is disabled and toggle flip-flop is cleared
;                    +------ #4: TxGSPM: Timerx Gate Single-Pulse Mode bit
;                                1 = Timerx Gate Single-Pulse mode is enabled and is controlling Timerx gate
;                               >0 = Timerx Gate Single-Pulse mode is disabled
;                     +----- #3: TxGGO/DONE: Timerx Gate Single-Pulse Acquisition Status bit
;                                1 = Timerx gate single-pulse acquisition is ready, waiting for an edge
;                                0 = Timerx gate single-pulse acquisition has completed or has not been started
;                                    This bit is automatically cleared when TxGSPM is cleared1 = Enables CCP4 interrupt
;                      +---- #2: TxGVAL: Timerx Gate Value Status bit (read-only)
;                                1 = Enables CCP3 interrupt
;                               >0 = Disables CCP3 interrupt
;                       +--- #1-0: TxGSS<1:0>: Timerx Gate Source Select bits
;                                11 = Comparator 2 optionally synchronized output
;                                10 = Comparator 1 optionally synchronized output
;                                01 = Timer0 overflow output
;                                00 = Timerx gate pin
        banksel T1GCON                   ; -> BANK x
        movwf T1GCON

        movlw   B'00000001'
;                 ++-------- #bit 7-6 TMRxCS<1:0>: Timerx Clock Source Select bits
;                                 #11 = Timerx clock Source is LFINTOSC
;                                 10 = Timerx clock source is pin or oscillator:
;                                 If TxSOSC = 0:
;                                 External clock from TxCKIPPS pin (on the rising edge)
;                                 If TxSOSC = 1:
;                                 Clock from SOSC, either crystal oscillator on TxSOSCI/TxSOSCO pins, or SOSCIN input
;                                 01 = Timerx clock source is system clock (F OSC )
;                                 00 = Timerx clock source is instruction clock (F OSC /4)
;                   ++------ #bit 5-4 TxCKPS<1:0>: Timerx Input Clock Prescale Select bits
;                                 11 = 1:8 Prescale value
;                                 10 = 1:4 Prescale value
;                                 01 = 1:2 Prescale value
;                                 00 = 1:1 Prescale value
;                     +----- #bit 3 TxSOSC: LP Oscillator Enable Control bit
;                                 1 = SOSC requested as the clock source
;                                 0 = TxCKI enabled as the clock source
;                      +---- #bit 2 TxSYNC: Timerx Synchronization Control bit
;                                 TMRxCS<1:0> = 1x
;                                 1 = Do not synchronize external clock input
;                                 0 = Synchronize external clock input with system clock
;                                 TMRxCS<1:0> = 0x
;                                 This bit is ignored. Timerx uses the internal clock and no additional synchronization is performed.
;                       +--- #bit 1 Unimplemented: Read as '0'
;                        +-- #bit 0 TMRxON: Timerx On bit
;                               > 1 = Enables Timerx
;                                 0 = Stops Timerx and clears Timerx gate flip-flop
        banksel T3CON                   ; -> BANK x
        movwf T3CON

        movlw   B'00000000'
;                 +--------- #7: Timerx Gate Enable bit (If TMRxON = 1)
;                  |||||||       1 = Timerx counting is controlled by the Timerx gate function
;                  |||||||      >0 = Timerx is always counting
;                  +-------- #6: TxGPOL: Timerx Gate Polarity bit
;                                1 = Timerx gate is active-high (Timerx counts when gate is high)
;                               >0 = Timerx gate is active-low (Timerx counts when gate is low)
;                   +------- #5: TxGTM: Timerx Gate Toggle Mode bit
;                                1 = Timerx Gate Toggle mode is enabled
;                               >0 = Timerx Gate Toggle mode is disabled and toggle flip-flop is cleared
;                    +------ #4: TxGSPM: Timerx Gate Single-Pulse Mode bit
;                                1 = Timerx Gate Single-Pulse mode is enabled and is controlling Timerx gate
;                               >0 = Timerx Gate Single-Pulse mode is disabled
;                     +----- #3: TxGGO/DONE: Timerx Gate Single-Pulse Acquisition Status bit
;                                1 = Timerx gate single-pulse acquisition is ready, waiting for an edge
;                                0 = Timerx gate single-pulse acquisition has completed or has not been started
;                                    This bit is automatically cleared when TxGSPM is cleared1 = Enables CCP4 interrupt
;                      +---- #2: TxGVAL: Timerx Gate Value Status bit (read-only)
;                                1 = Enables CCP3 interrupt
;                               >0 = Disables CCP3 interrupt
;                       +--- #1-0: TxGSS<1:0>: Timerx Gate Source Select bits
;                                11 = Comparator 2 optionally synchronized output
;                                10 = Comparator 1 optionally synchronized output
;                                01 = Timer0 overflow output
;                                00 = Timerx gate pin
        banksel T3GCON                   ; -> BANK x
        movwf T3GCON

        movlw   B'00000000'
;                 ++-------- #bit 7-6 TMRxCS<1:0>: Timerx Clock Source Select bits
;                                 #11 = Timerx clock Source is LFINTOSC
;                                 10 = Timerx clock source is pin or oscillator:
;                                 If TxSOSC = 0:
;                                 External clock from TxCKIPPS pin (on the rising edge)
;                                 If TxSOSC = 1:
;                                 Clock from SOSC, either crystal oscillator on TxSOSCI/TxSOSCO pins, or SOSCIN input
;                                 01 = Timerx clock source is system clock (F OSC )
;                                 00 = Timerx clock source is instruction clock (F OSC /4)
;                   ++------ #bit 5-4 TxCKPS<1:0>: Timerx Input Clock Prescale Select bits
;                                 11 = 1:8 Prescale value
;                                 10 = 1:4 Prescale value
;                                 01 = 1:2 Prescale value
;                                 00 = 1:1 Prescale value
;                     +----- #bit 3 TxSOSC: LP Oscillator Enable Control bit
;                                 1 = SOSC requested as the clock source
;                                 0 = TxCKI enabled as the clock source
;                      +---- #bit 2 TxSYNC: Timerx Synchronization Control bit
;                                 TMRxCS<1:0> = 1x
;                                 1 = Do not synchronize external clock input
;                                 0 = Synchronize external clock input with system clock
;                                 TMRxCS<1:0> = 0x
;                                 This bit is ignored. Timerx uses the internal clock and no additional synchronization is performed.
;                       +--- #bit 1 Unimplemented: Read as '0'
;                        +-- #bit 0 TMRxON: Timerx On bit
;                                 1 = Enables Timerx
;                               > 0 = Stops Timerx and clears Timerx gate flip-flop
        banksel T5CON                   ; -> BANK x
        movwf T5CON

        movlw   B'00000000'
;                 +--------- #7: Timerx Gate Enable bit (If TMRxON = 1)
;                  |||||||       1 = Timerx counting is controlled by the Timerx gate function
;                  |||||||      >0 = Timerx is always counting
;                  +-------- #6: TxGPOL: Timerx Gate Polarity bit
;                                1 = Timerx gate is active-high (Timerx counts when gate is high)
;                               >0 = Timerx gate is active-low (Timerx counts when gate is low)
;                   +------- #5: TxGTM: Timerx Gate Toggle Mode bit
;                                1 = Timerx Gate Toggle mode is enabled
;                               >0 = Timerx Gate Toggle mode is disabled and toggle flip-flop is cleared
;                    +------ #4: TxGSPM: Timerx Gate Single-Pulse Mode bit
;                                1 = Timerx Gate Single-Pulse mode is enabled and is controlling Timerx gate
;                               >0 = Timerx Gate Single-Pulse mode is disabled
;                     +----- #3: TxGGO/DONE: Timerx Gate Single-Pulse Acquisition Status bit
;                                1 = Timerx gate single-pulse acquisition is ready, waiting for an edge
;                                0 = Timerx gate single-pulse acquisition has completed or has not been started
;                                    This bit is automatically cleared when TxGSPM is cleared1 = Enables CCP4 interrupt
;                      +---- #2: TxGVAL: Timerx Gate Value Status bit (read-only)
;                                1 = Enables CCP3 interrupt
;                               >0 = Disables CCP3 interrupt
;                       +--- #1-0: TxGSS<1:0>: Timerx Gate Source Select bits
;                                11 = Comparator 2 optionally synchronized output
;                                10 = Comparator 1 optionally synchronized output
;                                01 = Timer0 overflow output
;                                00 = Timerx gate pin
        banksel T5GCON                   ; -> BANK x
        movwf T5GCON



; ********************************************************
; **  PWM Periode                                       **
; ********************************************************
#ifndef test
        movlw   B'00011111'
;                 +--------- #7-0 PRx<7:0>: TMRx Counter bits 7..0
;                                 When TMRx = PRx, the next clock will reset the counter; counter period is (PRx+1)
;                                 PWM Period = (PRx +1) x 4 x TOsc * TMR2 Prescale Value
        banksel PR2             ; -> BANK x
        movwf PR2               ; PR2 konfigurieren
#endif ; test
; ********************************************************
; **  Konfiguration CCP 1                               **
; ********************************************************
#ifndef test
        movlw   B'10011111'
;                 +--------- #7 CCPxEN: PWM Module Enable bit
;                                 1 = CCP is disabled
;                                 0 = CCP is enabled
;                  +-------- bit 6 Unimplemented: Read as 0
;                   +------- bit 5 CCPxOUT: CCPx Output Data (read-only) bit
;                    +------ bit 4 CCPxFMT: CCPW (pulse width) Alignment bit
;                                 CCPxMODE = PWM mode:
;                               > 1 = Left-aligned format
;                                 0 = Right-aligned format
;                     ++++-- bit 3-0 CCPxMODE<3:0>: CCPx Mode Select bits 
;                                 1111 = PWM mode
        banksel CCP1CON             ; -> BANK x
        movwf CCP1CON               ; CCP1CON konfigurieren



        movlw   B'00000000'
;                                 CCPxMODE = PWM modes when CCPxFMT = 1
;                                 CCPRxL<7:6>: CCPW<1:0>  Pulse-width Least Significant two bits
;                                 CCPRxL<5:0>: Not used
        banksel CCPR1L             ; -> BANK x
        movwf CCPR1L               ; CCPR1L konfigurieren



        movlw   B'00000100'        
;                                 CCPxMODE = PWM modes when CCPxFMT = 1
;                                 CCPRxH<7:0>: CCPW<9:2>  Pulse-width Most Significant eight bits
        banksel CCPR1H             ; -> BANK x
        movwf CCPR1H               ; CCPR1H konfigurieren
#endif ; test

; ********************************************************
; **  Konfiguration CCP 2                               **
; ********************************************************
#ifndef test
        movlw   B'10011111'
;                 +--------- #7 CCPxEN: PWM Module Enable bit
;                                 1 = CCP is disabled
;                                 0 = CCP is enabled
;                  +-------- bit 6 Unimplemented: Read as 0
;                   +------- bit 5 CCPxOUT: CCPx Output Data (read-only) bit
;                    +------ bit 4 CCPxFMT: CCPW (pulse width) Alignment bit
;                                 CCPxMODE = PWM mode:
;                               > 1 = Left-aligned format
;                                 0 = Right-aligned format
;                     ++++-- bit 3-0 CCPxMODE<3:0>: CCPx Mode Select bits 
;                                 1111 = PWM mode
        banksel CCP2CON             ; -> BANK x
        movwf CCP2CON               ; CCP2CON konfigurieren



        movlw   B'00000000'
;                                 CCPxMODE = PWM modes when CCPxFMT = 1
;                                 CCPRxL<7:6>: CCPW<1:0>  Pulse-width Least Significant two bits
;                                 CCPRxL<5:0>: Not used
        banksel CCPR2L             ; -> BANK x
        movwf CCPR2L               ; CCPR2L konfigurieren



        movlw   B'00001100'        
;                                 CCPxMODE = PWM modes when CCPxFMT = 1
;                                 CCPRxH<7:0>: CCPW<9:2>  Pulse-width Most Significant eight bits
        banksel CCPR2H             ; -> BANK x
        movwf CCPR2H               ; CCPR2H konfigurieren
#endif ; test

; ********************************************************
; **  Konfiguration CCP 3                               **
; ********************************************************
#ifndef test
        movlw   B'10011111'
;                 +--------- #7 CCPxEN: PWM Module Enable bit
;                                 1 = CCP is disabled
;                                 0 = CCP is enabled
;                  +-------- bit 6 Unimplemented: Read as 0
;                   +------- bit 5 CCPxOUT: CCPx Output Data (read-only) bit
;                    +------ bit 4 CCPxFMT: CCPW (pulse width) Alignment bit
;                                 CCPxMODE = PWM mode:
;                               > 1 = Left-aligned format
;                                 0 = Right-aligned format
;                     ++++-- bit 3-0 CCPxMODE<3:0>: CCPx Mode Select bits 
;                                 1111 = PWM mode
        banksel CCP3CON             ; -> BANK x
        movwf CCP3CON               ; CCP3CON konfigurieren



        movlw   B'00000000'
;                                 CCPxMODE = PWM modes when CCPxFMT = 1
;                                 CCPRxL<7:6>: CCPW<1:0>  Pulse-width Least Significant two bits
;                                 CCPRxL<5:0>: Not used
        banksel CCPR3L             ; -> BANK x
        movwf CCPR3L               ; CCPR3L konfigurieren



        movlw   B'00000110'        
;                                 CCPxMODE = PWM modes when CCPxFMT = 1
;                                 CCPRxH<7:0>: CCPW<9:2>  Pulse-width Most Significant eight bits
        banksel CCPR3H             ; -> BANK x
        movwf CCPR3H               ; CCPR3H konfigurieren
#endif ; test

; ********************************************************
; **  Konfiguration CCP 4                               **
; ********************************************************
#ifndef test
        movlw   B'10011111'
;                 +--------- #7 CCPxEN: PWM Module Enable bit
;                                 1 = CCP is disabled
;                                 0 = CCP is enabled
;                  +-------- bit 6 Unimplemented: Read as 0
;                   +------- bit 5 CCPxOUT: CCPx Output Data (read-only) bit
;                    +------ bit 4 CCPxFMT: CCPW (pulse width) Alignment bit
;                                 CCPxMODE = PWM mode:
;                               > 1 = Left-aligned format
;                                 0 = Right-aligned format
;                     ++++-- bit 3-0 CCPxMODE<3:0>: CCPx Mode Select bits 
;                                 1111 = PWM mode
        banksel CCP4CON             ; -> BANK x
        movwf CCP4CON               ; CCP4CON konfigurieren



        movlw   B'00000000'
;                                 CCPxMODE = PWM modes when CCPxFMT = 1
;                                 CCPRxL<7:6>: CCPW<1:0>  Pulse-width Least Significant two bits
;                                 CCPRxL<5:0>: Not used
        banksel CCPR4L             ; -> BANK x
        movwf CCPR4L               ; CCPR4L konfigurieren



        movlw   B'00011110'        
;                                 CCPxMODE = PWM modes when CCPxFMT = 1
;                                 CCPRxH<7:0>: CCPW<9:2>  Pulse-width Most Significant eight bits
        banksel CCPR4H             ; -> BANK x
        movwf CCPR4H               ; CCPR4H konfigurieren
#endif ; test

; ********************************************************
; **  Konfiguration TIMER 2/4/6 (8Bit, INTERRUPT on Match, used for PWM)
; ** Timer 2 = 32.256 us (125ns * 256) -> ggf. nderung durch PR2 beachten!
; ** Timer 4 = 2ms Raster = 125ns x 64 x 256 = 2048 us)  
; ** Timer 6 = 32.768 ms (125ns * 256 * 16 * 64)
; ********************************************************
        movlw   B'00000100'
;                 +--------- #7: Unimplemented: Read as '0'
;                  ++++----- #6-#3: TxOUTPS<3:0>: Timerx Output Postscaler Select bits
;                                 Bit |TMR0 Rate          
;                                 ----+---------          
;                               > 0000 | 1 : 1   Postscaler
;                                 0001 | 1 : 2   Postscaler
;                                 0010 | 1 : 3   Postscaler
;                                 0011 | 1 : 4   Postscaler 
;                                 0100 | 1 : 5   Postscaler 
;                                 0101 | 1 : 6   Postscaler
;                                 0110 | 1 : 7   Postscaler 
;                                 0111 | 1 : 8   Postscaler 
;                                 1000 | 1 : 9   Postscaler
;                                 1001 | 1 : 10  Postscaler
;                                 1010 | 1 : 11  Postscaler
;                                 1011 | 1 : 12  Postscaler 
;                                 1100 | 1 : 13  Postscaler 
;                                 1101 | 1 : 14  Postscaler
;                                 1110 | 1 : 15  Postscaler 
;                                 1111 | 1 : 16  Postscaler 
;                      +---- bit 2 TMRxON: Timer2 On bit
;                                 1 = Timerx is on
;                                 0 = Timerx is off
;                       ++-- bit 1-0 TxCKPS<1:0>: Timerx Clock Prescale Select bits
;                                 11 = Prescaler is 64
;                                 10 = Prescaler is 16
;                                 01 = Prescaler is 4
;                               > 00 = Prescaler is 1
        banksel T2CON             ; -> BANK x
        movwf T2CON               ; T2CON konfigurieren

        movlw   B'00000111' ; 2ms Raster = 125ns x 64 x 256 = 2048 us)  
;                 +--------- #7: Unimplemented: Read as '0'
;                  ++++----- #6-#3: TxOUTPS<3:0>: Timerx Output Postscaler Select bits
;                                 Bit |TMR0 Rate          
;                                 ----+---------          
;                                 0000 | 1 : 1   Postscaler
;                                 0001 | 1 : 2   Postscaler
;                                 0010 | 1 : 3   Postscaler
;                                >0011 | 1 : 4   Postscaler 
;                                 0100 | 1 : 5   Postscaler 
;                                 0101 | 1 : 6   Postscaler
;                                 0110 | 1 : 7   Postscaler 
;                                 0111 | 1 : 8   Postscaler 
;                                 1000 | 1 : 9   Postscaler
;                                 1001 | 1 : 10  Postscaler
;                                 1010 | 1 : 11  Postscaler
;                                 1011 | 1 : 12  Postscaler 
;                                 1100 | 1 : 13  Postscaler 
;                                 1101 | 1 : 14  Postscaler
;                                 1110 | 1 : 15  Postscaler 
;                                 1111 | 1 : 16  Postscaler 
;                      +---- bit 2 TMRxON: Timer2 On bit
;                                >1 = Timerx is on
;                                 0 = Timerx is off
;                       ++-- bit 1-0 TxCKPS<1:0>: Timerx Clock Prescale Select bits
;                                 11 = Prescaler is 64
;                                 10 = Prescaler is 16
;                                >01 = Prescaler is 4
;                                 00 = Prescaler is 1
        banksel T4CON             ; -> BANK x
        movwf T4CON               ; T4CON konfigurieren

        movlw   B'01111111'
;                 +--------- #7: Unimplemented: Read as '0'
;                  +++------ #6-#3: TxOUTPS<3:0>: Timerx Output Postscaler Select bits
;                                 Bit |TMR0 Rate          
;                                 ----+---------          
;                                 0000 | 1 : 1   Postscaler
;                                 0001 | 1 : 2   Postscaler
;                                 0010 | 1 : 3   Postscaler
;                                 0011 | 1 : 4   Postscaler 
;                                 0100 | 1 : 5   Postscaler 
;                                 0101 | 1 : 6   Postscaler
;                                 0110 | 1 : 7   Postscaler 
;                                 0111 | 1 : 8   Postscaler 
;                                 1000 | 1 : 9   Postscaler
;                                 1001 | 1 : 10  Postscaler
;                                 1010 | 1 : 11  Postscaler
;                                 1011 | 1 : 12  Postscaler 
;                                 1100 | 1 : 13  Postscaler 
;                                 1101 | 1 : 14  Postscaler
;                                 1110 | 1 : 15  Postscaler 
;                               > 1111 | 1 : 16  Postscaler 
;                      +---- bit 2 TMRxON: Timer2 On bit
;                                 1 = Timerx is on
;                                 0 = Timerx is off
;                       ++-- bit 1-0 TxCKPS<1:0>: Timerx Clock Prescale Select bits
;                               > 11 = Prescaler is 64
;                                 10 = Prescaler is 16
;                                 01 = Prescaler is 4
;                                 00 = Prescaler is 1
        banksel T6CON             ; -> BANK x
        movwf T6CON               ; T6CON konfigurieren

; ********************************************************
; **  Konfiguration CCP Clock Selection                 **
; ********************************************************
        movlw   B'00000000'
;                 ++-------- bit 7-6 C4TSEL<1:0>: CCP4 Capture, Compare and PWM mode Timer Selection bits
;                                 Selection as show in Table 29-3.
;                   ++------ bit 5-4 C3TSEL<1:0>: CCP3 Capture, Compare and PWM mode Timer Selection bits
;                                 Selection as show in Table 29-3.
;                     ++---- bit 3-2 C2TSEL<1:0>: CCP2 Capture, Compare and PWM mode Timer Selection bits
;                                 Selection as show in Table 29-3.
;                       ++-- bit 1-0 C1TSEL<1:0>: CCP1 Capture, Compare and PWM mode Timer Selection bits
;                                 Selection as show in Table 29-3.
;                                 CxTSEL<1:0> Operating mode based on CCPxMODE<3:0>
;                                 Capture Compare PWM
;                                 00 TMR2
;                                 10 TMR4
;                                 11 TMR6

        banksel CCPTMRS             ; -> BANK x
        movwf CCPTMRS               ; CCPTMRS konfigurieren


; ********************************************************
; **  Konfiguration PWM 5                               **
; ********************************************************
#ifndef test
        movlw   B'10000000'
;                 +--------- #7 PWMxEN: PWM Module Enable bit
;                                 1 = PWM module is enabled
;                                 0 = PWM module is disabled
;                  +-------- bit 6 Unimplemented: Read as 0
;                   +------- bit 5 PWMxOUT: PWM Module Output Level when bit is read.
;                    +------ bit 4 PWMxPOL: PWMx Output Polarity Select bit
;                                 1 = PWM output is active-low.
;                                 0 = PWM output is active-high.
;                      +++-- bit 3-0 Unimplemented: Read as 0
        banksel PWM5CON             ; -> BANK x
        movwf PWM5CON               ; PWM5CON konfigurieren



;        movlw   B'00000000'
;                 ++++++++-- bit 7-0 PWMxDC<9:2>: PWM Duty Cycle Most Significant bits
;                            These bits are the MSbs of the PWM duty cycle. The two LSbs are found in PWMxDCL Register.
;        banksel PWM5DCH             ; -> BANK x
;        movwf PWM5DCH               ; PWM5DCH konfigurieren



        movlw   B'00000000'
;                 ++-------- bit 7-6 PWMxDC<1:0>: PWM Duty Cycle Least Significant bits
;                            These bits are the LSbs of the PWM duty cycle. The MSbs are found in PWMxDCH Register.
;                   ++++++-- bit 5-0 Unimplemented: Read as 0        banksel PWM5DCL             ; -> BANK x
        banksel PWM5DCL             ; -> BANK x
        movwf PWM5DCL               ; PWM5DCL konfigurieren
#endif ; test

; ********************************************************
; **  Konfiguration PWM 6                               **
; ********************************************************
#ifndef test
        movlw   B'10000000'
;                 +--------- #7 PWMxEN: PWM Module Enable bit
;                                 1 = PWM module is enabled
;                                 0 = PWM module is disabled
;                  +-------- bit 6 Unimplemented: Read as 0
;                   +------- bit 5 PWMxOUT: PWM Module Output Level when bit is read.
;                    +------ bit 4 PWMxPOL: PWMx Output Polarity Select bit
;                                 1 = PWM output is active-low.
;                                 0 = PWM output is active-high.
;                      +++-- bit 3-0 Unimplemented: Read as 0
        banksel PWM6CON             ; -> BANK x
        movwf PWM6CON               ; PWM6CON konfigurieren



;        movlw   B'00000000'
;                 ++++++++-- bit 7-0 PWMxDC<9:2>: PWM Duty Cycle Most Significant bits
;                            These bits are the MSbs of the PWM duty cycle. The two LSbs are found in PWMxDCL Register.
;        banksel PWM6DCH             ; -> BANK x
;        movwf PWM6DCH               ; PWM6DCH konfigurieren



        movlw   B'00000000'
;                 ++-------- bit 7-6 PWMxDC<1:0>: PWM Duty Cycle Least Significant bits
;                            These bits are the LSbs of the PWM duty cycle. The MSbs are found in PWMxDCH Register.
;                   ++++++-- bit 5-0 Unimplemented: Read as 0        banksel PWM5DCL             ; -> BANK x
        banksel PWM6DCL             ; -> BANK x
        movwf PWM6DCL               ; PWM6DCL konfigurieren
#endif ; test
; ********************************************************
; **  Konfiguration WDT                                 **
; ********************************************************
        movlw   B'00100100'
;                 ++-------- bit 7-6 Unimplemented: Read as '0'
;                   +++++--- bit 5-1 WDTPS<4:0>: Watchdog Timer Period Select bits (WDT time is based on 31 kHz LFINTOSC)
;                                 Bit Value = Prescale Rate
;                                 11111 = Reserved. Results in minimum interval (1:32)
;                                 ...
;                                 10011 = Reserved. Results in minimum interval (1:32)
;                                 10010 = 1:8388608 (2 23 ) (Interval 256s nominal)
;                                 10001 = 1:4194304 (2 22 ) (Interval 128s nominal)
;                                 10000 = 1:2097152 (2 21 ) (Interval 64s nominal)
;                                 01111 = 1:1048576 (2 20 ) (Interval 32s nominal)
;                                 01110 = 1:524288 (2 19 ) (Interval 16s nominal)
;                                 01101 = 1:262144 (2 18 ) (Interval 8s nominal)
;                                 01100 = 1:131072 (2 17 ) (Interval 4s nominal)
;                                 01011 = 1:65536 (Interval 2s nominal) (Reset value)
;                                 01010 = 1:32768 (Interval 1s nominal)
;                                 01001 = 1:16384 (Interval 512 ms nominal)
;                                 01000 = 1:8192 (Interval 256 ms nominal)
;                                 00111 = 1:4096 (Interval 128 ms nominal)
;                                 00110 = 1:2048 (Interval 64 ms nominal)
;                                 00101 = 1:1024 (Interval 32 ms nominal)
;                                 00100 = 1:512 (Interval 16 ms nominal)
;                                 00011 = 1:256 (Interval 8 ms nominal)
;                                 00010 = 1:128 (Interval 4 ms nominal)
;                                 00001 = 1:64 (Interval 2 ms nominal)
;                                 00000 = 1:32 (Interval 1 ms nominal)
;                        +-- bit 0 SWDTEN: Software Enable/Disable for Watchdog Timer bit
;                                 If WDTE<1:0> = 1x:
;                                 This bit is ignored.
;                                 If WDTE<1:0> = 01:
;                                 1 = WDT is turned on
;                                 0 = WDT is turned off
;                               > If WDTE<1:0> = 00:
;                               > This bit is ignored.
        banksel WDTCON             ; -> BANK x
        movwf WDTCON               ; WDTCON konfigurieren

; ********************************************************
; **  Konfiguration USART                               **
; ********************************************************
#ifdef use_lissy ; PORTC,4 -> TX mit 120kBaud, aber kein RX
        movlw   B'10100110'
;                 +--------- #7: CSRC: Clock Source Select bit
;                  |||||||       Asynchronous mode:                                   
;                  |||||||       Don't care                                           
;                  |||||||       Synchronous mode:                                    
;                  |||||||      >1 = Master mode (clock generated internally from BRG)
;                  |||||||       0 = Slave mode (clock from external source)          
;                  +-------- #6: TX9: 9-bit Transmit Enable bit
;                   ||||||       1 = Selects 9-bit transmission
;                   ||||||      >0 = Selects 8-bit transmission
;                   +------- #5: TXEN: Transmit Enable bit(1)
;                    |||||      >1 = Transmit enabled        
;                    |||||       0 = Transmit disabled       
;                    +------ #4: SYNC: EUSART Mode Select bit
;                     ||||       1 = Synchronous mode        
;                     ||||      >0 = Asynchronous mode       
;                     +----- #3: SENDB: Send Break Character bit                                               
;                      |||       Asynchronous mode:                                                            
;                      |||       1 = Send Sync Break on next transmission (cleared by hardware upon completion)
;                      |||      >0 = Sync Break transmission completed                                         
;                      |||       Synchronous mode:                                                             
;                      |||       Don?t care                                                                    
;                      +---- #2: BRGH: High Baud Rate Select bit
;                       ||       Asynchronous mode:             
;                       ||      >1 = High speed                 
;                       ||       0 = Low speed                  
;                       ||       Synchronous mode:              
;                       ||       Unused in this mode            
;                       +--- #1: TRMT: Transmit Shift Register Status bit 
;                        |      >1 = TSR empty                           
;                        |       0 = TSR full                            
;                        +-- #0: TX9D: Ninth bit of Transmit Data
;                                Can be address/data bit or a parity bit.

        banksel TX1STA                 ; -> BANK x
        movwf TX1STA                   ; TX1STA-Reg. konfigurieren

        movlw   B'10000000'
;                 +--------- #7: SPEN: Serial Port Enable bit
;                  |||||||      >1 = Serial port enabled (configures RX/DT and TX/CK pins as serial port pins)
;                  |||||||       0 = Serial port disabled (held in Reset)                                     
;                  +-------- #6: RX9: 9-bit Receive Enable bit
;                   ||||||       1 = Selects 9-bit reception  
;                   ||||||      >0 = Selects 8-bit reception  
;                   +------- #5: SREN: Single Receive Enable bit                 
;                    |||||       Asynchronous mode:                              
;                    |||||       Don't care                                      
;                    |||||       Synchronous mode - Master:                      
;                    |||||       1 = Enables single receive                      
;                    |||||      >0 = Disables single receive                     
;                    |||||       This bit is cleared after reception is complete.
;                    |||||       Synchronous mode - Slave                        
;                    |||||       Don't care                                      
;                    +------ #4: CREN: Continuous Receive Enable bit                                                  
;                     ||||       Asynchronous mode:                                                                   
;                     ||||       1 = Enables receiver                                                                              
;                     ||||      >0 = Disables receiver                                                                             
;                     ||||       Synchronous mode:                                                                                 
;                     ||||       1 = Enables continuous receive until enable bit CREN is cleared (CREN overrides SREN)             
;                     ||||       0 = Disables continuous receive                                                                   
;                     +----- #3: ADDEN: Address Detect Enable bit                                                              
;                      |||       Asynchronous mode 9-bit (RX9 = 1):                                                            
;                      |||       1 = Enables address detection, enable interrupt and load the receive buffer when RSR<8> is set
;                      |||      >0 = Disables address detection, all bytes are received and ninth bit can be used as parity bit
;                      |||       Asynchronous mode 8-bit (RX9 = 0):                                                            
;                      |||       Don?t care                                                                                    
;                      +---- #2: FERR: Framing Error bit                                                                 
;                       ||       1 = Framing error (can be updated by reading RCREG register and receive next valid byte)
;                       ||       0 = No framing error                                                                    
;                       +--- #1: OERR: Overrun Error bit                                
;                        |       1 = Overrun error (can be cleared by clearing bit CREN)
;                        |       0 = No overrun error                                   
;                        +-- #0: RX9D: Ninth bit of Received Data
;                                This can be address/data bit or a parity bit and must be calculated by user firmware.
        banksel RC1STA                 ; -> BANK 3
        movwf RC1STA                   ; RC1STA-Reg. konfigurieren

        movlw   B'00011000'
;                 +--------- #7: ABDOVF: Auto-Baud Detect Overflow bit
;                  |||||||       Asynchronous mode:                   
;                  |||||||       1 = Auto-baud timer overflowed       
;                  |||||||       0 = Auto-baud timer did not overflow 
;                  |||||||       Synchronous mode:                    
;                  +-------- #6: RCIDL: Receive Idle Flag bit                                 
;                   ||||||       Asynchronous mode:                                           
;                   ||||||       1 = Receiver is Idle                                         
;                   ||||||       0 = Start bit has been received and the receiver is receiving
;                   ||||||       Synchronous mode:                                            
;                   ||||||       Don't care                                                   
;                   +------- #5: Unimplemented: Read as 0                  
;                    +------ #4: SCKP: Synchronous Clock Polarity Select bit        
;                     ||||       Asynchronous mode:                                 
;                     ||||      >1 = Transmit inverted data to the RB7/TX/CK pin                 
;                     ||||       0 = Transmit non-inverted data to the RB7/TX/CK pin             
;                     ||||       Synchronous mode:                                               
;                     ||||       1 = Data is clocked on rising edge of the clock                 
;                     ||||       0 = Data is clocked on falling edge of the clock   
;                     +----- #3: BRG16: 16-bit Baud Rate Generator bit 
;                      |||      >1 = 16-bit Baud Rate Generator is used
;                      |||       0 = 8-bit Baud Rate Generator is used 
;                      +---- #2: Unimplemented: Read as 0                                                               
;                       +--- #1: WUE: Wake-up Enable bit                                                                                  
;                        |       Asynchronous mode:                                                                                       
;                        |       1 = Receiver is waiting for a falling edge. No character will be received byte RCIF will be set. WUE will
;                        |       automatically clear after RCIF is set.                                                                   
;                        |       0 = Receiver is operating normally                                                                       
;                        |       Synchronous mode:                                                                                        
;                        |       Don?t care                                                                                               
;                        +-- #0: ABDEN: Auto-Baud Detect Enable bit                                      
;                                Asynchronous mode:                                                      
;                                1 = Auto-Baud Detect mode is enabled (clears when auto-baud is complete)
;                                0 = Auto-Baud Detect mode is disabled                                   
;                                Synchronous mode:                                                       
;                                Don't care                                                              
        banksel BAUD1CON                 ; -> BANK 3
        movwf BAUD1CON                   ; BAUD1CON-Reg. konfigurieren


        movlw   d'0'           ; 120 kBaud @ 32 MHz, Tabelle (SYNC = 0, BRGH = 1, BRG16 = 1)
                               ; 8.3 us / Bit = 66.4 us / Byte 
                               ; SP1BRH = (32MHz/(BAUD*4))-1
        banksel SP1BRGH                 ; -> BANK 3
        movwf SP1BRGH

        movlw   d'66'          ; 120 kBaud @ 32 MHz, Tabelle (SYNC = 0, BRGH = 1, BRG16 = 1)
                               ; 8.3 us / Bit = 66.4 us / Byte 
                               ; SP1BRG = (32MHz/(BAUD*4))-1
        banksel SP1BRGL                 ; -> BANK 3
        movwf SP1BRGL

#else ;use_lissy
        banksel TX1STA                ; -> BANK x
        clrf TX1STA                   ; TX1STA-Reg. konfigurieren -> UART abschalten 

        banksel RC1STA                ; -> BANK 3
        clrf RC1STA                   ; RC1STA-Reg. konfigurieren -> UART abschalten 
                                      ; #7: SPEN: Serial Port Enable bit -> 0 = Serial port disabled (held in Reset)
#endif ; use_lissy

; ********************************************************
; **  Konfiguration TRIS                                **
; ********************************************************
        movlw   B'00001100'            ;   #2 #3 Input, Rest ist Output
        banksel TRISA                  ; -> BANK 1
        movwf TRISA                    ; TRISA-Reg. konfigurieren

        movlw   B'11000000';   = wieder OUTPUT (darf fr PWM erst nach der Konfiguration erfolgen)
        banksel TRISC                  ; -> BANK 1
        movwf TRISC                   ; TRISC-Reg. konfigurieren

; ********************************************************
; **  Konfiguration INTERRUPT                           **
; ********************************************************
        movlw   B'00000001'
;                 +--------- #7-6: Unimplemented: Read as '0'.
;                   +------- #5: TMR0IE: TMR0 Overflow Interrupt Enable bi
;                                1 = Enables
;                               >0 = Disables
;                    +------ #4: IOCIE: Interrupt-on-Change Interrupt Enable bit
;                                1 = Enables
;                               >0 = Disables
;                     +----- #3-1: Unimplemented: Read as '0'.
;                        +-- #0: INTE: INT External Interrupt Flag bit
;                              > 1 = Enables
;                                0 = Disables

        banksel PIE0                   ; -> BANK 1
        movwf PIE0

        movlw   B'00000010'
;                    +++++-- bit 4-0 xxxPPS<4:0>: Peripheral xxx Input Selection bits
;                                11xxx = Reserved. Do not use.
;                                10111 = Peripheral input is RC7 (1)
;                                10110 = Peripheral input is RC6 (1)
;                                10101 = Peripheral input is RC5
;                                10100 = Peripheral input is RC4
;                                10011 = Peripheral input is RC3
;                                10010 = Peripheral input is RC2
;                                10001 = Peripheral input is RC1
;                                10000 = Peripheral input is RC0
;                                01111 = Peripheral input is RB7 (1)
;                                01110 = Peripheral input is RB6 (1)
;                                01101 = Peripheral input is RB5 (1)
;                                01100 = Peripheral input is RB4 (1)
;                                0011x = Reserved. Do not use.
;                                00101 = Peripheral input is RA5
;                                00100 = Peripheral input is RA4
;                                00011 = Peripheral input is RA3
;                              > 00010 = Peripheral input is RA2
;                                00001 = Peripheral input is RA1
;                                00000 = Peripheral input is RA0

        banksel INTPPS                   ; -> BANK x
        movwf INTPPS


#ifdef timer1_is_ir ;TMR1 IR verwendet fr PWM
        movlw   B'00000001'
#endif
#ifndef timer1_is_ir ;ohne TMR1 IR
        movlw   B'00000000'
#endif
;                 +--------- #7: TMR1GIE: Timer1 Gate Interrupt Enable bit
;                  |||||||       1 = Enables the Timer1 Gate Acquisition interrupt
;                  |||||||      >0 = Disables the Timer1 Gate Acquisition interrup
;                  +-------- #6: ADIE: A/D Converter (ADC) Interrupt Enable bit
;                   ||||||       1 = Enables the A/D converter interrupt
;                   ||||||      >0 = Disables the A/D converter interrupt
;                   +------- #5: RCIE: USART Receive Interrupt Enable bit
;                    +------ #4: TXIE: USART Transmit Interrupt Enable bit
;                     +----- #3: SSP1IE: Synchronous Serial Port (MSSP) Interrupt Enable bit
;                                1 = Enables the MSSP interrupt
;                               >0 = Disables the MSSP interrupt
;                      +---- #2: BCL1IE: MSSP1 Bus Collision Interrupt Enable bit
;                                1 = Enables the MSSP bus collision interrupt
;                               >0 = Disables the MSSP bus collision interrupt
;                       +--- #1: TMR2IE: TMR2 to PR2 Match Interrupt Enable bit
;                        +-- #0: TMR1IE: TMR1 Overflow Interrupt Enable bit
;                             (>)1 = Enables the TMR1 overflow interrupt
;                               >0 = Disables the TMR1 overflow interrupt

        banksel PIE1                   ; -> BANK 1
        movwf PIE1

        movlw   B'00000000'
;                 +--------- #7: TMR6IE: TMR6 to PR6 Match Interrupt Enable bit
;                  |||||||       1 = Enables the TMR6 to PR6 match interrupt
;                  |||||||      >0 = Disables the TMR6 to PR6 match interrupt
;                  +-------- #6: C2IE: Comparator C2 Interrupt Enable bit
;                   ||||||       1 = Enables the Comparator C2 interrupt
;                   ||||||      >0 = Disables the Comparator C2 interrupt
;                   +------- #5: C1IE: Comparator C1 Interrupt Enable bi
;                                1 = Enables the Comparator C1 interrupt
;                               >0 = Disables the Comparator C1 interrupt
;                    +------ #4: NVMIE: NVM Interrupt Enable Bit
;                                1 = Enables NVM task complete interrupt
;                               >0 = Disables NVM task complete interrupt
;                     +----- #3-2 Unimplemented: Read as '0'.
;                       +--- #1: TMR4IE: TMR4 to PR4 Match Interrupt Enable bit
;                                1 = Enables TMR4 to PR4 match interrupt
;                               >0 = Disables TMR4 to PR4 match interrupt
;                        +-- #0: NCO1IE: NCO Interrupt Enable bitt
;                                1 = Enables NCO rollover interrupt
;                               >0 = Disables NCO rollover interrupt

        banksel PIE2                   ; -> BANK 1
        movwf PIE2

        movlw   B'00000000'
;                 +--------- #7: OSFIE: Oscillator Fail Interrupt Enable bit
;                  |||||||       1 = Enables the Oscillator Fail interrupt
;                  |||||||      >0 = Disables the Oscillator Fail interrupt
;                  +-------- #6: CSWIE: Clock Switch Complete Interrupt Enable bit
;                                1 = Enables clock switch module interrupt
;                               >0 = Disables clock switch module interrupt
;                   +------- #5: TMR3GIE: Timer3 Gate Interrupt Enable bit
;                                1 = Enables
;                               >0 = Disables
;                    +------ #4: TMR3IE: TMR3 Overflow Interrupt Enable bitt
;                                1 = Enables
;                               >0 = Disables
;                     +----- #3: CLC4IE: CLC4 Interrupt Flag bit
;                                1 = Enables
;                               >0 = Disables
;                      +---- #2: CLC3IE: CLC3 Interrupt Flag bit
;                                1 = Enables the CLC3 interrup
;                               >0 = Disables the CLC3 interrup
;                       +--- #1: CLC2IE: CLC2 Interrupt Enable bit
;                                1 = Enables
;                               >0 = Disables
;                        +-- #0: CLC1IE: CLC1 Interrupt Enable bi
;                                1 = Enables
;                               >0 = Disables

        banksel PIE3                   ; -> BANK 1
        movwf PIE3

        movlw   B'00000000'
;                 +--------- #7: CWG2IE: CWG 2 Interrupt Enable bit
;                  |||||||       1 = Enables CWG2 interrupt
;                  |||||||      >0 = Disables CWG2 interrupt
;                  +-------- #6: CWG1IE: CWG 1 Interrupt Enable bi
;                                1 = Enables CWG1 interrupt
;                               >0 = Disables CWG1 interrupt
;                   +------- #5: TMR5GIE: Timer5 Gate Interrupt Enable bit
;                                1 = Enables TMR5 Gate interrupt
;                               >0 = Disables TMR5 Gate interrupt
;                    +------ #4: TMR5IE: TMR5 Overflow Interrupt Enable bit
;                                1 = Enables TMR5 overflow interrupt
;                               >0 = Disables TMR5 overflow interrupt
;                     +----- #3: CCP4IE: CCP4 Interrupt Enable bit
;                                1 = Enables CCP4 interrupt
;                               >0 = Disables CCP4 interrupt
;                      +---- #2: CCP3IE: CCP3 Interrupt Enable bit
;                                1 = Enables CCP3 interrupt
;                               >0 = Disables CCP3 interrupt
;                       +--- #1: CCP2IE: CCP2 Interrupt Enable bit
;                                1 = Enables CCP2 interrupt
;                               >0 = Disables CCP2 interrupt
;                        +-- #0: CCP1IE: CCP1 Interrupt Enable bit
;                                1 = Enables CCP1 interrupt
;                               >0 = Disables CCP1 interrupt

        banksel PIE4                   ; -> BANK 1
        movwf PIE4

        movlw   B'00000000'
;                 +--------- #7: GIE: Global Interrupt Enable bit
;                  |||||||       1 = Enables all un-masked interrupts
;                  |||||||      >0 = Disables all interrupts, enable later
;                  +-------- #6: PEIE: Peripherial Interrupt Enable bit
;                   ||||||       1 = Enables all unmasked peripherial interrupts
;                   ||||||      >0 = Disables all peripherial interrupts
;                   +++++--- #5-1: Unimplemented: Read as '0'
;                        +-- #0: INTEDG:  Interrupt-on-Change Interrupt Flag bit
;                                1 = Interrupt on rising edge of INT pin
;                                0 = Interrupt on falling edge of INT pin

        banksel INTCON                 ; -> BANK 0
        movwf INTCON
        bank_0                         ; -> BANK 0
