#ifndef use16f688
 error "falsches File"
#endif

CONST_RAM equ h'80' 
 
 __config b'11001111001100'          ; Programmer-Configuration
;           ++---------------- #13-#12 Unimplemented: Read as ?1?
;             +--------------- #11 FCMEN: Fail Clock Monitor Enabled bit
;              |||||||||||         1 = Fail-Safe Clock Monitor is enabled
;              |||||||||||        >0 = Fail-Safe Clock Monitor is disabled
;              +-------------- #10 IESO: Internal External Switch Over bit
;               ||||||||||         1 = Internal External Switch Over mode is enabled
;               ||||||||||        >0 = Internal External Switch Over mode is disabledt
;               ++------------ #9-#8 BODEN1:BODEN0: Brown-out Detect Selection bits(1)
;                 ||||||||        >11 = BOD enabled
;                 ||||||||         10 = BOD enabled during operation and disabled in SLEEP
;                 ||||||||         01 = BOD controlled by SBODEN bit (PCON<4>)
;                 ||||||||         00 = BOD disabled
;                 +----------- #7: CPD: Data Code Protection bit(2)
;                  |||||||        >1 = Data memory code protection is disabled
;                  |||||||         0 = Data memory code protection is enabled
;                  +---------- #6: CP: Code Protection bit
;                   ||||||        >1 = Program Memory code protection is disabled
;                   ||||||         0 = Program Memory code protection is enabled
;                   +--------- #5: MCLRE: RA3/MCLR pin function select bit(4)
;                    |||||         1 = RA3/MCLR pin function is MCLR
;                    |||||        >0 = RA3/MCLR pin function is digital input, MCLR internally tied to VDD
;                    +-------- #4: PWRTE: Power-up Timer Enable bitd
;                     ||||         1 = PWRT disabled
;                     ||||        >0 = PWRT enabled
;                     +------- #3: WDTE: Watchdog Timer Enable bit
;                      |||        >1 = WDT enabled
;                      |||         0 = WDT disabled
;                      +++---- #2-#0: FOSC2:FOSC0: Oscillator Selection bits
;                                  111 = RC oscillator: CLKOUT function on RA4/OSC2/CLKOUT pin, RC on RA5/OSC1/CLKIN
;                                  110 = RC oscillator: I/O function on RA4/OSC2/CLKOUT pin, RC on RA5/OSC1/CLKIN
;                                  101 = INTOSC oscillator: CLKOUT function on RA4/OSC2/CLKOUT pin, I/O function on RA5/OSC1/CLKIN
;                                 >100 = INTOSC oscillator: I/O function on RA4/OSC2/CLKOUT pin, I/O function on RA5/OSC1/CLKIN
;                                  011 = EC: I/O function on RA4/OSC2/CLKOUT pin, CLKIN on RA5/OSC1/CLKIN
;                                  010 = HS oscillator: High speed crystal/resonator on RA4/OSC2/CLKOUT and RA5/OSC1/CLKIN
;                                  001 = XT oscillator: Crystal/resonator on RA4/OSC2/CLKOUT and RA5/OSC1/CLKIN
;                                  000 = LP oscillator: Low power crystal on RA4/OSC2/CLKOUT and RA5/OSC1/CLKIN

;                                 >100 = INTOSC oscillator: I/O function on GP4/OSC2/CLKOUT pin,
;                                        I/O function on GP5/OSC1/CLKIN

; ****************************************************************************
; **  Konfiguration CMCON0 COMPARATOR CONFIGURATION REGISTER (ADDRESS: 19h) ** 
;                   CMCON1 COMPARATOR CONFIGURATION REGISTER (ADDRESS: 1Ah) **
; ****************************************************************************
        movlw   B'00000111'
;                 +--------- #7: C2OUT: Comparator 2 Output bit
;                  |||||||       When C2INV = 0:
;                  |||||||       1 = C2 VIN+ > C2 VIN-
;                  |||||||       0 = C2 VIN+ < C2 VINWhen
;                  |||||||       C2INV = 1:
;                  |||||||       1 = C2 VIN+ < C2 VIN-
;                  |||||||       0 = C2 VIN+ > C2
;                  +-------- #6: C1OUT: Comparator 1 Output bit
;                   ||||||       When C1INV = 0:
;                   ||||||       1 = C1 VIN+ > C1 VIN-
;                   ||||||       0 = C1 VIN+ < C1 VINWhen
;                   ||||||       C1INV = 1:
;                   ||||||       1 = C1 VIN+ < C1 VIN-
;                   ||||||       0 = C1 VIN+ > C1 VINbit
;                   +------- #5: C2INV: Comparator 2 Output Inversion bit
;                    |||||       1 = C2 output inverted
;                    |||||       0 = C2 output not inverted
;                    +------- #4: C1INV: Comparator 1 Output Inversion bit
;                     ||||       1 = C1 Output inverted
;                     ||||       0 = C1 Output not inverted
;                     +------ #3: CIS: Comparator Input Switch bit
;                      |||       When CM<2:0> = 010:
;                      |||       1 = C1IN+ connects to C1 VIN-
;                      |||       C2IN+ connects to C2 VIN-
;                      |||       0 = C1IN- connects to C1 VIN-
;                      |||       C2IN- connects to C2 VINWhen
;                      |||       CM<2:0> = 001:
;                      |||       1 = C1IN+ connects to C1 VIN-
;                      |||       0 = C1IN- connects to C1
;                      +++--- #2-0:  CM<2:0>: Comparator Mode bits (See Figure 8-5)
;                                000 = Comparators off. CxIN pins are configured as analog
;                                001 = Three inputs multiplexed to two comparators
;                                010 = Four inputs multiplexed to two comparators
;                                011 = Two common reference comparators
;                                100 = Two independent comparators
;                                101 = One independent comparator
;                                110 = Two common reference comparators with outputs
;                               >111 = Comparators off. CxIN pins are configured as digital I/O

        movwf CMCON0                    ; CMCON0-Reg. konfigurieren

        movlw   B'00000000'
;                 ++++++---- #7-2 : Unimplemented: Read as ?0?
;                       +--- #1: T1GSS: Timer1 Gate Source Select bit(
;                        |        1 = Timer1 gate source is T1G pin (pin should be configured as digital input)
;                        |        0 = Timer1 gate source is Comparator C2 output
;                        +-- #0: C2SYNC: Comparator C2 Output Synchronization bit(
;                                 1 = Output is synchronized with falling edge of Timer1 clock
;                                 0 = Output is asynchronous

        movwf CMCON1                    ; CMCON1-Reg. konfigurieren

; ****************************************************************
; **  Konfiguration PCON: POWER CONTROL REGISTER (ADDRESS: 8Eh) **
; ****************************************************************
        movlw   B'00010000'
;                 ++-------- #7-#6: Unimplemented: Read as ?0?
;                   +------- #5: ULPWUE: Ultra Low Power Wake-up Enable bit
;                    |||||       1 = Ultra Low Power Wake-up enabled
;                    |||||      >0 = Ultra Low Power Wake-up disabled
;                    +------ #4: SBODEN: Software BOD Enable bit(1)
;                     ||||      >1 = BOD enabled 
;                     ||||           (BODEN<1:0> = 01 in Configuration Word for this bit to control the BOD.)
;                     ||||       0 = BOD disabled
;                     ++---- #3-#2: Unimplemented: Read as ?0?
;                       +--- #1: POR: Power-on Reset STATUS bit
;                        |       1 = No Power-on Reset occurred
;                        |      >0 = A Power-on Reset occurred (must be set in software after a Power-on Reset occurs)
;                        +-- #0: BOD: Brown-out Detect STATUS bit
;                                1 = No Brown-out Detect occurred
;                               >0 = A Brown-out Detect occurred 
;                                    (must be set in software after a Brown-out Detect occurs)

        bsf STATUS,RP0                 ; -> BANK 1
        movwf PCON                     ; PCON-Reg. konfigurieren
        bank_0                         ; -> BANK 0

; ************************************************************************
; **  Konfiguration OSCCON: OSCILLATOR CONTROL REGISTER (ADDRESS: 8Fh)  **
; ************************************************************************
        movlw   B'01100000'
;                 +--------- #7: Unimplemented: Read as ?0?
;                  +++------ #6-#4: IRCF<2:0>: Internal Oscillator Frequency Select bits
;                     ||||       000 = 31 kHz
;                     ||||       001 = 125 kHz
;                     ||||       010 = 250 kHz
;                     ||||       011 = 500 kHz
;                     ||||       100 = 1 MHz
;                     ||||       101 = 2 MHz
;                     ||||      >110 = 4 MHz
;                     ||||       111 = 8 MHz
;                     +---  #3 OSTS: Oscillator Start-up Time-out STATUS bit
;                      |||       1 = Device is running from the primary system clock (FOSC<2:0>)
;                      |||       0 = Device is running from the secondary system clock (INTOSC or INTRC)
;                      +---- #2: HTS: INTOSC (High Frequency - 8 MHz to 125 kHz) STATUS bit
;                       ||       1 = INTOSC is stable
;                       ||      >0 = INTOSC is not stable
;                       +--- #1: POR: Power-on Reset STATUS bit
;                        |       1 = INTRC is stable
;                        |      >0 = INTRC is not stable
;                        +-- #0: SCS: Oscillator Mode Select bits
;                                1 = Internal oscillator is used for system clock
;                               >0 = Oscillator mode defined by FOSC<2:0> 

        bsf STATUS,RP0                 ; -> BANK 1
        movwf OSCCON                   ; OSCCON-Reg. konfigurieren
        bank_0                         ; -> BANK 0

; ********************************************************
; **  Konfiguration AD-Ports                            **
; ********************************************************
        movlw   B'00000000'
;                 ++++++++-- #7-#0: ANS3:ANS0: Analog Select bits
;                                (Between analog or digital function on pins AN<7:0>, respectively.)
;                                0 = Digital I/O; pin is assigned to port or special function
;                                1 = Analog input; pin is assigned as analog input (1)
;                                    0 = ANS7: Digital 
;                                    0 = ANS6: Digital
;                                    0 = ANS5: Digital
;                                    0 = ANS4: Digital
;                                    0 = ANS3: Digital
;                                    0 = ANS2: Digital
;                                    0 = ANS1: Digital
;                                    0 = ANS0: Digital

        bsf STATUS,RP0                 ; -> BANK 1
        movwf ANSEL                    ; ANSEL-Register
        nop
        bank_0                         ; -> BANK 0

; ********************************************************
; **  Konfiguration TIMER / WDT / Pull-Ups              **
; ********************************************************
#ifndef dummy
        movlw   B'11001000'
;                 +--------- #7: GPPU: PORTA Pull-up Enable bit
;                  ||||| |      >1 = PORTA pull-ups are disabled
;                  ||||| |       0 = PORTA pull-ups are enabled by individual port latch values
;                  +-------- #6: INTEDG: Interrupt Edge Select bit
;                   |||| |      >1 = Interrupt on rising edge of GP2/INT pin
;                   |||| |       0 = Interrupt on falling edge of GP2/INT pin
;                   +------- #5: T0CS: TMR0 Clock Source Select bit
;                    ||| |       1 = Transition on GP2/T0CKI pin
;                    ||| |      >0 = Internal instruction cycle clock (CLKOUT)
;                    +------ #4: T0SE: TMR0 Source Edge Select bit
;                     || |       1 = Increment on high-to-low transition on GP2/T0CKI pin
;                     || |      >0 = Increment on low-to-high transition on GP2/T0CKI pin
;                     +----- #3: PSA: Prescaler Assignment bit
;                      | |      >1 = Prescaler is assigned to the WDT
;                      | |       0 = Prescaler is assigned to the TIMER0 module
;                      +++-- #2-#0: PS2:PS0: Prescaler Rate Select bits
;                                 Bit |TMR0 Rate|WDT Rate
;                                 ----+---------+--------
;                               > 000 | 1 : 2   | 1 : 1
;                                 001 | 1 : 4   | 1 : 2
;                                 010 | 1 : 8   | 1 : 4
;                                 011 | 1 : 16  | 1 : 8
;                                 100 | 1 : 32  | 1 : 16
;                                 101 | 1 : 64  | 1 : 32
;                                 110 | 1 : 128 | 1 : 64
;                                 111 | 1 : 256 | 1 : 128

        bsf STATUS,RP0                 ; -> BANK 1
        movwf OPTION_REG               ; OPTION-Reg. konfigurieren
        bank_0                         ; -> BANK 0

#ifdef timer1_is_ir ;TMR1 IR verwendet fr PWM -> 00 = 1:1 Prescale Value
        movlw   B'00000001' ; -> 1:1 Prescale Value
#endif

#ifndef timer1_is_ir ;ohne TMR1 IR -> 1:8 Prescale Value
        movlw   B'00110001' ; -> 1:8 Prescale Value
#endif
;                 +--------- #7: Unimplemented: Read as ?0?
;                  +-------- #6: TMR1GE: Timer1 Gate Enable bit
;                   |||| |      >If TMR1ON = 0: This bit is ignored
;                   |||| |       If TMR1ON = 1:
;                   |||| |       1 = Timer1 is on if T1G pin is low
;                   |||| |       0 = Timer1 is on
;                   ++------ #5-#4: T1CKPS1:T1CKPS0: Timer1 Input Clock Prescale Select bits
;                    ||| |      >11 = 1:8 Prescale Value
;                    ||| |       10 = 1:4 Prescale Value
;                    ||| |       01 = 1:2 Prescale Valueue
;                    ||| |       00 = 1:1 Prescale Value
;                     +----- #3: T1OSCEN: LP Oscillator Enable Control bit
;                      | |       If INTOSC without CLKOUT oscillator is active:
;                      | |       1 = LP oscillator is enabled for Timer1 clock
;                      | |      >0 = LP oscillator is off
;                      | |       Else: This bit is ignored
;                      +---- #2: T1SYNC: Timer1 External Clock Input Synchronization Control bit
;                       ||      >if TMR1CS = 0: This bit is ignored. Timer1 uses the internal clock.
;                       +--- #1: TMR1CS: Timer1 Clock Source Select bit
;                        |       1 = External clock from T1OSO/T1CKI pin (on the rising edge)
;                        |      >0 = Internal clock (FOSC/4)
;                        +-- #0: TMR1ON: Timer1 On bit
;                               >1 = Enables Timer1
;                                0 = Stops Timer1

        movwf T1CON                    ; T1CON-Reg. konfigurieren
#endif; dummy

; ********************************************************
; **  Konfiguration USART                               **
; ********************************************************
#ifdef use_lissy
        movlw   B'10100110'
;                 +--------- #7: CSRC: Clock Source Select bit
;                  |||||||       Asynchronous mode:                                   
;                  |||||||       Don?t care                                           
;                  |||||||       Synchronous mode:                                    
;                  |||||||      >1 = Master mode (clock generated internally from BRG)
;                  |||||||       0 = Slave mode (clock from external source)          
;                  +-------- #6: TX9: 9-bit Transmit Enable bit
;                   ||||||       1 = Selects 9-bit transmission
;                   ||||||      >0 = Selects 8-bit transmission
;                   +------- #5: TXEN: Transmit Enable bit(1)
;                    |||||      >1 = Transmit enabled        
;                    |||||       0 = Transmit disabled       
;                    +------ #4: SYNC: EUSART Mode Select bit
;                     ||||       1 = Synchronous mode        
;                     ||||      >0 = Asynchronous mode       
;                     +----- #3: SENDB: Send Break Character bit                                               
;                      |||       Asynchronous mode:                                                            
;                      |||       1 = Send Sync Break on next transmission (cleared by hardware upon completion)
;                      |||      >0 = Sync Break transmission completed                                         
;                      |||       Synchronous mode:                                                             
;                      |||       Don?t care                                                                    
;                      +---- #2: BRGH: High Baud Rate Select bit
;                       ||       Asynchronous mode:             
;                       ||      >1 = High speed                 
;                       ||       0 = Low speed                  
;                       ||       Synchronous mode:              
;                       ||       Unused in this mode            
;                       +--- #1: TRMT: Transmit Shift Register Status bit 
;                        |      >1 = TSR empty                           
;                        |       0 = TSR full                            
;                        +-- #0: TX9D: Ninth bit of Transmit Data
;                                Can be address/data bit or a parity bit.



        movwf TXSTA

        movlw   B'00011000'
;                 +--------- #7: ABDOVF: Auto-Baud Detect Overflow bit
;                  |||||||       Asynchronous mode:                   
;                  |||||||       1 = Auto-baud timer overflowed       
;                  |||||||       0 = Auto-baud timer did not overflow 
;                  |||||||       Synchronous mode:                    
;                  +-------- #6: RCIDL: Receive Idle Flag bit                                 
;                   ||||||       Asynchronous mode:                                           
;                   ||||||       1 = Receiver is Idle                                         
;                   ||||||       0 = Start bit has been received and the receiver is receiving
;                   ||||||       Synchronous mode:                                            
;                   ||||||       Don?t care                                                   
;                   +------- #5: Unimplemented: Read as ?0?                
;                    +------ #4: SCKP: Synchronous Clock Polarity Select bit        
;                     ||||       Asynchronous mode:                                 
;                     ||||      >1 = Transmit inverted data to the RB7/TX/CK pin                 
;                     ||||       0 = Transmit non-inverted data to the RB7/TX/CK pin             
;                     ||||       Synchronous mode:                                               
;                     ||||       1 = Data is clocked on rising edge of the clock                 
;                     ||||       0 = Data is clocked on falling edge of the clock   
;                     +----- #3: BRG16: 16-bit Baud Rate Generator bit 
;                      |||      >1 = 16-bit Baud Rate Generator is used
;                      |||       0 = 8-bit Baud Rate Generator is used 
;                      +---- #2: Unimplemented: Read as ?0?                                                                
;                       +--- #1: WUE: Wake-up Enable bit                                                                                  
;                        |       Asynchronous mode:                                                                                       
;                        |       1 = Receiver is waiting for a falling edge. No character will be received byte RCIF will be set. WUE will
;                        |       automatically clear after RCIF is set.                                                                   
;                        |       0 = Receiver is operating normally                                                                       
;                        |       Synchronous mode:                                                                                        
;                        |       Don?t care                                                                                               
;                        +-- #0: ABDEN: Auto-Baud Detect Enable bit                                      
;                                Asynchronous mode:                                                      
;                                1 = Auto-Baud Detect mode is enabled (clears when auto-baud is complete)
;                                0 = Auto-Baud Detect mode is disabled                                   
;                                Synchronous mode:                                                       
;                                Don?t care                                                              

        movwf BAUDCTL

        movlw   B'10000000'
;                 +--------- #7: SPEN: Serial Port Enable bit
;                  |||||||      >1 = Serial port enabled (configures RX/DT and TX/CK pins as serial port pins)
;                  |||||||       0 = Serial port disabled (held in Reset)                                     
;                  +-------- #6: RX9: 9-bit Receive Enable bit
;                   ||||||       1 = Selects 9-bit reception  
;                   ||||||      >0 = Selects 8-bit reception  
;                   +------- #5: SREN: Single Receive Enable bit                 
;                    |||||       Asynchronous mode:                              
;                    |||||       Don?t care                                      
;                    |||||       Synchronous mode ? Master:                      
;                    |||||       1 = Enables single receive                      
;                    |||||      >0 = Disables single receive                     
;                    |||||       This bit is cleared after reception is complete.
;                    |||||       Synchronous mode ? Slave                        
;                    |||||       Don?t care                                      
;                    +------ #4: CREN: Continuous Receive Enable bit                                                  
;                     ||||       Asynchronous mode:                                                                   
;                     ||||       1 = Enables receiver                                                                              
;                     ||||      >0 = Disables receiver                                                                             
;                     ||||       Synchronous mode:                                                                                 
;                     ||||       1 = Enables continuous receive until enable bit CREN is cleared (CREN overrides SREN)             
;                     ||||       0 = Disables continuous receive                                                                   
;                     +----- #3: ADDEN: Address Detect Enable bit                                                              
;                      |||       Asynchronous mode 9-bit (RX9 = 1):                                                            
;                      |||       1 = Enables address detection, enable interrupt and load the receive buffer when RSR<8> is set
;                      |||      >0 = Disables address detection, all bytes are received and ninth bit can be used as parity bit
;                      |||       Asynchronous mode 8-bit (RX9 = 0):                                                            
;                      |||       Don?t care                                                                                    
;                      +---- #2: FERR: Framing Error bit                                                                 
;                       ||       1 = Framing error (can be updated by reading RCREG register and receive next valid byte)
;                       ||       0 = No framing error                                                                    
;                       +--- #1: OERR: Overrun Error bit                                
;                        |       1 = Overrun error (can be cleared by clearing bit CREN)
;                        |       0 = No overrun error                                   
;                        +-- #0: RX9D: Ninth bit of Received Data
;                                This can be address/data bit or a parity bit and must be calculated by user firmware.
        movwf RCSTA

        movlw   d'7'           ; 120 kBaud @ 4 MHz, Tabelle S.98 (SYNC = 0, BRGH = 1, BRG16 = 1)
                               ; 8.3 us / Bit = 66.4 us / Byte 
                               ; SPBRG = (4MHz/(BAUD*16))-1
        movwf SPBRG
#endif; use_lissy

; ********************************************************
; **  Konfiguration TRIS                                **
; ********************************************************
        clrf PORTA
        clrf PORTC

        banksel TRISA                  ; -> BANK 1
          movlw b'00001100'            ; #2 #3 Input, Rest ist Output
          andwf TRISA,F
          clrf TRISC                   ; PORTC ist Output
        bank_0                         ; -> BANK 0

#ifdef sand_4
        ;PDATA als Input schalten
        bank_TRIS                      ; -> BANK 1
          bsf TRISA,0                  ; set TRIS.Register
        bank_0                         ; -> BANK 0
#endif ; sand_4

#ifdef sand_ei
        ;PDATA, SW3/4 als Input schalten
        bank_TRIS                      ; -> BANK 1
          bsf TRISA,0                  ; set TRIS.Register
          bsf TRISC,3                  ; set TRIS.Register
          bsf TRISC,4                  ; set TRIS.Register
        bank_0                         ; -> BANK 0
#endif ; sand_ei

; ********************************************************
; **  Konfiguration INTERRUPT                           **
; ********************************************************
#ifndef dummy

#ifdef timer1_is_ir ;TMR1 IR verwendet fr PWM
        movlw   B'00000001'
#endif

#ifndef timer1_is_ir ;ohne TMR1 IR
        movlw   B'00000000'
#endif
;                 +--------- #7: EEIE: EE Write Complete Interrupt Enable Bit
;                  |||||||       1 = Enables the EE write complete interrupt
;                  |||||||      >0 = Disables the EE write complete interrupt
;                  +-------- #6: ADIE: A/D Converter Interrupt Enable bit (PIC12F675 only)
;                                1 = Enables the A/D converter interrupt
;                               >0 = Disables the A/D converter interrupt
;                   +------- #5: Unimplemented: Read as ?0?
;                    +------ #4: Unimplemented: Read as ?0?
;                     +----- #3: CMIE: Comparator Interrupt Enable bit
;                                1 = Enables the comparator interrupt
;                               >0 = Disables the comparator interrupt
;                      +---- #2: Unimplemented: Read as ?0?
;                       +--- #1: Unimplemented: Read as ?0?
;                        +-- #0: TMR1IE: TMR1 Overflow Interrupt Enable bit
;                             (>)1 = Enables the TMR1 overflow interrupt
;                               >0 = Disables the TMR1 overflow interrupt

        bsf STATUS,RP0                 ; -> BANK 1
        movwf PIE1                     ; PIE1-Reg. konfigurieren
        bank_0                         ; -> BANK 0

        movlw   B'00010000'
;                 +--------- #7: GIE: Global Interrupt Enable bit
;                  |||||||       1 = Enables all un-masked interrupts
;                  |||||||      >0 = Disables all interrupts, enable later
;                  +-------- #6: PEIE: Peripherial Interrupt Enable bit
;                   ||||||       1 = Enables all unmasked peripherial interrupts
;                   ||||||      >0 = Disables all peripherial interrupts
;                   +------- #5: T0IE: TMR0 Overflow Interrupt Enable bit
;                    |||||       1 = Enables the TMR0 interrupt
;                    |||||      >0 = Disables the TMR0 interrupt
;                    +------ #4: INTE: GP2/INT External Interrupt Enable bit
;                     ||||      >1 = Enables the GP2/INT external interrupt
;                     ||||       0 = Disables the GP2/INT external interrupt
;                     +----- #3: RAIE: PortA Change Interrupt Enable bit
;                      |||       1 = Enables the portA change interrupt
;                      |||      >0 = Disables the portA change interrupt
;                      +---- #2: T0IF: TMR0 overflow interrupt flag bit
;                       ||       1 = TMR0 has overflowed (must be cleared in software)
;                       ||      >0 = TMR0 did not overflow
;                       +--- #1: INTF: GP2/INT External Interrupt Flag bit
;                        |       1 = The GP2/INT external interrupt occurred (must be cleared in software)
;                        |      >0 = The GP2/INT external interrupt did not occur
;                        +-- #0: RAIF: PortA Change Interrupt Flag bit
;                                1 = When at least one of the PORTA pins changed state
;                                    (must be cleared in software)
;                               >0 = None of the PORTA pins have changed state

        movwf INTCON                   ; INTCON-Reg. konfigurieren
#endif; dummy
