; ********************************************************
; ** Version: V3.00 vom 24/07/2006                      **
; ********************************************************
; ** Include-File zu dekoder.asm                        **
; ********************************************************
; ** Sven Brandt                                        **
; ********************************************************
; Copyright (C) 2003/04/05/18 Sven Brandt

; ----- Saving STATUS and W ----------------------
        movwf W_TEMP                   ; Saving W
        swapf STATUS,W                 ; STATUS -> W
        movwf STATUS_TEMP              ; Saving STATUS
        bcf STATUS,RP0                 ; -> BANK 0

; ----- IR IB0-Change (positive/negative Edge) ------------
ir_2    btfsc PORTA,2        
         goto ir_2a

#ifdef test_isr
   bcf PORTA,4
#endif ; test_isr
         
        ; was a falling edge
        bsf STATUS,RP0                 ; -> BANK 1
         bsf OPTION_REG,INTEDG         ; nun rising Edge
        bcf STATUS,RP0                 ; -> BANK 0

        movlw d'255'-d'77'             ; Timer 0 wird mit einer Konst. geladen.
        movwf TMR0                     ; Wenn T > (255-Konst)us ist, ist beim 
                                       ; nchsten IR das TOIF gesetzt.
        clrf R_CNT_TOIF
        goto posret

ir_2a   ; was a rising edge
#ifdef test_isr
   bsf PORTA,4
#endif ; test_isr
        bsf STATUS,RP0                 ; -> BANK 1
         bcf OPTION_REG,INTEDG         ; nun falling Edge
        bcf STATUS,RP0                 ; -> BANK 0

        bsf STATUS,C
        btfsc INTCON,T0IF              ; wenn TOIF, lschen
         bcf STATUS,C                  ; von CARRY

#ifdef test_isr
        bcf PORTA,5
        btfsc STATUS,C ;test
         bsf PORTA,5
#endif ; test_isr

#ifdef test_isr
   bsf PORTA,0
#endif ; test_isr
xxx     rlf R_DEKADR_1,F               ; Carry wird weitergeschoben
        rlf R_DEKADR_2,F               ; Carry wird weitergeschoben
        rlf R_DEKADR_3,F               ; Carry wird weitergeschoben
        rlf R_DEKADR_4,F               ; Carry wird weitergeschoben
        rlf R_DEKADR_5,F               ; Carry wird weitergeschoben
        bsf R_DEKADR_5,5               ; durch den RLF -> Bits 7-5 auf 1

#ifdef test_isr
   bcf PORTA,0
#endif ; test_isr

        movlw b'11111111'
        subwf R_DEKADR_5,W             ; W = R_DEKADR_5 - W
        btfss STATUS,Z                 ; if not the same
         goto posret

        movlw b'11111010'
        subwf R_DEKADR_4,W             ; W = R_DEKADR_4 - W
        btfss STATUS,Z                 ; if not the same
         goto posret

        ; *** all 18 Bits read ***
#ifdef test_isr
   bsf PORTC,3
#endif ; test_isr
        bsf R_FLAG,F_CMD               ; FLAG for valid command
        movf  R_DEKADR_3,W
        movwf R_DEKADR_3_L
        movf  R_DEKADR_2,W
        movwf R_DEKADR_2_L
        movf  R_DEKADR_1,W
        movwf R_DEKADR_1_L
#ifdef test_isr
   bcf PORTC,3
#endif ; test_isr

; ----- Restore STATUS and W ---------------------
posret
        bcf INTCON,INTF                ; clear IR-Flag
        bcf INTCON,T0IF                ; clear IR-Flag
        swapf STATUS_TEMP,W            ; saved STATUS in W
        movwf STATUS                   ; w -> STATUS
        SWAPF W_TEMP,F                 ; W_TEMP -> W, without..
        SWAPF W_TEMP,W                 ; .. changing Z-Flag

        retfie
