; ********************************************************
; ** Version: V3.25 vom 24/02/2000                      **
; ********************************************************
; ** Include-File zu dekoder.asm                        **
; ********************************************************
; ** Sven Brandt                                        **
; ********************************************************
; Copyright (C) 2009 Sven Brandt

;***********************************
;***********************************
;***********************************
;***********************************
;** Routine: statemachine_sand_ei **
;** Blinksmdus                    **
;** needs <    us                 **
;***********************************
;***********************************
;***********************************
;***********************************
statemachine_blinkmuster

        movlw d'10'                    ; Wert d'10' = 20 ms
        subwf TMR1H,W                  ; W = TMR1H - Wert
        btfss STATUS,C                 ; if C=0, -> TMR1H < Wert
         return                        ; ... then return

        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 
                
;***********************************
a01_check_aktiv
        btfss R_STATUS,0               ; Adresse 1 aktiv?
         goto a02_check_aktiv
        ; Muster 01 ist aktiv

        ; check STRETCH-Faktor
        decfsz R_COUNT_STRETCH_01,F    ; wenn Stretch-Counter noch nicht auf ZERO
         goto a02_check_aktiv          ; .. dann nochmal mit den alten Werten (kein Tab-Zugriff)
        movf R_KURVE_STRETCH_01,W      ; Stretch-Wert in den dafr ntigen
        movwf R_COUNT_STRETCH_01       ; .. Counter laden

        ; nchster Tabellen-Wert oder fertig mit der Tabelle?
        incf R_COUNT_01,F
        movf R_KURVE_NUMBER_01,W       ; Wert
        subwf R_COUNT_01,W             ; W = TMR1H - Wert
        btfsc STATUS,C                 ; if C!=0, -> R_COUNT >= R_KURVE_NUMBER
         goto a01_state_finished           ; ... then jump
        
a01_switch_outputs
        ; Tabellenwert lesen
        call TABLE1                   ; get PWM-value from table
        movwf R_OUTVALUE               ; gelesenen Wert bernehmen

a01_out1
        btfss A01_USE_OUT1
         goto a01_out2
        btfss R_OUTVALUE,0
         bcf OUTPUT1
        btfsc R_OUTVALUE,0
         bsf OUTPUT1
a01_out2
        btfss A01_USE_OUT2
         goto a01_out3
        btfss R_OUTVALUE,1
         bcf OUTPUT2
        btfsc R_OUTVALUE,1
         bsf OUTPUT2
a01_out3
        btfss A01_USE_OUT3
         goto a01_out4
        btfss R_OUTVALUE,2
         bcf OUTPUT3
        btfsc R_OUTVALUE,2
         bsf OUTPUT3
a01_out4
        btfss A01_USE_OUT4
         goto a02_check_aktiv
        btfss R_OUTVALUE,3
         bcf OUTPUT4
        btfsc R_OUTVALUE,3
         bsf OUTPUT4
        goto a02_check_aktiv            ; check next adress

a01_state_finished
        clrf R_COUNT_01                 ;
        btfsc A01_KURVE_FLAG_LOOP
         goto a01_switch_outputs        ; start again with table#01

a01_state_switch_off
        bcf R_STATUS,0                  ; damit Re-Start mglich ist

;***********************************
a02_check_aktiv
        btfss R_STATUS,1               ; Adresse 1 aktiv?
         goto a03_check_aktiv
        ; Muster 02 ist aktiv

        ; check STRETCH-Faktor
        decfsz R_COUNT_STRETCH_02,F    ; wenn Stretch-Counter noch nicht auf ZERO
         goto a03_check_aktiv          ; .. dann nochmal mit den alten Werten (kein Tab-Zugriff)
        movf R_KURVE_STRETCH_02,W      ; Stretch-Wert in den dafr ntigen
        movwf R_COUNT_STRETCH_02       ; .. Counter laden

        ; nchster Tabellen-Wert oder fertig mit der Tabelle?
        incf R_COUNT_02,F
        movf R_KURVE_NUMBER_02,W       ; Wert
        subwf R_COUNT_02,W             ; W = TMR1H - Wert
        btfsc STATUS,C                 ; if C!=0, -> R_COUNT >= R_KURVE_NUMBER
         goto a02_state_finished           ; ... then jump
        
a02_switch_outputs
        ; Tabellenwert lesen
        call TABLE2                   ; get PWM-value from table
        movwf R_OUTVALUE               ; gelesenen Wert bernehmen

a02_out1
        btfss A02_USE_OUT1
         goto a02_out2
        btfss R_OUTVALUE,0
         bcf OUTPUT1
        btfsc R_OUTVALUE,0
         bsf OUTPUT1
a02_out2
        btfss A02_USE_OUT2
         goto a02_out3
        btfss R_OUTVALUE,1
         bcf OUTPUT2
        btfsc R_OUTVALUE,1
         bsf OUTPUT2
a02_out3
        btfss A02_USE_OUT3
         goto a02_out4
        btfss R_OUTVALUE,2
         bcf OUTPUT3
        btfsc R_OUTVALUE,2
         bsf OUTPUT3
a02_out4
        btfss A02_USE_OUT4
         goto a03_check_aktiv
        btfss R_OUTVALUE,3
         bcf OUTPUT4
        btfsc R_OUTVALUE,3
         bsf OUTPUT4
        goto a03_check_aktiv            ; check next adress

a02_state_finished
        clrf R_COUNT_02                 ;
        btfsc A02_KURVE_FLAG_LOOP
         goto a02_switch_outputs        ; start again with table#01

a02_state_switch_off
        bcf R_STATUS,1                  ; damit Re-Start mglich ist

;***********************************
a03_check_aktiv
        btfss R_STATUS,2               ; Adresse 1 aktiv?
         goto a04_check_aktiv
        ; Muster 03 ist aktiv

        ; check STRETCH-Faktor
        decfsz R_COUNT_STRETCH_03,F    ; wenn Stretch-Counter noch nicht auf ZERO
         goto a04_check_aktiv          ; .. dann nochmal mit den alten Werten (kein Tab-Zugriff)
        movf R_KURVE_STRETCH_03,W      ; Stretch-Wert in den dafr ntigen
        movwf R_COUNT_STRETCH_03       ; .. Counter laden

        ; nchster Tabellen-Wert oder fertig mit der Tabelle?
        incf R_COUNT_03,F
        movf R_KURVE_NUMBER_03,W       ; Wert
        subwf R_COUNT_03,W             ; W = TMR1H - Wert
        btfsc STATUS,C                 ; if C!=0, -> R_COUNT >= R_KURVE_NUMBER
         goto a03_state_finished           ; ... then jump
        
a03_switch_outputs
        ; Tabellenwert lesen
        call TABLE3                   ; get PWM-value from table
        movwf R_OUTVALUE               ; gelesenen Wert bernehmen

a03_out1
        btfss A03_USE_OUT1
         goto a03_out2
        btfss R_OUTVALUE,0
         bcf OUTPUT1
        btfsc R_OUTVALUE,0
         bsf OUTPUT1
a03_out2
        btfss A03_USE_OUT2
         goto a03_out3
        btfss R_OUTVALUE,1
         bcf OUTPUT2
        btfsc R_OUTVALUE,1
         bsf OUTPUT2
a03_out3
        btfss A03_USE_OUT3
         goto a03_out4
        btfss R_OUTVALUE,2
         bcf OUTPUT3
        btfsc R_OUTVALUE,2
         bsf OUTPUT3
a03_out4
        btfss A03_USE_OUT4
         goto a04_check_aktiv
        btfss R_OUTVALUE,3
         bcf OUTPUT4
        btfsc R_OUTVALUE,3
         bsf OUTPUT4
        goto a04_check_aktiv            ; check next adress

a03_state_finished
        clrf R_COUNT_03                 ;
        btfsc A03_KURVE_FLAG_LOOP
         goto a03_switch_outputs        ; start again with table#01

a03_state_switch_off
        bcf R_STATUS,2                  ; damit Re-Start mglich ist

;***********************************
a04_check_aktiv
        btfss R_STATUS,3               ; Adresse 1 aktiv?
         goto a05_check_aktiv
        ; Muster 04 ist aktiv

        ; check STRETCH-Faktor
        decfsz R_COUNT_STRETCH_04,F    ; wenn Stretch-Counter noch nicht auf ZERO
         goto a05_check_aktiv          ; .. dann nochmal mit den alten Werten (kein Tab-Zugriff)
        movf R_KURVE_STRETCH_04,W      ; Stretch-Wert in den dafr ntigen
        movwf R_COUNT_STRETCH_04       ; .. Counter laden

        ; nchster Tabellen-Wert oder fertig mit der Tabelle?
        incf R_COUNT_04,F
        movf R_KURVE_NUMBER_04,W       ; Wert
        subwf R_COUNT_04,W             ; W = TMR1H - Wert
        btfsc STATUS,C                 ; if C!=0, -> R_COUNT >= R_KURVE_NUMBER
         goto a04_state_finished           ; ... then jump
        
a04_switch_outputs
        ; Tabellenwert lesen
        call TABLE4                   ; get PWM-value from table
        movwf R_OUTVALUE               ; gelesenen Wert bernehmen

a04_out1
        btfss A04_USE_OUT1
         goto a04_out2
        btfss R_OUTVALUE,0
         bcf OUTPUT1
        btfsc R_OUTVALUE,0
         bsf OUTPUT1
a04_out2
        btfss A04_USE_OUT2
         goto a04_out3
        btfss R_OUTVALUE,1
         bcf OUTPUT2
        btfsc R_OUTVALUE,1
         bsf OUTPUT2
a04_out3
        btfss A04_USE_OUT3
         goto a04_out4
        btfss R_OUTVALUE,2
         bcf OUTPUT3
        btfsc R_OUTVALUE,2
         bsf OUTPUT3
a04_out4
        btfss A04_USE_OUT4
         goto a05_check_aktiv
        btfss R_OUTVALUE,3
         bcf OUTPUT4
        btfsc R_OUTVALUE,3
         bsf OUTPUT4
        goto a05_check_aktiv            ; check next adress

a04_state_finished
        clrf R_COUNT_04                 ;
        btfsc A04_KURVE_FLAG_LOOP
         goto a04_switch_outputs        ; start again with table#01

a04_state_switch_off
        bcf R_STATUS,3                  ; damit Re-Start mglich ist

;***********************************
a05_check_aktiv
        return
        
; ********************************************************
; **  Tabelle for Impulse-Width                         **
; ********************************************************
; org 0x0280
TABLE1  movlw b'00000011'           ; load PCLATH with High Adress (Tabelle ab $0300)
        movwf PCLATH
        movf R_COUNT_01,w           ; R_COUNT 
        addlw d'0'                  ; Offset fr Tabelle (Adr. 1)
        movwf PCL

TABLE2  movlw b'00000011'           ; load PCLATH with High Adress (Tabelle ab $0300)
        movwf PCLATH
        movf R_COUNT_02,w           ; R_COUNT 
        addlw d'64'                 ; Offset fr Tabelle (Adr. 2)
        movwf PCL

TABLE3  movlw b'00000011'           ; load PCLATH with High Adress (Tabelle ab $0300)
        movwf PCLATH
        movf R_COUNT_03,w           ; R_COUNT 
        addlw d'128'                ; Offset fr Tabelle (Adr. 3)
        movwf PCL

TABLE4  movlw b'00000011'           ; load PCLATH with High Adress (Tabelle ab $0300)
        movwf PCLATH
        movf R_COUNT_04,w           ; R_COUNT 
        addlw d'192'                ; Offset fr Tabelle (Adr. 4)
        movwf PCL

; ********************************************************
; **  Tabelle for Kurven-Flags                          **
; ********************************************************
KURVE_PARA_1_FLAGS
        movlw b'00000011'              ; load PCLATH with High Adress (Tabelle ab $0300)
        movwf PCLATH
        movlw d'55'                    ; Tabelle Zeile 55 
        movwf PCL
        
KURVE_PARA_2_FLAGS
        movlw b'00000011'              ; load PCLATH with High Adress (Tabelle ab $0300)
        movwf PCLATH
        movlw d'119'                   ; Tabelle Zeile 119 
        movwf PCL

KURVE_PARA_3_FLAGS
        movlw b'00000011'              ; load PCLATH with High Adress (Tabelle ab $0300)
        movwf PCLATH
        movlw d'183'                   ; Tabelle Zeile 183 
        movwf PCL

KURVE_PARA_4_FLAGS
        movlw b'00000011'              ; load PCLATH with High Adress (Tabelle ab $0300)
        movwf PCLATH
        movlw d'247'                   ; Tabelle Zeile 247 
        movwf PCL

; ********************************************************
; **  Tabelle for # of steps                            **
; ********************************************************
KURVE_PARA_1_NUMBER
        movlw b'00000011'             ; load PCLATH with High Adress (Tabelle ab $0300)
        movwf PCLATH
        movlw d'53'                   ; Tabelle Zeile 53
        movwf PCL
        
KURVE_PARA_2_NUMBER
        movlw b'00000011'             ; load PCLATH with High Adress (Tabelle ab $0300)
        movwf PCLATH
        movlw d'117'                  ; Tabelle Zeile 117 
        movwf PCL

KURVE_PARA_3_NUMBER
        movlw b'00000011'             ; load PCLATH with High Adress (Tabelle ab $0300)
        movwf PCLATH
        movlw d'181'                  ; Tabelle Zeile 181 
        movwf PCL

KURVE_PARA_4_NUMBER
        movlw b'00000011'             ; load PCLATH with High Adress (Tabelle ab $0300)
        movwf PCLATH
        movlw d'245'                  ; Tabelle Zeile 245 
        movwf PCL


; ********************************************************
; **  Tabelle for Kurven-Stretchfaktor                  **
; ********************************************************
KURVE_PARA_1_STRETCH
        movlw b'00000011'           ; load PCLATH with High Adress (Tabelle ab $0300)
        movwf PCLATH
        movlw d'54'                 ; Tabelle Zeile 252 
        movwf PCL
        
KURVE_PARA_2_STRETCH
        movlw b'00000011'           ; load PCLATH with High Adress (Tabelle ab $0300)
        movwf PCLATH
        movlw d'118'                 ; Tabelle Zeile 252
        movwf PCL

KURVE_PARA_3_STRETCH
        movlw b'00000011'           ; load PCLATH with High Adress (Tabelle ab $0300)
        movwf PCLATH
        movlw d'182'                 ; Tabelle Zeile 252 
        movwf PCL

KURVE_PARA_4_STRETCH
        movlw b'00000011'           ; load PCLATH with High Adress (Tabelle ab $0300)
        movwf PCLATH
        movlw d'246'                 ; Tabelle Zeile 252 
        movwf PCL

; ********************************************************
; **  Tabelle fuer Adresse 1..4                         **
; ********************************************************
 org 0x0300
; Tabelle:
; ab 0x0300 - 0x033f [Zeilen 0..63] = Adresse 1
  ; d00 - d49 = Kurven-Parameter: #1=Out1 / #1=Out2 / #3=Out3 / #4=out4
  ; d53 = Anzahl Punkte (1..50)
  ; d54 = Stretch Faktor (1..200)
  ; d55 = Flags  #0=loop / #4=use_out1 / #5=use_out2 / #6=use_out3 / #7=use_out4 
; 0x0340 - 0x037f [Zeilen 64..127] = Adresse 1
  ; d64 - d113 = Kurven-Parameter: #1=Out1 / #1=Out2 / #3=Out3 / #4=out4
  ; d117 = Anzahl Punkte (1..50)
  ; d118 = Stretch Faktor (1..200)
  ; d119 = Flags  #0=loop / #4=use_out1 / #5=use_out2 / #6=use_out3 / #7=use_out4 
; 0x0380 - 0x03bf [Zeilen 128..191] = Adresse 1
  ; d128 - d177 = Kurven-Parameter: #1=Out1 / #1=Out2 / #3=Out3 / #4=out4
  ; d181 = Anzahl Punkte (1..50)
  ; d182 = Stretch Faktor (1..200)
  ; d183 = Flags  #0=loop / #4=use_out1 / #5=use_out2 / #6=use_out3 / #7=use_out4 
; 0x03c0 - 0x03ff [Zeilen 192..255] = Adresse 1
  ; d192 - d241 = Kurven-Parameter: #1=Out1 / #1=Out2 / #3=Out3 / #4=out4
  ; d245 = Anzahl Punkte (1..50)
  ; d246 = Stretch Faktor (1..200)
  ; d247 = Flags  #0=loop / #4=use_out1 / #5=use_out2 / #6=use_out3 / #7=use_out4 


; ********************************************************
        ; Kurve Adress 1
; ********************************************************
        retlw d'1'   ; #0
        retlw d'2'   ; #1
        retlw d'3'   ; #2
        retlw d'4'   ; #3
        retlw d'5'   ; #4
        retlw d'6'   ; #5
        retlw d'7'   ; #6
        retlw d'8'   ; #7
        retlw d'9'   ; #8
        retlw d'10'   ; #9
        retlw d'11'   ; #10
        retlw d'12'   ; #11
        retlw d'13'   ; #12
        retlw d'14'   ; #13
        retlw d'15'   ; #14
        retlw d'16'   ; #15
        retlw d'17'   ; #16
        retlw d'18'   ; #17
        retlw d'19'   ; #18
        retlw d'20'   ; #19
        retlw d'21'   ; #20
        retlw d'22'   ; #21
        retlw d'23'   ; #22
        retlw d'24'   ; #23
        retlw d'25'   ; #24
        retlw d'26'   ; #25
        retlw d'27'   ; #26
        retlw d'28'   ; #27
        retlw d'29'   ; #28
        retlw d'30'   ; #29
        retlw d'31'   ; #30
        retlw d'32'   ; #31
        retlw d'33'   ; #32
        retlw d'34'   ; #33
        retlw d'35'   ; #34
        retlw d'36'   ; #35
        retlw d'37'   ; #36
        retlw d'38'   ; #37
        retlw d'39'   ; #38
        retlw d'40'   ; #39
        retlw d'41'   ; #40
        retlw d'42'   ; #41
        retlw d'43'   ; #42
        retlw d'44'   ; #43
        retlw d'45'   ; #44
        retlw d'46'   ; #45
        retlw d'47'   ; #46
        retlw d'48'   ; #47
        retlw d'49'   ; #48
        retlw d'50'   ; #49

        ; END Kurve, following lines not used
        retlw d'65'   ; #50
        retlw d'66'   ; #51
        retlw d'67'   ; #52

        ; following lines are parameter
        retlw d'50'          ; #53 = number of steps
        retlw d'40'          ; #54 = Stretch-Faktor

        retlw b'11110001'   ; #55 = Flags       
            ; #0  ; Loop Kurve                  
            ; #4  ; switch Out 1      
            ; #5  ; switch Out 2      
            ; #6  ; switch Out 3      
            ; #7  ; switch Out 4      
        retlw d'128'   ; #56
        retlw d'128'   ; #57
        retlw d'128'   ; #58
        retlw d'128'   ; #59
        retlw d'128'   ; #60
        retlw d'128'   ; #61
        retlw d'128'   ; #62
        retlw d'255'   ; #63

; ********************************************************
        ; Kurve Adress 2
; ********************************************************
        retlw d'1'   ; #0
        retlw d'2'   ; #1
        retlw d'3'   ; #2
        retlw d'4'   ; #3
        retlw d'5'   ; #4
        retlw d'6'   ; #5
        retlw d'7'   ; #6
        retlw d'8'   ; #7
        retlw d'9'   ; #8
        retlw d'10'   ; #9
        retlw d'11'   ; #10
        retlw d'12'   ; #11
        retlw d'13'   ; #12
        retlw d'14'   ; #13
        retlw d'15'   ; #14
        retlw d'16'   ; #15
        retlw d'17'   ; #16
        retlw d'18'   ; #17
        retlw d'19'   ; #18
        retlw d'20'   ; #19
        retlw d'21'   ; #20
        retlw d'22'   ; #21
        retlw d'23'   ; #22
        retlw d'24'   ; #23
        retlw d'25'   ; #24
        retlw d'26'   ; #25
        retlw d'27'   ; #26
        retlw d'28'   ; #27
        retlw d'29'   ; #28
        retlw d'30'   ; #29
        retlw d'31'   ; #30
        retlw d'32'   ; #31
        retlw d'33'   ; #32
        retlw d'34'   ; #33
        retlw d'35'   ; #34
        retlw d'36'   ; #35
        retlw d'37'   ; #36
        retlw d'38'   ; #37
        retlw d'39'   ; #38
        retlw d'40'   ; #39
        retlw d'41'   ; #40
        retlw d'42'   ; #41
        retlw d'43'   ; #42
        retlw d'44'   ; #43
        retlw d'45'   ; #44
        retlw d'46'   ; #45
        retlw d'47'   ; #46
        retlw d'48'   ; #47
        retlw d'49'   ; #48
        retlw d'50'   ; #49

        ; END Kurve, following lines not used
        retlw d'128'   ; #114
        retlw d'128'   ; #115
        retlw d'128'   ; #116

        ; following lines are parameter
        retlw d'50'          ; #117 = number of steps
        retlw d'30'           ; #118 = Stretch-Faktor

        retlw b'00110000'   ; #119 = Flags       
            ; #0  ; Loop Kurve                  
            ; #4  ; switch Out 1      
            ; #5  ; switch Out 2      
            ; #6  ; switch Out 3      
            ; #7  ; switch Out 4      
        retlw d'128'   ; #120
        retlw d'128'   ; #121
        retlw d'128'   ; #122
        retlw d'128'   ; #123
        retlw d'128'   ; #124
        retlw d'128'   ; #125
        retlw d'128'   ; #126
        retlw d'255'   ; #127

; ********************************************************
        ; Kurve Adress 3
; ********************************************************
        retlw d'1'   ; #0
        retlw d'2'   ; #1
        retlw d'3'   ; #2
        retlw d'4'   ; #3
        retlw d'5'   ; #4
        retlw d'6'   ; #5
        retlw d'7'   ; #6
        retlw d'8'   ; #7
        retlw d'9'   ; #8
        retlw d'10'   ; #9
        retlw d'11'   ; #10
        retlw d'12'   ; #11
        retlw d'13'   ; #12
        retlw d'14'   ; #13
        retlw d'15'   ; #14
        retlw d'16'   ; #15
        retlw d'17'   ; #16
        retlw d'18'   ; #17
        retlw d'19'   ; #18
        retlw d'20'   ; #19
        retlw d'21'   ; #20
        retlw d'22'   ; #21
        retlw d'23'   ; #22
        retlw d'24'   ; #23
        retlw d'25'   ; #24
        retlw d'26'   ; #25
        retlw d'27'   ; #26
        retlw d'28'   ; #27
        retlw d'29'   ; #28
        retlw d'30'   ; #29
        retlw d'31'   ; #30
        retlw d'32'   ; #31
        retlw d'33'   ; #32
        retlw d'34'   ; #33
        retlw d'35'   ; #34
        retlw d'36'   ; #35
        retlw d'37'   ; #36
        retlw d'38'   ; #37
        retlw d'39'   ; #38
        retlw d'40'   ; #39
        retlw d'41'   ; #40
        retlw d'42'   ; #41
        retlw d'43'   ; #42
        retlw d'44'   ; #43
        retlw d'45'   ; #44
        retlw d'46'   ; #45
        retlw d'47'   ; #46
        retlw d'48'   ; #47
        retlw d'49'   ; #48
        retlw d'50'   ; #49

        ; END Kurve, following lines not used
        retlw d'128'   ; #178
        retlw d'128'   ; #179
        retlw d'128'   ; #180

        ; following lines are parameter
        retlw d'50'          ; #181 = number of steps
        retlw d'10'           ; #182 = Stretch-Faktor

        retlw b'11110001'   ; #183 = Flags       
            ; #0  ; Loop Kurve                  
            ; #4  ; switch Out 1      
            ; #5  ; switch Out 2      
            ; #6  ; switch Out 3      
            ; #7  ; switch Out 4      
        retlw d'128'   ; #184
        retlw d'128'   ; #185
        retlw d'128'   ; #186
        retlw d'128'   ; #187
        retlw d'128'   ; #188
        retlw d'128'   ; #189
        retlw d'128'   ; #190
        retlw d'255'   ; #191

; ********************************************************
        ; Kurve Adress 4
; ********************************************************
        retlw d'1'   ; #0
        retlw d'2'   ; #1
        retlw d'3'   ; #2
        retlw d'4'   ; #3
        retlw d'5'   ; #4
        retlw d'6'   ; #5
        retlw d'7'   ; #6
        retlw d'8'   ; #7
        retlw d'9'   ; #8
        retlw d'10'   ; #9
        retlw d'11'   ; #10
        retlw d'12'   ; #11
        retlw d'13'   ; #12
        retlw d'14'   ; #13
        retlw d'15'   ; #14
        retlw d'16'   ; #15
        retlw d'17'   ; #16
        retlw d'18'   ; #17
        retlw d'19'   ; #18
        retlw d'20'   ; #19
        retlw d'21'   ; #20
        retlw d'22'   ; #21
        retlw d'23'   ; #22
        retlw d'24'   ; #23
        retlw d'25'   ; #24
        retlw d'26'   ; #25
        retlw d'27'   ; #26
        retlw d'28'   ; #27
        retlw d'29'   ; #28
        retlw d'30'   ; #29
        retlw d'31'   ; #30
        retlw d'32'   ; #31
        retlw d'33'   ; #32
        retlw d'34'   ; #33
        retlw d'35'   ; #34
        retlw d'36'   ; #35
        retlw d'37'   ; #36
        retlw d'38'   ; #37
        retlw d'39'   ; #38
        retlw d'40'   ; #39
        retlw d'41'   ; #40
        retlw d'42'   ; #41
        retlw d'43'   ; #42
        retlw d'44'   ; #43
        retlw d'45'   ; #44
        retlw d'46'   ; #45
        retlw d'47'   ; #46
        retlw d'48'   ; #47
        retlw d'49'   ; #48
        retlw d'50'   ; #49

        ; END Kurve, following lines not used
        retlw d'128'   ; #242
        retlw d'128'   ; #243
        retlw d'128'   ; #244

        ; following lines are parameter
        retlw d'50'          ; #245 = number of steps
        retlw d'20'           ; #246 = Stretch-Faktor

        retlw b'11110001'   ; #247 = Flags       
            ; #0  ; Loop Kurve                  
            ; #4  ; switch Out 1      
            ; #5  ; switch Out 2      
            ; #6  ; switch Out 3      
            ; #7  ; switch Out 4      
        retlw d'128'   ; #248
        retlw d'128'   ; #249
        retlw d'128'   ; #250
        retlw d'128'   ; #251
        retlw d'128'   ; #252
        retlw d'128'   ; #253
        retlw d'128'   ; #254
 ;      retlw d'255'    ; #255  // Do not use 0x03ff  !! OSCCAL-Location !!
        
