; ********************************************************
; ** Version: V3.08 vom 10/09/2007                      **
; ********************************************************
; ** Include-File zu dekoder.asm                        **
; ********************************************************
; ** Sven Brandt                                        **
; ********************************************************
; Copyright (C) 2003/04/05/06/07 Sven Brandt

; ********************************************************
; History:
; V3.08 - LED-Dekoder_blink: bei NODECODER Fehler beim Weiterschalten behoben
; ********************************************************

;*********************************
;*********************************
;*********************************
;*********************************
;** Routine: statemachine_blink **
;** Blinksmdus                  **
;*********************************
;*********************************
;*********************************
;*********************************

T_FLASH1    equ d'245'        ; (1..255) duration of long off-time for FLASH1
T_BREAK1    equ d'45'         ; (1..255) duration of short off-time for FLASH1
T_FLASH2    equ d'240'        ; (1..255) duration of long off-time for FLASH2
T_BREAK2    equ d'55'         ; (1..255) duration of short off-time for FLASH2
T_FLASH3    equ d'230'        ; (1..255) duration of long off-time for FLASH3
T_BREAK3    equ d'48'         ; (1..255) duration of short off-time for FLASH3
T_FLASH4    equ d'250'        ; (1..255) duration of long off-time for FLASH4
T_BREAK4    equ d'35'         ; (1..255) duration of short off-time for FLASH4
T_FLASH5    equ d'234'        ; (1..255) duration of long off-time for FLASH5
T_BREAK5    equ d'41'         ; (1..255) duration of short off-time for FLASH5
T_FLASH6    equ d'222'        ; (1..255) duration of long off-time for FLASH6
T_BREAK6    equ d'55'         ; (1..255) duration of short off-time for FLASH6
T_FLASH7    equ d'201'        ; (1..255) duration of long off-time for FLASH7
T_BREAK7    equ d'45'         ; (1..255) duration of short off-time for FLASH7
T_FLASH8    equ d'225'        ; (1..255) duration of long off-time for FLASH8
T_BREAK8    equ d'35'         ; (1..255) duration of short off-time for FLASH8
T_FLASH9    equ d'251'        ; (1..255) duration of long off-time for FLASH9
T_BREAK9    equ d'44'         ; (1..255) duration of short off-time for FLASH9
T_FLASH10   equ d'243'        ; (1..255) duration of long off-time for FLASH10
T_BREAK10   equ d'65'         ; (1..255) duration of short off-time for FLASH10
T_FLASHLL   equ d'70'         ; (1..255) speed of "Leitlicht"
T_FLASH     equ d'10'         ; duration of a flash

T_FOTO1     equ d'240'        ; (1..255) duration of long off-time for FLASH1
T_FOTO2     equ d'140'        ; (1..255) duration of long off-time for FLASH1
T_FOTO3     equ d'111'        ; (1..255) duration of long off-time for FLASH1
T_FOTO4     equ d'155'        ; (1..255) duration of long off-time for FLASH1
T_FOTO5     equ d'225'        ; (1..255) duration of long off-time for FLASH1
T_FOTO6     equ d'090'        ; (1..255) duration of long off-time for FLASH1
T_FOTO7     equ d'145'        ; (1..255) duration of long off-time for FLASH1
T_FOTO8     equ d'199'        ; (1..255) duration of long off-time for FLASH1
T_FOTO9     equ d'122'        ; (1..255) duration of long off-time for FLASH1
T_FOTO10    equ d'177'        ; (1..255) duration of long off-time for FLASH1

statemachine_blink
;   -------------------------
;   --- create 3ms-Raster ---
;   -------------------------
#ifndef test
        movf TMR1H,F 
        btfsc STATUS,Z                 ; if TMR1H <> ZERO
         return
        clrf TMR1H                     ; .. then reset to ZERO
#endif

; **********************************************************
; **** Blink-Mode 1 (Einsatz Strobo / Rundum / gemischt)****
; **********************************************************
blinkmode1
        movlw b'00000111'              ; check state
        andwf R_STATUS,W               ; if not this mode
        btfsc STATUS,Z                 ; .. then
         goto blinkmode2               ; .. check next

blink1_1 ; *** FLASH1 LED 1 ***
        movlw b'00000010'              ; check state
        andwf R_STATUS,W               ; if this mode
        btfss STATUS,Z                 ; .. then
        bcf R_FLAG_F1,0                ; .. clear flag for double-flash

        movf R_STATE1,W                ; get counter into W-Register
        sublw T_FLASH1-T_FLASH         ; if T_FLASH is over..
        btfsc STATUS,C                 ;
         bcf PORTA,4                   ; .. LED off

        btfsc R_FLAG_F1,0              ; check for FLAG double-Flash
         goto blink1_1a

        decfsz R_STATE1,F              ; if T_FLASH1 is over..
         goto blink1_2                   
        goto blink1_1b                 ; .. then jump

blink1_1a ; only if double-Flash
        decf R_STATE1,F
        movf R_STATE1,W                ; get counter into W-Register
        sublw T_FLASH1-T_BREAK1        ; if T_BREAK1 is not over..
        btfss STATUS,C                 ;
         goto blink1_2                 ; .. then jump

blink1_1b
        bsf PORTA,4                    ; .. LED on
        movlw T_FLASH1                 ; .. and
        movwf R_STATE1                 ; .. reload coumter
        movf R_FLAG_F1,W               ; Flag fr
        xorlw b'00000001'              ; .. Doppelblitz
        movwf R_FLAG_F1                ; .. invertieren

blink1_2 ; *** FLASH1 LED 2 ***
        movlw b'00000010'              ; check state
        andwf R_STATUS,W               ; if this mode
        btfss STATUS,Z                 ; .. then
        bcf R_FLAG_F1,1                ; .. clear flag for double-flash

        movf R_STATE2,W                ; get counter into W-Register
        sublw T_FLASH2-T_FLASH         ; if T_FLASH is over..
        btfsc STATUS,C                 ;
         bcf PORTA,5                   ; .. LED off

        btfsc R_FLAG_F1,1              ; check for FLAG double-Flash
         goto blink1_2a

        decfsz R_STATE2,F              ; if T_FLASH2 is over..
         goto blink1_3                   
        goto blink1_2b                 ; .. then jump

blink1_2a ; only if double-Flash
        decf R_STATE2,F
        movf R_STATE2,W                ; get counter into W-Register
        sublw T_FLASH2-T_BREAK2        ; if T_BREAK2 is not over..
        btfss STATUS,C                 ;
         goto blink1_3                 ; .. then jump

blink1_2b
        bsf PORTA,5                    ; .. LED on
        movlw T_FLASH2                 ; .. and
        movwf R_STATE2                 ; .. reload coumter
        movf R_FLAG_F1,W               ; Flag fr
        xorlw b'00000010'              ; .. Doppelblitz
        movwf R_FLAG_F1                ; .. invertieren

blink1_3 ; *** FLASH1 LED 3 ***
        movlw b'00000010'              ; check state
        andwf R_STATUS,W               ; if this mode
        btfss STATUS,Z                 ; .. then
        bcf R_FLAG_F1,2                ; .. clear flag for double-flash

        movf R_STATE3,W                ; get counter into W-Register
        sublw T_FLASH3-T_FLASH         ; if T_FLASH is over..
        btfsc STATUS,C                 ;
         bcf PORTA,0                   ; .. LED off

        btfsc R_FLAG_F1,2              ; check for FLAG double-Flash
         goto blink1_3a

        decfsz R_STATE3,F              ; if T_FLASH2 is over..
         goto blink1_4                   
        goto blink1_3b                 ; .. then jump

blink1_3a ; only if double-Flash
        decf R_STATE3,F
        movf R_STATE3,W                ; get counter into W-Register
        sublw T_FLASH3-T_BREAK3        ; if T_BREAK3 is not over..
        btfss STATUS,C                 ;
         goto blink1_4                 ; .. then jump

blink1_3b
        bsf PORTA,0                    ; .. LED on
        movlw T_FLASH3                 ; .. and
        movwf R_STATE3                 ; .. reload coumter
        movf R_FLAG_F1,W               ; Flag fr
        xorlw b'00000100'              ; .. Doppelblitz
        movwf R_FLAG_F1                ; .. invertieren

blink1_4 ; *** FLASH1 LED 4 ***
        movlw b'00000010'              ; check state
        andwf R_STATUS,W               ; if this mode
        btfss STATUS,Z                 ; .. then
        bcf R_FLAG_F1,3                ; .. clear flag for double-flash

        movf R_STATE4,W                ; get counter into W-Register
        sublw T_FLASH4-T_FLASH         ; if T_FLASH is over..
        btfsc STATUS,C                 ;
         bcf PORTA,1                   ; .. LED off

        btfsc R_FLAG_F1,3              ; check for FLAG double-Flash
         goto blink1_4a

        decfsz R_STATE4,F              ; if T_FLASH4 is over..
         goto blink1_5                   
        goto blink1_4b                 ; .. then jump

blink1_4a ; only if double-Flash
        decf R_STATE4,F
        movf R_STATE4,W                ; get counter into W-Register
        sublw T_FLASH4-T_BREAK4        ; if T_BREAK4 is not over..
        btfss STATUS,C                 ;
         goto blink1_5                 ; .. then jump

blink1_4b
        bsf PORTA,1                    ; .. LED on
        movlw T_FLASH4                 ; .. and
        movwf R_STATE4                 ; .. reload coumter
        movf R_FLAG_F1,W               ; Flag fr
        xorlw b'00001000'              ; .. Doppelblitz
        movwf R_FLAG_F1                ; .. invertieren

blink1_5 ; *** FLASH1 LED 5 ***
        movlw b'00000010'              ; check state
        andwf R_STATUS,W               ; if this mode
        btfss STATUS,Z                 ; .. then
        bcf R_FLAG_F1,4                ; .. clear flag for double-flash

        movf R_STATE5,W                ; get counter into W-Register
        sublw T_FLASH5-T_FLASH         ; if T_FLASH is over..
        btfsc STATUS,C                 ;
         bcf PORTC,1                   ; .. LED off

        btfsc R_FLAG_F1,4              ; check for FLAG double-Flash
         goto blink1_5a

        decfsz R_STATE5,F              ; if T_FLASH5 is over..
         goto blink1_6                   
        goto blink1_5b                 ; .. then jump

blink1_5a ; only if double-Flash
        decf R_STATE5,F
        movf R_STATE5,W                ; get counter into W-Register
        sublw T_FLASH5-T_BREAK5        ; if T_BREAK5 is not over..
        btfss STATUS,C                 ;
         goto blink1_6                 ; .. then jump

blink1_5b
        bsf PORTC,1                    ; .. LED on
        movlw T_FLASH5                 ; .. and
        movwf R_STATE5                 ; .. reload coumter
        movf R_FLAG_F1,W               ; Flag fr
        xorlw b'00010000'              ; .. Doppelblitz
        movwf R_FLAG_F1                ; .. invertieren

blink1_6 ; *** FLASH1 LED 6 ***
        movlw b'00000110'              ; check state
        andwf R_STATUS,W               ; if this mode
        btfss STATUS,Z                 ; .. then
        bcf R_FLAG_F1,5                ; .. clear flag for double-flash

        movf R_STATE6,W                ; get counter into W-Register
        sublw T_FLASH6-T_FLASH         ; if T_FLASH is over..
        btfsc STATUS,C                 ;
         bcf PORTC,2                   ; .. LED off

        btfsc R_FLAG_F1,5              ; check for FLAG double-Flash
         goto blink1_6a

        decfsz R_STATE6,F              ; if T_FLASH6 is over..
         goto blink1_7                   
        goto blink1_6b                 ; .. then jump

blink1_6a ; only if double-Flash
        decf R_STATE6,F
        movf R_STATE6,W                ; get counter into W-Register
        sublw T_FLASH6-T_BREAK6        ; if T_BREAK6 is not over..
        btfss STATUS,C                 ;
         goto blink1_7                 ; .. then jump

blink1_6b
        bsf PORTC,2                    ; .. LED on
        movlw T_FLASH6                 ; .. and
        movwf R_STATE6                 ; .. reload coumter
        movf R_FLAG_F1,W               ; Flag fr
        xorlw b'00100000'              ; .. Doppelblitz
        movwf R_FLAG_F1                ; .. invertieren

blink1_7 ; *** FLASH1 LED 7 ***
        movlw b'00000110'              ; check state
        andwf R_STATUS,W               ; if this mode
        btfss STATUS,Z                 ; .. then
        bcf R_FLAG_F1,6                ; .. clear flag for double-flash

        movf R_STATE7,W                ; get counter into W-Register
        sublw T_FLASH7-T_FLASH         ; if T_FLASH is over..
        btfsc STATUS,C                 ;
         bcf PORTC,0                   ; .. LED off

        btfsc R_FLAG_F1,6              ; check for FLAG double-Flash
         goto blink1_7a

        decfsz R_STATE7,F              ; if T_FLASH7 is over..
         goto blink1_8                   
        goto blink1_7b                 ; .. then jump

blink1_7a ; only if double-Flash
        decf R_STATE7,F
        movf R_STATE7,W                ; get counter into W-Register
        sublw T_FLASH7-T_BREAK7        ; if T_BREAK7 is not over..
        btfss STATUS,C                 ;
         goto blink1_8                 ; .. then jump

blink1_7b
        bsf PORTC,0                    ; .. LED on
        movlw T_FLASH7                 ; .. and
        movwf R_STATE7                 ; .. reload coumter
        movf R_FLAG_F1,W               ; Flag fr
        xorlw b'01000000'              ; .. Doppelblitz
        movwf R_FLAG_F1                ; .. invertieren

blink1_8 ; *** FLASH1 LED 8 ***
        movlw b'00000110'              ; check state
        andwf R_STATUS,W               ; if this mode
        btfss STATUS,Z                 ; .. then
        bcf R_FLAG_F1,7                ; .. clear flag for double-flash

        movf R_STATE8,W                ; get counter into W-Register
        sublw T_FLASH8-T_FLASH         ; if T_FLASH is over..
        btfsc STATUS,C                 ;
         bcf PORTC,5                   ; .. LED off

        btfsc R_FLAG_F1,7              ; check for FLAG double-Flash
         goto blink1_8a

        decfsz R_STATE8,F              ; if T_FLASH8 is over..
         goto blink1_9                   
        goto blink1_8b                 ; .. then jump

blink1_8a ; only if double-Flash
        decf R_STATE8,F
        movf R_STATE8,W                ; get counter into W-Register
        sublw T_FLASH8-T_BREAK8        ; if T_BREAK8 is not over..
        btfss STATUS,C                 ;
         goto blink1_9                 ; .. then jump

blink1_8b
        bsf PORTC,5                    ; .. LED on
        movlw T_FLASH8                 ; .. and
        movwf R_STATE8                 ; .. reload coumter
        movf R_FLAG_F1,W               ; Flag fr
        xorlw b'10000000'              ; .. Doppelblitz
        movwf R_FLAG_F1                ; .. invertieren

blink1_9 ; *** FLASH1 LED 9 ***
        movlw b'00000110'              ; check state
        andwf R_STATUS,W               ; if this mode
        btfss STATUS,Z                 ; .. then
        bcf R_FLAG_F2,0                ; .. clear flag for double-flash

        movf R_STATE9,W                ; get counter into W-Register
        sublw T_FLASH9-T_FLASH         ; if T_FLASH is over..
        btfsc STATUS,C                 ;
         bcf PORTC,4                   ; .. LED off

        btfsc R_FLAG_F2,0              ; check for FLAG double-Flash
         goto blink1_9a

        decfsz R_STATE9,F              ; if T_FLASH9 is over..
         goto blink1_10                   
        goto blink1_9b                 ; .. then jump

blink1_9a ; only if double-Flash
        decf R_STATE9,F
        movf R_STATE9,W                ; get counter into W-Register
        sublw T_FLASH9-T_BREAK9        ; if T_BREAK9 is not over..
        btfss STATUS,C                 ;
         goto blink1_10                 ; .. then jump

blink1_9b
        bsf PORTC,4                    ; .. LED on
        movlw T_FLASH9                 ; .. and
        movwf R_STATE9                 ; .. reload coumter
        movf R_FLAG_F2,W               ; Flag fr
        xorlw b'00000001'              ; .. Doppelblitz
        movwf R_FLAG_F2                ; .. invertieren

blink1_10 ; *** FLASH1 LED 10 ***
        movlw b'00000110'              ; check state
        andwf R_STATUS,W               ; if this mode
        btfss STATUS,Z                 ; .. then
        bcf R_FLAG_F2,1                ; .. clear flag for double-flash

        movf R_STATE10,W               ; get counter into W-Register
        sublw T_FLASH10-T_FLASH        ; if T_FLASH is over..
        btfsc STATUS,C                 ;
         bcf PORTC,3                   ; .. LED off

        btfsc R_FLAG_F2,1              ; check for FLAG double-Flash
         goto blink1_10a

        decfsz R_STATE10,F             ; if T_FLASH10 is over..
         goto blink1_11                   
        goto blink1_10b                ; .. then jump

blink1_10a ; only if double-Flash
        decf R_STATE10,F
        movf R_STATE10,W               ; get counter into W-Register
        sublw T_FLASH10-T_BREAK10      ; if T_BREAK10 is not over..
        btfss STATUS,C                 ;
         goto blink1_11                ; .. then jump

blink1_10b
        bsf PORTC,3                    ; .. LED on
        movlw T_FLASH10                ; .. and
        movwf R_STATE10                ; .. reload coumter
        movf R_FLAG_F2,W               ; Flag fr
        xorlw b'00000010'              ; .. Doppelblitz
        movwf R_FLAG_F2                ; .. invertieren

blink1_11 

; **********************************************
; **** Blink-Mode 2 (Laufblitz / Leitlicht )****
; **********************************************
blinkmode2
        movlw b'00011000'              ; check state
        andwf R_STATUS,W               ; if not this mode
        btfsc STATUS,Z                 ; .. then
         goto blinkmode3               ; .. check next

        btfss R_STATUS,3
         goto blink2

        movf R_STATE1,W                ; get counter into W-Register
        sublw T_FLASHLL-T_FLASH        ; if T_FLASH is not over..
        btfss STATUS,C                 ;
         goto blink2                   ; .. then jump
        clrf PORTA                     ; else LEDs off (Laufblitz)
        clrf PORTC                     ; ..

blink2  decfsz R_STATE1,F              ; if Time is not over..
         return                        ; .. then finished

        decf R_COUNT,F                 ; decrement State Counter

        movlw T_FLASHLL                ; .. and
        movwf R_STATE1                 ; .. reload coumter
        
blink2_11
        movlw d'11'                    ;
        subwf R_COUNT,W
        btfss STATUS,Z                 ; if not the same
         goto blink2_10                ; .. then check next
        bsf PORTA,4    
        
blink2_10
        movlw d'10'                    ;
        subwf R_COUNT,W
        btfss STATUS,Z                 ; if not the same
         goto blink2_9                 ; .. then check next
        bsf PORTA,5    

blink2_9
        movlw d'9'                     ;
        subwf R_COUNT,W
        btfss STATUS,Z                 ; if not the same
         goto blink2_8                 ; .. then check next
        bsf PORTA,0    

blink2_8
        movlw d'8'                     ;
        subwf R_COUNT,W
        btfss STATUS,Z                 ; if not the same
         goto blink2_7                 ; .. then check next
        bsf PORTA,1    

blink2_7
        movlw d'7'                     ;
        subwf R_COUNT,W
        btfss STATUS,Z                 ; if not the same
         goto blink2_6                 ; .. then check next
        bsf PORTC,1    

blink2_6
        movlw d'6'                     ;
        subwf R_COUNT,W
        btfss STATUS,Z                 ; if not the same
         goto blink2_5                 ; .. then check next
        bsf PORTC,2    

blink2_5
        movlw d'5'                     ;
        subwf R_COUNT,W
        btfss STATUS,Z                 ; if not the same
         goto blink2_4                 ; .. then check next
        bsf PORTC,0    

blink2_4
        movlw d'4'                     ;
        subwf R_COUNT,W
        btfss STATUS,Z                 ; if not the same
         goto blink2_3                 ; .. then check next
        bsf PORTC,5    

blink2_3
        movlw d'3'                     ;
        subwf R_COUNT,W
        btfss STATUS,Z                 ; if not the same
         goto blink2_2                 ; .. then check next
        bsf PORTC,4    

blink2_2
        movlw d'2'                     ;
        subwf R_COUNT,W
        btfss STATUS,Z                 ; if not the same
         goto blink2_1                 ; .. then check next
        bsf PORTC,3    

blink2_1
        movlw d'1'                     ;
        subwf R_COUNT,W
        btfss STATUS,Z                 ; if not the same
         goto blink2_0                 ; .. then check next

blink2_0
        movlw d'18'                    ; Anzahl der States
        subwf R_COUNT,W                ; W = R_COUNT - W = R_COUNT - 11
        btfss STATUS,C                 ; if C=0, -> R_COUNT < 11
         return                        ; .. then finished

        clrf PORTA
        clrf PORTC

        movlw d'12'                    ; reload
        movwf R_COUNT                  ; .. counter
        return                         ; and finished

; ************************************
; **** Blink-Mode 3 (Warnblinker) ****
; ************************************
blinkmode3

blink3_1
        movlw b'00100000'              ; check state
        andwf R_STATUS,W               ; if not this mode
        btfsc STATUS,Z                 ; .. then
         goto blinkmode4               ; .. check next
 
        decfsz R_STATE1,F              ; if T_FLASH1 is over..
         goto blink3_2                   
        movf PORTA,W
        xorlw b'00010000'              ; .. toggle LED
        movwf PORTA
        movlw T_FLASH1-d'115'           ; .. and
        movwf R_STATE1                 ; .. reload coumter

blink3_2
        decfsz R_STATE2,F              ; if T_FLASH2 is over..
         goto blink3_3                   
        movf PORTA,W
        xorlw b'00100000'              ; .. toggle LED
        movwf PORTA
        movlw T_FLASH2-d'115'           ; .. and
        movwf R_STATE2                 ; .. reload coumter

blink3_3
        decfsz R_STATE3,F              ; if T_FLASH3 is over..
         goto blink3_4                   
        movf PORTA,W
        xorlw b'00000001'              ; .. toggle LED
        movwf PORTA
        movlw T_FLASH3-d'115'           ; .. and
        movwf R_STATE3                 ; .. reload coumter

blink3_4
        decfsz R_STATE4,F              ; if T_FLASH4 is over..
         goto blink3_5                   
        movf PORTA,W
        xorlw b'00000010'              ; .. toggle LED
        movwf PORTA
        movlw T_FLASH4-d'115'           ; .. and
        movwf R_STATE4                 ; .. reload coumter

blink3_5
        decfsz R_STATE5,F              ; if T_FLASH5 is over..
         goto blink3_6                   
        movf PORTC,W
        xorlw b'00000010'              ; .. toggle LED
        movwf PORTC
        movlw T_FLASH5-d'115'           ; .. and
        movwf R_STATE5                 ; .. reload coumter

blink3_6
        decfsz R_STATE6,F              ; if T_FLASH6 is over..
         goto blink3_7                   
        movf PORTC,W
        xorlw b'00000100'              ; .. toggle LED
        movwf PORTC
        movlw T_FLASH6-d'115'           ; .. and
        movwf R_STATE6                 ; .. reload coumter

blink3_7
        decfsz R_STATE7,F              ; if T_FLASH7 is over..
         goto blink3_8                   
        movf PORTC,W
        xorlw b'00000001'              ; .. toggle LED
        movwf PORTC
        movlw T_FLASH7-d'115'           ; .. and
        movwf R_STATE7                 ; .. reload coumter

blink3_8
        decfsz R_STATE8,F              ; if T_FLASH8 is over..
         goto blink3_9                   
        movf PORTC,W
        xorlw b'00100000'              ; .. toggle LED
        movwf PORTC
        movlw T_FLASH8-d'115'           ; .. and
        movwf R_STATE8                 ; .. reload coumter

blink3_9
        decfsz R_STATE9,F              ; if T_FLASH9 is over..
         goto blink3_10                  
        movf PORTC,W
        xorlw b'00010000'              ; .. toggle LED
        movwf PORTC
        movlw T_FLASH9-d'115'           ; .. and
        movwf R_STATE9                 ; .. reload coumter

blink3_10
        decfsz R_STATE10,F             ; if T_FLASH10 is over..
         goto blink3_11                   
        movf PORTC,W
        xorlw b'00001000'              ; .. toggle LED
        movwf PORTC
        movlw T_FLASH10-d'115'          ; .. and
        movwf R_STATE10                ; .. reload coumter

blink3_11

; ************************************
; **** Blink-Mode 4 (Foto) ****
; ************************************
blinkmode4

        movlw b'01000000'              ; check state
        andwf R_STATUS,W               ; if not this mode
        btfsc STATUS,Z                 ; .. then
         goto blinkmode5               ; .. check next
 
blink4_1 ; *** FLASH1 LED 1 ***
        movf R_STATE1,W                ; get counter into W-Register
        sublw T_FOTO1-T_FLASH          ; if T_FLASH is over..
        btfsc STATUS,C                 ;
         bcf PORTA,4                   ; .. LED off

        decfsz R_STATE1,F              ; if T_FLASH1 is over..
         goto blink4_2                   

        bsf PORTA,4                    ; .. LED on
        movlw T_FOTO1                  ; .. and
        movwf R_STATE1                 ; .. reload coumter

        movlw d'33'                    ; Delay counter for automatic switch off
        addwf R_DELAY,F
        btfsc STATUS,C                 ; 
         goto blink4_stop

        movlw d'177'
        addwf R_STATE2,F
        movlw d'250'
        addwf R_STATE3,F
        movlw d'200'
        addwf R_STATE4,F
        movlw d'100'
        addwf R_STATE5,F
        movlw d'150'
        addwf R_STATE6,F
        movlw d'190'
        addwf R_STATE7,F
        movlw d'170'
        addwf R_STATE8,F
        movlw d'154'
        addwf R_STATE9,F
        movlw d'196'
        addwf R_STATE10,F

        goto blink4_2
blink4_stop
        movlw b'10000000'
        movwf R_STATUS                 ; nur 1 STATUS-Flag setzten -> stop
        

blink4_2 ; *** FLASH1 LED 2 ***
        movf R_STATE2,W                ; get counter into W-Register
        sublw T_FOTO2-T_FLASH          ; if T_FLASH is over..
        btfsc STATUS,C                 ;
         bcf PORTA,5                   ; .. LED off

        decfsz R_STATE2,F              ; if T_FLASH1 is over..
         goto blink4_3                   

        bsf PORTA,5                    ; .. LED on
        movlw T_FOTO2                  ; .. and
        movwf R_STATE2                 ; .. reload coumter

blink4_3 ; *** FLASH1 LED 3 ***
        movf R_STATE3,W                ; get counter into W-Register
        sublw T_FOTO3-T_FLASH          ; if T_FLASH is over..
        btfsc STATUS,C                 ;
         bcf PORTA,0                   ; .. LED off

        decfsz R_STATE3,F              ; if T_FLASH1 is over..
         goto blink4_4                   

        bsf PORTA,0                    ; .. LED on
        movlw T_FOTO3                  ; .. and
        movwf R_STATE3                 ; .. reload coumter

blink4_4 ; *** FLASH1 LED 4 ***
        movf R_STATE4,W                ; get counter into W-Register
        sublw T_FOTO4-T_FLASH          ; if T_FLASH is over..
        btfsc STATUS,C                 ;
         bcf PORTA,1                   ; .. LED off

        decfsz R_STATE4,F              ; if T_FLASH1 is over..
         goto blink4_5                   

        bsf PORTA,1                    ; .. LED on
        movlw T_FOTO4                  ; .. and
        movwf R_STATE4                 ; .. reload coumter

blink4_5 ; *** FLASH1 LED 5 ***
        movf R_STATE5,W                ; get counter into W-Register
        sublw T_FOTO5-T_FLASH          ; if T_FLASH is over..
        btfsc STATUS,C                 ;
         bcf PORTC,1                   ; .. LED off

        decfsz R_STATE5,F              ; if T_FLASH1 is over..
         goto blink4_6                   

        bsf PORTC,1                    ; .. LED on
        movlw T_FOTO5                  ; .. and
        movwf R_STATE5                 ; .. reload coumter

blink4_6 ; *** FLASH1 LED 6 ***
        movf R_STATE6,W                ; get counter into W-Register
        sublw T_FOTO6-T_FLASH          ; if T_FLASH is over..
        btfsc STATUS,C                 ;
         bcf PORTC,2                   ; .. LED off

        decfsz R_STATE6,F              ; if T_FLASH1 is over..
         goto blink4_7                   

        bsf PORTC,2                    ; .. LED on
        movlw T_FOTO6                  ; .. and
        movwf R_STATE6                 ; .. reload coumter

blink4_7 ; *** FLASH1 LED 7 ***
        movf R_STATE7,W                ; get counter into W-Register
        sublw T_FOTO7-T_FLASH          ; if T_FLASH is over..
        btfsc STATUS,C                 ;
         bcf PORTC,0                   ; .. LED off

        decfsz R_STATE7,F              ; if T_FLASH1 is over..
         goto blink4_8                   

        bsf PORTC,0                    ; .. LED on
        movlw T_FOTO7                  ; .. and
        movwf R_STATE7                 ; .. reload coumter

blink4_8 ; *** FLASH1 LED 8 ***
        movf R_STATE8,W                ; get counter into W-Register
        sublw T_FOTO8-T_FLASH          ; if T_FLASH is over..
        btfsc STATUS,C                 ;
         bcf PORTC,5                   ; .. LED off

        decfsz R_STATE8,F              ; if T_FLASH1 is over..
         goto blink4_9                   

        bsf PORTC,5                    ; .. LED on
        movlw T_FOTO8                  ; .. and
        movwf R_STATE8                 ; .. reload coumter

blink4_9 ; *** FLASH1 LED 9 ***
        movf R_STATE9,W                ; get counter into W-Register
        sublw T_FOTO9-T_FLASH          ; if T_FLASH is over..
        btfsc STATUS,C                 ;
         bcf PORTC,4                   ; .. LED off

        decfsz R_STATE9,F              ; if T_FLASH1 is over..
         goto blink4_10                  

        bsf PORTC,4                    ; .. LED on
        movlw T_FOTO9                  ; .. and
        movwf R_STATE9                 ; .. reload coumter

blink4_10 ; *** FLASH1 LED 10 ***
        movf R_STATE10,W               ; get counter into W-Register
        sublw T_FOTO10-T_FLASH         ; if T_FLASH is over..
        btfsc STATUS,C                 ;
         bcf PORTC,3                   ; .. LED off

        decfsz R_STATE10,F             ; if T_FLASH1 is over..
         goto blink4_11                  

        bsf PORTC,3                    ; .. LED on
        movlw T_FOTO10                 ; .. and
        movwf R_STATE10                ; .. reload coumter

blink4_11; *** FLASH1 LED 11***

; ************************************
; **** Blink-Mode 5 (Off) ****
; ************************************
blinkmode5
        movlw b'10000000'              ; check state
        andwf R_STATUS,W               ; if not this mode
        btfsc STATUS,Z                 ; .. then
         goto blinkmode6               ; .. check next

        clrf PORTA
        clrf PORTC
        
        clrf R_DELAY

; **** Blink-Mode 5 ****
blinkmode6
        return                         ; .. then return
