; ********************************************************
; ** Version: V3.25 vom 24/02/2000                      **
; ********************************************************
; ** Include-File zu dekoder.asm                        **
; ********************************************************
; ** Sven Brandt                                        **
; ********************************************************
; Copyright (C) 2009-2014 Sven Brandt

; History:
; V3.61 - 04.05.2014 Warteschleife nach LOOP Durchgang fr Kurve 1 ermglicht, Wert aus Zeile 105 (KurvenParameter)
; V3.60 - 06.03.2014 2. Verzgerung (R_KURVE_STRETCH_0ca / R_COUNT_STRETCH_0xa) hinzu

;***********************************
;***********************************
;***********************************
;***********************************
;** Routine: statemachine_sand_ei **
;** Blinksmdus                    **
;** needs <    us                 **
;***********************************
;***********************************
;***********************************
;***********************************
 org 0x0708
statemachine_led_blinkmuster

  ; test-Routinen, ab hier Auslsung durch Watch-List
   clrf R_OUTVALUE
   btfsc R_OUTVALUE,7
    call gruen_1
   btfsc R_OUTVALUE,6
    call gruen_2
   btfsc R_OUTVALUE,5
    call gruen_3
   btfsc R_OUTVALUE,4
    call gruen_4
  ; ENDE Test-Routine, gesetzte BITs werden sowieso gelscht..

        movlw d'10'                    ; Wert d'10' = 20 ms
        subwf TMR1H,W                  ; W = TMR1H - Wert
        btfss STATUS,C                 ; if C=0, -> TMR1H < Wert
         return                        ; ... then return

        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 
                
;***********************************
a01_check_aktiv
        btfss R_STATUS,0               ; Adresse 1 aktiv?
         goto a02_check_aktiv
        ; Muster 01 ist aktiv

        ; check STRETCH-Faktor
        decfsz R_COUNT_STRETCH_01,F    ; wenn Stretch-Counter noch nicht auf ZERO
         goto a02_check_aktiv          ; .. dann nochmal mit den alten Werten (kein Tab-Zugriff)

        ; check STRETCH-Faktor2
        decfsz R_COUNT_STRETCH_01a,F   ; wenn Stretch-Counter A noch nicht auf ZERO
         goto a02_check_aktiv          ; .. dann nochmal mit den alten Werten (kein Tab-Zugriff)
        movf R_KURVE_STRETCH_01,W      ; Stretch-Wert in den dafr ntigen
        movwf R_COUNT_STRETCH_01       ; .. Counter laden
        movf R_KURVE_STRETCH_01a,W     ; Stretch-Wert A in den dafr ntigen
        movwf R_COUNT_STRETCH_01a      ; .. Counter laden

        ; nchster Tabellen-Wert oder fertig mit der Tabelle?
        incf R_COUNT_01,F
        movf R_KURVE_NUMBER_01,W       ; Wert
        subwf R_COUNT_01,W             ; W = TMR1H - Wert
        btfsc STATUS,C                 ; if C!=0, -> R_COUNT >= R_KURVE_NUMBER
         goto a01_state_finished           ; ... then jump
        
a01_switch_outputs
        ; Counter in Transfer-Register umladen
        movf R_COUNT_01,w              ; access this line
        movwf R_TABLEREAD              ; .. in the table
        ; Tabellenwert lesen
        call TABLE_READ1               ; get PWM-value from table1
        movwf R_OUTVALUE               ; gelesenen Wert bernehmen
        ; Part 2 lesen: Counter in Transfer-Register umladen
        movf R_COUNT_01,w              ; access this line
        movwf R_TABLEREAD              ; .. in the table
        ; Tabellenwert 2 lesen
        call TABLE_READ2               ; get PWM-value from table5
        movwf R_OUTVALUE2              ; gelesenen Wert bernehmen

        ; Transfer-Register laden
        movf R_KURVE_FLAGS1_01,w
        movwf R_KURVE_FLAGS1_xx
        movf R_KURVE_FLAGS2_01,w
        movwf R_KURVE_FLAGS2_xx

        ; Outputs schalten
        call switch_outputs
        goto a02_check_aktiv            ; check next adress

a01_state_finished
        decfsz R_COUNT_WAIT_01,F       ; wenn Wait-Counter 1 noch nicht auf ZERO
         goto a02_check_aktiv          ; .. dann nochmal mit den alten Werten (kein Tab-Zugriff)
        movf R_KURVE_WAIT_01,W         ; Wait-Wert in den dafr ntigen
        movwf R_COUNT_WAIT_01          ; .. Counter laden

        clrf R_COUNT_01                 ;
        btfsc A01_KURVE_FLAG_LOOP
         goto a01_switch_outputs        ; start again with table#01

a01_state_switch_off
        bcf R_STATUS,0                  ; damit Re-Start mglich ist

;***********************************
a02_check_aktiv
        btfss R_STATUS,1               ; Adresse 1 aktiv?
         goto a03_check_aktiv
        ; Muster 02 ist aktiv

        ; check STRETCH-Faktor
        decfsz R_COUNT_STRETCH_02,F    ; wenn Stretch-Counter noch nicht auf ZERO
         goto a03_check_aktiv          ; .. dann nochmal mit den alten Werten (kein Tab-Zugriff)

        ; check STRETCH-Faktor2
        decfsz R_COUNT_STRETCH_02a,F   ; wenn Stretch-Counter A noch nicht auf ZERO
         goto a03_check_aktiv          ; .. dann nochmal mit den alten Werten (kein Tab-Zugriff)
        movf R_KURVE_STRETCH_02,W      ; Stretch-Wert in den dafr ntigen
        movwf R_COUNT_STRETCH_02       ; .. Counter laden
        movf R_KURVE_STRETCH_02a,W     ; Stretch-Wert A in den dafr ntigen
        movwf R_COUNT_STRETCH_02a      ; .. Counter laden

        ; nchster Tabellen-Wert oder fertig mit der Tabelle?
        incf R_COUNT_02,F
        movf R_KURVE_NUMBER_02,W       ; Wert
        subwf R_COUNT_02,W             ; W = TMR1H - Wert
        btfsc STATUS,C                 ; if C!=0, -> R_COUNT >= R_KURVE_NUMBER
         goto a02_state_finished           ; ... then jump
        
a02_switch_outputs
        ; Counter in Transfer-Register umladen
        movf R_COUNT_02,w              ; access this line
        movwf R_TABLEREAD              ; .. in the table
        ; Tabellenwert lesen
        call TABLE_READ3               ; get PWM-value from table1
        movwf R_OUTVALUE               ; gelesenen Wert bernehmen
        ; Part 2 lesen: Counter in Transfer-Register umladen
        movf R_COUNT_02,w              ; access this line
        movwf R_TABLEREAD              ; .. in the table
        ; Tabellenwert 2 lesen
        call TABLE_READ4               ; get PWM-value from table1
        movwf R_OUTVALUE2              ; gelesenen Wert bernehmen

        ; Transfer-Register laden
        movf R_KURVE_FLAGS1_02,w
        movwf R_KURVE_FLAGS1_xx
        movf R_KURVE_FLAGS2_02,w
        movwf R_KURVE_FLAGS2_xx

        ; Outputs schalten
        call switch_outputs
        goto a03_check_aktiv            ; check next adress

a02_state_finished
        clrf R_COUNT_02                 ;
        btfsc A02_KURVE_FLAG_LOOP
         goto a02_switch_outputs        ; start again with table#01

a02_state_switch_off
        bcf R_STATUS,1                  ; damit Re-Start mglich ist

;***********************************
a03_check_aktiv
        btfss R_STATUS,2               ; Adresse 1 aktiv?
         goto a04_check_aktiv
        ; Muster 03 ist aktiv

        ; check STRETCH-Faktor
        decfsz R_COUNT_STRETCH_03,F    ; wenn Stretch-Counter noch nicht auf ZERO
         goto a04_check_aktiv          ; .. dann nochmal mit den alten Werten (kein Tab-Zugriff)

        ; check STRETCH-Faktor2
        decfsz R_COUNT_STRETCH_03a,F   ; wenn Stretch-Counter A noch nicht auf ZERO
         goto a04_check_aktiv          ; .. dann nochmal mit den alten Werten (kein Tab-Zugriff)
        movf R_KURVE_STRETCH_03,W      ; Stretch-Wert in den dafr ntigen
        movwf R_COUNT_STRETCH_03       ; .. Counter laden
        movf R_KURVE_STRETCH_03a,W     ; Stretch-Wert A in den dafr ntigen
        movwf R_COUNT_STRETCH_03a      ; .. Counter laden

        ; nchster Tabellen-Wert oder fertig mit der Tabelle?
        incf R_COUNT_03,F
        movf R_KURVE_NUMBER_03,W       ; Wert
        subwf R_COUNT_03,W             ; W = TMR1H - Wert
        btfsc STATUS,C                 ; if C!=0, -> R_COUNT >= R_KURVE_NUMBER
         goto a03_state_finished           ; ... then jump
        
a03_switch_outputs
        ; Counter in Transfer-Register umladen
        movf R_COUNT_03,w              ; access this line
        movwf R_TABLEREAD              ; .. in the table
        ; Tabellenwert lesen
        call TABLE_READ5               ; get PWM-value from table1
        movwf R_OUTVALUE               ; gelesenen Wert bernehmen
        ; Part 2 lesen: Counter in Transfer-Register umladen
        movf R_COUNT_03,w              ; access this line
        movwf R_TABLEREAD              ; .. in the table
        ; Tabellenwert 2 lesen
        call TABLE_READ6               ; get PWM-value from table1
        movwf R_OUTVALUE2              ; gelesenen Wert bernehmen

        ; Transfer-Register laden
        movf R_KURVE_FLAGS1_03,w
        movwf R_KURVE_FLAGS1_xx
        movf R_KURVE_FLAGS2_03,w
        movwf R_KURVE_FLAGS2_xx

        ; Outputs schalten
        call switch_outputs
        goto a04_check_aktiv            ; check next adress

a03_state_finished
        clrf R_COUNT_03                 ;
        btfsc A03_KURVE_FLAG_LOOP
         goto a03_switch_outputs        ; start again with table#01

a03_state_switch_off
        bcf R_STATUS,2                  ; damit Re-Start mglich ist

;***********************************
a04_check_aktiv
        btfss R_STATUS,3               ; Adresse 1 aktiv?
         goto a05_check_aktiv
        ; Muster 04 ist aktiv

        ; check STRETCH-Faktor
        decfsz R_COUNT_STRETCH_04,F    ; wenn Stretch-Counter noch nicht auf ZERO
         goto a05_check_aktiv          ; .. dann nochmal mit den alten Werten (kein Tab-Zugriff)

        ; check STRETCH-Faktor2
        decfsz R_COUNT_STRETCH_04a,F   ; wenn Stretch-Counter A noch nicht auf ZERO
         goto a05_check_aktiv          ; .. dann nochmal mit den alten Werten (kein Tab-Zugriff)
        movf R_KURVE_STRETCH_04,W      ; Stretch-Wert in den dafr ntigen
        movwf R_COUNT_STRETCH_04       ; .. Counter laden
        movf R_KURVE_STRETCH_04a,W     ; Stretch-Wert A in den dafr ntigen
        movwf R_COUNT_STRETCH_04a      ; .. Counter laden

        ; nchster Tabellen-Wert oder fertig mit der Tabelle?
        incf R_COUNT_04,F
        movf R_KURVE_NUMBER_04,W       ; Wert
        subwf R_COUNT_04,W             ; W = TMR1H - Wert
        btfsc STATUS,C                 ; if C!=0, -> R_COUNT >= R_KURVE_NUMBER
         goto a04_state_finished           ; ... then jump
        
a04_switch_outputs
        ; Counter in Transfer-Register umladen
        movf R_COUNT_04,w              ; access this line
        movwf R_TABLEREAD              ; .. in the table
        ; Tabellenwert lesen
        call TABLE_READ7               ; get PWM-value from table1
        movwf R_OUTVALUE               ; gelesenen Wert bernehmen
        ; Part 2 lesen: Counter in Transfer-Register umladen
        movf R_COUNT_04,w              ; access this line
        movwf R_TABLEREAD              ; .. in the table
        ; Tabellenwert 2 lesen
        call TABLE_READ8               ; get PWM-value from table1
        movwf R_OUTVALUE2              ; gelesenen Wert bernehmen

        ; Transfer-Register laden
        movf R_KURVE_FLAGS1_04,w
        movwf R_KURVE_FLAGS1_xx
        movf R_KURVE_FLAGS2_04,w
        movwf R_KURVE_FLAGS2_xx

        ; Outputs schalten
        call switch_outputs
        goto a05_check_aktiv            ; check next adress

a04_state_finished
        clrf R_COUNT_04                 ;
        btfsc A04_KURVE_FLAG_LOOP
         goto a04_switch_outputs        ; start again with table#01

a04_state_switch_off
        bcf R_STATUS,3                  ; damit Re-Start mglich ist

;***********************************
a05_check_aktiv
        return
        

; ********************************************************
; **  Switch-Outputs                                    **
; ********************************************************
 org 0x0290
; diese Routine schaltet die Outputs gemass der Transfer-Register
; - R_KURVE_FLAGS1_xx / R_KURVE_FLAGS2_xx (definiert, welche Ausgnge geschaltet werden sollen)
; - R_OUTVALUE / R_OUTVALUE2 (definiert, on ON oder OFF)
switch_outputs
switch_out1
        btfss Axx_USE_OUT1
         goto switch_out2
        btfss R_OUTVALUE,0
         bcf LED_01
        btfsc R_OUTVALUE,0
         bsf LED_01
switch_out2
        btfss Axx_USE_OUT2
         goto switch_out3
        btfss R_OUTVALUE,1
         bcf LED_02
        btfsc R_OUTVALUE,1
         bsf LED_02
switch_out3
        btfss Axx_USE_OUT3
         goto switch_out4
        btfss R_OUTVALUE,2
         bcf LED_03
        btfsc R_OUTVALUE,2
         bsf LED_03
switch_out4
        btfss Axx_USE_OUT4
         goto switch_out5
        btfss R_OUTVALUE,3
         bcf LED_04
        btfsc R_OUTVALUE,3
         bsf LED_04
switch_out5
        btfss Axx_USE_OUT5
         goto switch_out6
        btfss R_OUTVALUE2,0
         bcf LED_05
        btfsc R_OUTVALUE2,0
         bsf LED_05
switch_out6
        btfss Axx_USE_OUT6
         goto switch_out7
        btfss R_OUTVALUE2,1
         bcf LED_06
        btfsc R_OUTVALUE2,1
         bsf LED_06
switch_out7
        btfss Axx_USE_OUT7
         goto switch_out8
        btfss R_OUTVALUE2,2
         bcf LED_07
        btfsc R_OUTVALUE2,2
         bsf LED_07
switch_out8
        btfss Axx_USE_OUT8
         goto switch_out9
        btfss R_OUTVALUE2,3
         bcf LED_08
        btfsc R_OUTVALUE2,3
         bsf LED_08
switch_out9
        btfss Axx_USE_OUT9
         goto switch_out10
        btfss R_OUTVALUE2,4
         bcf LED_09
        btfsc R_OUTVALUE2,4
         bsf LED_09
switch_out10
        btfss Axx_USE_OUT10
         goto switch_out11
        btfss R_OUTVALUE2,5
         bcf LED_10
        btfsc R_OUTVALUE2,5
         bsf LED_10
switch_out11
        return

; ********************************************************
; **  Tabellen-Zugriff                                  **
; ********************************************************
TABLE_READ1
        movlw b'00000011'           ; load PCLATH with High Adress (Tabelle ab $0300)
        movwf PCLATH
        bcf R_TABLEREAD,7           ; unterer Adress-Bereich (bis $0580)
        movf R_TABLEREAD,W          ; Tabelle Zeile R_'TABLEREAD' 
        movwf PCL
        
TABLE_READ2
        movlw b'00000011'           ; load PCLATH with High Adress (Tabelle ab $0300)
        movwf PCLATH
        bsf R_TABLEREAD,7           ; Oberer ADress-Bereich (ab $0580)
        movf R_TABLEREAD,W          ; Tabelle Zeile R_'TABLEREAD' 
        movwf PCL

TABLE_READ3
        movlw b'00000100'           ; load PCLATH with High Adress (Tabelle ab $0400)
        movwf PCLATH
        bcf R_TABLEREAD,7           ; unterer Adress-Bereich (bis $0680)
        movf R_TABLEREAD,W          ; Tabelle Zeile R_'TABLEREAD' 
        movwf PCL

TABLE_READ4
        movlw b'00000100'           ; load PCLATH with High Adress (Tabelle ab $0400)
        movwf PCLATH
        bsf R_TABLEREAD,7           ; Oberer ADress-Bereich (ab $0680)
        movf R_TABLEREAD,W          ; Tabelle Zeile R_'TABLEREAD' 
        movwf PCL

TABLE_READ5
        movlw b'00000101'           ; load PCLATH with High Adress (Tabelle ab $0500)
        movwf PCLATH
        bcf R_TABLEREAD,7           ; unterer Adress-Bereich (bis $0580)
        movf R_TABLEREAD,W          ; Tabelle Zeile R_'TABLEREAD' 
        movwf PCL
        
TABLE_READ6
        movlw b'00000101'           ; load PCLATH with High Adress (Tabelle ab $0500)
        movwf PCLATH
        bsf R_TABLEREAD,7           ; Oberer ADress-Bereich (ab $0580)
        movf R_TABLEREAD,W          ; Tabelle Zeile R_'TABLEREAD' 
        movwf PCL

TABLE_READ7
        movlw b'00000110'           ; load PCLATH with High Adress (Tabelle ab $0600)
        movwf PCLATH
        bcf R_TABLEREAD,7           ; unterer Adress-Bereich (bis $0680)
        movf R_TABLEREAD,W          ; Tabelle Zeile R_'TABLEREAD' 
        movwf PCL

TABLE_READ8
        movlw b'00000110'           ; load PCLATH with High Adress (Tabelle ab $0600)
        movwf PCLATH
        bsf R_TABLEREAD,7           ; Oberer ADress-Bereich (ab $0680)
        movf R_TABLEREAD,W          ; Tabelle Zeile R_'TABLEREAD' 
        movwf PCL


; ********************************************************
; **  Tabelle fuer Adresse 1..4                         **
; ********************************************************
 org 0x0300
; ********************************************************
        ; Kurve Adress 1
; ********************************************************
        retlw d'0'   ; #0
        retlw d'1'   ; #1
        retlw d'2'   ; #2
        retlw d'3'   ; #3
        retlw d'4'   ; #4
        retlw d'5'   ; #5
        retlw d'6'   ; #6
        retlw d'7'   ; #7
        retlw d'8'   ; #8
        retlw d'9'   ; #9
        retlw d'10'   ; #10
        retlw d'11'   ; #11
        retlw d'12'   ; #12
        retlw d'13'   ; #13
        retlw d'14'   ; #14
        retlw d'15'   ; #15
        retlw d'16'   ; #16
        retlw d'17'   ; #17
        retlw d'18'   ; #18
        retlw d'19'   ; #19
        retlw d'20'   ; #20
        retlw d'21'   ; #21
        retlw d'22'   ; #22
        retlw d'23'   ; #23
        retlw d'24'   ; #24
        retlw d'25'   ; #25
        retlw d'26'   ; #26
        retlw d'27'   ; #27
        retlw d'28'   ; #28
        retlw d'29'   ; #29
        retlw d'30'   ; #30
        retlw d'31'   ; #31
        retlw d'32'   ; #32
        retlw d'33'   ; #33
        retlw d'34'   ; #34
        retlw d'35'   ; #35
        retlw d'36'   ; #36
        retlw d'37'   ; #37
        retlw d'38'   ; #38
        retlw d'39'   ; #39
        retlw d'40'   ; #40
        retlw d'41'   ; #41
        retlw d'42'   ; #42
        retlw d'43'   ; #43
        retlw d'44'   ; #44
        retlw d'45'   ; #45
        retlw d'46'   ; #46
        retlw d'47'   ; #47
        retlw d'48'   ; #48
        retlw d'49'   ; #49
        retlw d'50'   ; #50
        retlw d'51'   ; #51
        retlw d'52'   ; #52
        retlw d'53'   ; #53
        retlw d'54'   ; #54
        retlw d'55'   ; #55
        retlw d'56'   ; #56
        retlw d'57'   ; #57
        retlw d'58'   ; #58
        retlw d'59'   ; #59
        retlw d'60'   ; #60
        retlw d'61'   ; #61
        retlw d'62'   ; #62
        retlw d'63'   ; #63
        retlw d'64'   ; #64
        retlw d'65'   ; #65
        retlw d'66'   ; #66
        retlw d'67'   ; #67
        retlw d'68'   ; #68
        retlw d'69'   ; #69
        retlw d'70'   ; #70
        retlw d'71'   ; #71
        retlw d'72'   ; #72
        retlw d'73'   ; #73
        retlw d'74'   ; #74
        retlw d'75'   ; #75
        retlw d'76'   ; #76
        retlw d'77'   ; #77
        retlw d'78'   ; #78
        retlw d'79'   ; #79
        retlw d'80'   ; #80
        retlw d'81'   ; #81
        retlw d'82'   ; #82
        retlw d'83'   ; #83
        retlw d'84'   ; #84
        retlw d'85'   ; #85
        retlw d'86'   ; #86
        retlw d'87'   ; #87
        retlw d'88'   ; #88
        retlw d'89'   ; #89
        retlw d'90'   ; #90
        retlw d'91'   ; #91
        retlw d'92'   ; #92
        retlw d'93'   ; #93
        retlw d'94'   ; #94
        retlw d'95'   ; #95
        retlw d'96'   ; #96
        retlw d'97'   ; #97
        retlw d'98'   ; #98
        retlw d'99'   ; #99
        ; --------------- Kurve 1 Part 1 Ende ----------------

        ; Curve Flags $100
        retlw b'11110001'   ; #100 = Flags       
            ; #0  ; Loop Kurve                  
            ; #4  ; switch Out 1      
            ; #5  ; switch Out 2      
            ; #6  ; switch Out 3      
            ; #7  ; switch Out 4      

        ; Curve Parameter $101
        retlw d'100'         ; #101 = number of steps
        retlw d'30'          ; #102 = Stretch-Faktor

        ; Curve Flags 2 $103
        retlw b'00111111'    ; #103 = Flags 2      
            ; #0  ; switch Out 5      
            ; #1  ; switch Out 6      
            ; #2  ; switch Out 7      
            ; #3  ; switch Out 8      
            ; #4  ; switch Out 9      
            ; #5  ; switch Out 10     

        retlw d'1'   ; #104 = Stretch-Faktor 2
        retlw d'1'   ; #105 = WAIT nach Loop Durchlauf (nur fr Kurve 1 mglich)
        retlw d'0'   ; #106 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #107 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #108 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #109 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #110 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #111 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #112 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #113 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #114 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #115 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #116 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #117 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #118 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #119 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #120 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #121 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #122 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #123 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #124 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #125 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #126 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #127 Dummy, damit keine Lcken im HEX-File 

; ********************************************************
        ; Kurve Adress 1 (Part 2)
; ********************************************************
        retlw d'0'   ; #0
        retlw d'1'   ; #1
        retlw d'2'   ; #2
        retlw d'3'   ; #3
        retlw d'4'   ; #4
        retlw d'5'   ; #5
        retlw d'6'   ; #6
        retlw d'7'   ; #7
        retlw d'8'   ; #8
        retlw d'9'   ; #9
        retlw d'10'   ; #10
        retlw d'11'   ; #11
        retlw d'12'   ; #12
        retlw d'13'   ; #13
        retlw d'14'   ; #14
        retlw d'15'   ; #15
        retlw d'16'   ; #16
        retlw d'17'   ; #17
        retlw d'18'   ; #18
        retlw d'19'   ; #19
        retlw d'20'   ; #20
        retlw d'21'   ; #21
        retlw d'22'   ; #22
        retlw d'23'   ; #23
        retlw d'24'   ; #24
        retlw d'25'   ; #25
        retlw d'26'   ; #26
        retlw d'27'   ; #27
        retlw d'28'   ; #28
        retlw d'29'   ; #29
        retlw d'30'   ; #30
        retlw d'31'   ; #31
        retlw d'32'   ; #32
        retlw d'33'   ; #33
        retlw d'34'   ; #34
        retlw d'35'   ; #35
        retlw d'36'   ; #36
        retlw d'37'   ; #37
        retlw d'38'   ; #38
        retlw d'39'   ; #39
        retlw d'40'   ; #40
        retlw d'41'   ; #41
        retlw d'42'   ; #42
        retlw d'43'   ; #43
        retlw d'44'   ; #44
        retlw d'45'   ; #45
        retlw d'46'   ; #46
        retlw d'47'   ; #47
        retlw d'48'   ; #48
        retlw d'49'   ; #49
        retlw d'50'   ; #50
        retlw d'51'   ; #51
        retlw d'52'   ; #52
        retlw d'53'   ; #53
        retlw d'54'   ; #54
        retlw d'55'   ; #55
        retlw d'56'   ; #56
        retlw d'57'   ; #57
        retlw d'58'   ; #58
        retlw d'59'   ; #59
        retlw d'60'   ; #60
        retlw d'61'   ; #61
        retlw d'62'   ; #62
        retlw d'63'   ; #63
        retlw d'64'   ; #64
        retlw d'65'   ; #65
        retlw d'66'   ; #66
        retlw d'67'   ; #67
        retlw d'68'   ; #68
        retlw d'69'   ; #69
        retlw d'70'   ; #70
        retlw d'71'   ; #71
        retlw d'72'   ; #72
        retlw d'73'   ; #73
        retlw d'74'   ; #74
        retlw d'75'   ; #75
        retlw d'76'   ; #76
        retlw d'77'   ; #77
        retlw d'78'   ; #78
        retlw d'79'   ; #79
        retlw d'80'   ; #80
        retlw d'81'   ; #81
        retlw d'82'   ; #82
        retlw d'83'   ; #83
        retlw d'84'   ; #84
        retlw d'85'   ; #85
        retlw d'86'   ; #86
        retlw d'87'   ; #87
        retlw d'88'   ; #88
        retlw d'89'   ; #89
        retlw d'90'   ; #90
        retlw d'91'   ; #91
        retlw d'92'   ; #92
        retlw d'93'   ; #93
        retlw d'94'   ; #94
        retlw d'95'   ; #95
        retlw d'96'   ; #96
        retlw d'97'   ; #97
        retlw d'98'   ; #98
        retlw d'99'   ; #99
        ; --------------- Kurve Ende ----------------
        retlw d'0'   ; #100 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #101 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #102 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #103 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #104 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #105 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #106 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #107 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #108 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #109 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #110 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #111 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #112 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #113 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #114 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #115 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #116 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #117 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #118 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #119 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #120 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #121 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #122 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #123 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #124 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #125 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #126 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #127 Dummy, damit keine Lcken im HEX-File 

; ********************************************************
        ; Kurve Adress 2
; ********************************************************
        retlw d'0'   ; #0
        retlw d'1'   ; #1
        retlw d'2'   ; #2
        retlw d'3'   ; #3
        retlw d'4'   ; #4
        retlw d'5'   ; #5
        retlw d'6'   ; #6
        retlw d'7'   ; #7
        retlw d'8'   ; #8
        retlw d'9'   ; #9
        retlw d'10'   ; #10
        retlw d'11'   ; #11
        retlw d'12'   ; #12
        retlw d'13'   ; #13
        retlw d'14'   ; #14
        retlw d'15'   ; #15
        retlw d'16'   ; #16
        retlw d'17'   ; #17
        retlw d'18'   ; #18
        retlw d'19'   ; #19
        retlw d'20'   ; #20
        retlw d'21'   ; #21
        retlw d'22'   ; #22
        retlw d'23'   ; #23
        retlw d'24'   ; #24
        retlw d'25'   ; #25
        retlw d'26'   ; #26
        retlw d'27'   ; #27
        retlw d'28'   ; #28
        retlw d'29'   ; #29
        retlw d'30'   ; #30
        retlw d'31'   ; #31
        retlw d'32'   ; #32
        retlw d'33'   ; #33
        retlw d'34'   ; #34
        retlw d'35'   ; #35
        retlw d'36'   ; #36
        retlw d'37'   ; #37
        retlw d'38'   ; #38
        retlw d'39'   ; #39
        retlw d'40'   ; #40
        retlw d'41'   ; #41
        retlw d'42'   ; #42
        retlw d'43'   ; #43
        retlw d'44'   ; #44
        retlw d'45'   ; #45
        retlw d'46'   ; #46
        retlw d'47'   ; #47
        retlw d'48'   ; #48
        retlw d'49'   ; #49
        retlw d'50'   ; #50
        retlw d'51'   ; #51
        retlw d'52'   ; #52
        retlw d'53'   ; #53
        retlw d'54'   ; #54
        retlw d'55'   ; #55
        retlw d'56'   ; #56
        retlw d'57'   ; #57
        retlw d'58'   ; #58
        retlw d'59'   ; #59
        retlw d'60'   ; #60
        retlw d'61'   ; #61
        retlw d'62'   ; #62
        retlw d'63'   ; #63
        retlw d'64'   ; #64
        retlw d'65'   ; #65
        retlw d'66'   ; #66
        retlw d'67'   ; #67
        retlw d'68'   ; #68
        retlw d'69'   ; #69
        retlw d'70'   ; #70
        retlw d'71'   ; #71
        retlw d'72'   ; #72
        retlw d'73'   ; #73
        retlw d'74'   ; #74
        retlw d'75'   ; #75
        retlw d'76'   ; #76
        retlw d'77'   ; #77
        retlw d'78'   ; #78
        retlw d'79'   ; #79
        retlw d'80'   ; #80
        retlw d'81'   ; #81
        retlw d'82'   ; #82
        retlw d'83'   ; #83
        retlw d'84'   ; #84
        retlw d'85'   ; #85
        retlw d'86'   ; #86
        retlw d'87'   ; #87
        retlw d'88'   ; #88
        retlw d'89'   ; #89
        retlw d'90'   ; #90
        retlw d'91'   ; #91
        retlw d'92'   ; #92
        retlw d'93'   ; #93
        retlw d'94'   ; #94
        retlw d'95'   ; #95
        retlw d'96'   ; #96
        retlw d'97'   ; #97
        retlw d'98'   ; #98
        retlw d'99'   ; #99
        ; --------------- Kurve 2 Part 1 Ende ----------------

        ; Curve Flags $100
        retlw b'11110001'   ; #100 = Flags       
            ; #0  ; Loop Kurve                  
            ; #4  ; switch Out 1      
            ; #5  ; switch Out 2      
            ; #6  ; switch Out 3      
            ; #7  ; switch Out 4      

        ; Curve Parameter $101
        retlw d'100'         ; #101 = number of steps
        retlw d'30'          ; #102 = Stretch-Faktor

        ; Curve Flags 2 $103
        retlw b'00111111'    ; #103 = Flags 2      
            ; #0  ; switch Out 5      
            ; #1  ; switch Out 6      
            ; #2  ; switch Out 7      
            ; #3  ; switch Out 8      
            ; #4  ; switch Out 9      
            ; #5  ; switch Out 10     

        retlw d'1'   ; #104  = Stretch-Faktor 2
        retlw d'0'   ; #105 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #106 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #107 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #108 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #109 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #110 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #111 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #112 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #113 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #114 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #115 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #116 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #117 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #118 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #119 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #120 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #121 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #122 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #123 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #124 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #125 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #126 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #127 Dummy, damit keine Lcken im HEX-File 

; ********************************************************
        ; Kurve Adress 2 (Part 2)
; ********************************************************
        retlw d'0'   ; #0
        retlw d'1'   ; #1
        retlw d'2'   ; #2
        retlw d'3'   ; #3
        retlw d'4'   ; #4
        retlw d'5'   ; #5
        retlw d'6'   ; #6
        retlw d'7'   ; #7
        retlw d'8'   ; #8
        retlw d'9'   ; #9
        retlw d'10'   ; #10
        retlw d'11'   ; #11
        retlw d'12'   ; #12
        retlw d'13'   ; #13
        retlw d'14'   ; #14
        retlw d'15'   ; #15
        retlw d'16'   ; #16
        retlw d'17'   ; #17
        retlw d'18'   ; #18
        retlw d'19'   ; #19
        retlw d'20'   ; #20
        retlw d'21'   ; #21
        retlw d'22'   ; #22
        retlw d'23'   ; #23
        retlw d'24'   ; #24
        retlw d'25'   ; #25
        retlw d'26'   ; #26
        retlw d'27'   ; #27
        retlw d'28'   ; #28
        retlw d'29'   ; #29
        retlw d'30'   ; #30
        retlw d'31'   ; #31
        retlw d'32'   ; #32
        retlw d'33'   ; #33
        retlw d'34'   ; #34
        retlw d'35'   ; #35
        retlw d'36'   ; #36
        retlw d'37'   ; #37
        retlw d'38'   ; #38
        retlw d'39'   ; #39
        retlw d'40'   ; #40
        retlw d'41'   ; #41
        retlw d'42'   ; #42
        retlw d'43'   ; #43
        retlw d'44'   ; #44
        retlw d'45'   ; #45
        retlw d'46'   ; #46
        retlw d'47'   ; #47
        retlw d'48'   ; #48
        retlw d'49'   ; #49
        retlw d'50'   ; #50
        retlw d'51'   ; #51
        retlw d'52'   ; #52
        retlw d'53'   ; #53
        retlw d'54'   ; #54
        retlw d'55'   ; #55
        retlw d'56'   ; #56
        retlw d'57'   ; #57
        retlw d'58'   ; #58
        retlw d'59'   ; #59
        retlw d'60'   ; #60
        retlw d'61'   ; #61
        retlw d'62'   ; #62
        retlw d'63'   ; #63
        retlw d'64'   ; #64
        retlw d'65'   ; #65
        retlw d'66'   ; #66
        retlw d'67'   ; #67
        retlw d'68'   ; #68
        retlw d'69'   ; #69
        retlw d'70'   ; #70
        retlw d'71'   ; #71
        retlw d'72'   ; #72
        retlw d'73'   ; #73
        retlw d'74'   ; #74
        retlw d'75'   ; #75
        retlw d'76'   ; #76
        retlw d'77'   ; #77
        retlw d'78'   ; #78
        retlw d'79'   ; #79
        retlw d'80'   ; #80
        retlw d'81'   ; #81
        retlw d'82'   ; #82
        retlw d'83'   ; #83
        retlw d'84'   ; #84
        retlw d'85'   ; #85
        retlw d'86'   ; #86
        retlw d'87'   ; #87
        retlw d'88'   ; #88
        retlw d'89'   ; #89
        retlw d'90'   ; #90
        retlw d'91'   ; #91
        retlw d'92'   ; #92
        retlw d'93'   ; #93
        retlw d'94'   ; #94
        retlw d'95'   ; #95
        retlw d'96'   ; #96
        retlw d'97'   ; #97
        retlw d'98'   ; #98
        retlw d'99'   ; #99
        ; --------------- Kurve Ende ----------------
        retlw d'0'   ; #100 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #101 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #102 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #103 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #104 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #105 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #106 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #107 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #108 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #109 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #110 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #111 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #112 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #113 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #114 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #115 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #116 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #117 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #118 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #119 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #120 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #121 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #122 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #123 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #124 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #125 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #126 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #127 Dummy, damit keine Lcken im HEX-File 

; ********************************************************
        ; Kurve Adress 3
; ********************************************************
        retlw d'0'   ; #0
        retlw d'1'   ; #1
        retlw d'2'   ; #2
        retlw d'3'   ; #3
        retlw d'4'   ; #4
        retlw d'5'   ; #5
        retlw d'6'   ; #6
        retlw d'7'   ; #7
        retlw d'8'   ; #8
        retlw d'9'   ; #9
        retlw d'10'   ; #10
        retlw d'11'   ; #11
        retlw d'12'   ; #12
        retlw d'13'   ; #13
        retlw d'14'   ; #14
        retlw d'15'   ; #15
        retlw d'16'   ; #16
        retlw d'17'   ; #17
        retlw d'18'   ; #18
        retlw d'19'   ; #19
        retlw d'20'   ; #20
        retlw d'21'   ; #21
        retlw d'22'   ; #22
        retlw d'23'   ; #23
        retlw d'24'   ; #24
        retlw d'25'   ; #25
        retlw d'26'   ; #26
        retlw d'27'   ; #27
        retlw d'28'   ; #28
        retlw d'29'   ; #29
        retlw d'30'   ; #30
        retlw d'31'   ; #31
        retlw d'32'   ; #32
        retlw d'33'   ; #33
        retlw d'34'   ; #34
        retlw d'35'   ; #35
        retlw d'36'   ; #36
        retlw d'37'   ; #37
        retlw d'38'   ; #38
        retlw d'39'   ; #39
        retlw d'40'   ; #40
        retlw d'41'   ; #41
        retlw d'42'   ; #42
        retlw d'43'   ; #43
        retlw d'44'   ; #44
        retlw d'45'   ; #45
        retlw d'46'   ; #46
        retlw d'47'   ; #47
        retlw d'48'   ; #48
        retlw d'49'   ; #49
        retlw d'50'   ; #50
        retlw d'51'   ; #51
        retlw d'52'   ; #52
        retlw d'53'   ; #53
        retlw d'54'   ; #54
        retlw d'55'   ; #55
        retlw d'56'   ; #56
        retlw d'57'   ; #57
        retlw d'58'   ; #58
        retlw d'59'   ; #59
        retlw d'60'   ; #60
        retlw d'61'   ; #61
        retlw d'62'   ; #62
        retlw d'63'   ; #63
        retlw d'64'   ; #64
        retlw d'65'   ; #65
        retlw d'66'   ; #66
        retlw d'67'   ; #67
        retlw d'68'   ; #68
        retlw d'69'   ; #69
        retlw d'70'   ; #70
        retlw d'71'   ; #71
        retlw d'72'   ; #72
        retlw d'73'   ; #73
        retlw d'74'   ; #74
        retlw d'75'   ; #75
        retlw d'76'   ; #76
        retlw d'77'   ; #77
        retlw d'78'   ; #78
        retlw d'79'   ; #79
        retlw d'80'   ; #80
        retlw d'81'   ; #81
        retlw d'82'   ; #82
        retlw d'83'   ; #83
        retlw d'84'   ; #84
        retlw d'85'   ; #85
        retlw d'86'   ; #86
        retlw d'87'   ; #87
        retlw d'88'   ; #88
        retlw d'89'   ; #89
        retlw d'90'   ; #90
        retlw d'91'   ; #91
        retlw d'92'   ; #92
        retlw d'93'   ; #93
        retlw d'94'   ; #94
        retlw d'95'   ; #95
        retlw d'96'   ; #96
        retlw d'97'   ; #97
        retlw d'98'   ; #98
        retlw d'99'   ; #99
        ; --------------- Kurve 3 Part 1 Ende ----------------

        ; Curve Flags $100
        retlw b'11110001'   ; #100 = Flags       
            ; #0  ; Loop Kurve                  
            ; #4  ; switch Out 1      
            ; #5  ; switch Out 2      
            ; #6  ; switch Out 3      
            ; #7  ; switch Out 4      

        ; Curve Parameter $101
        retlw d'100'         ; #101 = number of steps
        retlw d'30'          ; #102 = Stretch-Faktor

        ; Curve Flags 2 $103
        retlw b'00111111'    ; #103 = Flags 2      
            ; #0  ; switch Out 5      
            ; #1  ; switch Out 6      
            ; #2  ; switch Out 7      
            ; #3  ; switch Out 8      
            ; #4  ; switch Out 9      
            ; #5  ; switch Out 10     

        retlw d'1'   ; #104  = Stretch-Faktor 2
        retlw d'0'   ; #105 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #106 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #107 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #108 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #109 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #110 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #111 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #112 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #113 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #114 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #115 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #116 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #117 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #118 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #119 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #120 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #121 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #122 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #123 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #124 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #125 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #126 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #127 Dummy, damit keine Lcken im HEX-File 

; ********************************************************
        ; Kurve Adress 3 (Part 2)
; ********************************************************
        retlw d'0'   ; #0
        retlw d'1'   ; #1
        retlw d'2'   ; #2
        retlw d'3'   ; #3
        retlw d'4'   ; #4
        retlw d'5'   ; #5
        retlw d'6'   ; #6
        retlw d'7'   ; #7
        retlw d'8'   ; #8
        retlw d'9'   ; #9
        retlw d'10'   ; #10
        retlw d'11'   ; #11
        retlw d'12'   ; #12
        retlw d'13'   ; #13
        retlw d'14'   ; #14
        retlw d'15'   ; #15
        retlw d'16'   ; #16
        retlw d'17'   ; #17
        retlw d'18'   ; #18
        retlw d'19'   ; #19
        retlw d'20'   ; #20
        retlw d'21'   ; #21
        retlw d'22'   ; #22
        retlw d'23'   ; #23
        retlw d'24'   ; #24
        retlw d'25'   ; #25
        retlw d'26'   ; #26
        retlw d'27'   ; #27
        retlw d'28'   ; #28
        retlw d'29'   ; #29
        retlw d'30'   ; #30
        retlw d'31'   ; #31
        retlw d'32'   ; #32
        retlw d'33'   ; #33
        retlw d'34'   ; #34
        retlw d'35'   ; #35
        retlw d'36'   ; #36
        retlw d'37'   ; #37
        retlw d'38'   ; #38
        retlw d'39'   ; #39
        retlw d'40'   ; #40
        retlw d'41'   ; #41
        retlw d'42'   ; #42
        retlw d'43'   ; #43
        retlw d'44'   ; #44
        retlw d'45'   ; #45
        retlw d'46'   ; #46
        retlw d'47'   ; #47
        retlw d'48'   ; #48
        retlw d'49'   ; #49
        retlw d'50'   ; #50
        retlw d'51'   ; #51
        retlw d'52'   ; #52
        retlw d'53'   ; #53
        retlw d'54'   ; #54
        retlw d'55'   ; #55
        retlw d'56'   ; #56
        retlw d'57'   ; #57
        retlw d'58'   ; #58
        retlw d'59'   ; #59
        retlw d'60'   ; #60
        retlw d'61'   ; #61
        retlw d'62'   ; #62
        retlw d'63'   ; #63
        retlw d'64'   ; #64
        retlw d'65'   ; #65
        retlw d'66'   ; #66
        retlw d'67'   ; #67
        retlw d'68'   ; #68
        retlw d'69'   ; #69
        retlw d'70'   ; #70
        retlw d'71'   ; #71
        retlw d'72'   ; #72
        retlw d'73'   ; #73
        retlw d'74'   ; #74
        retlw d'75'   ; #75
        retlw d'76'   ; #76
        retlw d'77'   ; #77
        retlw d'78'   ; #78
        retlw d'79'   ; #79
        retlw d'80'   ; #80
        retlw d'81'   ; #81
        retlw d'82'   ; #82
        retlw d'83'   ; #83
        retlw d'84'   ; #84
        retlw d'85'   ; #85
        retlw d'86'   ; #86
        retlw d'87'   ; #87
        retlw d'88'   ; #88
        retlw d'89'   ; #89
        retlw d'90'   ; #90
        retlw d'91'   ; #91
        retlw d'92'   ; #92
        retlw d'93'   ; #93
        retlw d'94'   ; #94
        retlw d'95'   ; #95
        retlw d'96'   ; #96
        retlw d'97'   ; #97
        retlw d'98'   ; #98
        retlw d'99'   ; #99
        ; --------------- Kurve Ende ----------------
        retlw d'0'   ; #100 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #101 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #102 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #103 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #104 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #105 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #106 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #107 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #108 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #109 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #110 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #111 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #112 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #113 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #114 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #115 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #116 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #117 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #118 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #119 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #120 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #121 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #122 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #123 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #124 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #125 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #126 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #127 Dummy, damit keine Lcken im HEX-File 

; ********************************************************
        ; Kurve Adress 4
; ********************************************************
        retlw d'0'   ; #0
        retlw d'1'   ; #1
        retlw d'2'   ; #2
        retlw d'3'   ; #3
        retlw d'4'   ; #4
        retlw d'5'   ; #5
        retlw d'6'   ; #6
        retlw d'7'   ; #7
        retlw d'8'   ; #8
        retlw d'9'   ; #9
        retlw d'10'   ; #10
        retlw d'11'   ; #11
        retlw d'12'   ; #12
        retlw d'13'   ; #13
        retlw d'14'   ; #14
        retlw d'15'   ; #15
        retlw d'16'   ; #16
        retlw d'17'   ; #17
        retlw d'18'   ; #18
        retlw d'19'   ; #19
        retlw d'20'   ; #20
        retlw d'21'   ; #21
        retlw d'22'   ; #22
        retlw d'23'   ; #23
        retlw d'24'   ; #24
        retlw d'25'   ; #25
        retlw d'26'   ; #26
        retlw d'27'   ; #27
        retlw d'28'   ; #28
        retlw d'29'   ; #29
        retlw d'30'   ; #30
        retlw d'31'   ; #31
        retlw d'32'   ; #32
        retlw d'33'   ; #33
        retlw d'34'   ; #34
        retlw d'35'   ; #35
        retlw d'36'   ; #36
        retlw d'37'   ; #37
        retlw d'38'   ; #38
        retlw d'39'   ; #39
        retlw d'40'   ; #40
        retlw d'41'   ; #41
        retlw d'42'   ; #42
        retlw d'43'   ; #43
        retlw d'44'   ; #44
        retlw d'45'   ; #45
        retlw d'46'   ; #46
        retlw d'47'   ; #47
        retlw d'48'   ; #48
        retlw d'49'   ; #49
        retlw d'50'   ; #50
        retlw d'51'   ; #51
        retlw d'52'   ; #52
        retlw d'53'   ; #53
        retlw d'54'   ; #54
        retlw d'55'   ; #55
        retlw d'56'   ; #56
        retlw d'57'   ; #57
        retlw d'58'   ; #58
        retlw d'59'   ; #59
        retlw d'60'   ; #60
        retlw d'61'   ; #61
        retlw d'62'   ; #62
        retlw d'63'   ; #63
        retlw d'64'   ; #64
        retlw d'65'   ; #65
        retlw d'66'   ; #66
        retlw d'67'   ; #67
        retlw d'68'   ; #68
        retlw d'69'   ; #69
        retlw d'70'   ; #70
        retlw d'71'   ; #71
        retlw d'72'   ; #72
        retlw d'73'   ; #73
        retlw d'74'   ; #74
        retlw d'75'   ; #75
        retlw d'76'   ; #76
        retlw d'77'   ; #77
        retlw d'78'   ; #78
        retlw d'79'   ; #79
        retlw d'80'   ; #80
        retlw d'81'   ; #81
        retlw d'82'   ; #82
        retlw d'83'   ; #83
        retlw d'84'   ; #84
        retlw d'85'   ; #85
        retlw d'86'   ; #86
        retlw d'87'   ; #87
        retlw d'88'   ; #88
        retlw d'89'   ; #89
        retlw d'90'   ; #90
        retlw d'91'   ; #91
        retlw d'92'   ; #92
        retlw d'93'   ; #93
        retlw d'94'   ; #94
        retlw d'95'   ; #95
        retlw d'96'   ; #96
        retlw d'97'   ; #97
        retlw d'98'   ; #98
        retlw d'99'   ; #99
        ; --------------- Kurve 4 Part 1 Ende ----------------

        ; Curve Flags $100
        retlw b'11110001'   ; #100 = Flags       
            ; #0  ; Loop Kurve                  
            ; #4  ; switch Out 1      
            ; #5  ; switch Out 2      
            ; #6  ; switch Out 3      
            ; #7  ; switch Out 4      

        ; Curve Parameter $101
        retlw d'100'         ; #101 = number of steps
        retlw d'30'           ; #102 = Stretch-Faktor

        ; Curve Flags 2 $103
        retlw b'00111111'    ; #103 = Flags 2      
            ; #0  ; switch Out 5      
            ; #1  ; switch Out 6      
            ; #2  ; switch Out 7      
            ; #3  ; switch Out 8      
            ; #4  ; switch Out 9      
            ; #5  ; switch Out 10     

        retlw d'1'   ; #104  = Stretch-Faktor 2
        retlw d'0'   ; #105 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #106 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #107 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #108 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #109 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #110 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #111 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #112 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #113 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #114 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #115 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #116 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #117 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #118 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #119 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #120 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #121 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #122 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #123 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #124 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #125 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #126 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #127 Dummy, damit keine Lcken im HEX-File 
        
; ********************************************************
        ; Kurve Adress 4 (Part 2)
; ********************************************************
        retlw d'0'   ; #0
        retlw d'1'   ; #1
        retlw d'2'   ; #2
        retlw d'3'   ; #3
        retlw d'4'   ; #4
        retlw d'5'   ; #5
        retlw d'6'   ; #6
        retlw d'7'   ; #7
        retlw d'8'   ; #8
        retlw d'9'   ; #9
        retlw d'10'   ; #10
        retlw d'11'   ; #11
        retlw d'12'   ; #12
        retlw d'13'   ; #13
        retlw d'14'   ; #14
        retlw d'15'   ; #15
        retlw d'16'   ; #16
        retlw d'17'   ; #17
        retlw d'18'   ; #18
        retlw d'19'   ; #19
        retlw d'20'   ; #20
        retlw d'21'   ; #21
        retlw d'22'   ; #22
        retlw d'23'   ; #23
        retlw d'24'   ; #24
        retlw d'25'   ; #25
        retlw d'26'   ; #26
        retlw d'27'   ; #27
        retlw d'28'   ; #28
        retlw d'29'   ; #29
        retlw d'30'   ; #30
        retlw d'31'   ; #31
        retlw d'32'   ; #32
        retlw d'33'   ; #33
        retlw d'34'   ; #34
        retlw d'35'   ; #35
        retlw d'36'   ; #36
        retlw d'37'   ; #37
        retlw d'38'   ; #38
        retlw d'39'   ; #39
        retlw d'40'   ; #40
        retlw d'41'   ; #41
        retlw d'42'   ; #42
        retlw d'43'   ; #43
        retlw d'44'   ; #44
        retlw d'45'   ; #45
        retlw d'46'   ; #46
        retlw d'47'   ; #47
        retlw d'48'   ; #48
        retlw d'49'   ; #49
        retlw d'50'   ; #50
        retlw d'51'   ; #51
        retlw d'52'   ; #52
        retlw d'53'   ; #53
        retlw d'54'   ; #54
        retlw d'55'   ; #55
        retlw d'56'   ; #56
        retlw d'57'   ; #57
        retlw d'58'   ; #58
        retlw d'59'   ; #59
        retlw d'60'   ; #60
        retlw d'61'   ; #61
        retlw d'62'   ; #62
        retlw d'63'   ; #63
        retlw d'64'   ; #64
        retlw d'65'   ; #65
        retlw d'66'   ; #66
        retlw d'67'   ; #67
        retlw d'68'   ; #68
        retlw d'69'   ; #69
        retlw d'70'   ; #70
        retlw d'71'   ; #71
        retlw d'72'   ; #72
        retlw d'73'   ; #73
        retlw d'74'   ; #74
        retlw d'75'   ; #75
        retlw d'76'   ; #76
        retlw d'77'   ; #77
        retlw d'78'   ; #78
        retlw d'79'   ; #79
        retlw d'80'   ; #80
        retlw d'81'   ; #81
        retlw d'82'   ; #82
        retlw d'83'   ; #83
        retlw d'84'   ; #84
        retlw d'85'   ; #85
        retlw d'86'   ; #86
        retlw d'87'   ; #87
        retlw d'88'   ; #88
        retlw d'89'   ; #89
        retlw d'90'   ; #90
        retlw d'91'   ; #91
        retlw d'92'   ; #92
        retlw d'93'   ; #93
        retlw d'94'   ; #94
        retlw d'95'   ; #95
        retlw d'96'   ; #96
        retlw d'97'   ; #97
        retlw d'98'   ; #98
        retlw d'99'   ; #99
        ; --------------- Kurve Ende ----------------
        retlw d'0'   ; #100 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #101 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #102 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #103 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #104 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #105 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #106 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #107 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #108 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #109 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #110 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #111 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #112 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #113 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #114 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #115 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #116 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #117 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #118 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #119 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #120 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #121 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #122 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #123 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #124 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #125 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #126 Dummy, damit keine Lcken im HEX-File 
        retlw d'0'   ; #127 Dummy, damit keine Lcken im HEX-File 