; ********************************************************
; ** Version: V3.00 vom 24/07/2006                      **
; ********************************************************
; ** Include-File zu dekoder.asm                        **
; ********************************************************
; ** Sven Brandt                                        **
; ********************************************************
; Copyright (C) 2005 Sven Brandt

;*********************************
;*********************************
;*********************************
;*********************************
;** Routine: statemachine_feuer **
;** Blinksmdus                  **
;** needs <    us               **
;*********************************
;*********************************
;*********************************
;*********************************
statemachine_feuer

; **********************************************
; **** Blink-Mode  (FEUER) ****
; **********************************************
        movlw b'00000001'             ; check state
        andwf R_STATUS,W              ; if not this mode
        btfsc STATUS,Z                ; .. then
         return                       ; .. return

        btfsc R_ONOFF1,0
         bsf PORTA,4                   ; .. then switch LED_1 on
        btfsc R_ONOFF1,1
         bsf PORTA,5                   ; .. then switch LED_2 on
        btfsc R_ONOFF1,2
         bsf PORTA,0                   ; .. then switch LED_3 on
        btfsc R_ONOFF1,3
         bsf PORTA,1                   ; .. then switch LED_4 on
        btfsc R_ONOFF1,4
         bsf PORTC,1                   ; .. then switch LED_5 on
        btfsc R_ONOFF1,5
         bsf PORTC,2                   ; .. then switch LED_6 on
        btfsc R_ONOFF1,6
         bsf PORTC,0                   ; .. then switch LED_7 on
        btfsc R_ONOFF1,7
         bsf PORTC,5                   ; .. then switch LED_8 on
        btfsc R_ONOFF2,0
         bsf PORTC,4                   ; .. then switch LED_9 on
        btfsc R_ONOFF2,1
         bsf PORTC,3                   ; .. then switch LED_10 on

        movlw d'230'                   ; get PWM-value into W-register
        subwf TMR1L,W                  ; W = TMR1L - W = TMR1 - PWM-Value
        btfss STATUS,C                 ; if C=1, -> TMR1 > PWM-Value
        goto led00
         bsf PORTA,4                   ; .. then switch LED_1 on
         bsf PORTA,5                   ; .. then switch LED_2 on
         bsf PORTA,0                   ; .. then switch LED_3 on
         bsf PORTA,1                   ; .. then switch LED_4 on
         bsf PORTC,1                   ; .. then switch LED_5 on
         bsf PORTC,2                   ; .. then switch LED_6 on
         bsf PORTC,0                   ; .. then switch LED_7 on
         bsf PORTC,5                   ; .. then switch LED_8 on
         bsf PORTC,4                   ; .. then switch LED_9 on
         bsf PORTC,3                   ; .. then switch LED_10 on

led00
;   -------------------------
;   --- create 3ms-Raster ---
;   -------------------------
        movf TMR1H,F 
        btfsc STATUS,Z                 ; if TMR1H <> ZERO
         return
        clrf TMR1H                     ; .. then reset to ZERO

        clrf PORTA                     ; .. switch LED_1 OFF
        clrf PORTC                     ; .. switch LED_1 OFF

        ; Register SHUFFLE1..8 neu mischen
        movf R_SHUFFLE1,W     
        movwf R_SHUFFLE                ; R_SHUFFLEx into R_SHUFFLE
        call shuffle                   ; shuffle R_SHUFFLE
        movwf R_SHUFFLE1               ; shuffled R_SHUFFLE into R_SHUFFLEx

        movf R_SHUFFLE2,W     
        movwf R_SHUFFLE                ; R_SHUFFLEx into R_SHUFFLE
        call shuffle                   ; shuffle R_SHUFFLE
        movwf R_SHUFFLE2               ; shuffled R_SHUFFLE into R_SHUFFLEx

        movf R_SHUFFLE3,W     
        movwf R_SHUFFLE                ; R_SHUFFLEx into R_SHUFFLE
        btfss R_SHUFFLE1,0             ; mehr Varianz surch Querverbindung
        call shuffle                   ; shuffle R_SHUFFLE
        movwf R_SHUFFLE3               ; shuffled R_SHUFFLE into R_SHUFFLEx

        movf R_SHUFFLE4,W     
        movwf R_SHUFFLE                ; R_SHUFFLEx into R_SHUFFLE
        btfss R_SHUFFLE1,1             ; mehr Varianz surch Querverbindung
        call shuffle                   ; shuffle R_SHUFFLE
        movwf R_SHUFFLE4               ; shuffled R_SHUFFLE into R_SHUFFLEx

        movf R_SHUFFLE5,W     
        movwf R_SHUFFLE                ; R_SHUFFLEx into R_SHUFFLE
        btfss R_SHUFFLE1,2             ; mehr Varianz surch Querverbindung
        call shuffle                   ; shuffle R_SHUFFLE
        movwf R_SHUFFLE5               ; shuffled R_SHUFFLE into R_SHUFFLEx

        movf R_SHUFFLE6,W     
        movwf R_SHUFFLE                ; R_SHUFFLEx into R_SHUFFLE
        btfss R_SHUFFLE1,3             ; mehr Varianz surch Querverbindung
        call shuffle                   ; shuffle R_SHUFFLE
        movwf R_SHUFFLE6               ; shuffled R_SHUFFLE into R_SHUFFLEx

        movf R_SHUFFLE7,W     
        movwf R_SHUFFLE                ; R_SHUFFLEx into R_SHUFFLE
        btfss R_SHUFFLE1,4             ; mehr Varianz surch Querverbindung
        call shuffle                   ; shuffle R_SHUFFLE
        movwf R_SHUFFLE7               ; shuffled R_SHUFFLE into R_SHUFFLEx

        movf R_SHUFFLE8,W     
        movwf R_SHUFFLE                ; R_SHUFFLEx into R_SHUFFLE
        btfss R_SHUFFLE1,5             ; mehr Varianz surch Querverbindung
        call shuffle                   ; shuffle R_SHUFFLE
        movwf R_SHUFFLE8               ; shuffled R_SHUFFLE into R_SHUFFLEx


led01   ; *** Neon defekt *** 

        decfsz R_CNT1,F
         goto led02

        movf R_SHUFFLE1,W     
        movwf R_CNT1                   ; R_SHUFFLEx in R_CNT1

        btfsc R_SHUFFLE1,1             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF1,0                ; ..AN
        btfss R_SHUFFLE1,5             ; ..oder
         bcf R_ONOFF1,0                ; ..AUS
        btfss R_SHUFFLE1,3             ; ..oder
         bcf R_ONOFF1,0                ; ..AUS

led02   ; *** Neon defekt *** 

        decfsz R_CNT2,F
         goto led03

        movf R_SHUFFLE2,W     
        movwf R_CNT2                   ; R_SHUFFLEx in R_CNT2

        btfsc R_SHUFFLE2,5             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF1,1                ; ..AN
        btfss R_SHUFFLE2,2             ; ..oder
         bcf R_ONOFF1,1                ; ..AUS
        btfss R_SHUFFLE2,6             ; ..oder
         bcf R_ONOFF1,1                ; ..AUS
 
led03   ; *** Neon defekt *** 
        decfsz R_CNT3,F
         goto led04

        movf R_SHUFFLE3,W     
        movwf R_CNT3                   ; R_SHUFFLEx in R_CNT3

        btfsc R_SHUFFLE3,4             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF1,2                ; ..AN
        btfss R_SHUFFLE3,6             ; ..oder
         bcf R_ONOFF1,2                ; ..AUS
        btfss R_SHUFFLE3,3             ; ..oder
         bcf R_ONOFF1,2                ; ..AUS

led04   ; *** Neon defekt *** 

        decfsz R_CNT4,F
         goto led05

        movf R_SHUFFLE4,W     
        movwf R_CNT4                   ; R_SHUFFLEx in R_CNT4

        btfsc R_SHUFFLE4,4             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF1,3                ; ..AN
        btfss R_SHUFFLE4,7             ; ..oder
         bcf R_ONOFF1,3                ; ..AUS
        btfss R_SHUFFLE4,3             ; ..oder
         bcf R_ONOFF1,3                ; ..AUS

led05   ; *** Neon defekt *** 

        decfsz R_CNT5,F
         goto led06

        movf R_SHUFFLE5,W     
        movwf R_CNT5                   ; R_SHUFFLEx in R_CNT5

        btfsc R_SHUFFLE5,7             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF1,4                ; ..AN
        btfss R_SHUFFLE5,7             ; ..oder
         bcf R_ONOFF1,4                ; ..AUS
        btfss R_SHUFFLE5,1             ; ..oder
         bcf R_ONOFF1,4                ; ..AUS

led06   ; *** Neon defekt *** 
        decfsz R_CNT6,F
         goto led07

        movf R_SHUFFLE6,W     
        movwf R_CNT6                   ; R_SHUFFLEx in R_CNT6

        btfsc R_SHUFFLE6,4             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF1,5                ; ..AN
        btfss R_SHUFFLE6,4             ; ..oder
         bcf R_ONOFF1,5                ; ..AUS
        btfss R_SHUFFLE6,7             ; ..oder
         bcf R_ONOFF1,5                ; ..AUS

led07   ; *** Neon defekt ***   

        decfsz R_CNT7,F
         goto led08

        movf R_SHUFFLE7,W     
        movwf R_CNT7                   ; R_SHUFFLEx in R_CNT7

        btfsc R_SHUFFLE7,3             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF1,6                ; ..AN
        btfss R_SHUFFLE7,3             ; ..oder
         bcf R_ONOFF1,6                ; ..AUS
        btfss R_SHUFFLE7,4             ; ..oder
         bcf R_ONOFF1,6                ; ..AUS

led08   ; *** Neon defekt *** 
        decfsz R_CNT8,F
         goto led09

        movf R_SHUFFLE8,W     
        movwf R_CNT8                   ; R_SHUFFLEx in R_CNT8

        btfsc R_SHUFFLE8,4             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF1,7                ; ..AN
        btfss R_SHUFFLE8,4             ; ..oder
         bcf R_ONOFF1,7                ; ..AUS
        btfss R_SHUFFLE8,7             ; ..oder
         bcf R_ONOFF1,7                ; ..AUS


led09   ; *** Neon defekt ***   
        decfsz R_CNT9,F
         goto led10

        movf R_SHUFFLE3,W     
        movwf R_CNT9                   ; R_SHUFFLEx in R_CNT9

        btfsc R_SHUFFLE2,7             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF2,0                ; ..AN
        btfss R_SHUFFLE4,7             ; ..oder
         bcf R_ONOFF2,0                ; ..AUS

led10   ; *** Neon defekt ***   
        decfsz R_CNT10,F
         goto led11

        movf R_SHUFFLE4,W     
        movwf R_CNT10                  ; R_SHUFFLEx in R_CNT10

        btfsc R_SHUFFLE3,7             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF2,1                ; ..AN
        btfss R_SHUFFLE5,7             ; ..oder
         bcf R_ONOFF2,1                ; ..AUS
         
led11   return


;*******************************************
;*******************************************
;*******************************************
;*******************************************
;** Routine: shuffle                      **
;** (A|B) & !(A&B)                        **
;** uses  R_SHUFF (Register to shuffle)   **
;** uses  R_TEMP  (temporary registere)   **
;** returns shuffled value in W_REG!      **
;*******************************************
;*******************************************
;*******************************************
;*******************************************
shuffle
        clrf R_TEMP
        movf R_SHUFFLE,F   ; check for
        btfsc STATUS,Z     ; .. ZERO
         decf R_SHUFFLE,F  ; if ZERO Reload with FF
        btfsc R_SHUFFLE,0  ; = A
         bsf R_TEMP,0       
        btfsc R_SHUFFLE,5  ; = B
         bsf R_TEMP,0      ; R_TEMP#0 = A|B
        movf R_TEMP,W      ; W#0 = A|B
        clrf R_TEMP
        btfss R_SHUFFLE,0  ; = A
         bsf R_TEMP,0       
        btfss R_SHUFFLE,5  ; = B
         bsf R_TEMP,0      ; R_TEMP#0 = (!A)|(!B) = !(A&B)
        andwf R_TEMP,F     ; R_TEMP#0 = (A|B) & !(A&B)
        RRF R_TEMP,F       ; R_TEMP#0 -> CARRY
        RRF R_SHUFFLE,W    ; CARRY in R_SHUFFLE von links hineinschieben
        return             ; und ins W_REG

