; ********************************************************
; ** Version: V3.07 vom 25/08/2006                      **
; ********************************************************
; ** Include-File zu dekoder.asm                        **
; ********************************************************
; ** Sven Brandt                                        **
; ********************************************************
; Copyright (C) 2005 Sven Brandt

; ********************************************************
; History:
; V3.07 - LED-Dekoder_gas: jetzt mit Gasdruckschwankungen (nderungen nur in _SUB und _STATS)
; ********************************************************

;*********************************
;*********************************
;*********************************
;*********************************
;** Routine: statemachine_gas   **
;** Blinksmdus                  **
;** needs <    us               **
;*********************************
;*********************************
;*********************************
;*********************************
statemachine_gas

PWM_start_1        equ d'10'         ; (1..255) Starthelligkeit (fr LED1 am langsamsten wg. Gasdruckschwankungen)
PWM_start_2        equ d'10'         ; (1..255) Starthelligkeit
PWM_start_3        equ d'25'         ; (1..255) Starthelligkeit
PWM_start_4        equ d'10'         ; (1..255) Starthelligkeit
PWM_start_5        equ d'15'         ; (1..255) Starthelligkeit
PWM_start_6        equ d'20'         ; (1..255) Starthelligkeit
PWM_start_7        equ d'15'         ; (1..255) Starthelligkeit
PWM_start_8        equ d'10'         ; (1..255) Starthelligkeit
PWM_start_9        equ d'15'         ; (1..255) Starthelligkeit
PWM_start_10       equ d'10'         ; (1..255) Starthelligkeit

PWM_verz_ein_1     equ d'30'         ; (1..255) einblend-Verzoegerung (fr LED1 am langsamsten wg. Gasdruckschwankungen)
PWM_verz_ein_2     equ d'15'         ; (1..255) einblend-Verzoegerung
PWM_verz_ein_3     equ d'10'         ; (1..255) einblend-Verzoegerung
PWM_verz_ein_4     equ d'15'         ; (1..255) einblend-Verzoegerung
PWM_verz_ein_5     equ d'15'         ; (1..255) einblend-Verzoegerung
PWM_verz_ein_6     equ d'27'         ; (1..255) einblend-Verzoegerung
PWM_verz_ein_7     equ d'15'         ; (1..255) einblend-Verzoegerung
PWM_verz_ein_8     equ d'15'         ; (1..255) einblend-Verzoegerung
PWM_verz_ein_9     equ d'10'         ; (1..255) einblend-Verzoegerung
PWM_verz_ein_10    equ d'20'         ; (1..255) einblend-Verzoegerung

PWM_verz_aus_1     equ d'10'         ; (1..255) Ausblend-Verzoegerung
PWM_verz_aus_2     equ d'11'         ; (1..255) Ausblend-Verzoegerung
PWM_verz_aus_3     equ d'9'          ; (1..255) Ausblend-Verzoegerung
PWM_verz_aus_4     equ d'8'          ; (1..255) Ausblend-Verzoegerung
PWM_verz_aus_5     equ d'13'         ; (1..255) Ausblend-Verzoegerung
PWM_verz_aus_6     equ d'11'         ; (1..255) Ausblend-Verzoegerung
PWM_verz_aus_7     equ d'7'          ; (1..255) Ausblend-Verzoegerung
PWM_verz_aus_8     equ d'12'         ; (1..255) Ausblend-Verzoegerung
PWM_verz_aus_9     equ d'6'          ; (1..255) Ausblend-Verzoegerung
PWM_verz_aus_10    equ d'11'         ; (1..255) Ausblend-Verzoegerung

; **********************************************
; **** Blink-Mode  (Gas) ****
; **********************************************
        movf R_PWM1,W                  ; get PWM-value into W-register
        subwf TMR1L,W                  ; W = TMR1L - W = TMR1L - PWM-Value
        btfss STATUS,C                 ; if C=0, -> TMR1L < PWM-Value
         bsf PORTA,4                   ; .. then switch LED_1 on
        btfsc STATUS,C                 ; if C=1, -> TMR1L >= PWM-Value
         bcf PORTA,4                   ; .. then switch LED_1 off

        movf R_PWM2,W                  ; get PWM-value into W-register
        subwf TMR1L,W                  ; W = TMR1L - W = TMR1L - PWM-Value
        btfss STATUS,C                 ; if C=0, -> TMR1L < PWM-Value
         bsf PORTA,5                   ; .. then switch LED_2 on
        btfsc STATUS,C                 ; if C=1, -> TMR1L >= PWM-Value
         bcf PORTA,5                   ; .. then switch LED_2 off

        movf R_PWM3,W                  ; get PWM-value into W-register
        subwf TMR1L,W                  ; W = TMR1L - W = TMR1L - PWM-Value
        btfss STATUS,C                 ; if C=0, -> TMR1L < PWM-Value
         bsf PORTA,0                   ; .. then switch LED_3 on
        btfsc STATUS,C                 ; if C=1, -> TMR1L >= PWM-Value
         bcf PORTA,0                   ; .. then switch LED_3 off

        movf R_PWM4,W                  ; get PWM-value into W-register
        subwf TMR1L,W                  ; W = TMR1L - W = TMR1L - PWM-Value
        btfss STATUS,C                 ; if C=0, -> TMR1L < PWM-Value
         bsf PORTA,1                   ; .. then switch LED_4 on
        btfsc STATUS,C                 ; if C=1, -> TMR1L >= PWM-Value
         bcf PORTA,1                   ; .. then switch LED_4 off

        movf R_PWM5,W                  ; get PWM-value into W-register
        subwf TMR1L,W                  ; W = TMR1L - W = TMR1L - PWM-Value
        btfss STATUS,C                 ; if C=0, -> TMR1L < PWM-Value
         bsf PORTC,1                   ; .. then switch LED_4 on
        btfsc STATUS,C                 ; if C=1, -> TMR1L >= PWM-Value
         bcf PORTC,1                   ; .. then switch LED_4 off

        movf R_PWM6,W                  ; get PWM-value into W-register
        subwf TMR1L,W                  ; W = TMR1L - W = TMR1L - PWM-Value
        btfss STATUS,C                 ; if C=0, -> TMR1L < PWM-Value
         bsf PORTC,2                   ; .. then switch LED_4 on
        btfsc STATUS,C                 ; if C=1, -> TMR1L >= PWM-Value
         bcf PORTC,2                   ; .. then switch LED_4 off

        movf R_PWM7,W                  ; get PWM-value into W-register
        subwf TMR1L,W                  ; W = TMR1L - W = TMR1L - PWM-Value
        btfss STATUS,C                 ; if C=0, -> TMR1L < PWM-Value
         bsf PORTC,0                   ; .. then switch LED_4 on
        btfsc STATUS,C                 ; if C=1, -> TMR1L >= PWM-Value
         bcf PORTC,0                   ; .. then switch LED_4 off

        movf R_PWM8,W                  ; get PWM-value into W-register
        subwf TMR1L,W                  ; W = TMR1L - W = TMR1L - PWM-Value
        btfss STATUS,C                 ; if C=0, -> TMR1L < PWM-Value
         bsf PORTC,5                   ; .. then switch LED_4 on
        btfsc STATUS,C                 ; if C=1, -> TMR1L >= PWM-Value
         bcf PORTC,5                   ; .. then switch LED_4 off

        movf R_PWM9,W                  ; get PWM-value into W-register
        subwf TMR1L,W                  ; W = TMR1L - W = TMR1L - PWM-Value
        btfss STATUS,C                 ; if C=0, -> TMR1L < PWM-Value
         bsf PORTC,4                   ; .. then switch LED_4 on
        btfsc STATUS,C                 ; if C=1, -> TMR1L >= PWM-Value
         bcf PORTC,4                   ; .. then switch LED_4 off

        movf R_PWM10,W                 ; get PWM-value into W-register
        subwf TMR1L,W                  ; W = TMR1L - W = TMR1L - PWM-Value
        btfss STATUS,C                 ; if C=0, -> TMR1L < PWM-Value
         bsf PORTC,3                   ; .. then switch LED_4 on
        btfsc STATUS,C                 ; if C=1, -> TMR1L >= PWM-Value
         bcf PORTC,3                   ; .. then switch LED_4 off
;   -------------------------
;   --- create 3ms-Raster ---
;   -------------------------
#ifndef test
        movf TMR1H,F 
        btfsc STATUS,Z                 ; if TMR1H <> ZERO
         return
        clrf TMR1H                     ; .. then reset to ZERO
#endif

        clrf PORTA                     ; .. switch LEDs OFF
        clrf PORTC                     ; .. switch LEDs OFF
        
; ######## led 01 ########
led01   ; ***** State "flash" *****
        btfss R_STATE1,0
         goto led01_1
        ; *** PWM auf 100% ***
        movlw h'ff'
        movwf R_PWM1
        ; *** Verzoegerung ***     
        decfsz R_VERZ1,F
         goto led02

        ; *** Status wechseln ***
        clrf R_STATE1
        bsf R_STATE1,1                 ; change R_STATEx
        ; *** PWM vorladen ***
        movlw PWM_start_1              ; Anfangshelligkeit
        movwf R_PWM1

led01_1 ; ***** State "fade in" *****
        btfss R_STATE1,1
         goto led01_2

        ; *** Verzoegerung Einblendung ***     
        decfsz R_VERZ1,F
         goto led02
        movlw PWM_verz_ein_1           ; 15 x 3ms = 45 ms fr jede PWM-Stufe
        movwf R_VERZ1                  ; 45 ms x (255-25) = 45 x 230 ms = 10.350 ms
                                       ; von 10% auf 100% PWM
        ; *** PWM aufdrehen ***
        incfsz R_PWM1,F
         goto led02

        ; *** Status wechseln ***
        decf R_PWM1,F                 ; wenn 0 dann 255
        clrf R_STATE1
        bsf R_STATE1,2                ; change R_STATEx

        movlw d'20'                    ; zu verlngern, zum anderen damit die Schwankungen nicht zu haufig auftreten
        movwf R_VERZ_A                ; Zeitbereich von 40 * 255 * 3 ms = 30 sec. und eine minimales Zeitraster von 40 * 3 ms = 120 ms 

led01_2 ; ***** State "on" *****
        btfss R_STATE1,2
         goto led01_3

        ; *** Gasdruckschwankungen (fuer alle LEDs) ***
        decfsz R_VERZ_A,F              ; 1. Verzgerungszhler (slow down:)
         goto led02                   ; R_VERZ2 wird ebenfalls gebraucht, um zum einen die "low power" Zeit (Niederdruck-Zeit)
        movlw h'30'                   ; zu verlngern, zum anderen damit die Schwankungen nicht zu haufig auftreten
        movwf R_VERZ_A                 ; Zeitbereich von 40 * 255 * 3 ms = 30 sec. und eine minimales Zeitraster von 40 * 3 ms = 120 ms 

        ; *** PWM auf 100% ***
        movlw h'ff'
        movwf R_PWM1
        movwf R_PWM2
        movwf R_PWM3
        movwf R_PWM4
        movwf R_PWM5
        movwf R_PWM6
        movwf R_PWM7
        movwf R_PWM8
        movwf R_PWM9
        movwf R_PWM10

        decfsz R_VERZ1,F              ; 2. Verzgerungs-Zhler
         goto led02
        
        movlw d'133'                    ; Varianz im Timing fr 2. Verzgerungs-Zhler
        addwf R_VERZ_B,W
        movwf R_VERZ_B
        movwf R_VERZ1
        
        movlw h'88'                   ; Gasdruckschwankung
        btfsc R_MODE,2                 ; Skip Schwankungen in Mode 3
         movlw h'ff'
        btfsc R_MODE,3                 ; Skip Schwankungen in Mode 4
         movlw h'ff'

        movwf R_PWM1
        movwf R_PWM2
        movwf R_PWM3
        movwf R_PWM4
        movwf R_PWM5
        movwf R_PWM6
        movwf R_PWM7
        movwf R_PWM8
        movwf R_PWM9
        movwf R_PWM10

        goto led02

led01_3; ***** State "fade off" *****
        btfss R_STATE1,3
         goto led01_4

        ; *** Verzoegerung Ausblendung ***     
        decfsz R_VERZ1,F
         goto led02
        movlw PWM_verz_aus_1           ; 6 x 3ms = 18 ms fr jede PWM-Stufe
        movwf R_VERZ1                  ; 18 ms x 255 = 4.590 ms
                                       ; von 100% auf 0% PWM
        ; *** PWM runterdrehen ***
        decfsz R_PWM1,F
         goto led02

led01_4 ; ***** State "off" *****
        ; *** PWM auf 0% ***
        clrf R_PWM1
        ; *** VERZ vorladen ***
        movlw d'25'                    ; laenge des FLASH
        movwf R_VERZ1
        ; *** Status loeschen ***
        clrf R_STATE1
        goto led02

; ######## led 02 ########
led02   ; ***** State "flash" *****
        btfss R_STATE2,0
         goto led02_1
        ; *** PWM auf 100% ***
        movlw h'ff'
        movwf R_PWM2
        ; *** Verzoegerung ***     
        decfsz R_VERZ2,F
         goto led03

        ; *** Status wechseln ***
        clrf R_STATE2
        bsf R_STATE2,1                 ; change R_STATEx
        ; *** PWM vorladen ***
        movlw PWM_start_2              ; Anfangshelligkeit
        movwf R_PWM2

led02_1 ; ***** State "fade in" *****
        btfss R_STATE2,1
         goto led02_2

        ; *** Verzoegerung Einblendung ***     
        decfsz R_VERZ2,F
         goto led03
        movlw PWM_verz_ein_2           ; 15 x 3ms = 45 ms fr jede PWM-Stufe
        movwf R_VERZ2                  ; 45 ms x (255-25) = 45 x 230 ms = 10.350 ms
                                       ; von 10% auf 100% PWM
        ; *** PWM aufdrehen ***
        incfsz R_PWM2,F
         goto led03

        ; *** Status wechseln ***
        decf R_PWM2,F                 ; wenn 0 dann 255
        clrf R_STATE2
        bsf R_STATE2,2                ; change R_STATEx

led02_2 ; ***** State "on" *****
        btfss R_STATE2,2
         goto led02_3

        ; *** PWM auf 100% ***
        goto led03

led02_3; ***** State "fade off" *****
        btfss R_STATE2,3
         goto led02_4

        ; *** Verzoegerung Ausblendung ***     
        decfsz R_VERZ2,F
         goto led03
        movlw PWM_verz_aus_2           ; 6 x 3ms = 18 ms fr jede PWM-Stufe
        movwf R_VERZ2                  ; 18 ms x 255 = 4.590 ms
                                       ; von 100% auf 0% PWM
        ; *** PWM runterdrehen ***
        decfsz R_PWM2,F
         goto led03

led02_4 ; ***** State "off" *****
        ; *** PWM auf 0% ***
        clrf R_PWM2
        ; *** VERZ vorladen ***
        movlw d'20'                    ; laenge des FLASH
        movwf R_VERZ2
        ; *** Status loeschen ***
        clrf R_STATE2
        goto led03
 
; ######## led 03 ########
led03   ; ***** State "flash" *****
        btfss R_STATE3,0
         goto led03_1
        ; *** PWM auf 100% ***
        movlw h'ff'
        movwf R_PWM3
        ; *** Verzoegerung ***     
        decfsz R_VERZ3,F
         goto led04

        ; *** Status wechseln ***
        clrf R_STATE3
        bsf R_STATE3,1                 ; change R_STATEx
        ; *** PWM vorladen ***
        movlw PWM_start_3              ; Anfangshelligkeit
        movwf R_PWM3

led03_1 ; ***** State "fade in" *****
        btfss R_STATE3,1
         goto led03_2

        ; *** Verzoegerung Einblendung ***     
        decfsz R_VERZ3,F
         goto led04
        movlw PWM_verz_ein_3           ; 15 x 3ms = 45 ms fr jede PWM-Stufe
        movwf R_VERZ3                  ; 45 ms x (255-25) = 45 x 230 ms = 10.350 ms
                                       ; von 10% auf 100% PWM
        ; *** PWM aufdrehen ***
        incfsz R_PWM3,F
         goto led04

        ; *** Status wechseln ***
        decf R_PWM3,F                 ; wenn 0 dann 255
        clrf R_STATE3
        bsf R_STATE3,2                ; change R_STATEx

led03_2 ; ***** State "on" *****
        btfss R_STATE3,2
         goto led03_3

        ; *** PWM auf 100% ***
        goto led04

led03_3; ***** State "fade off" *****
        btfss R_STATE3,3
         goto led03_4

        ; *** Verzoegerung Ausblendung ***     
        decfsz R_VERZ3,F
         goto led04
        movlw PWM_verz_aus_3           ; 6 x 3ms = 18 ms fr jede PWM-Stufe
        movwf R_VERZ3                  ; 18 ms x 255 = 4.590 ms
                                       ; von 100% auf 0% PWM
        ; *** PWM runterdrehen ***
        decfsz R_PWM3,F
         goto led04

led03_4 ; ***** State "off" *****
        ; *** PWM auf 0% ***
        clrf R_PWM3
        ; *** VERZ vorladen ***
        movlw d'20'                    ; laenge des FLASH
        movwf R_VERZ3
        ; *** Status loeschen ***
        clrf R_STATE3
        goto led04

; ######## led 04 ########
led04   ; ***** State "flash" *****
        btfss R_STATE4,0
         goto led04_1
        ; *** PWM auf 100% ***
        movlw h'ff'
        movwf R_PWM4
        ; *** Verzoegerung ***     
        decfsz R_VERZ4,F
         goto led05

        ; *** Status wechseln ***
        clrf R_STATE4
        bsf R_STATE4,1                 ; change R_STATEx
        ; *** PWM vorladen ***
        movlw PWM_start_4              ; Anfangshelligkeit
        movwf R_PWM4

led04_1 ; ***** State "fade in" *****
        btfss R_STATE4,1
         goto led04_2

        ; *** Verzoegerung Einblendung ***     
        decfsz R_VERZ4,F
         goto led05
        movlw PWM_verz_ein_4           ; 15 x 3ms = 45 ms fr jede PWM-Stufe
        movwf R_VERZ4                  ; 45 ms x (255-25) = 45 x 230 ms = 10.350 ms
                                       ; von 10% auf 100% PWM
        ; *** PWM aufdrehen ***
        incfsz R_PWM4,F
         goto led05

        ; *** Status wechseln ***
        decf R_PWM4,F                 ; wenn 0 dann 255
        clrf R_STATE4
        bsf R_STATE4,2                ; change R_STATEx

led04_2 ; ***** State "on" *****
        btfss R_STATE4,2
         goto led04_3

        ; *** PWM auf 100% ***
        goto led05

led04_3; ***** State "fade off" *****
        btfss R_STATE4,3
         goto led04_4

        ; *** Verzoegerung Ausblendung ***     
        decfsz R_VERZ4,F
         goto led05
        movlw PWM_verz_aus_4           ; 6 x 3ms = 18 ms fr jede PWM-Stufe
        movwf R_VERZ4                  ; 18 ms x 255 = 4.590 ms
                                       ; von 100% auf 0% PWM
        ; *** PWM runterdrehen ***
        decfsz R_PWM4,F
         goto led05

led04_4 ; ***** State "off" *****
        ; *** PWM auf 0% ***
        clrf R_PWM4
        ; *** VERZ vorladen ***
        movlw d'20'                    ; laenge des FLASH
        movwf R_VERZ4
        ; *** Status loeschen ***
        clrf R_STATE4
        goto led05
    
; ######## led 05 ########
led05   ; ***** State "flash" *****
        btfss R_STATE5,0
         goto led05_1
        ; *** PWM auf 100% ***
        movlw h'ff'
        movwf R_PWM5
        ; *** Verzoegerung ***     
        decfsz R_VERZ5,F
         goto led06

        ; *** Status wechseln ***
        clrf R_STATE5
        bsf R_STATE5,1                 ; change R_STATEx
        ; *** PWM vorladen ***
        movlw PWM_start_5              ; Anfangshelligkeit
        movwf R_PWM5

led05_1 ; ***** State "fade in" *****
        btfss R_STATE5,1
         goto led05_2

        ; *** Verzoegerung Einblendung ***     
        decfsz R_VERZ5,F
         goto led06
        movlw PWM_verz_ein_5           ; 15 x 3ms = 45 ms fr jede PWM-Stufe
        movwf R_VERZ5                  ; 45 ms x (255-25) = 45 x 230 ms = 10.350 ms
                                       ; von 10% auf 100% PWM
        ; *** PWM aufdrehen ***
        incfsz R_PWM5,F
         goto led06

        ; *** Status wechseln ***
        decf R_PWM5,F                 ; wenn 0 dann 255
        clrf R_STATE5
        bsf R_STATE5,2                ; change R_STATEx

led05_2 ; ***** State "on" *****
        btfss R_STATE5,2
         goto led05_3

        ; *** PWM auf 100% ***
        goto led06

led05_3; ***** State "fade off" *****
        btfss R_STATE5,3
         goto led05_4

        ; *** Verzoegerung Ausblendung ***     
        decfsz R_VERZ5,F
         goto led06
        movlw PWM_verz_aus_5           ; 6 x 3ms = 18 ms fr jede PWM-Stufe
        movwf R_VERZ5                  ; 18 ms x 255 = 4.590 ms
                                       ; von 100% auf 0% PWM
        ; *** PWM runterdrehen ***
        decfsz R_PWM5,F
         goto led06

led05_4 ; ***** State "off" *****
        ; *** PWM auf 0% ***
        clrf R_PWM5
        ; *** VERZ vorladen ***
        movlw d'20'                    ; laenge des FLASH
        movwf R_VERZ5
        ; *** Status loeschen ***
        clrf R_STATE5
        goto led06

; ######## led 06 ########
led06   ; ***** State "flash" *****
        btfss R_STATE6,0
         goto led06_1
        ; *** PWM auf 100% ***
        movlw h'ff'
        movwf R_PWM6
        ; *** Verzoegerung ***     
        decfsz R_VERZ6,F
         goto led07

        ; *** Status wechseln ***
        clrf R_STATE6
        bsf R_STATE6,1                 ; change R_STATEx
        ; *** PWM vorladen ***
        movlw PWM_start_6              ; Anfangshelligkeit
        movwf R_PWM6

led06_1 ; ***** State "fade in" *****
        btfss R_STATE6,1
         goto led06_2

        ; *** Verzoegerung Einblendung ***     
        decfsz R_VERZ6,F
         goto led07
        movlw PWM_verz_ein_6           ; 15 x 3ms = 45 ms fr jede PWM-Stufe
        movwf R_VERZ6                  ; 45 ms x (255-25) = 45 x 230 ms = 10.350 ms
                                       ; von 10% auf 100% PWM
        ; *** PWM aufdrehen ***
        incfsz R_PWM6,F
         goto led07

        ; *** Status wechseln ***
        decf R_PWM6,F                 ; wenn 0 dann 255
        clrf R_STATE6
        bsf R_STATE6,2                ; change R_STATEx

led06_2 ; ***** State "on" *****
        btfss R_STATE6,2
         goto led06_3

        ; *** PWM auf 100% ***
        goto led07

led06_3; ***** State "fade off" *****
        btfss R_STATE6,3
         goto led06_4

        ; *** Verzoegerung Ausblendung ***     
        decfsz R_VERZ6,F
         goto led07
        movlw PWM_verz_aus_6           ; 6 x 3ms = 18 ms fr jede PWM-Stufe
        movwf R_VERZ6                  ; 18 ms x 255 = 4.590 ms
                                       ; von 100% auf 0% PWM
        ; *** PWM runterdrehen ***
        decfsz R_PWM6,F
         goto led07

led06_4 ; ***** State "off" *****
        ; *** PWM auf 0% ***
        clrf R_PWM6
        ; *** VERZ vorladen ***
        movlw d'20'                    ; laenge des FLASH
        movwf R_VERZ6
        ; *** Status loeschen ***
        clrf R_STATE6
        goto led07

; ######## led 07 ########
led07   ; ***** State "flash" *****
        btfss R_STATE7,0
         goto led07_1
        ; *** PWM auf 100% ***
        movlw h'ff'
        movwf R_PWM7
        ; *** Verzoegerung ***     
        decfsz R_VERZ7,F
         goto led08

        ; *** Status wechseln ***
        clrf R_STATE7
        bsf R_STATE7,1                 ; change R_STATEx
        ; *** PWM vorladen ***
        movlw PWM_start_7              ; Anfangshelligkeit
        movwf R_PWM7

led07_1 ; ***** State "fade in" *****
        btfss R_STATE7,1
         goto led07_2

        ; *** Verzoegerung Einblendung ***     
        decfsz R_VERZ7,F
         goto led08
        movlw PWM_verz_ein_7           ; 15 x 3ms = 45 ms fr jede PWM-Stufe
        movwf R_VERZ7                  ; 45 ms x (255-25) = 45 x 230 ms = 10.350 ms
                                       ; von 10% auf 100% PWM
        ; *** PWM aufdrehen ***
        incfsz R_PWM7,F
         goto led08

        ; *** Status wechseln ***
        decf R_PWM7,F                 ; wenn 0 dann 255
        clrf R_STATE7
        bsf R_STATE7,2                ; change R_STATEx

led07_2 ; ***** State "on" *****
        btfss R_STATE7,2
         goto led07_3

        ; *** PWM auf 100% ***
        goto led08

led07_3; ***** State "fade off" *****
        btfss R_STATE7,3
         goto led07_4

        ; *** Verzoegerung Ausblendung ***     
        decfsz R_VERZ7,F
         goto led08
        movlw PWM_verz_aus_7           ; 6 x 3ms = 18 ms fr jede PWM-Stufe
        movwf R_VERZ7                  ; 18 ms x 255 = 4.590 ms
                                       ; von 100% auf 0% PWM
        ; *** PWM runterdrehen ***
        decfsz R_PWM7,F
         goto led08

led07_4 ; ***** State "off" *****
        ; *** PWM auf 0% ***
        clrf R_PWM7
        ; *** VERZ vorladen ***
        movlw d'20'                    ; laenge des FLASH
        movwf R_VERZ7
        ; *** Status loeschen ***
        clrf R_STATE7
        goto led08

; ######## led 08 ########
led08   ; ***** State "flash" *****
        btfss R_STATE8,0
         goto led08_1
        ; *** PWM auf 100% ***
        movlw h'ff'
        movwf R_PWM8
        ; *** Verzoegerung ***     
        decfsz R_VERZ8,F
         goto led09

        ; *** Status wechseln ***
        clrf R_STATE8
        bsf R_STATE8,1                 ; change R_STATEx
        ; *** PWM vorladen ***
        movlw PWM_start_8              ; Anfangshelligkeit
        movwf R_PWM8

led08_1 ; ***** State "fade in" *****
        btfss R_STATE8,1
         goto led08_2

        ; *** Verzoegerung Einblendung ***     
        decfsz R_VERZ8,F
         goto led09
        movlw PWM_verz_ein_8           ; 15 x 3ms = 45 ms fr jede PWM-Stufe
        movwf R_VERZ8                  ; 45 ms x (255-25) = 45 x 230 ms = 10.350 ms
                                       ; von 10% auf 100% PWM
        ; *** PWM aufdrehen ***
        incfsz R_PWM8,F
         goto led09

        ; *** Status wechseln ***
        decf R_PWM8,F                 ; wenn 0 dann 255
        clrf R_STATE8
        bsf R_STATE8,2                ; change R_STATEx

led08_2 ; ***** State "on" *****
        btfss R_STATE8,2
         goto led08_3

        ; *** PWM auf 100% ***
        goto led09

led08_3; ***** State "fade off" *****
        btfss R_STATE8,3
         goto led08_4

        ; *** Verzoegerung Ausblendung ***     
        decfsz R_VERZ8,F
         goto led09
        movlw PWM_verz_aus_8           ; 6 x 3ms = 18 ms fr jede PWM-Stufe
        movwf R_VERZ8                  ; 18 ms x 255 = 4.590 ms
                                       ; von 100% auf 0% PWM
        ; *** PWM runterdrehen ***
        decfsz R_PWM8,F
         goto led09

led08_4 ; ***** State "off" *****
        ; *** PWM auf 0% ***
        clrf R_PWM8
        ; *** VERZ vorladen ***
        movlw d'20'                    ; laenge des FLASH
        movwf R_VERZ8
        ; *** Status loeschen ***
        clrf R_STATE8
        goto led09

; ######## led 09 ########
led09   ; ***** State "flash" *****
        btfss R_STATE9,0
         goto led09_1
        ; *** PWM auf 100% ***
        movlw h'ff'
        movwf R_PWM9
        ; *** Verzoegerung ***     
        decfsz R_VERZ9,F
         goto led10

        ; *** Status wechseln ***
        clrf R_STATE9
        bsf R_STATE9,1                 ; change R_STATEx
        ; *** PWM vorladen ***
        movlw PWM_start_9              ; Anfangshelligkeit
        movwf R_PWM9

led09_1 ; ***** State "fade in" *****
        btfss R_STATE9,1
         goto led09_2

        ; *** Verzoegerung Einblendung ***     
        decfsz R_VERZ9,F
         goto led10
        movlw PWM_verz_ein_9           ; 15 x 3ms = 45 ms fr jede PWM-Stufe
        movwf R_VERZ9                  ; 45 ms x (255-25) = 45 x 230 ms = 10.350 ms
                                       ; von 10% auf 100% PWM
        ; *** PWM aufdrehen ***
        incfsz R_PWM9,F
         goto led10

        ; *** Status wechseln ***
        decf R_PWM9,F                 ; wenn 0 dann 255
        clrf R_STATE9
        bsf R_STATE9,2                ; change R_STATEx

led09_2 ; ***** State "on" *****
        btfss R_STATE9,2
         goto led09_3

        ; *** PWM auf 100% ***
        goto led10

led09_3; ***** State "fade off" *****
        btfss R_STATE9,3
         goto led09_4

        ; *** Verzoegerung Ausblendung ***     
        decfsz R_VERZ9,F
         goto led10
        movlw PWM_verz_aus_9           ; 6 x 3ms = 18 ms fr jede PWM-Stufe
        movwf R_VERZ9                  ; 18 ms x 255 = 4.590 ms
                                       ; von 100% auf 0% PWM
        ; *** PWM runterdrehen ***
        decfsz R_PWM9,F
         goto led10

led09_4 ; ***** State "off" *****
        ; *** PWM auf 0% ***
        clrf R_PWM9
        ; *** VERZ vorladen ***
        movlw d'20'                    ; laenge des FLASH
        movwf R_VERZ9
        ; *** Status loeschen ***
        clrf R_STATE9
        goto led10

; ######## led 10 ########
led10   ; ***** State "flash" *****
        btfss R_STATE10,0
         goto led10_1
        ; *** PWM auf 100% ***
        movlw h'ff'
        movwf R_PWM10
        ; *** Verzoegerung ***     
        decfsz R_VERZ10,F
         goto led11

        ; *** Status wechseln ***
        clrf R_STATE10
        bsf R_STATE10,1                ; change R_STATEx
        ; *** PWM vorladen ***
        movlw PWM_start_10             ; Anfangshelligkeit
        movwf R_PWM10

led10_1 ; ***** State "fade in" *****
        btfss R_STATE10,1
         goto led10_2

        ; *** Verzoegerung Einblendung ***     
        decfsz R_VERZ10,F
         goto led11
        movlw PWM_verz_ein_10          ; 15 x 3ms = 45 ms fr jede PWM-Stufe
        movwf R_VERZ10                 ; 45 ms x (255-25) = 45 x 230 ms = 10.350 ms
                                       ; von 10% auf 100% PWM
        ; *** PWM aufdrehen ***
        incfsz R_PWM10,F
         goto led11

        ; *** Status wechseln ***
        decf R_PWM10,F                 ; wenn 0 dann 255
        clrf R_STATE10
        bsf R_STATE10,2                ; change R_STATEx

led10_2 ; ***** State "on" *****
        btfss R_STATE10,2
         goto led10_3

        ; *** PWM auf 100% ***
        goto led11

led10_3; ***** State "fade off" *****
        btfss R_STATE10,3
         goto led10_4

        ; *** Verzoegerung Ausblendung ***     
        decfsz R_VERZ10,F
         goto led11
        movlw PWM_verz_aus_10          ; 6 x 3ms = 18 ms fr jede PWM-Stufe
        movwf R_VERZ10                 ; 18 ms x 255 = 4.590 ms
                                       ; von 100% auf 0% PWM
        ; *** PWM runterdrehen ***
        decfsz R_PWM10,F
         goto led11

led10_4 ; ***** State "off" *****
        ; *** PWM auf 0% ***
        clrf R_PWM10
        ; *** VERZ vorladen ***
        movlw d'20'                    ; laenge des FLASH
        movwf R_VERZ10
        ; *** Status loeschen ***
        clrf R_STATE10
        goto led11

led11   return


