; ********************************************************
; ** Version: V3.00 vom 24/07/2006                      **
; ********************************************************
; ** Include-File zu dekoder.asm                        **
; ********************************************************
; ** Sven Brandt                                        **
; ********************************************************
; Copyright (C) 2003/04/05 Sven Brandt

;*********************************
;*********************************
;*********************************
;*********************************
;** Routine: statemachine_kirmes**
;** Blinksmdus                  **
;*********************************
;*********************************
;*********************************
;*********************************
statemachine_kirmes

;   -------------------------
;   --- create 3ms-Raster ---
;   -------------------------
#ifndef test
        movf TMR1H,F 
        btfsc STATUS,Z                 ; if TMR1H <> ZERO
         return
        clrf TMR1H                     ; .. then reset to ZERO
#endif

        ; *** Verzgerung ***     
        decfsz R_VERZ,F
         return
        movf R_MAKESLOW,W
        movwf R_VERZ

        decfsz R_TIME,F
         return

        movf R_TIME_L,W                ; laden von R_TIME_L = Tabellenwert[R_POINTER2
        movwf R_TIME                   ; .. into R_TIME

        movlw b'00000111'              ; check MODE
        andwf R_STATUS,W 
        btfsc STATUS,Z
         goto kirmes_03                ; if not a flash-Mode then jump (LEDs off)

        btfsc R_EFFECT,7               ; increment / decrement R_POINTER1
         incf R_POINTER1,F             ; depending on
        btfss R_EFFECT,7               ; #7 of
         decf R_POINTER1,F             ; R_EFFECT = Tabellenwert[R_POINTER2]

        ; *** ber-/ Unterlauf fuer R_POINTER1 anfangen (Bereich 0..9) ***
        movlw 9+1                      ; Anzahl der Tabellenzeilen (# of rows) +1
        subwf R_POINTER1,W             ; W = R_POINTER1 - W = R_POINTER1 - Anzahl+1
        btfss STATUS,C                 ; if C=0, -> R_POINTER1 < Anzahl+1
         goto kirmes_02                ; .. jump
        clrf R_POINTER1                ; else R_POINTER1 = 0
        movlw d'9'                     ; if down-counting..
        btfss R_EFFECT,7               ; ..then preload R_POINTER1
         movwf R_POINTER1              ; .. with "Anzahl der Tabellenzeilen"

        ; *** @ berlauf R_POINTER1: todo-Durchlufe decrementieren bis zu ZERO
        decf R_EFFECT,W                ; Anzahl der
        movwf R_EFFECT                 ; .. geforderten Durchlufe
        andlw b'01111111'              ; .. R_EFFECT = Tabellenwert[R_POINTER2]
        btfss STATUS,Z                 ; .. decrementieren
         goto kirmes_02                ; wenn <>0, springe

        ; *** @ R_EFFECT = ZERO: Zeiger R_POINTER2 fr Effect-Nummer incrementieren  ***
        incf R_POINTER2,F
        movlw d'15'+1                  ; Anzahl der Tabellenzeilen (# of rows) +1
        subwf R_POINTER2,W             ; W = R_POINTER2 - W = R_POINTER2 - Anzahl+1
        btfss STATUS,C                 ; if C=0, -> R_POINTER2 < Anzahl+1
         goto kirmes_01                ; .. jump
        clrf R_POINTER2                ; else R_POINTER2 = 0

        
kirmes_01 ; *** Register R_EFFECT neu laden, neuer Effekt ***
        call T_MODE01A
        movwf R_EFFECT                 ; R_EFFECT = Tabellenwert[R_POINTER2]
        call T_MODE01B
        movwf R_EFFECT_NR              ; R_EFFECT_NR = Tabellenwert[R_POINTER2]
        call T_MODE01C
        movwf R_TIME_L                 ; R_TIME_L = Tabellenwert[R_POINTER2]
        movwf R_TIME                   ; .. and into R_TIME

        ; R_POINTER1 initialisieren, da neuer Effekt-Anfang
        clrf R_POINTER1                ; Preload R_POINTER1 = 0
        movlw d'9'                     ; if down-counting..
        btfss R_EFFECT,7               ; ..then preload R_POINTER1
         movwf R_POINTER1              ; .. with "Anzahl der Tabellenzeilen"


kirmes_02 ; *** LEDs neu Setzen, neue Effekt-Stufe ***
        call TABLE01A                  ; PortA = Tabellenwert[R_POINTER1;R_EFFECT_NR]
        movwf PORTA
        call TABLE01C                  ; PortC = Tabellenwert[R_POINTER1;R_EFFECT_NR]
        movwf PORTC
        return                         ; .. then return

kirmes_03 ; *** LEDs aus, kein Blink-Mode ***
        clrf PORTA
        clrf PORTC
        return                         ; .. then return

; ***********************
; **  Tabelle for mode **
; ***********************
 org 0250
T_MODE01A; R_POINTER2 -> R_EFFECT
        movlw b'00000010'              ; load PCLATH with High Adress
        movwf PCLATH
        movf R_POINTER2,W              ; 
        btfss R_STATUS,0
         goto $+3         
          addlw h'88'
          movwf PCL
        btfss R_STATUS,1
         goto $+3         
          addlw h'88'
          movwf PCL
        btfss R_STATUS,2
         goto $+3         
          addlw h'98'
          movwf PCL
        retlw d'00'                    ; wenn nicht Mode 1

T_MODE01B; R_POINTER2 -> R_EFFECT_NR
        movlw b'00000010'              ; load PCLATH with High Adress
        movwf PCLATH
        movf R_POINTER2,W              ; 
        btfss R_STATUS,0
         goto $+3         
          addlw h'a8'
          movwf PCL
        btfss R_STATUS,1
         goto $+3         
          addlw h'b8'
          movwf PCL
        btfss R_STATUS,2
         goto $+3         
          addlw h'b8'
          movwf PCL
        retlw d'00'                    ; wenn nicht Mode 1

T_MODE01C; R_POINTER2 -> R_TIME_L
        movlw b'00000010'              ; load PCLATH with High Adress
        movwf PCLATH
        movf R_POINTER2,W              ; 
        btfss R_STATUS,0
         goto $+3         
          addlw h'c8'
          movwf PCL
        btfss R_STATUS,1
         goto $+3         
          addlw h'd8'
          movwf PCL
        btfss R_STATUS,2
         goto $+3         
          addlw h'e8'
          movwf PCL
        retlw d'01'                    ; wenn nicht Mode 1


; **********************************************************
; **  Tabelle for up/down and number of runnings Mode 1+2 **
; **********************************************************
 org 288
;               +-- 0= Counting Down, 1= Counting Up (Effect running "left" / "right")
;               |+++++++-- Number of Runnings with this effect (xxxx 1111 = 16 runs)
;               ||||||||
        retlw b'00000111' ; #00
        retlw b'10000111' ; #01
        retlw b'00000111' ; #02
        retlw b'10000111' ; #03
        retlw b'00000011' ; #04
        retlw b'10000011' ; #05
        retlw b'00000011' ; #06
        retlw b'10000011' ; #07
        retlw b'00001011' ; #08
        retlw b'00000011' ; #09
        retlw b'00001111' ; #10
        retlw b'00000111' ; #11
        retlw b'00001011' ; #12
        retlw b'00000011' ; #13
        retlw b'00000011' ; #14
        retlw b'00000111' ; #15

; ********************************************************
; **  Tabelle for up/down and number of runnings Mode 3 **
; ********************************************************
 org 298
;               +-- 0= Counting Down, 1= Counting Up (Effect running "left" / "right")
;               |+++++++-- Number of Runnings with this effect (xxxx 1111 = 16 runs)
;               ||||||||
        retlw b'00000101' ; #00
        retlw b'10000111' ; #01
        retlw b'00000111' ; #02
        retlw b'00100101' ; #03
        retlw b'10000011' ; #04
        retlw b'00000011' ; #05
        retlw b'00000111' ; #06
        retlw b'10001001' ; #07
        retlw b'00001011' ; #08
        retlw b'00000011' ; #09
        retlw b'10001111' ; #10
        retlw b'00000101' ; #11
        retlw b'10001011' ; #12
        retlw b'00010001' ; #13
        retlw b'00000011' ; #14
        retlw b'00000011' ; #15

; ********************************************************
; **  Tabelle for Number of effect Mode 1               **
; ********************************************************
 org 2a8
;               +-- 5er Flash (Richtung ist egal)
;               |+-- 2er Leitlicht ber Kreus (Richtung ist egal)
;               ||+-- 2er Leitlicht ber Kreus (Richtung ist egal)
;               |||+-- 2er Lauflicht ber Kreus (Richtung ist egal)
;               ||||+-- 2er Lauflicht
;               |||||+-- Leitlicht DOWM
;               ||||||+-- Leitlicht UP
;               |||||||+-- Lauflicht
;               ||||||||
        retlw b'00000001' ; #00
        retlw b'00000001' ; #01
        retlw b'00000010' ; #02
        retlw b'00000010' ; #03
        retlw b'00000100' ; #04
        retlw b'00000100' ; #05
        retlw b'00001000' ; #06
        retlw b'00001000' ; #07
        retlw b'00010000' ; #08
        retlw b'00010000' ; #09
        retlw b'00100000' ; #10
        retlw b'00100000' ; #11
        retlw b'01000000' ; #12
        retlw b'01000000' ; #13
        retlw b'10000000' ; #14
        retlw b'10000000' ; #15

; ********************************************************
; **  Tabelle for Number of effect Mode 2+3             **
; ********************************************************
 org 2b8
;               +-- 5er Flash (Richtung ist egal)
;               |+-- 2er Leitlicht ber Kreus (Richtung ist egal)
;               ||+-- 2er Leitlicht ber Kreus (Richtung ist egal)
;               |||+-- 2er Lauflicht ber Kreus (Richtung ist egal)
;               ||||+-- 2er Lauflicht
;               |||||+-- Leitlicht DOWM
;               ||||||+-- Leitlicht UP
;               |||||||+-- Lauflicht
;               ||||||||
        retlw b'00001000' ; #00
        retlw b'00000100' ; #01
        retlw b'00000010' ; #02
        retlw b'10000000' ; #03
        retlw b'01000000' ; #04
        retlw b'10000000' ; #05
        retlw b'00010000' ; #06
        retlw b'00000010' ; #07
        retlw b'00000100' ; #08
        retlw b'00010000' ; #09
        retlw b'00100000' ; #10
        retlw b'00000001' ; #11
        retlw b'00000100' ; #12
        retlw b'01000000' ; #13
        retlw b'10000100' ; #14
        retlw b'10000000' ; #15

; ********************************************************
; **  Tabelle for Speed of each effect Mode 1           **
; ********************************************************
 org 2c8
        retlw b'00001001' ; #00
        retlw b'00001001' ; #01
        retlw b'00001010' ; #02
        retlw b'00001010' ; #03
        retlw b'00001000' ; #04
        retlw b'00001000' ; #05
        retlw b'00001000' ; #06
        retlw b'00001000' ; #07
        retlw b'00001000' ; #08
        retlw b'00011000' ; #09
        retlw b'00001000' ; #10
        retlw b'00011000' ; #11
        retlw b'00001000' ; #12
        retlw b'00011000' ; #13
        retlw b'00010000' ; #14
        retlw b'00001000' ; #15

; ********************************************************
; **  Tabelle for Speed of each effect Mode 2           **
; ********************************************************
 org 2d8
        retlw b'00001001' ; #00
        retlw b'00101001' ; #01
        retlw b'00001010' ; #02
        retlw b'00011010' ; #03
        retlw b'00101000' ; #04
        retlw b'00001000' ; #05
        retlw b'00001000' ; #06
        retlw b'00001000' ; #07
        retlw b'00001010' ; #08
        retlw b'00111000' ; #09
        retlw b'00001000' ; #10
        retlw b'00011010' ; #11
        retlw b'00001000' ; #12
        retlw b'01011000' ; #13
        retlw b'00010000' ; #14
        retlw b'01001000' ; #15

; ********************************************************
; **  Tabelle for Speed of each effect Mode 3           **
; ********************************************************
 org 2e8
        retlw b'00101001' ; #00
        retlw b'00001001' ; #01
        retlw b'00001010' ; #02
        retlw b'00001010' ; #03
        retlw b'00101000' ; #04
        retlw b'00001000' ; #05
        retlw b'00001000' ; #06
        retlw b'01001000' ; #07
        retlw b'00101000' ; #08
        retlw b'00011000' ; #09
        retlw b'10001000' ; #10
        retlw b'00011000' ; #11
        retlw b'00101000' ; #12
        retlw b'00011000' ; #13
        retlw b'00010000' ; #14
        retlw b'00001000' ; #15

; ********************************************************
; **  call Tabelle for effect                           **
; ********************************************************
 org 0300
TABLE01A ; Port A
        movlw b'00000011'              ; load PCLATH with High Adress
        movwf PCLATH
        movf R_POINTER1,W              ; 
        btfss R_EFFECT_NR,0
         goto $+3         
          addlw h'4b'
          movwf PCL
        btfss R_EFFECT_NR,1
         goto $+3         
          addlw h'56'
          movwf PCL
        btfss R_EFFECT_NR,2
         goto $+3         
          addlw h'61'
          movwf PCL
        btfss R_EFFECT_NR,3
         goto $+3         
          addlw h'6c'
          movwf PCL
        btfss R_EFFECT_NR,4
         goto $+3         
          addlw h'77'
          movwf PCL
        btfss R_EFFECT_NR,5
         goto $+3         
          addlw h'82'
          movwf PCL
        btfss R_EFFECT_NR,6
         goto $+3         
          addlw h'8d'
          movwf PCL
        btfss R_EFFECT_NR,7
         goto $+3         
          addlw h'98'
          movwf PCL
        retlw d'00'

TABLE01C ; Port C
        movlw b'00000011'              ; load PCLATH with High Adress
        movwf PCLATH
        movf R_POINTER1,W              ; 
        btfss R_EFFECT_NR,0
         goto $+3         
          addlw h'a3'
          movwf PCL
        btfss R_EFFECT_NR,1
         goto $+3         
          addlw h'ae'
          movwf PCL
        btfss R_EFFECT_NR,2
         goto $+3         
          addlw h'b9'
          movwf PCL
        btfss R_EFFECT_NR,3
         goto $+3         
          addlw h'c4'
          movwf PCL
        btfss R_EFFECT_NR,4
         goto $+3         
          addlw h'cf'
          movwf PCL
        btfss R_EFFECT_NR,5
         goto $+3         
          addlw h'da'
          movwf PCL
        btfss R_EFFECT_NR,6
         goto $+3         
          addlw h'e5'
          movwf PCL
        btfss R_EFFECT_NR,7
         goto $+3         
          addlw h'f0'
          movwf PCL
        retlw d'00'

; ********************************************************
; **  Tabelle A for effect00 = Lauflicht                **
; ********************************************************
 org 34b
;                 +-- LED# 2
;                 |+-- LED# 1
;                 ||  +-- LED# 4
;                 ||  |+-- LED# 3
;                 ||  ||
        retlw b'00010000' ; #00
        retlw b'00100000' ; #01
        retlw b'00000001' ; #02
        retlw b'00000010' ; #03
        retlw b'00000000' ; #04
        retlw b'00000000' ; #05
        retlw b'00000000' ; #06
        retlw b'00000000' ; #07
        retlw b'00000000' ; #08
        retlw b'00000000' ; #09

; ********************************************************
; **  Tabelle A for effect01 = Leitlicht UP             **
; ********************************************************
 org 356
;                 +-- LED# 2
;                 |+-- LED# 1
;                 ||  +-- LED# 4
;                 ||  |+-- LED# 3
;                 ||  ||
        retlw b'00010000' ; #00
        retlw b'00110000' ; #01
        retlw b'00110001' ; #02
        retlw b'00110011' ; #03
        retlw b'00110011' ; #04
        retlw b'00110011' ; #05
        retlw b'00110011' ; #06
        retlw b'00110011' ; #07
        retlw b'00110011' ; #08
        retlw b'00110011' ; #09

; ********************************************************
; **  Tabelle A for effect02 = Leitlicht DOWN           **
; ********************************************************
 org 361
;                 +-- LED# 2
;                 |+-- LED# 1
;                 ||  +-- LED# 4
;                 ||  |+-- LED# 3
;                 ||  ||
        retlw b'00000000' ; #00
        retlw b'00000000' ; #01
        retlw b'00000000' ; #02
        retlw b'00000000' ; #03
        retlw b'00000000' ; #04
        retlw b'00000000' ; #05
        retlw b'00000010' ; #06
        retlw b'00000011' ; #07
        retlw b'00100011' ; #08
        retlw b'00110011' ; #09

; ********************************************************
; **  Tabelle A for effect03 = 2er Lauflicht            **
; ********************************************************
 org 36c
;                 +-- LED# 2
;                 |+-- LED# 1
;                 ||  +-- LED# 4
;                 ||  |+-- LED# 3
;                 ||  ||
        retlw b'00010000' ; #00
        retlw b'00100000' ; #01
        retlw b'00000001' ; #02
        retlw b'00000010' ; #03
        retlw b'00000000' ; #04
        retlw b'00010000' ; #05
        retlw b'00100000' ; #06
        retlw b'00000001' ; #07
        retlw b'00000010' ; #08
        retlw b'00000000' ; #09

; ********************************************************
; **  Tabelle A for effect04 = 2er Lauflicht ber Kreuz **
; ********************************************************
 org 377
;                 +-- LED# 2
;                 |+-- LED# 1
;                 ||  +-- LED# 4
;                 ||  |+-- LED# 3
;                 ||  ||
        retlw b'00010000' ; #00
        retlw b'00100000' ; #01
        retlw b'00000001' ; #02
        retlw b'00000010' ; #03
        retlw b'00000000' ; #04
        retlw b'00000000' ; #05
        retlw b'00000010' ; #06
        retlw b'00000001' ; #07
        retlw b'00100000' ; #08
        retlw b'00010000' ; #09

; ********************************************************
; **  Tabelle A for effect05 = 2er Leitlicht ber Kreuz **
; ********************************************************
 org 382
;                 +-- LED# 2
;                 |+-- LED# 1
;                 ||  +-- LED# 4
;                 ||  |+-- LED# 3
;                 ||  ||
        retlw b'00010000' ; #00
        retlw b'00110000' ; #01
        retlw b'00110001' ; #02
        retlw b'00110011' ; #03
        retlw b'00110011' ; #04
        retlw b'00110011' ; #05
        retlw b'00110001' ; #06
        retlw b'00110000' ; #07
        retlw b'00010000' ; #08
        retlw b'00000000' ; #09

; ********************************************************
; **  Tabelle A for effect06 = 2er Leitlicht ber Kreuz **
; ********************************************************
 org 38d
;                 +-- LED# 2
;                 |+-- LED# 1
;                 ||  +-- LED# 4
;                 ||  |+-- LED# 3
;                 ||  ||
        retlw b'00110011' ; #00
        retlw b'00100011' ; #01
        retlw b'00000011' ; #02
        retlw b'00000010' ; #03
        retlw b'00000000' ; #04
        retlw b'00000000' ; #05
        retlw b'00000010' ; #06
        retlw b'00000011' ; #07
        retlw b'00100011' ; #08
        retlw b'00110011' ; #09

; ********************************************************
; **  Tabelle A for effect07 = 5x Flash                 **
; ********************************************************
 org 398
;                 +-- LED# 2
;                 |+-- LED# 1
;                 ||  +-- LED# 4
;                 ||  |+-- LED# 3
;                 ||  ||
        retlw b'00110011' ; #00
        retlw b'00000000' ; #01
        retlw b'00110011' ; #02
        retlw b'00000000' ; #03
        retlw b'00110011' ; #04
        retlw b'00000000' ; #05
        retlw b'00110011' ; #06
        retlw b'00000000' ; #07
        retlw b'00110011' ; #08
        retlw b'00000000' ; #09
        
; ********************************************************
; **  Tabelle C for effect00 = Lauflicht                **
; ********************************************************
 org 3a3
;                 +-- LED# 8
;                 |+-- LED# 9
;                 ||+-- LED# 10
;                 |||+-- LED# 6
;                 ||||+-- LED# 5
;                 |||||+-- LED# 7
;                 ||||||
        retlw b'00000000' ; #00
        retlw b'00000000' ; #01
        retlw b'00000000' ; #02
        retlw b'00000000' ; #03
        retlw b'00000010' ; #04
        retlw b'00000100' ; #05
        retlw b'00000001' ; #06
        retlw b'00100000' ; #07
        retlw b'00010000' ; #08
        retlw b'00001000' ; #09

; ********************************************************
; **  Tabelle C for effect01 = Leitlicht UP             **
; ********************************************************
 org 3ae
;                 +-- LED# 8
;                 |+-- LED# 9
;                 ||+-- LED# 10
;                 |||+-- LED# 6
;                 ||||+-- LED# 5
;                 |||||+-- LED# 7
;                 ||||||
        retlw b'00000000' ; #00
        retlw b'00000000' ; #01
        retlw b'00000000' ; #02
        retlw b'00000000' ; #03
        retlw b'00000010' ; #04
        retlw b'00000110' ; #05
        retlw b'00000111' ; #06
        retlw b'00100111' ; #07
        retlw b'00110111' ; #08
        retlw b'00111111' ; #09

; ********************************************************
; **  Tabelle C for effect02 = Leitlicht DOWN           **
; ********************************************************
 org 3b9
;                 +-- LED# 8
;                 |+-- LED# 9
;                 ||+-- LED# 10
;                 |||+-- LED# 6
;                 ||||+-- LED# 5
;                 |||||+-- LED# 7
;                 ||||||
        retlw b'00001000' ; #00
        retlw b'00011000' ; #01
        retlw b'00111000' ; #02
        retlw b'00111001' ; #03
        retlw b'00111101' ; #04
        retlw b'00111111' ; #05
        retlw b'00111111' ; #06
        retlw b'00111111' ; #07
        retlw b'00111111' ; #08
        retlw b'00111111' ; #09

; ********************************************************
; **  Tabelle C for effect03 = 2er Lauflicht            **
; ********************************************************
 org 3c4
;                 +-- LED# 8
;                 |+-- LED# 9
;                 ||+-- LED# 10
;                 |||+-- LED# 6
;                 ||||+-- LED# 5
;                 |||||+-- LED# 7
;                 ||||||
        retlw b'00000100' ; #00
        retlw b'00000001' ; #01
        retlw b'00100000' ; #02
        retlw b'00010000' ; #03
        retlw b'00001010' ; #04
        retlw b'00000100' ; #05
        retlw b'00000001' ; #06
        retlw b'00100000' ; #07
        retlw b'00010000' ; #08
        retlw b'00001010' ; #09

; ********************************************************
; **  Tabelle C for effect04 = 2er Lauflicht ber Kreuz **
; ********************************************************
 org 3cf
;                 +-- LED# 8
;                 |+-- LED# 9
;                 ||+-- LED# 10
;                 |||+-- LED# 6
;                 ||||+-- LED# 5
;                 |||||+-- LED# 7
;                 ||||||
        retlw b'00001000' ; #00
        retlw b'00010000' ; #01
        retlw b'00100000' ; #02
        retlw b'00000001' ; #03
        retlw b'00000110' ; #04
        retlw b'00000110' ; #05
        retlw b'00000001' ; #06
        retlw b'00100000' ; #07
        retlw b'00010000' ; #08
        retlw b'00001000' ; #09

; ********************************************************
; **  Tabelle C for effect05 = 2er Leitlicht ber Kreuz **
; ********************************************************
 org 3da
;                 +-- LED# 8
;                 |+-- LED# 9
;                 ||+-- LED# 10
;                 |||+-- LED# 6
;                 ||||+-- LED# 5
;                 |||||+-- LED# 7
;                 ||||||
        retlw b'00001000' ; #00
        retlw b'00011000' ; #01
        retlw b'00111000' ; #02
        retlw b'00111001' ; #03
        retlw b'00111111' ; #04
        retlw b'00111001' ; #05
        retlw b'00111000' ; #06
        retlw b'00011000' ; #07
        retlw b'00001000' ; #08
        retlw b'00000000' ; #09

; ********************************************************
; **  Tabelle C for effect06 = 2er Leitlicht ber Kreuz **
; ********************************************************
 org 3e5
;                 +-- LED# 8
;                 |+-- LED# 9
;                 ||+-- LED# 10
;                 |||+-- LED# 6
;                 ||||+-- LED# 5
;                 |||||+-- LED# 7
;                 ||||||
        retlw b'00111111' ; #00
        retlw b'00110111' ; #01
        retlw b'00100111' ; #02
        retlw b'00000111' ; #03
        retlw b'00000110' ; #04
        retlw b'00000110' ; #05
        retlw b'00000111' ; #06
        retlw b'00100111' ; #07
        retlw b'00110111' ; #08
        retlw b'00111111' ; #09

; ********************************************************
; **  Tabelle C for effect07 = 5x Flash                 **
; ********************************************************
 org 3f0
;                 +-- LED# 8
;                 |+-- LED# 9
;                 ||+-- LED# 10
;                 |||+-- LED# 6
;                 ||||+-- LED# 5
;                 |||||+-- LED# 7
;                 ||||||
        retlw b'00111111' ; #00
        retlw b'00000000' ; #01
        retlw b'00111111' ; #02
        retlw b'00000000' ; #03
        retlw b'00111111' ; #04
        retlw b'00000000' ; #05
        retlw b'00111111' ; #06
        retlw b'00000000' ; #07
        retlw b'00111111' ; #08
        retlw b'00000000' ; #09

