; ********************************************************
; ** Version: V3.48 vom 23/01/2011                      **
; ********************************************************
; ** Include-File zu dekoder.asm                        **
; ********************************************************
; ** Sven Brandt                                        **
; ********************************************************
; Copyright (C) 2005-2011 Sven Brandt

; ********************************************************
; History:
; ********************************************************
; V3.48 - LED_Neon: Ausgnge konfigurierbar, in NODECODER Starten und Stoppen per Taster, fr DCC/MM durch skip_g2 ff. Platzbedarf reduziert
; V3.38 - LED_neon: - Ausgang 10 "Schweisslicht" und 9 "defekt" auch als normale Neon-Ausgnge nutzbar (Flags in EE $20)

;*********************************
;*********************************
;*********************************
;*********************************
;** Routine: statemachine_neon  **
;** Blinksmdus                  **
;** needs <    us               **
;*********************************
;*********************************
;*********************************
;*********************************
statemachine_neon

; **********************************************
; **** Blink-Mode  (Neon) ****
; **********************************************
        movlw b'00000001'              ; check state
        andwf R_STATUS,W               ; if not this mode
        btfsc STATUS,Z                 ; .. then
         return                        ; .. return

        btfsc F_out01_schweiss         ; nur, wenn Flag F_outxx_schweiss nicht gesetzt ist
         goto $+3
          btfsc R_ONOFF1,0
           bsf LED_01                  ; .. then switch LED_1 on

        btfsc F_out02_schweiss         ; nur, wenn Flag F_outxx_schweiss nicht gesetzt ist
         goto $+3
          btfsc R_ONOFF1,1
           bsf LED_02                  ; .. then switch LED_2 on

        btfsc F_out03_schweiss         ; nur, wenn Flag F_outxx_schweiss nicht gesetzt ist
         goto $+3
          btfsc R_ONOFF1,2
           bsf LED_03                  ; .. then switch LED_3 on

        btfsc F_out04_schweiss         ; nur, wenn Flag F_outxx_schweiss nicht gesetzt ist
         goto $+3
          btfsc R_ONOFF1,3
           bsf LED_04                  ; .. then switch LED_4 on

        btfsc F_out05_schweiss         ; nur, wenn Flag F_outxx_schweiss nicht gesetzt ist
         goto $+3
          btfsc R_ONOFF1,4
           bsf LED_05                    ; .. then switch LED_5 on

        btfsc F_out06_schweiss         ; nur, wenn Flag F_outxx_schweiss nicht gesetzt ist
         goto $+3
          btfsc R_ONOFF1,5
           bsf LED_06                    ; .. then switch LED_6 on

        btfsc F_out07_schweiss         ; nur, wenn Flag F_outxx_schweiss nicht gesetzt ist
         goto $+3
          btfsc R_ONOFF1,6
           bsf LED_07                    ; .. then switch LED_7 on

        btfsc F_out08_schweiss         ; nur, wenn Flag F_outxx_schweiss nicht gesetzt ist
         goto $+3
          btfsc R_ONOFF1,7
           bsf LED_08                    ; .. then switch LED_8 on

        btfsc F_out09_schweiss         ; nur, wenn Flag F_outxx_schweiss nicht gesetzt ist
         goto $+3
          btfsc R_ONOFF2,0
           bsf LED_09                    ; .. then switch LED_9 on

        btfsc F_out10_schweiss         ; nur, wenn Flag F_outxx_schweiss nicht gesetzt ist
         goto $+3
           btfsc R_ONOFF2,1
            bsf LED_10                 ; .. then switch LED_10 on

        movlw d'230'                   ; get PWM-value into W-register
        subwf TMR1L,W                  ; W = TMR1L - W = TMR1 - PWM-Value
        btfss STATUS,C                 ; if C=1, -> TMR1 > PWM-Value
        goto led00
         btfss F_out01_schweiss        ; nur, wenn Flag F_outxx_schweiss nicht gesetzt ist
          bsf LED_01                   ; .. then switch LED_1 on

         btfss F_out02_schweiss        ; nur, wenn Flag F_outxx_schweiss nicht gesetzt ist
          bsf LED_02                   ; .. then switch LED_2 on

         btfss F_out03_schweiss        ; nur, wenn Flag F_outxx_schweiss nicht gesetzt ist
          bsf LED_03                   ; .. then switch LED_3 on

         btfss F_out04_schweiss        ; nur, wenn Flag F_outxx_schweiss nicht gesetzt ist
          bsf LED_04                   ; .. then switch LED_4 on

         btfss F_out05_schweiss        ; nur, wenn Flag F_outxx_schweiss nicht gesetzt ist
          bsf LED_05                    ; .. then switch LED_5 on

         btfss F_out06_schweiss        ; nur, wenn Flag F_outxx_schweiss nicht gesetzt ist
          bsf LED_06                    ; .. then switch LED_6 on

         btfss F_out07_schweiss        ; nur, wenn Flag F_outxx_schweiss nicht gesetzt ist
          bsf LED_07                    ; .. then switch LED_7 on

         btfss F_out08_schweiss        ; nur, wenn Flag F_outxx_schweiss nicht gesetzt ist
          bsf LED_08                    ; .. then switch LED_8 on

         btfss F_out09_schweiss        ; nur, wenn Flag F_outxx_schweiss nicht gesetzt ist
          bsf LED_09                    ; .. then switch LED_9 on

         btfss F_out10_schweiss        ; nur, wenn Flag F_outxx_schweiss nicht gesetzt ist
          bsf LED_10                   ; .. then switch LED_10 on

led00
;   -------------------------
;   --- create 3ms-Raster ---
;   -------------------------
        movf TMR1H,F 
        btfsc STATUS,Z                 ; if TMR1H <> ZERO
         return
        clrf TMR1H                     ; .. then reset to ZERO

        clrf PORTA                     ; .. switch LED_1 OFF
        clrf PORTC                     ; .. switch LED_1 OFF

        ; Register SHUFFLE1..8 neu mischen
        movf R_SHUFFLE1,W     
        movwf R_SHUFFLE                ; R_SHUFFLEx into R_SHUFFLE
        call shuffle                   ; shuffle R_SHUFFLE
        movwf R_SHUFFLE1               ; shuffled R_SHUFFLE into R_SHUFFLEx

        movf R_SHUFFLE2,W     
        movwf R_SHUFFLE                ; R_SHUFFLEx into R_SHUFFLE
        call shuffle                   ; shuffle R_SHUFFLE
        movwf R_SHUFFLE2               ; shuffled R_SHUFFLE into R_SHUFFLEx

        movf R_SHUFFLE3,W     
        movwf R_SHUFFLE                ; R_SHUFFLEx into R_SHUFFLE
        btfss R_SHUFFLE1,0             ; mehr Varianz surch Querverbindung
        call shuffle                   ; shuffle R_SHUFFLE
        movwf R_SHUFFLE3               ; shuffled R_SHUFFLE into R_SHUFFLEx

        movf R_SHUFFLE4,W     
        movwf R_SHUFFLE                ; R_SHUFFLEx into R_SHUFFLE
        btfss R_SHUFFLE1,1             ; mehr Varianz surch Querverbindung
        call shuffle                   ; shuffle R_SHUFFLE
        movwf R_SHUFFLE4               ; shuffled R_SHUFFLE into R_SHUFFLEx

        movf R_SHUFFLE5,W     
        movwf R_SHUFFLE                ; R_SHUFFLEx into R_SHUFFLE
        btfss R_SHUFFLE1,2             ; mehr Varianz surch Querverbindung
        call shuffle                   ; shuffle R_SHUFFLE
        movwf R_SHUFFLE5               ; shuffled R_SHUFFLE into R_SHUFFLEx

        movf R_SHUFFLE6,W     
        movwf R_SHUFFLE                ; R_SHUFFLEx into R_SHUFFLE
        btfss R_SHUFFLE1,3             ; mehr Varianz surch Querverbindung
        call shuffle                   ; shuffle R_SHUFFLE
        movwf R_SHUFFLE6               ; shuffled R_SHUFFLE into R_SHUFFLEx

        movf R_SHUFFLE7,W     
        movwf R_SHUFFLE                ; R_SHUFFLEx into R_SHUFFLE
        btfss R_SHUFFLE1,4             ; mehr Varianz surch Querverbindung
        call shuffle                   ; shuffle R_SHUFFLE
        movwf R_SHUFFLE7               ; shuffled R_SHUFFLE into R_SHUFFLEx


;***************** LED01 *******************
led01
       ; *** Schweisslicht ***
        btfss F_out01_schweiss         ; nur, wenn Flag F_outxx_schweiss gesetzt ist
         goto led01_defekt 

        btfsc R_START01,7              ; wenn Startphase..
         goto led01c                   ; kein Flackern -> Springen
        btfss R_START01,1              ; Entscheidung, ob Flackern 
         bcf LED_01                    ; kein Flackern -> LED AUS
        btfss R_START01,1              ; Entscheidung, ob Flackern 
         goto led01b                   ; kein Flackern -> Springen

       ; schnelles Flackern der LED
        bcf LED_01                     ; ..AUS
        btfsc R_SHUFFLE4,2             ; Entscheidung, ob LED denn nun gerade
         bsf LED_01                    ; ..oder AN

led01b  ; weitermachen oder Status-Wechsel?
        decfsz R_CNT1,F                ; Status-Wechsel, wenn R_CNT1 = ZERO
         goto led02

        ; Statuswechsel
        movf R_SHUFFLE2,W     
        movwf R_CNT1                   ; R_SHUFFLEx in R_CNT1

        clrf R_START01                 ; Entscheidung, ob Flackern 
        btfsc R_SHUFFLE1,7             ; ..denn nun gerade
         bsf R_START01,1               ; ..AN sein soll
        btfsc R_SHUFFLE4,7             ; ..denn nun gerade
         bcf R_START01,1               ; ..AUS sein soll (weniger Flacker-Anteil)
        btfsc R_SHUFFLE4,0             ; ..denn nun gerade
         bcf R_START01,1               ; ..AUS sein soll (weniger Flacker-Anteil)
        goto led02

led01c  ; Startphase
        bcf LED_01                     ; ..AUS
        decfsz R_CNT1,F                ; Status-Wechsel, wenn R_CNT01 = ZERO
         goto led02
        decf R_START01,F                 ; R_STATx = R_STATx-1
        goto led02

led01_defekt
        ; *** Neon defekt *** 

led01_normal  ; *** Neon normal ***   
        movf R_START01,F               ; check R_STARTx
        btfsc STATUS,Z                 ; 
         bsf LED_01                    ; wenn ZERO, dann immer an   
        btfsc STATUS,Z                 ;
         goto led02                    ; wenn ZERO, nchste LED

        decfsz R_CNT1,F
         goto led02
        btfsc R_SHUFFLE1,7             ; Entscheidung, R_STARTx decrementiert
         decf R_START01,F               ; R_STARTx = R_STARTx-1

        movf R_SHUFFLE1,W     
        movwf R_CNT1                   ; R_SHUFFLEx in R_CNT1

        btfsc R_SHUFFLE1,1             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF1,0                ; ..AN
        btfss R_SHUFFLE1,5             ; ..oder
         bcf R_ONOFF1,0                ; ..AUS
        btfss R_SHUFFLE1,3             ; ..oder
         bcf R_ONOFF1,0                ; ..AUS

;***************** LED02 *******************
led02
       ; *** Schweisslicht ***
        btfss F_out02_schweiss         ; nur, wenn Flag F_outxx_schweiss gesetzt ist
         goto led02_normal  

        btfsc R_START02,7              ; wenn Startphase..
         goto led02c                   ; kein Flackern -> Springen
        btfss R_START02,1              ; Entscheidung, ob Flackern 
         bcf LED_02                    ; kein Flackern -> LED AUS
        btfss R_START02,1              ; Entscheidung, ob Flackern 
         goto led02b                   ; kein Flackern -> Springen

       ; schnelles Flackern der LED
        bcf LED_02                     ; ..AUS
        btfsc R_SHUFFLE4,0             ; Entscheidung, ob LED denn nun gerade
         bsf LED_02                    ; ..oder AN

led02b  ; weitermachen oder Status-Wechsel?
        decfsz R_CNT2,F                ; Status-Wechsel, wenn R_CNT2 = ZERO
         goto led03

        ; Statuswechsel
        movf R_SHUFFLE2,W     
        movwf R_CNT2                   ; R_SHUFFLEx in R_CNT2

        clrf R_START02                 ; Entscheidung, ob Flackern 
        btfsc R_SHUFFLE2,7             ; ..denn nun gerade
         bsf R_START02,1               ; ..AN sein soll
        btfsc R_SHUFFLE6,0             ; ..denn nun gerade
         bcf R_START02,1               ; ..AUS sein soll (weniger Flacker-Anteil)
        btfsc R_SHUFFLE2,3             ; ..denn nun gerade
         bcf R_START02,1               ; ..AUS sein soll (weniger Flacker-Anteil)
        goto led03

led02c  ; Startphase
        bcf LED_02                     ; ..AUS
        decfsz R_CNT2,F                ; Status-Wechsel, wenn R_CNT02 = ZERO
         goto led03
        decf R_START02,F                 ; R_STATx = R_STATx-1
        goto led03

led02_normal  ; *** Neon normal ***   
        movf R_START02,F               ; check R_STARTx
        btfsc STATUS,Z                 ; 
         bsf LED_02                    ; wenn ZERO, dann immer an   
        btfsc STATUS,Z                 ;
         goto led03                    ; wenn ZERO, nchste LED

        decfsz R_CNT2,F
         goto led03
        btfsc R_SHUFFLE2,7             ; Entscheidung, R_STARTx decrementiert
         decf R_START02,F               ; R_STARTx = R_STARTx-1

        movf R_SHUFFLE2,W     
        movwf R_CNT2                   ; R_SHUFFLEx in R_CNT2

        btfsc R_SHUFFLE2,5             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF1,1                ; ..AN
        btfss R_SHUFFLE2,2             ; ..oder
         bcf R_ONOFF1,1                ; ..AUS
        btfss R_SHUFFLE2,6             ; ..oder
         bcf R_ONOFF1,1                ; ..AUS
 
;***************** LED03 *******************
led03
       ; *** Schweisslicht ***
        btfss F_out03_schweiss         ; nur, wenn Flag F_outxx_schweiss gesetzt ist
         goto led03_normal  

        btfsc R_START03,7              ; wenn Startphase..
         goto led03c                   ; kein Flackern -> Springen
        btfss R_START03,1              ; Entscheidung, ob Flackern 
         bcf LED_03                    ; kein Flackern -> LED AUS
        btfss R_START03,1              ; Entscheidung, ob Flackern 
         goto led03b                   ; kein Flackern -> Springen

       ; schnelles Flackern der LED
        bcf LED_03                     ; ..AUS
        btfsc R_SHUFFLE6,2             ; Entscheidung, ob LED denn nun gerade
         bsf LED_03                    ; ..oder AN

led03b  ; weitermachen oder Status-Wechsel?
        decfsz R_CNT3,F                ; Status-Wechsel, wenn R_CNT3 = ZERO
         goto led04

        ; Statuswechsel
        movf R_SHUFFLE3,W     
        movwf R_CNT3                   ; R_SHUFFLEx in R_CNT3

        clrf R_START03                 ; Entscheidung, ob Flackern 
        btfsc R_SHUFFLE3,7             ; ..denn nun gerade
         bsf R_START03,1               ; ..AN sein soll
        btfsc R_SHUFFLE1,5             ; ..denn nun gerade
         bcf R_START03,1               ; ..AUS sein soll (weniger Flacker-Anteil)
        btfsc R_SHUFFLE3,3             ; ..denn nun gerade
         bcf R_START03,1               ; ..AUS sein soll (weniger Flacker-Anteil)
        goto led04

led03c  ; Startphase
        bcf LED_03                     ; ..AUS
        decfsz R_CNT3,F                ; Status-Wechsel, wenn R_CNT03 = ZERO
         goto led04
        decf R_START03,F                 ; R_STATx = R_STATx-1
        goto led04

led03_normal  ; *** Neon normal ***   
        movf R_START03,F               ; check R_STARTx
        btfsc STATUS,Z                 ; 
         bsf LED_03                    ; wenn ZERO, dann immer an   
        btfsc STATUS,Z                 ;
         goto led04                    ; wenn ZERO, nchste LED

        decfsz R_CNT3,F
         goto led04
        btfsc R_SHUFFLE3,7             ; Entscheidung, R_STARTx decrementiert
         decf R_START03,F               ; R_STARTx = R_STARTx-1

        movf R_SHUFFLE3,W     
        movwf R_CNT3                   ; R_SHUFFLEx in R_CNT3

        btfsc R_SHUFFLE3,4             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF1,2                ; ..AN
        btfss R_SHUFFLE3,6             ; ..oder
         bcf R_ONOFF1,2                ; ..AUS
        btfss R_SHUFFLE3,3             ; ..oder
         bcf R_ONOFF1,2                ; ..AUS

;***************** LED04 *******************
led04
       ; *** Schweisslicht ***
        btfss F_out04_schweiss         ; nur, wenn Flag F_outxx_schweiss gesetzt ist
         goto led04_defekt  

        btfsc R_START04,7              ; wenn Startphase..
         goto led04c                   ; kein Flackern -> Springen
        btfss R_START04,1              ; Entscheidung, ob Flackern 
         bcf LED_04                    ; kein Flackern -> LED AUS
        btfss R_START04,1              ; Entscheidung, ob Flackern 
         goto led04b                   ; kein Flackern -> Springen

       ; schnelles Flackern der LED
        bcf LED_04                     ; ..AUS
        btfsc R_SHUFFLE1,7             ; Entscheidung, ob LED denn nun gerade
         bsf LED_04                    ; ..oder AN

led04b  ; weitermachen oder Status-Wechsel?
        decfsz R_CNT4,F                ; Status-Wechsel, wenn R_CNT4 = ZERO
         goto led05

        ; Statuswechsel
        movf R_SHUFFLE4,W     
        movwf R_CNT4                   ; R_SHUFFLEx in R_CNT4

        clrf R_START04                 ; Entscheidung, ob Flackern 
        btfsc R_SHUFFLE4,7             ; ..denn nun gerade
         bsf R_START04,1               ; ..AN sein soll
        btfsc R_SHUFFLE3,5             ; ..denn nun gerade
         bcf R_START04,1               ; ..AUS sein soll (weniger Flacker-Anteil)
        btfsc R_SHUFFLE4,3             ; ..denn nun gerade
         bcf R_START04,1               ; ..AUS sein soll (weniger Flacker-Anteil)
        goto led05

led04c  ; Startphase
        bcf LED_04                     ; ..AUS
        decfsz R_CNT4,F                ; Status-Wechsel, wenn R_CNT04 = ZERO
         goto led05
        decf R_START04,F                 ; R_STATx = R_STATx-1
        goto led05

led04_defekt
        ; *** Neon defekt *** 
        btfss F_out04_defekt           ; nur, wenn Flag F_out09_defekt gesetzt ist
         goto led04_normal  

        decfsz R_CNT4,F
         goto led05

        movf R_SHUFFLE4,W     
        movwf R_CNT4                   ; R_SHUFFLEx in R_CNT9

        btfsc R_SHUFFLE1,7             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF1,3                ; ..AN
        btfss R_SHUFFLE6,7             ; ..oder
         bcf R_ONOFF1,3                ; ..AUS
        
        goto led05

led04_normal  ; *** Neon normal ***   
        movf R_START04,F               ; check R_STARTx
        btfsc STATUS,Z                 ; 
         bsf LED_04                    ; wenn ZERO, dann immer an   
        btfsc STATUS,Z                 ;
         goto led05                    ; wenn ZERO, nchste LED

        decfsz R_CNT4,F
         goto led05
        btfsc R_SHUFFLE4,7             ; Entscheidung, R_STARTx decrementiert
         decf R_START04,F               ; R_STARTx = R_STARTx-1

        movf R_SHUFFLE4,W     
        movwf R_CNT4                   ; R_SHUFFLEx in R_CNT4

        btfsc R_SHUFFLE4,4             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF1,3                ; ..AN
        btfss R_SHUFFLE4,7             ; ..oder
         bcf R_ONOFF1,3                ; ..AUS
        btfss R_SHUFFLE4,3             ; ..oder
         bcf R_ONOFF1,3                ; ..AUS

;***************** LED05 *******************
led05
       ; *** Schweisslicht ***
        btfss F_out05_schweiss         ; nur, wenn Flag F_outxx_schweiss gesetzt ist
         goto led05_normal  

        btfsc R_START05,7              ; wenn Startphase..
         goto led05c                   ; kein Flackern -> Springen
        btfss R_START05,1              ; Entscheidung, ob Flackern 
         bcf LED_05                    ; kein Flackern -> LED AUS
        btfss R_START05,1              ; Entscheidung, ob Flackern 
         goto led05b                   ; kein Flackern -> Springen

       ; schnelles Flackern der LED
        bcf LED_05                     ; ..AUS
        btfsc R_SHUFFLE1,5             ; Entscheidung, ob LED denn nun gerade
         bsf LED_05                    ; ..oder AN

led05b  ; weitermachen oder Status-Wechsel?
        decfsz R_CNT5,F                ; Status-Wechsel, wenn R_CNT5 = ZERO
         goto led06

        ; Statuswechsel
        movf R_SHUFFLE5,W     
        movwf R_CNT5                   ; R_SHUFFLEx in R_CNT5

        clrf R_START05                 ; Entscheidung, ob Flackern 
        btfsc R_SHUFFLE5,7             ; ..denn nun gerade
         bsf R_START05,1               ; ..AN sein soll
        btfsc R_SHUFFLE2,4             ; ..denn nun gerade
         bcf R_START05,1               ; ..AUS sein soll (weniger Flacker-Anteil)
        btfsc R_SHUFFLE4,7             ; ..denn nun gerade
         bcf R_START05,1               ; ..AUS sein soll (weniger Flacker-Anteil)
        goto led06

led05c  ; Startphase
        bcf LED_05                     ; ..AUS
        decfsz R_CNT5,F                ; Status-Wechsel, wenn R_CNT05 = ZERO
         goto led06
        decf R_START05,F                 ; R_STATx = R_STATx-1
        goto led06

led05_normal  ; *** Neon normal ***   
        movf R_START05,F               ; check R_STARTx
        btfsc STATUS,Z                 ; 
         bsf LED_05                    ; wenn ZERO, dann immer an   
        btfsc STATUS,Z                 ;
         goto led06                    ; wenn ZERO, nchste LED

        decfsz R_CNT5,F
         goto led06
        btfsc R_SHUFFLE5,7             ; Entscheidung, R_STARTx decrementiert
         decf R_START05,F               ; R_STARTx = R_STARTx-1

        movf R_SHUFFLE5,W     
        movwf R_CNT5                   ; R_SHUFFLEx in R_CNT5

        btfsc R_SHUFFLE5,7             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF1,4                ; ..AN
        btfss R_SHUFFLE5,7             ; ..oder
         bcf R_ONOFF1,4                ; ..AUS
        btfss R_SHUFFLE5,1             ; ..oder
         bcf R_ONOFF1,4                ; ..AUS

;***************** LED06 *******************
led06
       ; *** Schweisslicht ***
        btfss F_out06_schweiss         ; nur, wenn Flag F_outxx_schweiss gesetzt ist
         goto led06_normal  

        btfsc R_START06,7              ; wenn Startphase..
         goto led06c                   ; kein Flackern -> Springen
        btfss R_START06,1              ; Entscheidung, ob Flackern 
         bcf LED_06                    ; kein Flackern -> LED AUS
        btfss R_START06,1              ; Entscheidung, ob Flackern 
         goto led06b                   ; kein Flackern -> Springen

       ; schnelles Flackern der LED
        bcf LED_06                     ; ..AUS
        btfsc R_SHUFFLE3,5             ; Entscheidung, ob LED denn nun gerade
         bsf LED_06                    ; ..oder AN

led06b  ; weitermachen oder Status-Wechsel?
        decfsz R_CNT6,F                ; Status-Wechsel, wenn R_CNT6 = ZERO
         goto led07

        ; Statuswechsel
        movf R_SHUFFLE6,W     
        movwf R_CNT6                   ; R_SHUFFLEx in R_CNT6

        clrf R_START06                 ; Entscheidung, ob Flackern 
        btfsc R_SHUFFLE6,7             ; ..denn nun gerade
         bsf R_START06,1               ; ..AN sein soll
        btfsc R_SHUFFLE1,5             ; ..denn nun gerade
         bcf R_START06,1               ; ..AUS sein soll (weniger Flacker-Anteil)
        btfsc R_SHUFFLE2,3             ; ..denn nun gerade
         bcf R_START06,1               ; ..AUS sein soll (weniger Flacker-Anteil)
        goto led07

led06c  ; Startphase
        bcf LED_06                     ; ..AUS
        decfsz R_CNT6,F                ; Status-Wechsel, wenn R_CNT06 = ZERO
         goto led07
        decf R_START06,F                 ; R_STATx = R_STATx-1
        goto led07

led06_normal  ; *** Neon normal ***   
        movf R_START06,F               ; check R_STARTx
        btfsc STATUS,Z                 ; 
         bsf LED_06                    ; wenn ZERO, dann immer an   
        btfsc STATUS,Z                 ;
         goto led07                    ; wenn ZERO, nchste LED

        decfsz R_CNT6,F
         goto led07
        btfsc R_SHUFFLE6,7             ; Entscheidung, R_STARTx decrementiert
         decf R_START06,F               ; R_STARTx = R_STARTx-1

        movf R_SHUFFLE6,W     
        movwf R_CNT6                   ; R_SHUFFLEx in R_CNT6

        btfsc R_SHUFFLE6,4             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF1,5                ; ..AN
        btfss R_SHUFFLE6,4             ; ..oder
         bcf R_ONOFF1,5                ; ..AUS
        btfss R_SHUFFLE6,7             ; ..oder
         bcf R_ONOFF1,5                ; ..AUS

;***************** LED07 *******************
led07
       ; *** Schweisslicht ***
        btfss F_out07_schweiss         ; nur, wenn Flag F_outxx_schweiss gesetzt ist
         goto led07_normal  

        btfsc R_START07,7              ; wenn Startphase..
         goto led07c                   ; kein Flackern -> Springen
        btfss R_START07,1              ; Entscheidung, ob Flackern 
         bcf LED_07                    ; kein Flackern -> LED AUS
        btfss R_START07,1              ; Entscheidung, ob Flackern 
         goto led07b                   ; kein Flackern -> Springen

       ; schnelles Flackern der LED
        bcf LED_07                     ; ..AUS
        btfsc R_SHUFFLE5,2             ; Entscheidung, ob LED denn nun gerade
         bsf LED_07                    ; ..oder AN

led07b  ; weitermachen oder Status-Wechsel?
        decfsz R_CNT7,F                ; Status-Wechsel, wenn R_CNT7 = ZERO
         goto led08

        ; Statuswechsel
        movf R_SHUFFLE7,W     
        movwf R_CNT7                   ; R_SHUFFLEx in R_CNT7

        clrf R_START07                 ; Entscheidung, ob Flackern 
        btfsc R_SHUFFLE7,7             ; ..denn nun gerade
         bsf R_START07,1               ; ..AN sein soll
        btfsc R_SHUFFLE3,3             ; ..denn nun gerade
         bcf R_START07,1               ; ..AUS sein soll (weniger Flacker-Anteil)
        btfsc R_SHUFFLE7,3             ; ..denn nun gerade
         bcf R_START07,1               ; ..AUS sein soll (weniger Flacker-Anteil)
        goto led08

led07c  ; Startphase
        bcf LED_07                     ; ..AUS
        decfsz R_CNT7,F                ; Status-Wechsel, wenn R_CNT07 = ZERO
         goto led08
        decf R_START07,F                 ; R_STATx = R_STATx-1
        goto led08

led07_normal  ; *** Neon normal ***   
        movf R_START07,F               ; check R_STARTx
        btfsc STATUS,Z                 ; 
         bsf LED_07                    ; wenn ZERO, dann immer an   
        btfsc STATUS,Z                 ;
         goto led08                    ; wenn ZERO, nchste LED

        decfsz R_CNT7,F
         goto led08
        btfsc R_SHUFFLE7,7             ; Entscheidung, R_STARTx decrementiert
         decf R_START07,F               ; R_STARTx = R_STARTx-1

        movf R_SHUFFLE7,W     
        movwf R_CNT7                   ; R_SHUFFLEx in R_CNT7

        btfsc R_SHUFFLE7,3             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF1,6                ; ..AN
        btfss R_SHUFFLE7,3             ; ..oder
         bcf R_ONOFF1,6                ; ..AUS
        btfss R_SHUFFLE7,4             ; ..oder
         bcf R_ONOFF1,6                ; ..AUS

;***************** LED08 *******************
led08
       ; *** Schweisslicht ***
        btfss F_out08_schweiss         ; nur, wenn Flag F_outxx_schweiss gesetzt ist
         goto led08_normal  

        btfsc R_START08,7              ; wenn Startphase..
         goto led08c                   ; kein Flackern -> Springen
        btfss R_START08,1              ; Entscheidung, ob Flackern 
         bcf LED_08                    ; kein Flackern -> LED AUS
        btfss R_START08,1              ; Entscheidung, ob Flackern 
         goto led08b                   ; kein Flackern -> Springen

       ; schnelles Flackern der LED
        bcf LED_08                     ; ..AUS
        btfsc R_SHUFFLE4,2             ; Entscheidung, ob LED denn nun gerade
         bsf LED_08                    ; ..oder AN

led08b  ; weitermachen oder Status-Wechsel?
        decfsz R_CNT8,F                ; Status-Wechsel, wenn R_CNT8 = ZERO
         goto led09

        ; Statuswechsel
        movf R_SHUFFLE2,W     
        movwf R_CNT8                   ; R_SHUFFLEx in R_CNT8

        clrf R_START08                 ; Entscheidung, ob Flackern 
        btfsc R_SHUFFLE5,7             ; ..denn nun gerade
         bsf R_START08,1               ; ..AN sein soll
        btfsc R_SHUFFLE6,2             ; ..denn nun gerade
         bcf R_START08,1               ; ..AUS sein soll (weniger Flacker-Anteil)
        btfsc R_SHUFFLE1,4             ; ..denn nun gerade
         bcf R_START08,1               ; ..AUS sein soll (weniger Flacker-Anteil)
        goto led09

led08c  ; Startphase
        bcf LED_08                     ; ..AUS
        decfsz R_CNT8,F                ; Status-Wechsel, wenn R_CNT08 = ZERO
         goto led09
        decf R_START08,F                 ; R_STATx = R_STATx-1
        goto led09

led08_normal  ; *** Neon normal ***   
        movf R_START08,F               ; check R_STARTx
        btfsc STATUS,Z                 ; 
         bsf LED_08                    ; wenn ZERO, dann immer an   
        btfsc STATUS,Z                 ;
         goto led09                    ; wenn ZERO, nchste LED

        decfsz R_CNT8,F
         goto led09
        btfsc R_SHUFFLE3,7             ; Entscheidung, R_STARTx decrementiert
         decf R_START08,F               ; R_STARTx = R_STARTx-1

        movf R_SHUFFLE5,W     
        movwf R_CNT8                   ; R_SHUFFLEx in R_CNT8

        btfsc R_SHUFFLE2,4             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF1,7                ; ..AN
        btfss R_SHUFFLE2,4             ; ..oder
         bcf R_ONOFF1,7                ; ..AUS
        btfss R_SHUFFLE6,7             ; ..oder
         bcf R_ONOFF1,7                ; ..AUS


;***************** LED09 *******************
led09
       ; *** Schweisslicht ***
        btfss F_out09_schweiss         ; nur, wenn Flag F_outxx_schweiss gesetzt ist
         goto led09_defekt  

        btfsc R_START09,7              ; wenn Startphase..
         goto led09c                   ; kein Flackern -> Springen
        btfss R_START09,1              ; Entscheidung, ob Flackern 
         bcf LED_09                    ; kein Flackern -> LED AUS
        btfss R_START09,1              ; Entscheidung, ob Flackern 
         goto led09b                   ; kein Flackern -> Springen

       ; schnelles Flackern der LED
        bcf LED_09                     ; ..AUS
        btfsc R_SHUFFLE1,2             ; Entscheidung, ob LED denn nun gerade
         bsf LED_09                    ; ..oder AN

led09b  ; weitermachen oder Status-Wechsel?
        decfsz R_CNT9,F                ; Status-Wechsel, wenn R_CNT9 = ZERO
         goto led10

        ; Statuswechsel
        movf R_SHUFFLE4,W     
        movwf R_CNT9                   ; R_SHUFFLEx in R_CNT9

        clrf R_START09                 ; Entscheidung, ob Flackern 
        btfsc R_SHUFFLE2,7             ; ..denn nun gerade
         bsf R_START09,1               ; ..AN sein soll
        btfsc R_SHUFFLE5,5             ; ..denn nun gerade
         bcf R_START09,1               ; ..AUS sein soll (weniger Flacker-Anteil)
        btfsc R_SHUFFLE4,3             ; ..denn nun gerade
         bcf R_START09,1               ; ..AUS sein soll (weniger Flacker-Anteil)
        goto led10

led09c  ; Startphase
        bcf LED_09                     ; ..AUS
        decfsz R_CNT9,F                ; Status-Wechsel, wenn R_CNT09 = ZERO
         goto led10
        decf R_START09,F                 ; R_STATx = R_STATx-1
        goto led10

led09_defekt
        ; *** Neon defekt *** 
        btfss F_out09_defekt           ; nur, wenn Flag F_out09_defekt gesetzt ist
         goto led09_normal  

        decfsz R_CNT9,F
         goto led10

        movf R_SHUFFLE3,W     
        movwf R_CNT9                   ; R_SHUFFLEx in R_CNT9

        btfsc R_SHUFFLE2,7             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF2,0                ; ..AN
        btfss R_SHUFFLE4,7             ; ..oder
         bcf R_ONOFF2,0                ; ..AUS
        
        goto led10

led09_normal  ; *** Neon normal ***   
        movf R_START09,F               ; check R_STARTx
        btfsc STATUS,Z                 ; 
         bsf LED_09                    ; wenn ZERO, dann immer an   
        btfsc STATUS,Z                 ;
         goto led10                    ; wenn ZERO, nchste LED

        decfsz R_CNT9,F
         goto led10
        btfsc R_SHUFFLE1,5             ; Entscheidung, R_STARTx decrementiert
         decf R_START09,F               ; R_STARTx = R_STARTx-1

        movf R_SHUFFLE4,W     
        movwf R_CNT9                   ; R_SHUFFLEx in R_CNT8

        btfsc R_SHUFFLE2,7             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF2,0                ; ..AN
        btfss R_SHUFFLE4,7             ; ..oder
         bcf R_ONOFF2,0                ; ..AUS

;***************** LED10 *******************
led10
       ; *** Schweisslicht ***
        btfss F_out10_schweiss         ; nur, wenn Flag F_out10_schweiss gesetzt ist
         goto led10_normal  

        btfsc R_START10,7              ; wenn Startphase..
         goto led10c                   ; kein Flackern -> Springen
        btfss R_START10,1              ; Entscheidung, ob Flackern 
         bcf LED_10                    ; kein Flackern -> LED AUS
        btfss R_START10,1              ; Entscheidung, ob Flackern 
         goto led10b                   ; kein Flackern -> Springen

       ; schnelles Flackern der LED
        bcf LED_10                     ; ..AUS
        btfsc R_SHUFFLE1,7             ; Entscheidung, ob LED denn nun gerade
         bsf LED_10                    ; ..oder AN

led10b  ; weitermachen oder Status-Wechsel?
        decfsz R_CNT10,F               ; Status-Wechsel, wenn R_CNT10 = ZERO
         return

        ; Statuswechsel
        movf R_SHUFFLE1,W     
        movwf R_CNT10                  ; R_SHUFFLEx in R_CNT10

        clrf R_START10                 ; Entscheidung, ob Flackern 
        btfsc R_SHUFFLE1,7             ; ..denn nun gerade
         bsf R_START10,1               ; ..AN sein soll
        btfsc R_SHUFFLE2,4             ; ..denn nun gerade
         bcf R_START10,1               ; ..AUS sein soll (weniger Flacker-Anteil)
        btfsc R_SHUFFLE2,3             ; ..denn nun gerade
         bcf R_START10,1               ; ..AUS sein soll (weniger Flacker-Anteil)
        return

led10c  ; Startphase
        bcf LED_10                     ; ..AUS
        decfsz R_CNT10,F               ; Status-Wechsel, wenn R_CNT10 = ZERO
         return
        decf R_START10,F                ; R_STATx = R_STATx-1
        return

led10_normal  ; *** Neon normal ***   
        movf R_START10,F               ; check R_STARTx
        btfsc STATUS,Z                 ; 
         bsf LED_10                    ; wenn ZERO, dann immer an   
        btfsc STATUS,Z                 ;
         return                        ; wenn ZERO, nchste LED

        decfsz R_CNT10,F
         return
        btfsc R_SHUFFLE4,7             ; Entscheidung, R_STARTx decrementiert
         decf R_START10,F              ; R_STARTx = R_STARTx-1

        movf R_SHUFFLE2,W     
        movwf R_CNT10                  ; R_SHUFFLEx in R_CNT8

        btfsc R_SHUFFLE5,4             ; Entscheidung, ob LED denn nun gerade
         bsf R_ONOFF2,1                ; ..AN
        btfss R_SHUFFLE5,4             ; ..oder
         bcf R_ONOFF2,1                ; ..AUS
        btfss R_SHUFFLE6,7             ; ..oder
         bcf R_ONOFF2,1                ; ..AUS
        return

;*******************************************
;*******************************************
;*******************************************
;*******************************************
;** Routine: shuffle                      **
;** (A|B) & !(A&B)                        **
;** uses  R_SHUFF (Register to shuffle)   **
;** uses  R_TEMP  (temporary registere)   **
;** returns shuffled value in W_REG!      **
;*******************************************
;*******************************************
;*******************************************
;*******************************************
shuffle
        clrf R_TEMP
        movf R_SHUFFLE,F   ; check for
        btfsc STATUS,Z     ; .. ZERO
         decf R_SHUFFLE,F  ; if ZERO Reload with FF
        btfsc R_SHUFFLE,0  ; = A
         bsf R_TEMP,0       
        btfsc R_SHUFFLE,5  ; = B
         bsf R_TEMP,0      ; R_TEMP#0 = A|B
        movf R_TEMP,W      ; W#0 = A|B
        clrf R_TEMP
        btfss R_SHUFFLE,0  ; = A
         bsf R_TEMP,0       
        btfss R_SHUFFLE,5  ; = B
         bsf R_TEMP,0      ; R_TEMP#0 = (!A)|(!B) = !(A&B)
        andwf R_TEMP,F     ; R_TEMP#0 = (A|B) & !(A&B)
        RRF R_TEMP,F       ; R_TEMP#0 -> CARRY
        RRF R_SHUFFLE,W    ; CARRY in R_SHUFFLE von links hineinschieben
        return             ; und ins W_REG

