; ********************************************************
; ** Version: V3.19 vom 07/12/2008                      **
; ********************************************************
; ** Include-File zu dekoder.asm                        **
; ********************************************************
; ** Sven Brandt                                        **
; ********************************************************
; Copyright (C) 2003/04/05 Sven Brandt
; ********************************************************
; History:
; V2.16 - auswhlbarer Mode: mit und ohne Dunkeltastung Vorsignal
;       - 3ms-Raster in diesem File

;*********************************
;*********************************
;*********************************
;*********************************
;** Routine: LED_SIGNAL4        **
;** state manager signal4       **
;** Aufruf alle 2-3 ms          **
;** needs <    us               **
;*********************************
;*********************************
;*********************************
;*********************************
;   ------------------
;   --- Signal 5x 2er ---
;   ------------------
;R_STATEx   *              *           
;------------\             :  : /--------  LEDxA (red)
;           : \----------------/ :       
;           :  :        :  :       
;#1         :#2 #3             #4:#1  
;
;Time *: receive order to switch    
;
;PWM detail, here Fade in (Fade out = inverted Signal):
;  0        1        2        3        4        5       6       7 Value of R_COUNT
;  :-:      :--:     :---:    :----:   :-----:  :-----: :------::-----
;  : :      :  :     :   :    :    :   :     :  :     : :      ::
; -: :------:  :-----:   :----:    :---:     :--:     :-:      ::
;  1 2      3  2     3   2    3    2   3     2  3     2 3       3
;@1: LED on, R_COUNT=0
;@2: LED off
;@3: LED on, R_COUNT increment every 2ms

statemachine_signal2
;   -------------------------
;   --- create 3ms-Raster ---
;   -------------------------
#ifndef test
        movf TMR1H,F 
        btfsc STATUS,Z                 ; if TMR1H <> ZERO
         return
#endif
        clrf TMR1H                     ; .. then reset to ZERO

        incfsz R_COUNT,F               ; if R_COUNT = 0
         goto signal2_1                ; .. then change R_STATE 
        incf R_COUNT,F                 ; R_COUNT starts with '1'

        ;***** Change STATE *****
        ; *** LED1 (Ausgang 1) ***
        btfss R_STATUS_a2,0
         goto LED1OFF                  ; .. then jump

LED1ON  ; *** LED1 ON ***      
ON1_2   btfss R_STATE1,2               ; check R_STATE1 #2
         goto ON1_3
        clrf R_STATE1                  ; clear R_STATE1  
        bsf R_STATE1,4                 ; continue R_STATE1#4
        goto STATUS_REG_2              ; continue

ON1_3   btfss R_STATE1,3               ; check R_STATE1 #3
         goto ON1_4
        clrf R_STATE1                  ; clear R_STATE1  
        bsf R_STATE1,4                 ; continue R_STATE1#4
        goto STATUS_REG_2              ; continue

ON1_4   btfss R_STATE1,4               ; check R_STATE1 #4
         goto STATUS_REG_2             ; continue
        clrf R_STATE1                  ; clear R_STATE1  
        bsf R_STATE1,1                 ; continue R_STATE1#1
        goto STATUS_REG_2              ; continue
        
LED1OFF ; *** LED1 OFF ***      
OFF1_1  btfss R_STATE1,1               ; check R_STATE1 #1
         goto OFF1_2
        clrf R_STATE1                  ; clear R_STATE1  
        bsf R_STATE1,2                 ; continue R_STATE1#2
         goto STATUS_REG_2             ; continue
        
OFF1_2  btfss R_STATE1,2               ; check R_STATE1 #2
         goto OFF1_4
        clrf R_STATE1                  ; clear R_STATE1  
        bsf R_STATE1,3                 ; continue R_STATE1#3
        goto STATUS_REG_2              ; continue

OFF1_4  btfss R_STATE1,4               ; check R_STATE1 #4
         goto STATUS_REG_2             ; continue
        clrf R_STATE1                  ; clear R_STATE1  
        bsf R_STATE1,2                 ; continue R_STATE1#2



STATUS_REG_2
        ; *** LED2 (Ausgang 2) ***
        btfss R_STATUS_a2,1
         goto LED2OFF                  ; .. then jump
           
LED2ON  ; *** LED2 ON *** 
ON2_2   btfss R_STATE2,2               ; check R_STATE2 #2
         goto ON2_3
        clrf R_STATE2                  ; clear R_STATE2  
        bsf R_STATE2,4                 ; continue R_STATE2#4
        goto STATUS_REG_3              ; continue

ON2_3   btfss R_STATE2,3               ; check R_STATE2 #3
         goto ON2_4
        clrf R_STATE2                  ; clear R_STATE2  
        bsf R_STATE2,4                 ; continue R_STATE2#4
        goto STATUS_REG_3              ; continue

ON2_4   btfss R_STATE2,4               ; check R_STATE2 #4
         goto STATUS_REG_3             ; continue
        clrf R_STATE2                  ; clear R_STATE2  
        bsf R_STATE2,1                 ; continue R_STATE2#1
        goto STATUS_REG_3              ; continue
        
LED2OFF ; *** LED2 OFF ***      
OFF2_1  btfss R_STATE2,1               ; check R_STATE2 #1
         goto OFF2_2
        clrf R_STATE2                  ; clear R_STATE2  
        bsf R_STATE2,2                 ; continue R_STATE2#2
         goto STATUS_REG_3             ; continue
        
OFF2_2  btfss R_STATE2,2               ; check R_STATE2 #2
         goto OFF2_4
        clrf R_STATE2                  ; clear R_STATE2  
        bsf R_STATE2,3                 ; continue R_STATE2#3
        goto STATUS_REG_3              ; continue

OFF2_4  btfss R_STATE2,4               ; check R_STATE2 #4
         goto STATUS_REG_3             ; continue
        clrf R_STATE2                  ; clear R_STATE2  
        bsf R_STATE2,2                 ; continue R_STATE2#2



STATUS_REG_3
        ; *** LED3 (Ausgang 3) ***
        btfss R_STATUS_a2,2
         goto LED3OFF                  ; .. then jump
          
LED3ON  ; *** LED3 ON ***  
ON3_2   btfss R_STATE3,2               ; check R_STATE3 #2
         goto ON3_3
        clrf R_STATE3                  ; clear R_STATE3  
        bsf R_STATE3,4                 ; continue R_STATE3#4
        goto STATUS_REG_4              ; continue

ON3_3   btfss R_STATE3,3               ; check R_STATE3 #3
         goto ON3_4
        clrf R_STATE3                  ; clear R_STATE3  
        bsf R_STATE3,4                 ; continue R_STATE3#4
        goto STATUS_REG_4              ; continue

ON3_4   btfss R_STATE3,4               ; check R_STATE3 #4
         goto STATUS_REG_4             ; continue
        clrf R_STATE3                  ; clear R_STATE3  
        bsf R_STATE3,1                 ; continue R_STATE3#1
        goto STATUS_REG_4              ; continue
        
LED3OFF ; *** LED3 OFF ***  
OFF3_1  btfss R_STATE3,1               ; check R_STATE3 #1
         goto OFF3_2
        clrf R_STATE3                  ; clear R_STATE3  
        bsf R_STATE3,2                 ; continue R_STATE3#2
         goto STATUS_REG_4             ; continue
        
OFF3_2  btfss R_STATE3,2               ; check R_STATE3 #2
         goto OFF3_4
        clrf R_STATE3                  ; clear R_STATE3  
        bsf R_STATE3,3                 ; continue R_STATE3#3
        goto STATUS_REG_4              ; continue

OFF3_4  btfss R_STATE3,4               ; check R_STATE3 #4
         goto STATUS_REG_4             ; continue
        clrf R_STATE3                  ; clear R_STATE3  
        bsf R_STATE3,2                 ; continue R_STATE3#2



STATUS_REG_4
        ; *** LED4 (Ausgang 4) ***
        btfss R_STATUS_a2,3
         goto LED4OFF                  ; .. then jump

LED4ON  ; *** LED4 ON ***      
ON4_2   btfss R_STATE4,2               ; check R_STATE4 #2
         goto ON4_3
        clrf R_STATE4                  ; clear R_STATE4  
        bsf R_STATE4,4                 ; continue R_STATE4#4
        goto STATUS_REG_5              ; continue

ON4_3   btfss R_STATE4,3               ; check R_STATE4 #3
         goto ON4_4
        clrf R_STATE4                  ; clear R_STATE4  
        bsf R_STATE4,4                 ; continue R_STATE4#4
        goto STATUS_REG_5              ; continue

ON4_4   btfss R_STATE4,4               ; check R_STATE4 #4
         goto STATUS_REG_5             ; continue
        clrf R_STATE4                  ; clear R_STATE4  
        bsf R_STATE4,1                 ; continue R_STATE4#1
        goto STATUS_REG_5              ; continue
        
LED4OFF ; *** LED4 OFF ***      
OFF4_1  btfss R_STATE4,1               ; check R_STATE4 #1
         goto OFF4_2
        clrf R_STATE4                  ; clear R_STATE4  
        bsf R_STATE4,2                 ; continue R_STATE4#2
         goto STATUS_REG_5             ; continue
        
OFF4_2  btfss R_STATE4,2               ; check R_STATE4 #2
         goto OFF4_4
        clrf R_STATE4                  ; clear R_STATE4  
        bsf R_STATE4,3                 ; continue R_STATE4#3
        goto STATUS_REG_5              ; continue

OFF4_4  btfss R_STATE4,4               ; check R_STATE4 #4
         goto STATUS_REG_5             ; continue
        clrf R_STATE4                  ; clear R_STATE4  
        bsf R_STATE4,2                 ; continue R_STATE4#2



STATUS_REG_5
        ; *** LED5 (Ausgang 5) ***
        btfss R_STATUS_a2,4
         goto LED5OFF                  ; .. then jump

LED5ON  ; *** LED5 ON ***      
ON5_2   btfss R_STATE5,2               ; check R_STATE5 #2
         goto ON5_3
        clrf R_STATE5                  ; clear R_STATE5  
        bsf R_STATE5,4                 ; continue R_STATE5#4
        goto STATUS_REG_6              ; continue

ON5_3   btfss R_STATE5,3               ; check R_STATE5 #3
         goto ON5_4
        clrf R_STATE5                  ; clear R_STATE5  
        bsf R_STATE5,4                 ; continue R_STATE5#4
        goto STATUS_REG_6              ; continue

ON5_4   btfss R_STATE5,4               ; check R_STATE5 #4
         goto STATUS_REG_6             ; continue
        clrf R_STATE5                  ; clear R_STATE5  
        bsf R_STATE5,1                 ; continue R_STATE5#1
        goto STATUS_REG_6              ; continue
        
LED5OFF ; *** LED5 OFF ***      
OFF5_1  btfss R_STATE5,1               ; check R_STATE5 #1
         goto OFF5_2
        clrf R_STATE5                  ; clear R_STATE5  
        bsf R_STATE5,2                 ; continue R_STATE5#2
         goto STATUS_REG_6             ; continue
        
OFF5_2  btfss R_STATE5,2               ; check R_STATE5 #2
         goto OFF5_4
        clrf R_STATE5                  ; clear R_STATE5  
        bsf R_STATE5,3                 ; continue R_STATE5#3
        goto STATUS_REG_6              ; continue

OFF5_4  btfss R_STATE5,4               ; check R_STATE5 #4
         goto STATUS_REG_6             ; continue
        clrf R_STATE5                  ; clear R_STATE5  
        bsf R_STATE5,2                 ; continue R_STATE5#2



STATUS_REG_6
        ; *** LED6 (Ausgang 6) ***
        btfss R_STATUS_a2,5
         goto LED6OFF                  ; .. then jump

LED6ON  ; *** LED6 ON ***      
ON6_2   btfss R_STATE6,2               ; check R_STATE6 #2
         goto ON6_3
        clrf R_STATE6                  ; clear R_STATE6  
        bsf R_STATE6,4                 ; continue R_STATE6#4
        goto STATUS_REG_7              ; continue

ON6_3   btfss R_STATE6,3               ; check R_STATE6 #3
         goto ON6_4
        clrf R_STATE6                  ; clear R_STATE6  
        bsf R_STATE6,4                 ; continue R_STATE6#4
        goto STATUS_REG_7              ; continue

ON6_4   btfss R_STATE6,4               ; check R_STATE6 #4
         goto STATUS_REG_7             ; continue
        clrf R_STATE6                  ; clear R_STATE6  
        bsf R_STATE6,1                 ; continue R_STATE6#1
        goto STATUS_REG_7              ; continue
        
LED6OFF ; *** LED6 OFF ***      
OFF6_1  btfss R_STATE6,1               ; check R_STATE6 #1
         goto OFF6_2
        clrf R_STATE6                  ; clear R_STATE6  
        bsf R_STATE6,2                 ; continue R_STATE6#2
         goto STATUS_REG_7             ; continue
        
OFF6_2  btfss R_STATE6,2               ; check R_STATE6 #2
         goto OFF6_4
        clrf R_STATE6                  ; clear R_STATE6  
        bsf R_STATE6,3                 ; continue R_STATE6#3
        goto STATUS_REG_7              ; continue

OFF6_4  btfss R_STATE6,4               ; check R_STATE6 #4
         goto STATUS_REG_7             ; continue
        clrf R_STATE6                  ; clear R_STATE6  
        bsf R_STATE6,2                 ; continue R_STATE6#2



STATUS_REG_7
        ; *** LED7 (Ausgang 7) ***
        btfss R_STATUS_a2,6
         goto LED7OFF                  ; .. then jump

LED7ON  ; *** LED7 ON ***      
ON7_2   btfss R_STATE7,2               ; check R_STATE7 #2
         goto ON7_3
        clrf R_STATE7                  ; clear R_STATE7  
        bsf R_STATE7,4                 ; continue R_STATE7#4
        goto STATUS_REG_8              ; continue

ON7_3   btfss R_STATE7,3               ; check R_STATE7 #3
         goto ON7_4
        clrf R_STATE7                  ; clear R_STATE7  
        bsf R_STATE7,4                 ; continue R_STATE7#4
        goto STATUS_REG_8              ; continue

ON7_4   btfss R_STATE7,4               ; check R_STATE7 #4
         goto STATUS_REG_8             ; continue
        clrf R_STATE7                  ; clear R_STATE7  
        bsf R_STATE7,1                 ; continue R_STATE7#1
        goto STATUS_REG_8              ; continue
        
LED7OFF ; *** LED7 OFF ***      
OFF7_1  btfss R_STATE7,1               ; check R_STATE7 #1
         goto OFF7_2
        clrf R_STATE7                  ; clear R_STATE7  
        bsf R_STATE7,2                 ; continue R_STATE7#2
         goto STATUS_REG_8             ; continue
        
OFF7_2  btfss R_STATE7,2               ; check R_STATE7 #2
         goto OFF7_4
        clrf R_STATE7                  ; clear R_STATE7  
        bsf R_STATE7,3                 ; continue R_STATE7#3
        goto STATUS_REG_8              ; continue

OFF7_4  btfss R_STATE7,4               ; check R_STATE7 #4
         goto STATUS_REG_8             ; continue
        clrf R_STATE7                  ; clear R_STATE7  
        bsf R_STATE7,2                 ; continue R_STATE7#2



STATUS_REG_8
        ; *** LED8 (Ausgang 8) ***
        btfss R_STATUS_a2,7
         goto LED8OFF                  ; .. then jump

LED8ON  ; *** LED8 ON ***      
ON8_2   btfss R_STATE8,2               ; check R_STATE8 #2
         goto ON8_3
        clrf R_STATE8                  ; clear R_STATE8  
        bsf R_STATE8,4                 ; continue R_STATE8#4
        goto STATUS_REG_9              ; continue

ON8_3   btfss R_STATE8,3               ; check R_STATE8 #3
         goto ON8_4
        clrf R_STATE8                  ; clear R_STATE8  
        bsf R_STATE8,4                 ; continue R_STATE8#4
        goto STATUS_REG_9              ; continue

ON8_4   btfss R_STATE8,4               ; check R_STATE8 #4
         goto STATUS_REG_9             ; continue
        clrf R_STATE8                  ; clear R_STATE8  
        bsf R_STATE8,1                 ; continue R_STATE8#1
        goto STATUS_REG_9              ; continue
        
LED8OFF ; *** LED8 OFF ***      
OFF8_1  btfss R_STATE8,1               ; check R_STATE8 #1
         goto OFF8_2
        clrf R_STATE8                  ; clear R_STATE8  
        bsf R_STATE8,2                 ; continue R_STATE8#2
         goto STATUS_REG_9             ; continue
        
OFF8_2  btfss R_STATE8,2               ; check R_STATE8 #2
         goto OFF8_4
        clrf R_STATE8                  ; clear R_STATE8  
        bsf R_STATE8,3                 ; continue R_STATE8#3
        goto STATUS_REG_9              ; continue

OFF8_4  btfss R_STATE8,4               ; check R_STATE8 #4
         goto STATUS_REG_9             ; continue
        clrf R_STATE8                  ; clear R_STATE8  
        bsf R_STATE8,2                 ; continue R_STATE8#2



STATUS_REG_9
        ; *** LED9 (Ausgang 9 ***
        btfss R_STATUS_b2,0
         goto LED9OFF                  ; .. then jump

LED9ON  ; *** LED9 ON ***      
ON9_2   btfss R_STATE9,2               ; check R_STATE9 #2
         goto ON9_3
        clrf R_STATE9                  ; clear R_STATE9  
        bsf R_STATE9,4                 ; continue R_STATE9#4
        goto STATUS_REG_10              ; continue

ON9_3   btfss R_STATE9,3               ; check R_STATE9 #3
         goto ON9_4
        clrf R_STATE9                  ; clear R_STATE9  
        bsf R_STATE9,4                 ; continue R_STATE9#4
        goto STATUS_REG_10              ; continue

ON9_4   btfss R_STATE9,4               ; check R_STATE9 #4
         goto STATUS_REG_10             ; continue
        clrf R_STATE9                  ; clear R_STATE9  
        bsf R_STATE9,1                 ; continue R_STATE9#1
        goto STATUS_REG_10              ; continue
        
LED9OFF ; *** LED9 OFF ***      
OFF9_1  btfss R_STATE9,1               ; check R_STATE9 #1
         goto OFF9_2
        clrf R_STATE9                  ; clear R_STATE9  
        bsf R_STATE9,2                 ; continue R_STATE9#2
         goto STATUS_REG_10             ; continue
        
OFF9_2  btfss R_STATE9,2               ; check R_STATE9 #2
         goto OFF9_4
        clrf R_STATE9                  ; clear R_STATE9  
        bsf R_STATE9,3                 ; continue R_STATE9#3
        goto STATUS_REG_10              ; continue

OFF9_4  btfss R_STATE9,4               ; check R_STATE9 #4
         goto STATUS_REG_10             ; continue
        clrf R_STATE9                  ; clear R_STATE9  
        bsf R_STATE9,2                 ; continue R_STATE9#2



STATUS_REG_10
        ; *** LED10 (Ausgang 10 ***
        btfss R_STATUS_b2,1
         goto LED10OFF                  ; .. then jump

LED10ON ; *** LED10 ON ***      
ON10_2  btfss R_STATE10,2               ; check R_STATE10 #2
         goto ON10_3
        clrf R_STATE10                  ; clear R_STATE10  
        bsf R_STATE10,4                 ; continue R_STATE10#4
        goto STATUS_REG_11              ; continue

ON10_3  btfss R_STATE10,3               ; check R_STATE10 #3
         goto ON10_4
        clrf R_STATE10                  ; clear R_STATE10  
        bsf R_STATE10,4                 ; continue R_STATE10#4
        goto STATUS_REG_11              ; continue

ON10_4  btfss R_STATE10,4               ; check R_STATE10 #4
         goto STATUS_REG_11             ; continue
        clrf R_STATE10                  ; clear R_STATE10  
        bsf R_STATE10,1                 ; continue R_STATE10#1
        goto STATUS_REG_11              ; continue
        
LED10OFF; *** LED10 OFF ***      
OFF10_1 btfss R_STATE10,1               ; check R_STATE10 #1
         goto OFF10_2
        clrf R_STATE10                  ; clear R_STATE10  
        bsf R_STATE10,2                 ; continue R_STATE10#2
         goto STATUS_REG_11             ; continue
        
OFF10_2 btfss R_STATE10,2               ; check R_STATE10 #2
         goto OFF10_4
        clrf R_STATE10                  ; clear R_STATE10  
        bsf R_STATE10,3                 ; continue R_STATE10#3
        goto STATUS_REG_11              ; continue

OFF10_4 btfss R_STATE10,4               ; check R_STATE10 #4
         goto STATUS_REG_11             ; continue
        clrf R_STATE10                  ; clear R_STATE10  
        bsf R_STATE10,2                 ; continue R_STATE10#2



STATUS_REG_11
        ; --- Status speichern ? ---
        call save_status               ; .. 

        movf R_STATUS_a,W                ; copy R_STATUS into R_STATUS2
        movwf R_STATUS_a2                ; (fuer Dunkelphase)
        movf R_STATUS_b,W                ; copy R_STATUS into R_STATUS2
        movwf R_STATUS_b2                ; (fuer Dunkelphase)

signal2_1 ;**** LED steuern ****
;        btfss R_STATE1,0
;         bcf PORTA,4
;        btfsc R_STATE1,0
;         bsf PORTA,4
;
;        btfss R_STATE1,1
;         bcf PORTA,5
;        btfsc R_STATE1,1
;         bsf PORTA,5
;
;        btfss R_STATE1,2
;         bcf PORTA,0
;        btfsc R_STATE1,2
;         bsf PORTA,0
;
;        btfss R_STATE1,3
;         bcf PORTA,1
;        btfsc R_STATE1,3
;         bsf PORTA,1
;
;        btfss R_STATE1,4
;         bcf PORTC,1
;        btfsc R_STATE1,4
;         bsf PORTC,1
;
;        btfss R_STATE1,5
;         bcf PORTC,2
;        btfsc R_STATE1,5
;         bsf PORTC,2
;
;        btfss R_STATE1,6
;         bcf PORTC,0
;        btfsc R_STATE1,6
;         bsf PORTC,0
;
;        btfss R_STATE1,7
;         bcf PORTC,5
;        btfsc R_STATE1,7
;         bsf PORTC,5

        movf R_COUNT,W                 ; get R_COUNT
        movwf R_PWMVALUE               ; .. and put into PWMVALUE

        ;***** PWM-Time ON *****
        movlw b'00001100'              ; check status #2,#3
        andwf R_STATE1,W               ; = off or fade out LED1
        btfss STATUS,Z
         bcf PORTA,4                   ; LED_1 off
        movlw b'00001100'              ; check status #2,#3
        andwf R_STATE2,W               ; = off or fade out LED2
        btfss STATUS,Z
         bcf PORTA,5                   ; LED_2 off
        movlw b'00001100'              ; check status #2,#3
        andwf R_STATE3,W               ; = off or fade out LED3
        btfss STATUS,Z
         bcf PORTA,0                   ; LED_3 off
        movlw b'00001100'              ; check status #2,#3
        andwf R_STATE4,W               ; = off or fade out LED4
        btfss STATUS,Z
         bcf PORTA,1                   ; LED_4 off
        movlw b'00001100'              ; check status #2,#3
        andwf R_STATE5,W               ; = off or fade out LED5
        btfss STATUS,Z
         bcf PORTC,1                   ; LED_5 off
        movlw b'00001100'              ; check status #2,#3
        andwf R_STATE6,W               ; = off or fade out LED6
        btfss STATUS,Z
         bcf PORTC,2                   ; LED_6 off
        movlw b'00001100'              ; check status #2,#3
        andwf R_STATE7,W               ; = off or fade out LED7
        btfss STATUS,Z
         bcf PORTC,0                   ; LED_7 off
        movlw b'00001100'              ; check status #2,#3
        andwf R_STATE8,W               ; = off or fade out LED8
        btfss STATUS,Z
         bcf PORTC,5                   ; LED_8 off
        movlw b'00001100'              ; check status #2,#3
        andwf R_STATE9,W               ; = off or fade out LED9
        btfss STATUS,Z
         bcf PORTC,4                   ; LED_9 off
        movlw b'00001100'              ; check status #2,#3
        andwf R_STATE10,W               ; = off or fade out LED10
        btfss STATUS,Z
         bcf PORTC,3                   ; LED_10 off

        movf R_PWMVALUE,W              ; get PWM-Value into W-Register
        subwf TMR1L,W                  ; W = TMR1L - W
        btfsc STATUS,C                 ; if C=1, -> TMR1L > PWM-Value
        goto signal4_2                 ; ... then JUMP

        movlw b'00010010'              ; check status #1,#4
        andwf R_STATE1,W               ; = fade in/on LED1
        btfss STATUS,Z
         bsf PORTA,4                   ; LED_1 on
        movlw b'00010010'              ; check status #1,#4
        andwf R_STATE2,W               ; = fade in/on LED2
        btfss STATUS,Z
         bsf PORTA,5                   ; LED_2 on
        movlw b'00010010'              ; check status #1,#4
        andwf R_STATE3,W               ; = fade in/on LED3
        btfss STATUS,Z
         bsf PORTA,0                   ; LED_3 on
        movlw b'00010010'              ; check status #1,#4
        andwf R_STATE4,W               ; = fade in/on LED4
        btfss STATUS,Z
         bsf PORTA,1                   ; LED_4 on
        movlw b'00010010'              ; check status #1,#4
        andwf R_STATE5,W               ; = fade in/on LED5
        btfss STATUS,Z
         bsf PORTC,1                   ; LED_5 on
        movlw b'00010010'              ; check status #1,#4
        andwf R_STATE6,W               ; = fade in/on LED6
        btfss STATUS,Z
         bsf PORTC,2                   ; LED_6 on
        movlw b'00010010'              ; check status #1,#4
        andwf R_STATE7,W               ; = fade in/on LED7
        btfss STATUS,Z
         bsf PORTC,0                   ; LED_7 on
        movlw b'00010010'              ; check status #1,#4
        andwf R_STATE8,W               ; = fade in/on LED8
        btfss STATUS,Z
         bsf PORTC,5                   ; LED_8 on
        movlw b'00010010'              ; check status #1,#4
        andwf R_STATE9,W               ; = fade in/on LED9
        btfss STATUS,Z
         bsf PORTC,4                   ; LED_9 on
        movlw b'00010010'              ; check status #1,#4
        andwf R_STATE10,W              ; = fade in/on LED10
        btfss STATUS,Z
         bsf PORTC,3                   ; LED_9 on

        movlw b'11111111'              ; if R_COUNT
        subwf R_COUNT,W                ; .. = 255
        btfsc STATUS,Z
         return                        ; .. then return

signal4_2 ; ** warten auf PWM Off-Time **
        movf TMR1H,F 
        btfss STATUS,Z                 ; if TMR1H <> ZERO
         return                        ; .. then return

        call polarity                  ; check polarity
        movf R_PWMVALUE,W              ; get PWM-Value into W-Register
        subwf TMR1L,W                  ; W = TMR1L - W
        btfss STATUS,C                 ; if C=0, -> TMR1L < PWM-Value
         goto signal4_2                ; ... then JUMP_2

        ; ***** PWM-Time ready *****
        movlw b'00011000'              ; check status #3,#4
        andwf R_STATE1,W               ; = off or fade in LED1
        btfss STATUS,Z
         bcf PORTA,4                   ; LED_1 off
        movlw b'00000110'              ; check status #1,#2
        andwf R_STATE1,W               ; = on or fade out LED1
        btfss STATUS,Z
         bsf PORTA,4                   ; LED_1 on

        movlw b'00011000'              ; check status #3,#4
        andwf R_STATE2,W               ; = off or fade in LED2
        btfss STATUS,Z
         bcf PORTA,5                   ; LED_2 off
        movlw b'00000110'              ; check status #1,#2
        andwf R_STATE2,W               ; = on or fade out LED2
        btfss STATUS,Z
         bsf PORTA,5                   ; LED_2 on

        movlw b'00011000'              ; check status #3,#4
        andwf R_STATE3,W               ; = off or fade in LED3
        btfss STATUS,Z
         bcf PORTA,0                   ; LED_3 off
        movlw b'00000110'              ; check status #1,#2
        andwf R_STATE3,W               ; = on or fade out LED3
        btfss STATUS,Z
         bsf PORTA,0                   ; LED_3 on

        movlw b'00011000'              ; check status #3,#4
        andwf R_STATE4,W               ; = off or fade in LED4
        btfss STATUS,Z
         bcf PORTA,1                   ; LED_4 off
        movlw b'00000110'              ; check status #1,#2
        andwf R_STATE4,W               ; = on or fade out LED4
        btfss STATUS,Z
         bsf PORTA,1                   ; LED_4 on

        movlw b'00011000'              ; check status #3,#4
        andwf R_STATE5,W               ; = off or fade in LED5
        btfss STATUS,Z
         bcf PORTC,1                   ; LED_5 off
        movlw b'00000110'              ; check status #1,#2
        andwf R_STATE5,W               ; = on or fade out LED5
        btfss STATUS,Z
         bsf PORTC,1                   ; LED_5 on

        movlw b'00011000'              ; check status #3,#4
        andwf R_STATE6,W               ; = off or fade in LED6
        btfss STATUS,Z
         bcf PORTC,2                   ; LED_6 off
        movlw b'00000110'              ; check status #1,#2
        andwf R_STATE6,W               ; = on or fade out LED6
        btfss STATUS,Z
         bsf PORTC,2                   ; LED_6 on

        movlw b'00011000'              ; check status #3,#4
        andwf R_STATE7,W               ; = off or fade in LED7
        btfss STATUS,Z
         bcf PORTC,0                   ; LED_7 off
        movlw b'00000110'              ; check status #1,#2
        andwf R_STATE7,W               ; = on or fade out LED7
        btfss STATUS,Z
         bsf PORTC,0                   ; LED_7 on

        movlw b'00011000'              ; check status #3,#4
        andwf R_STATE8,W               ; = off or fade in LED8
        btfss STATUS,Z
         bcf PORTC,5                   ; LED_8 off
        movlw b'00000110'              ; check status #1,#2
        andwf R_STATE8,W               ; = on or fade out LED8
        btfss STATUS,Z
         bsf PORTC,5                   ; LED_8 on

        movlw b'00011000'              ; check status #3,#4
        andwf R_STATE9,W               ; = off or fade in LED9
        btfss STATUS,Z
         bcf PORTC,4                   ; LED_9 off
        movlw b'00000110'              ; check status #1,#2
        andwf R_STATE9,W               ; = on or fade out LED9
        btfss STATUS,Z
         bsf PORTC,4                   ; LED_9 on

        movlw b'00011000'              ; check status #3,#4
        andwf R_STATE10,W               ; = off or fade in LED9
        btfss STATUS,Z
         bcf PORTC,3                   ; LED_10 off
        movlw b'00000110'              ; check status #1,#2
        andwf R_STATE10,W               ; = on or fade out LED9
        btfss STATUS,Z
         bsf PORTC,3                   ; LED_10 on

        return                        ; .. then return
