; ********************************************************
; ** Version: V3.21 vom 03/01/2009                      **
; ********************************************************
; ** Include-File zu dekoder.asm                        **
; ********************************************************
; ** Sven Brandt                                        **
; ********************************************************
; Copyright (C) 2003/04/05/06/07/08/09 Sven Brandt

;*********************************
;*********************************
;*********************************
;*********************************
;** Routine: LED_AMPEL          **
;** state manager ampel         **
;*********************************
;*********************************
;*********************************
;*********************************
statemachine_signal_straba

T_GELB      equ d'150'         ; (1..255) duration Phase Gelb

;PWM detail, here Fade in (Fade out = inverted Signal):
;  0        1        2        3        4        5       6       7 Value of R_COUNT
;  :-:      :--:     :---:    :----:   :-----:  :-----: :------::-----
;  : :      :  :     :   :    :    :   :     :  :     : :      ::
; -: :------:  :-----:   :----:    :---:     :--:     :-:      ::
;  1 2      3  2     3   2    3    2   3     2  3     2 3       3
;@1: LED on, R_COUNT=0
;@2: LED off
;@3: LED on, R_COUNT increment every 2ms


;   -------------------------
;   --- create 3ms-Raster ---
;   -------------------------
#ifndef test
        movf TMR1H,F 
        btfsc STATUS,Z                 ; if TMR1H <> ZERO
         return
#endif
        clrf TMR1L                     ; .. then reset to ZERO
        clrf TMR1H                     ; .. then reset to ZERO

        movlw d'50'
        movwf TMR1L;          ; fr schnelleres Blinken / Fading

        movf R_COUNT,F                 ; wenn R_COUNT = ZERO, dann ist
        btfsc STATUS,Z                 ; .. PWM abgeschlossen,
         goto ampel_state              ; .. jetzt State-Machine

        incfsz R_COUNT,F               ; PWM fertig ?
         goto ampel_1                  ; .. wenn nicht, jump

        ; PWM fertig, ab jetzt statische LEDs
        ; wenn FADE-IN gewesen, dann entsprechendes Port EIN
        btfsc R_FADEIN1,0      ; = fade in LED1
         bsf PORTA,1           ; ROT   fuer Hauptstrasse = EIN
        btfsc R_FADEIN1,1      ; = fade in LED2
         bsf PORTA,0           ; GELB  fuer Hauptstrasse = EIN
        btfsc R_FADEIN1,2      ; = fade in LED3
         bsf PORTA,5           ; GRUEN fuer Hauptstrasse = EIN
        btfsc R_FADEIN1,3      ; = fade in LED4
         bsf PORTA,4           ; ROT   fuer Nebenstrasse = EIN
        clrf R_FADEIN1

        ; wenn FADE-OUT gewesen, dann entsprechendes Port AUS
        btfsc R_FADEOUT1,0     ; = fade out LED1
         bcf PORTA,1           ; ROT   fuer Hauptstrasse = AUS
        btfsc R_FADEOUT1,1     ; = fade out LED2
         bcf PORTA,0           ; GELB  fuer Hauptstrasse = AUS
        btfsc R_FADEOUT1,2     ; = fade out LED3
         bcf PORTA,5           ; GRUEN fuer Hauptstrasse = AUS
        btfsc R_FADEOUT1,3     ; = fade out LED4
         bcf PORTA,4           ; ROT   fuer Nebenstrasse = AUS
        clrf R_FADEOUT1
        goto ampel_state

ampel_1 ;**** LED steuern ****
        movf R_COUNT,W                 ; get R_COUNT
        movwf R_PWMVALUE               ; .. and put into PWMVALUE

        ; ***** PWM-Time Einschaltpunkt *****
        btfsc R_FADEIN1,0              ; = fade in LED1
         bsf PORTA,1                   ; LED_1 on
        btfsc R_FADEIN1,1              ; = fade in LED2
         bsf PORTA,0                   ; LED_2 on
        btfsc R_FADEIN1,2              ; = fade in LED3
         bsf PORTA,5                   ; LED_3 on
        btfsc R_FADEIN1,3              ; = fade in LED4
         bsf PORTA,4                   ; LED_4 on

        movf R_PWMVALUE,W              ; get PWM-Value into W-Register
        subwf TMR1L,W                  ; W = TMR1L - W
        btfsc STATUS,C                 ; if C=1, -> TMR1L > PWM-Value
         goto ampel_2                  ; ... then JUMP

        btfsc R_FADEOUT1,0             ; = fade out LED1
         bcf PORTA,1                   ; LED_1 off
        btfsc R_FADEOUT1,1             ; = fade out LED2
         bcf PORTA,0                   ; LED_2 off
        btfsc R_FADEOUT1,2             ; = fade out LED3
         bcf PORTA,5                   ; LED_3 off
        btfsc R_FADEOUT1,3             ; = fade out LED4
         bcf PORTA,4                   ; LED_4 off

        movlw b'11111111'              ; if R_COUNT
        subwf R_COUNT,W                ; .. = 255
        btfsc STATUS,Z
         return                        ; .. then return

ampel_2 ; ** warten auf PWM Off-Time **
        movf TMR1H,F 
        btfss STATUS,Z                 ; if TMR1H <> ZERO
         return                        ; .. then return

        call polarity                  ; check polarity
        movf R_PWMVALUE,W              ; get PWM-Value into W-Register
        subwf TMR1L,W                  ; W = TMR1L - W
        btfss STATUS,C                 ; if C=0, -> TMR1L < PWM-Value
         goto ampel_2                  ; ... then JUMP_2

        ;***** PWM-Time abgelaufen *****
        btfsc R_FADEIN1,0              ; = fade in LED1
         bcf PORTA,1                   ; LED_1 off
        btfsc R_FADEIN1,1              ; = fade in LED2
         bcf PORTA,0                   ; LED_2 off
        btfsc R_FADEIN1,2              ; = fade in LED3
         bcf PORTA,5                   ; LED_3 off
        btfsc R_FADEIN1,3              ; = fade in LED4
         bcf PORTA,4                   ; LED_4 off

        btfsc R_FADEOUT1,0             ; = fade out LED1
         bsf PORTA,1                   ; LED_1 on
        btfsc R_FADEOUT1,1             ; = fade out LED2
         bsf PORTA,0                   ; LED_2 on
        btfsc R_FADEOUT1,2             ; = fade out LED3
         bsf PORTA,5                   ; LED_3 on
        btfsc R_FADEOUT1,3             ; = fade out LED4
         bsf PORTA,4                   ; LED_4 on

        return





ampel_state
#ifndef test
;        decfsz R_DELAY2,F              ; extra-Verzgerung
;         return                        ; auf ca. 0.2 sec
;        movlw d'70'
;        movwf R_DELAY2
#endif

        decfsz R_DELAY,F               ; if R_DELAY = 0
         return                        ; .. then change R_STATE 

        movlw d'01'                    ; PWM wieder starten
        movwf R_COUNT                  ; .. mit '1'

phase1  ; *** Phase Rot
        movlw d'01'                    ;
        subwf R_PHASE,W
        btfss STATUS,Z                 ; if not the same
         goto phase3                   ; .. then OK -> jump

        bsf R_FADEIN1,0                ; ROT   Hauptstrasse einschalten
;        bsf R_FADEIN1,1                ; GELB  Hauptstrasse einschalten
;        bsf R_FADEIN1,2                ; GRUEN Hauptstrasse einschalten

;        bsf R_FADEOUT1,0               ; ROT   Hauptstrasse abschalten
        bsf R_FADEOUT1,1               ; GELB  Hauptstrasse abschalten
;        bsf R_FADEOUT1,2               ; GRUEN Hauptstrasse abschalten

        movlw d'01'                    ; minimale Verzoegerungszeit
        movwf R_DELAY

        movlw d'03'
        movwf R_PHASE         ; naechster STATE
        return                ; Return, jetzt muss erst R_DELAY wieder auf ZERO














phase3  ; *** Phase: Statisch Rot
        movlw d'03'                    ;
        subwf R_PHASE,W
        btfss STATUS,Z                 ; if not the same
         goto phase4                   ; .. then OK -> jump

        movlw d'01'                    ; minimale Verzoegerungszeit
        movwf R_DELAY

        clrf R_COUNT                   ; .. keine PWM

        btfss R_STATUS,0               ; wenn ROT,
         return                        ; .. nichts machen

        movlw d'04'
        movwf R_PHASE         ; naechster STATE
        return                ; Return, jetzt muss erst R_DELAY wieder auf ZERO

















phase4  ; *** Phase: GELB, ROT abschalten
        movlw d'04'                    ;
        subwf R_PHASE,W
        btfss STATUS,Z                 ; if not the same
         goto phase5                   ; .. then OK -> jump

;        bsf R_FADEIN1,0                ; ROT   Hauptstrasse einschalten
        bsf R_FADEIN1,1                ; GELB  Hauptstrasse einschalten
;        bsf R_FADEIN1,2                ; GRUEN Hauptstrasse einschalten

        bsf R_FADEOUT1,0               ; ROT   Hauptstrasse abschalten
;        bsf R_FADEOUT1,1               ; GELB  Hauptstrasse abschalten
;        bsf R_FADEOUT1,2               ; GRUEN Hauptstrasse abschalten

        movlw T_GELB                  ; Verzoegerungszeit
        movwf R_DELAY

        movlw d'05'
        movwf R_PHASE         ; naechster STATE
        return                ; Return, jetzt muss erst R_DELAY wieder auf ZERO














phase5  ; *** Phase: GRN
        movlw d'05'                    ;
        subwf R_PHASE,W
        btfss STATUS,Z                 ; if not the same
         goto phase6                   ; .. then OK -> jump

;        bsf R_FADEIN1,0                ; ROT   Hauptstrasse einschalten
;        bsf R_FADEIN1,1                ; GELB  Hauptstrasse einschalten
        bsf R_FADEIN1,2                ; GRUEN Hauptstrasse einschalten

;        bsf R_FADEOUT1,0               ; ROT   Hauptstrasse abschalten
        bsf R_FADEOUT1,1               ; GELB  Hauptstrasse abschalten
;        bsf R_FADEOUT1,2               ; GRUEN Hauptstrasse abschalten

        movlw d'01'                    ; minimale Verzoegerungszeit
        movwf R_DELAY

        movlw d'06'
        movwf R_PHASE                  ; naechster STATE
        return                         ; Return, jetzt muss erst R_DELAY wieder auf ZERO














phase6  ; *** Phase: Statisch Grn
        movlw d'06'                    ;
        subwf R_PHASE,W
        btfss STATUS,Z                 ; if not the same
         goto phase8                   ; .. then OK -> jump

        movlw d'01'                    ; minimale Verzoegerungszeit
        movwf R_DELAY

        clrf R_COUNT                   ; .. keine PWM

        btfsc R_STATUS,0               ; wenn GRN,
         return                        ; .. nichts machen

        movlw d'08'
        movwf R_PHASE         ; naechster STATE
        return                ; Return, jetzt muss erst R_DELAY wieder auf ZERO

















phase8  ; *** Phase: GELB, GRN abschalten
        movlw d'08'                    ;
        subwf R_PHASE,W
        btfss STATUS,Z                 ; if not the same
         goto phase99                   ; .. then OK -> jump

;        bsf R_FADEIN1,0                ; ROT   Hauptstrasse einschalten
        bsf R_FADEIN1,1                ; GELB  Hauptstrasse einschalten
;        bsf R_FADEIN1,2                ; GRUEN Hauptstrasse einschalten

;        bsf R_FADEOUT1,0               ; ROT   Hauptstrasse abschalten
;        bsf R_FADEOUT1,1               ; GELB  Hauptstrasse abschalten
        bsf R_FADEOUT1,2               ; GRUEN Hauptstrasse abschalten

        movlw T_GELB                  ; Verzoegerungszeit
        movwf R_DELAY

        movlw d'01'
        movwf R_PHASE         ; naechster STATE
        return                ; Return, jetzt muss erst R_DELAY wieder auf ZERO





phase99 ; keine gltige Phase eingestellt
        movlw d'01'
        movwf R_PHASE         ; naechster STATE
        return                ; Return, jetzt muss erst R_DELAY wieder auf ZERO


