; ********************************************************
; ** Version: V3.17 vom 24/07/2008                      **
; ********************************************************
; ** Include-File zu dekoder.asm                        **
; ********************************************************
; ** Sven Brandt                                        **
; ********************************************************
; Copyright (C) 2006/07 Sven Brandt

; ********************************************************
; History:
; ********************************************************

R_COUNT_01            equ  40h          ; Table counter
R_COUNT_02            equ  41h          ; Table counter
R_COUNT_03            equ  42h          ; Table counter
R_COUNT_04            equ  43h          ; Table counter
R_KURVE_NUMBER_01     equ  44h          ; Kurven-Parameter Anzahl Kurvenpunkte
R_KURVE_NUMBER_02     equ  45h          ; Kurven-Parameter Anzahl Kurvenpunkte
R_KURVE_NUMBER_03     equ  46h          ; Kurven-Parameter Anzahl Kurvenpunkte
R_KURVE_NUMBER_04     equ  47h          ; Kurven-Parameter Anzahl Kurvenpunkte
R_COUNT_STRETCH_01    equ  48h          ; Counter for Stretching
R_COUNT_STRETCH_02    equ  49h          ; Counter for Stretching
R_COUNT_STRETCH_03    equ  4ah          ; Counter for Stretching
R_COUNT_STRETCH_04    equ  4bh          ; Counter for Stretching
R_KURVE_STRETCH_01    equ  4ch          ; Kurven-Parameter Anzahl der Impulse der selben Lnge (1..255)
R_KURVE_STRETCH_02    equ  4dh          ; Kurven-Parameter Anzahl der Impulse der selben Lnge (1..255)
R_KURVE_STRETCH_03    equ  4eh          ; Kurven-Parameter Anzahl der Impulse der selben Lnge (1..255)
R_KURVE_STRETCH_04    equ  4fh          ; Kurven-Parameter Anzahl der Impulse der selben Lnge (1..255)

R_OUTVALUE            equ  50h          ; Output ON/OFF Value from table

R_KURVE_FLAGS_01      equ  5ch          ; Kurven-Parameter Flags
    #define A01_KURVE_FLAG_LOOP        R_KURVE_FLAGS_01,0  ; Loop Kurve
    #define A01_USE_OUT1               R_KURVE_FLAGS_01,4  ; use Out 1
    #define A01_USE_OUT2               R_KURVE_FLAGS_01,5  ; use Out 2
    #define A01_USE_OUT3               R_KURVE_FLAGS_01,6  ; use Out 3
    #define A01_USE_OUT4               R_KURVE_FLAGS_01,7  ; use Out 4
R_KURVE_FLAGS_02      equ  5dh          ; Kurven-Parameter Flags
    #define A02_KURVE_FLAG_LOOP        R_KURVE_FLAGS_02,0  ; Loop Kurve
    #define A02_USE_OUT1               R_KURVE_FLAGS_02,4  ; use Out 1
    #define A02_USE_OUT2               R_KURVE_FLAGS_02,5  ; use Out 2
    #define A02_USE_OUT3               R_KURVE_FLAGS_02,6  ; use Out 3
    #define A02_USE_OUT4               R_KURVE_FLAGS_02,7  ; use Out 4
R_KURVE_FLAGS_03      equ  5eh          ; Kurven-Parameter Flags
    #define A03_KURVE_FLAG_LOOP        R_KURVE_FLAGS_03,0  ; Loop Kurve
    #define A03_USE_OUT1               R_KURVE_FLAGS_03,4  ; use Out 1
    #define A03_USE_OUT2               R_KURVE_FLAGS_03,5  ; use Out 2
    #define A03_USE_OUT3               R_KURVE_FLAGS_03,6  ; use Out 3
    #define A03_USE_OUT4               R_KURVE_FLAGS_03,7  ; use Out 4
R_KURVE_FLAGS_04      equ  5fh          ; Kurven-Parameter Flags
    #define A04_KURVE_FLAG_LOOP        R_KURVE_FLAGS_04,0  ; Loop Kurve
    #define A04_USE_OUT1               R_KURVE_FLAGS_04,4  ; use Out 1
    #define A04_USE_OUT2               R_KURVE_FLAGS_04,5  ; use Out 2
    #define A04_USE_OUT3               R_KURVE_FLAGS_04,6  ; use Out 3
    #define A04_USE_OUT4               R_KURVE_FLAGS_04,7  ; use Out 4

;   --------------------------------------------------------------------------
;   --- EEprom Locations
;   --------------------------------------------------------------------------
#define EE_ADR_S1    h'10'           ; EEprom Adresse: R_STATUS_1: Status #1

;   --------------------------------------------------------------------------
;   --- Port Definition
;   --------------------------------------------------------------------------
#define OUTPUT1     PORTA,1        ;WeichZwei-Dekoder Layout Definition
#define OUTPUT2     PORTA,0        ;WeichZwei-Dekoder Layout Definition
#define OUTPUT3     PORTA,5        ;WeichZwei-Dekoder Layout Definition
#define OUTPUT4     PORTA,4        ;WeichZwei-Dekoder Layout Definition

; ********************
; *** INIT-Dekoder ***
; ********************
init_dekoder
;   -------------------------------------
;   --- read R_STATUS from EEPROM $10 ---
;   -------------------------------------
        bsf STATUS,RP0                 ; -> BANK 1
        movlw EE_ADR_S1
        movwf EEADR                    ; Adress to read
        bsf EECON1,RD                  ; initiate reading
        movf EEDATA,W                  ; EEDATA into W
        bcf STATUS,RP0                 ; -> BANK 0
        movwf R_STATUS                 ; ..into R_STATUS

        return

; ********************
; *** ADR Gruen-#1 ***
; ********************
gruen_1
        bsf R_STATUS,0                 ; STATUS Bit#0 on

        call KURVE_PARA_1_FLAGS
         movwf R_KURVE_FLAGS_01
         
        call KURVE_PARA_1_NUMBER
         movwf R_KURVE_NUMBER_01

        call KURVE_PARA_1_STRETCH
         movwf R_KURVE_STRETCH_01

        movlw d'1' 
        movwf R_COUNT_STRETCH_01        ; .. Counter laden, damit erst einmal Tab-Werte geladen werden
        movlw h'ff' 
        movwf R_COUNT_01                ; .. Counter laden, damit erst einmal Tab-Werte geladen werden
        
        return

; ********************
; *** ADR Gruen-#2 ***
; ********************
gruen_2
        bsf R_STATUS,1                 ; STATUS Bit#1 on

        call KURVE_PARA_2_FLAGS
         movwf R_KURVE_FLAGS_02
         
        call KURVE_PARA_2_NUMBER
         movwf R_KURVE_NUMBER_02

        call KURVE_PARA_2_STRETCH
         movwf R_KURVE_STRETCH_02

        movlw d'1' 
        movwf R_COUNT_STRETCH_02        ; .. Counter laden, damit erst einmal Tab-Werte geladen werden
        movlw h'ff' 
        movwf R_COUNT_02                ; .. Counter laden, damit erst einmal Tab-Werte geladen werden

        return
 

; ********************
; *** ADR Gruen-#3 ***
; ********************
gruen_3
        bsf R_STATUS,2                 ; STATUS Bit#2 on

        call KURVE_PARA_3_FLAGS
         movwf R_KURVE_FLAGS_03
         
        call KURVE_PARA_3_NUMBER
         movwf R_KURVE_NUMBER_03

        call KURVE_PARA_3_STRETCH
         movwf R_KURVE_STRETCH_03

        movlw d'1' 
        movwf R_COUNT_STRETCH_03        ; .. Counter laden, damit erst einmal Tab-Werte geladen werden
        movlw h'ff' 
        movwf R_COUNT_03                ; .. Counter laden, damit erst einmal Tab-Werte geladen werden
        
        return


; ********************
; *** ADR Gruen-#4 ***
; ********************
gruen_4
        bsf R_STATUS,3                 ; STATUS Bit#3 on

        call KURVE_PARA_4_FLAGS
         movwf R_KURVE_FLAGS_04
         
        call KURVE_PARA_4_NUMBER
         movwf R_KURVE_NUMBER_04

        call KURVE_PARA_4_STRETCH
         movwf R_KURVE_STRETCH_04

        movlw d'1' 
        movwf R_COUNT_STRETCH_04        ; .. Counter laden, damit erst einmal Tab-Werte geladen werden
        movlw h'ff' 
        movwf R_COUNT_04                ; .. Counter laden, damit erst einmal Tab-Werte geladen werden
        
        return

; ******************
; *** ADR Rot-#1 ***
; ******************
rot_1
        ; Aktive Ausgnge dieser Adresse AUS
        btfsc A01_USE_OUT1
         bcf OUTPUT1
        btfsc A01_USE_OUT2
         bcf OUTPUT2
        btfsc A01_USE_OUT3
         bcf OUTPUT3
        btfsc A01_USE_OUT4
         bcf OUTPUT4
        return

; ******************
; *** ADR Rot-#2 ***
; ******************
rot_2
        ; Aktive Ausgnge dieser Adresse AUS
        btfsc A02_USE_OUT1
         bcf OUTPUT1
        btfsc A02_USE_OUT2
         bcf OUTPUT2
        btfsc A02_USE_OUT3
         bcf OUTPUT3
        btfsc A02_USE_OUT4
         bcf OUTPUT4
        return

; ******************
; *** ADR Rot-#3 ***
; ******************
rot_3
        ; Aktive Ausgnge dieser Adresse AUS
        btfsc A03_USE_OUT1
         bcf OUTPUT1
        btfsc A03_USE_OUT2
         bcf OUTPUT2
        btfsc A03_USE_OUT3
         bcf OUTPUT3
        btfsc A03_USE_OUT4
         bcf OUTPUT4
        return

; ******************
; *** ADR Rot-#4 ***
; ******************
rot_4
        ; Aktive Ausgnge dieser Adresse AUS
        btfsc A04_USE_OUT1
         bcf OUTPUT1
        btfsc A04_USE_OUT2
         bcf OUTPUT2
        btfsc A04_USE_OUT3
         bcf OUTPUT3
        btfsc A04_USE_OUT4
         bcf OUTPUT4
        return

;*********************************
;** Routine: save               **
;** Signalisierung mit jew.     **
;** Ausgang                     **
;*********************************
; ********************
; *** Adresse #1   ***
; ********************
save_01
         comf R_TGLA,W
         andlw b'00000011'
         movwf PORTA
         movwf R_TGLA
        return

; ********************
; *** Adresse #2   ***
; ********************
save_02
         comf R_TGLA,W
         andlw b'00110000'
         movwf PORTA
         movwf R_TGLA
        return

; ************************
; *** save_toggle_start **
; ************************
; fr Dekoder, die im SAVE-Modus mit 2 Ausgngen alternierend togglen,
; muss hier ein Ausgang fr Adresse #1 eingeschaltet werden.
save_toggle_start
        return

;*******************************************
;** Routine: status_to_output             **
;** beim Start und nach dem Speichern     **
;** Ausgnge schalten gemss R_STATUS     **
;*******************************************
status_to_output
#ifndef skip_g1
        btfsc R_STATUS,0
         call gruen_1
        btfss A01_KURVE_FLAG_LOOP  ; Nur wieder einsteigen, wenn als LOOP definiert
         bcf R_STATUS,0            ; .. sonst R_STATUS Bit lschen
#endif

#ifndef skip_g3
        btfsc R_STATUS,1
         call gruen_2
        btfss A02_KURVE_FLAG_LOOP  ; Nur wieder einsteigen, wenn als LOOP definiert
         bcf R_STATUS,1            ; .. sonst R_STATUS Bit lschen
#endif

#ifndef skip_g3
        btfsc R_STATUS,2
         call gruen_3
        btfss A03_KURVE_FLAG_LOOP  ; Nur wieder einsteigen, wenn als LOOP definiert
         bcf R_STATUS,2            ; .. sonst R_STATUS Bit lschen
#endif

#ifndef skip_g4
        btfsc R_STATUS,3
         call gruen_4
        btfss A04_KURVE_FLAG_LOOP  ; Nur wieder einsteigen, wenn als LOOP definiert
         bcf R_STATUS,3            ; .. sonst R_STATUS Bit lschen
#endif

        return

;*********************************
;*********************************
;*********************************
;*********************************
;** Routine: change_status      **
;** change R_STATUS on switch   **
;*********************************
;*********************************
;*********************************
;*********************************
#ifdef nodecoder
; Bettigung des Tasters wirkt wie ein Weichen-Befehl
change_status_on
        btfsc R_STATUS,0               ; nur, wenn STATUS Bit#0 nich nicht ON ist
         return
        bsf R_STATUS,0                 ; STATUS Bit#0 on
        call gruen_1

        bsf R_SAVE_F,0                 ; set Flag for save
        return

change_status_off
        bcf R_STATUS,0                 ; STATUS Bit#1 on
        call rot_1 
        bcf R_STATUS,1                 ; STATUS Bit#1 on
        call rot_2 
        bcf R_STATUS,2                 ; STATUS Bit#1 on
        call rot_3 
        bcf R_STATUS,3                 ; STATUS Bit#1 on
        call rot_4 

        bsf R_SAVE_F,0                 ; set Flag for save
        return
#endif
