; ********************************************************
; ** Version: V3.17 vom 24/07/2008                      **
; ********************************************************
; ** Include-File zu dekoder.asm                        **
; ********************************************************
; ** Sven Brandt                                        **
; ********************************************************
; Copyright (C) 2009-2014 Sven Brandt

; History:
; V3.61 - 04.05.2014 Warteschleife nach LOOP Durchgang fr Kurve 1 ermglicht, Wert aus Zeile 105 (KurvenParameter)
; V3.61 - 04.05.2014 in NODECODER: Korrektur zu 'change_status_on' und 'change_status_off'
; V3.60 - 11.03.2014 in NODECODER: Korrektur zu 'change_status_on' und 'change_status_off'
; V3.60 - 06.03.2014 2. Verzgerung (R_KURVE_STRETCH_0xa / R_COUNT_STRETCH_0xa) hinzu

R_COUNT_01            equ  40h          ; Table counter
R_COUNT_02            equ  41h          ; Table counter
R_COUNT_03            equ  42h          ; Table counter
R_COUNT_04            equ  43h          ; Table counter
R_KURVE_NUMBER_01     equ  44h          ; Kurven-Parameter Anzahl Kurvenpunkte
R_KURVE_NUMBER_02     equ  45h          ; Kurven-Parameter Anzahl Kurvenpunkte
R_KURVE_NUMBER_03     equ  46h          ; Kurven-Parameter Anzahl Kurvenpunkte
R_KURVE_NUMBER_04     equ  47h          ; Kurven-Parameter Anzahl Kurvenpunkte
R_COUNT_STRETCH_01    equ  48h          ; Counter for Stretching
R_COUNT_STRETCH_02    equ  49h          ; Counter for Stretching
R_COUNT_STRETCH_03    equ  4ah          ; Counter for Stretching
R_COUNT_STRETCH_04    equ  4bh          ; Counter for Stretching
R_KURVE_STRETCH_01    equ  4ch          ; Kurven-Parameter Anzahl der Impulse der selben Lnge (1..255)
R_KURVE_STRETCH_02    equ  4dh          ; Kurven-Parameter Anzahl der Impulse der selben Lnge (1..255)
R_KURVE_STRETCH_03    equ  4eh          ; Kurven-Parameter Anzahl der Impulse der selben Lnge (1..255)
R_KURVE_STRETCH_04    equ  4fh          ; Kurven-Parameter Anzahl der Impulse der selben Lnge (1..255)
R_KURVE_STRETCH_01a   equ  50h          ; Kurven-Parameter Anzahl der Impulse der selben Lnge (1..255)
R_KURVE_STRETCH_02a   equ  51h          ; Kurven-Parameter Anzahl der Impulse der selben Lnge (1..255)
R_KURVE_STRETCH_03a   equ  52h          ; Kurven-Parameter Anzahl der Impulse der selben Lnge (1..255)
R_KURVE_STRETCH_04a   equ  53h          ; Kurven-Parameter Anzahl der Impulse der selben Lnge (1..255)
R_COUNT_STRETCH_01a   equ  54h          ; Counter for Stretching
R_COUNT_STRETCH_02a   equ  55h          ; Counter for Stretching
R_COUNT_STRETCH_03a   equ  56h          ; Counter for Stretching
R_COUNT_STRETCH_04a   equ  57h          ; Counter for Stretching

R_KURVE_WAIT_01       equ  58h          ; neu V3.61: Kurven-Parameter WARTEN nach Loop Durchlauf
R_COUNT_WAIT_01       equ  58h          ; neu V3.61: counter fr WARTEN nach Loop Durchlauf

R_OUTVALUE            equ  5ah          ; Output ON/OFF Value from table
                                        ; #4  ; Out 1  ON (1) oder OUT (0)
                                        ; #5  ; Out 2  ON (1) oder OUT (0)
                                        ; #6  ; Out 3  ON (1) oder OUT (0)
                                        ; #7  ; Out 4  ON (1) oder OUT (0)

R_OUTVALUE2           equ  5bh          ; Output ON/OFF Value from table
                                        ; #0  ; Out 5  ON (1) oder OUT (0)
                                        ; #1  ; Out 6  ON (1) oder OUT (0)
                                        ; #2  ; Out 7  ON (1) oder OUT (0)
                                        ; #3  ; Out 8  ON (1) oder OUT (0)
                                        ; #4  ; Out 9  ON (1) oder OUT (0)
                                        ; #5  ; Out 10 ON (1) oder OUT (0)

R_TABLEREAD           equ  5ch          ; request this line for Table-Read

R_KURVE_FLAGS1_01     equ  60h          ; Kurven-Parameter Flags
    #define A01_KURVE_FLAG_LOOP        R_KURVE_FLAGS1_01,0  ; Loop Kurve
    #define A01_USE_OUT1               R_KURVE_FLAGS1_01,4  ; use Out 1
    #define A01_USE_OUT2               R_KURVE_FLAGS1_01,5  ; use Out 2
    #define A01_USE_OUT3               R_KURVE_FLAGS1_01,6  ; use Out 3
    #define A01_USE_OUT4               R_KURVE_FLAGS1_01,7  ; use Out 4
R_KURVE_FLAGS2_01     equ  61h          ; Kurven-Parameter Flags
    #define A01_USE_OUT5               R_KURVE_FLAGS2_01,0  ; use Out 5
    #define A01_USE_OUT6               R_KURVE_FLAGS2_01,1  ; use Out 6
    #define A01_USE_OUT7               R_KURVE_FLAGS2_01,2  ; use Out 7
    #define A01_USE_OUT8               R_KURVE_FLAGS2_01,3  ; use Out 8
    #define A01_USE_OUT9               R_KURVE_FLAGS2_01,4  ; use Out 9
    #define A01_USE_OUT10              R_KURVE_FLAGS2_01,5  ; use Out 10

R_KURVE_FLAGS1_02     equ  62h          ; Kurven-Parameter Flags
    #define A02_KURVE_FLAG_LOOP        R_KURVE_FLAGS1_02,0  ; Loop Kurve
    #define A02_USE_OUT1               R_KURVE_FLAGS1_02,4  ; use Out 1
    #define A02_USE_OUT2               R_KURVE_FLAGS1_02,5  ; use Out 2
    #define A02_USE_OUT3               R_KURVE_FLAGS1_02,6  ; use Out 3
    #define A02_USE_OUT4               R_KURVE_FLAGS1_02,7  ; use Out 4
R_KURVE_FLAGS2_02     equ  63h          ; Kurven-Parameter Flags
    #define A02_USE_OUT5               R_KURVE_FLAGS2_02,0  ; use Out 5
    #define A02_USE_OUT6               R_KURVE_FLAGS2_02,1  ; use Out 6
    #define A02_USE_OUT7               R_KURVE_FLAGS2_02,2  ; use Out 7
    #define A02_USE_OUT8               R_KURVE_FLAGS2_02,3  ; use Out 8
    #define A02_USE_OUT9               R_KURVE_FLAGS2_02,4  ; use Out 9
    #define A02_USE_OUT10              R_KURVE_FLAGS2_02,5  ; use Out 10

R_KURVE_FLAGS1_03     equ  64h          ; Kurven-Parameter Flags
    #define A03_KURVE_FLAG_LOOP        R_KURVE_FLAGS1_03,0  ; Loop Kurve
    #define A03_USE_OUT1               R_KURVE_FLAGS1_03,4  ; use Out 1
    #define A03_USE_OUT2               R_KURVE_FLAGS1_03,5  ; use Out 2
    #define A03_USE_OUT3               R_KURVE_FLAGS1_03,6  ; use Out 3
    #define A03_USE_OUT4               R_KURVE_FLAGS1_03,7  ; use Out 4
R_KURVE_FLAGS2_03     equ  65h          ; Kurven-Parameter Flags
    #define A03_USE_OUT5               R_KURVE_FLAGS2_03,0  ; use Out 5
    #define A03_USE_OUT6               R_KURVE_FLAGS2_03,1  ; use Out 6
    #define A03_USE_OUT7               R_KURVE_FLAGS2_03,2  ; use Out 7
    #define A03_USE_OUT8               R_KURVE_FLAGS2_03,3  ; use Out 8
    #define A03_USE_OUT9               R_KURVE_FLAGS2_03,4  ; use Out 9
    #define A03_USE_OUT10              R_KURVE_FLAGS2_03,5  ; use Out 10

R_KURVE_FLAGS1_04     equ  66h          ; Kurven-Parameter Flags
    #define A04_KURVE_FLAG_LOOP        R_KURVE_FLAGS1_04,0  ; Loop Kurve
    #define A04_USE_OUT1               R_KURVE_FLAGS1_04,4  ; use Out 1
    #define A04_USE_OUT2               R_KURVE_FLAGS1_04,5  ; use Out 2
    #define A04_USE_OUT3               R_KURVE_FLAGS1_04,6  ; use Out 3
    #define A04_USE_OUT4               R_KURVE_FLAGS1_04,7  ; use Out 4
R_KURVE_FLAGS2_04     equ  67h          ; Kurven-Parameter Flags
    #define A04_USE_OUT5               R_KURVE_FLAGS2_04,0  ; use Out 5
    #define A04_USE_OUT6               R_KURVE_FLAGS2_04,1  ; use Out 6
    #define A04_USE_OUT7               R_KURVE_FLAGS2_04,2  ; use Out 7
    #define A04_USE_OUT8               R_KURVE_FLAGS2_04,3  ; use Out 8
    #define A04_USE_OUT9               R_KURVE_FLAGS2_04,4  ; use Out 9
    #define A04_USE_OUT10              R_KURVE_FLAGS2_04,5  ; use Out 10

R_KURVE_FLAGS1_xx     equ  68h         ; transfer Register Flags 1
    #define Axx_USE_OUT1               R_KURVE_FLAGS1_xx,4  ; use Out 1
    #define Axx_USE_OUT2               R_KURVE_FLAGS1_xx,5  ; use Out 2
    #define Axx_USE_OUT3               R_KURVE_FLAGS1_xx,6  ; use Out 3
    #define Axx_USE_OUT4               R_KURVE_FLAGS1_xx,7  ; use Out 4
R_KURVE_FLAGS2_xx     equ  69h         ; transfer Register Flags 6
    #define Axx_USE_OUT5               R_KURVE_FLAGS2_xx,0  ; use Out 5
    #define Axx_USE_OUT6               R_KURVE_FLAGS2_xx,1  ; use Out 6
    #define Axx_USE_OUT7               R_KURVE_FLAGS2_xx,2  ; use Out 7
    #define Axx_USE_OUT8               R_KURVE_FLAGS2_xx,3  ; use Out 8
    #define Axx_USE_OUT9               R_KURVE_FLAGS2_xx,4  ; use Out 9
    #define Axx_USE_OUT10              R_KURVE_FLAGS2_xx,5  ; use Out 10

#define LED_01     PORTA,4        ;LED-Dekoder Layout Definition
#define LED_02     PORTA,5        ;LED-Dekoder Layout Definition
#define LED_03     PORTA,0        ;LED-Dekoder Layout Definition
#define LED_04     PORTA,1        ;LED-Dekoder Layout Definition
#define LED_05     PORTC,1        ;LED-Dekoder Layout Definition
#define LED_06     PORTC,2        ;LED-Dekoder Layout Definition
#define LED_07     PORTC,0        ;LED-Dekoder Layout Definition
#define LED_08     PORTC,5        ;LED-Dekoder Layout Definition
#define LED_09     PORTC,4        ;LED-Dekoder Layout Definition
#define LED_10     PORTC,3        ;LED-Dekoder Layout Definition

#define hexline_curve_Flags1     d'100'
#define hexline_curveNumber      d'101'
#define hexline_curveStretch     d'102'
#define hexline_curve_Flags2     d'103'
#define hexline_curveStretch2    d'104'
#define hexline_curveWait        d'105'

;   --------------------------------------------------------------------------
;   --- EEprom Locations
;   --------------------------------------------------------------------------
#define EE_ADR_S1    h'10'           ; EEprom Adresse: R_STATUS_1: Status #1

; ********************
; *** INIT-Dekoder ***
; ********************
init_dekoder
;   -------------------------------------
;   --- read R_STATUS from EEPROM $10 ---
;   -------------------------------------
        bsf STATUS,RP0                 ; -> BANK 1
        movlw EE_ADR_S1
        movwf EEADR                    ; Adress to read
        bsf EECON1,RD                  ; initiate reading
        movf EEDATA,W                  ; EEDATA into W
        bcf STATUS,RP0                 ; -> BANK 0
        movwf R_STATUS                 ; ..into R_STATUS

        return

; ********************
; *** ADR Gruen-#1 ***
; ********************
gruen_1
        bsf R_STATUS,0                 ; STATUS Bit#0 on

        movlw hexline_curve_Flags1     ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ1
        movwf R_KURVE_FLAGS1_01

        movlw hexline_curve_Flags2     ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ1
        movwf R_KURVE_FLAGS2_01

        movlw hexline_curveNumber      ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ1
        movwf R_KURVE_NUMBER_01

        movlw hexline_curveStretch     ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ1
        movwf R_KURVE_STRETCH_01

        movlw hexline_curveStretch2    ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ1
        movwf R_KURVE_STRETCH_01a

        movlw hexline_curveWait        ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ1
        movwf R_KURVE_WAIT_01

        movlw d'1' 
        movwf R_COUNT_STRETCH_01        ; .. Counter laden, damit erst einmal Tab-Werte geladen werden
        movwf R_COUNT_STRETCH_01a       ; .. Counter laden, damit erst einmal Tab-Werte geladen werden
        movlw h'ff' 
        movwf R_COUNT_01                ; .. Counter laden, damit erst einmal Tab-Werte geladen werden
        
        return

; ********************
; *** ADR Gruen-#2 ***
; ********************
gruen_2
        bsf R_STATUS,1                 ; STATUS Bit#1 on

        movlw hexline_curve_Flags1     ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ3
        movwf R_KURVE_FLAGS1_02

        movlw hexline_curve_Flags2     ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ3
        movwf R_KURVE_FLAGS2_02

        movlw hexline_curveNumber      ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ3
        movwf R_KURVE_NUMBER_02

        movlw hexline_curveStretch     ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ3
        movwf R_KURVE_STRETCH_02

        movlw hexline_curveStretch2    ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ3
        movwf R_KURVE_STRETCH_02a

        movlw d'1' 
        movwf R_COUNT_STRETCH_02        ; .. Counter laden, damit erst einmal Tab-Werte geladen werden
        movwf R_COUNT_STRETCH_02a       ; .. Counter laden, damit erst einmal Tab-Werte geladen werden
        movlw h'ff' 
        movwf R_COUNT_02                ; .. Counter laden, damit erst einmal Tab-Werte geladen werden

        return
 

; ********************
; *** ADR Gruen-#3 ***
; ********************
gruen_3
        bsf R_STATUS,2                 ; STATUS Bit#2 on

        movlw hexline_curve_Flags1     ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ5
        movwf R_KURVE_FLAGS1_03

        movlw hexline_curve_Flags2     ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ5
        movwf R_KURVE_FLAGS2_03

        movlw hexline_curveNumber      ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ5
        movwf R_KURVE_NUMBER_03

        movlw hexline_curveStretch     ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ5
        movwf R_KURVE_STRETCH_03

        movlw hexline_curveStretch2    ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ5
        movwf R_KURVE_STRETCH_03a

        movlw d'1' 
        movwf R_COUNT_STRETCH_03        ; .. Counter laden, damit erst einmal Tab-Werte geladen werden
        movwf R_COUNT_STRETCH_03a       ; .. Counter laden, damit erst einmal Tab-Werte geladen werden
        movlw h'ff' 
        movwf R_COUNT_03                ; .. Counter laden, damit erst einmal Tab-Werte geladen werden
        
        return


; ********************
; *** ADR Gruen-#4 ***
; ********************
gruen_4
        bsf R_STATUS,3                 ; STATUS Bit#3 on

        movlw hexline_curve_Flags1     ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ7
        movwf R_KURVE_FLAGS1_04

        movlw hexline_curve_Flags2     ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ7
        movwf R_KURVE_FLAGS2_04

        movlw hexline_curveNumber      ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ7
        movwf R_KURVE_NUMBER_04

        movlw hexline_curveStretch     ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ7
        movwf R_KURVE_STRETCH_04

        movlw hexline_curveStretch2    ; access this line
        movwf R_TABLEREAD              ; .. in the table
        call TABLE_READ7
        movwf R_KURVE_STRETCH_04a

        movlw d'1' 
        movwf R_COUNT_STRETCH_04        ; .. Counter laden, damit erst einmal Tab-Werte geladen werden
        movwf R_COUNT_STRETCH_04a       ; .. Counter laden, damit erst einmal Tab-Werte geladen werden
        movlw h'ff' 
        movwf R_COUNT_04                ; .. Counter laden, damit erst einmal Tab-Werte geladen werden
        
        return

; ******************
; *** ADR Rot-#1 ***
; ******************
rot_1
        ; Aktive Ausgnge dieser Adresse AUS
        btfsc A01_USE_OUT1
         bcf LED_01 
        btfsc A01_USE_OUT2
         bcf LED_02
        btfsc A01_USE_OUT3
         bcf LED_03
        btfsc A01_USE_OUT4
         bcf LED_04
        btfsc A01_USE_OUT5
         bcf LED_05 
        btfsc A01_USE_OUT6
         bcf LED_06
        btfsc A01_USE_OUT7
         bcf LED_07
        btfsc A01_USE_OUT8
         bcf LED_08
        btfsc A01_USE_OUT9
         bcf LED_09 
        btfsc A01_USE_OUT10
         bcf LED_10
        return

; ******************
; *** ADR Rot-#2 ***
; ******************
rot_2
        ; Aktive Ausgnge dieser Adresse AUS
        btfsc A02_USE_OUT1
         bcf LED_01 
        btfsc A02_USE_OUT2
         bcf LED_02
        btfsc A02_USE_OUT3
         bcf LED_03
        btfsc A02_USE_OUT4
         bcf LED_04
        btfsc A02_USE_OUT5
         bcf LED_05 
        btfsc A02_USE_OUT6
         bcf LED_06
        btfsc A02_USE_OUT7
         bcf LED_07
        btfsc A02_USE_OUT8
         bcf LED_08
        btfsc A02_USE_OUT9
         bcf LED_09 
        btfsc A02_USE_OUT10
         bcf LED_10
        return

; ******************
; *** ADR Rot-#3 ***
; ******************
rot_3
        ; Aktive Ausgnge dieser Adresse AUS
        btfsc A03_USE_OUT1
         bcf LED_01 
        btfsc A03_USE_OUT2
         bcf LED_02
        btfsc A03_USE_OUT3
         bcf LED_03
        btfsc A03_USE_OUT4
         bcf LED_04
        btfsc A03_USE_OUT5
         bcf LED_05 
        btfsc A03_USE_OUT6
         bcf LED_06
        btfsc A03_USE_OUT7
         bcf LED_07
        btfsc A03_USE_OUT8
         bcf LED_08
        btfsc A03_USE_OUT9
         bcf LED_09 
        btfsc A03_USE_OUT10
         bcf LED_10
        return

; ******************
; *** ADR Rot-#4 ***
; ******************
rot_4
        ; Aktive Ausgnge dieser Adresse AUS
        btfsc A04_USE_OUT1
         bcf LED_01 
        btfsc A04_USE_OUT2
         bcf LED_02
        btfsc A04_USE_OUT3
         bcf LED_03
        btfsc A04_USE_OUT4
         bcf LED_04
        btfsc A04_USE_OUT5
         bcf LED_05 
        btfsc A04_USE_OUT6
         bcf LED_06
        btfsc A04_USE_OUT7
         bcf LED_07
        btfsc A04_USE_OUT8
         bcf LED_08
        btfsc A04_USE_OUT9
         bcf LED_09 
        btfsc A04_USE_OUT10
         bcf LED_10
        return

; ************************
; *** save_toggle_start **
; ************************
save_toggle_start
        movlw b'00010001'
        movwf PORTA
        movwf R_TGLA
        movlw b'00010011'
        movwf PORTC
        movwf R_TGLC
        return

; ************************
; *** save_toggle_next ***
; ************************
save_toggle_next
        clrf R_TGLA
        clrf R_TGLC
        return

;*******************************************
;** Routine: status_to_output             **
;** beim Start und nach dem Speichern     **
;** Ausgnge schalten gemss R_STATUS     **
;*******************************************
status_to_output
#ifndef skip_g1
        btfsc R_STATUS,0
         call gruen_1
        btfss A01_KURVE_FLAG_LOOP  ; Nur wieder einsteigen, wenn als LOOP definiert
         bcf R_STATUS,0            ; .. sonst R_STATUS Bit lschen
#endif

#ifndef skip_g3
        btfsc R_STATUS,1
         call gruen_2
        btfss A02_KURVE_FLAG_LOOP  ; Nur wieder einsteigen, wenn als LOOP definiert
         bcf R_STATUS,1            ; .. sonst R_STATUS Bit lschen
#endif

#ifndef skip_g3
        btfsc R_STATUS,2
         call gruen_3
        btfss A03_KURVE_FLAG_LOOP  ; Nur wieder einsteigen, wenn als LOOP definiert
         bcf R_STATUS,2            ; .. sonst R_STATUS Bit lschen
#endif

#ifndef skip_g4
        btfsc R_STATUS,3
         call gruen_4
        btfss A04_KURVE_FLAG_LOOP  ; Nur wieder einsteigen, wenn als LOOP definiert
         bcf R_STATUS,3            ; .. sonst R_STATUS Bit lschen
#endif

        return

;*********************************
;*********************************
;*********************************
;*********************************
;** Routine: change_status      **
;** change R_STATUS on switch   **
;*********************************
;*********************************
;*********************************
;*********************************
#ifdef nodecoder
; Bettigung des Tasters wirkt wie ein Weichen-Befehl
change_status_off ; = Taste release
        bcf R_STATUS,0                 ; STATUS Bit#1 on
        call rot_1 
        bcf R_STATUS,1                 ; STATUS Bit#1 on
        call rot_2 
        bcf R_STATUS,2                 ; STATUS Bit#1 on
        call rot_3 
        bcf R_STATUS,3                 ; STATUS Bit#1 on
        call rot_4 

        bsf R_SAVE_F,0                 ; set Flag for save
        return

change_status_on; = Taste PUSH
        btfsc R_STATUS,0               ; nur, wenn STATUS Bit#0 noch nicht ON ist
         return
        bsf R_STATUS,0                 ; STATUS Bit#0 on
        call gruen_1

        bsf R_SAVE_F,0                 ; set Flag for save
        return
#endif
