; ********************************************************
; ** Version: V3.48 vom 23/01/2011                      **
; ********************************************************
; ** Include-File zu dekoder.asm                        **
; ********************************************************
; ** Sven Brandt                                        **
; ********************************************************
; Copyright (C) 2006-2011 Sven Brandt

; ********************************************************
; History:
; ********************************************************
; V3.48 - LED_feuer: in NODECODER Starten und Stoppen per Taster, fr DCC/MM durch skip_g2 ff. Platzbedarf reduziert
; ********************************************************

  ; ****************************
  ; ** nur fuer led_feuer     **
  ; ****************************
R_TEMP        equ  40h          ;
R_CNT1        equ  4ah          ; Verzgerungs-Counter
R_CNT2        equ  4bh          ; Verzgerungs-Counter
R_CNT3        equ  4ch          ; Verzgerungs-Counter
R_CNT4        equ  4dh          ; Verzgerungs-Counter
R_CNT5        equ  4eh          ; Verzgerungs-Counter
R_CNT6        equ  4fh          ; Verzgerungs-Counter
R_CNT7        equ  50h          ; Verzgerungs-Counter
R_CNT8        equ  51h          ; Verzgerungs-Counter
R_CNT9        equ  52h          ; Verzgerungs-Counter
R_CNT10       equ  53h          ; Verzgerungs-Counter
R_SHUFFLE1    equ  54h          ; Zufalls-Wert
R_SHUFFLE2    equ  55h          ; Zufalls-Wert
R_SHUFFLE3    equ  56h          ; Zufalls-Wert
R_SHUFFLE4    equ  57h          ; Zufalls-Wert
R_SHUFFLE5    equ  58h          ; Zufalls-Wert
R_SHUFFLE6    equ  59h          ; Zufalls-Wert
R_SHUFFLE7    equ  5ah          ; Zufalls-Wert
R_SHUFFLE8    equ  5bh          ; Zufalls-Wert

R_ONOFF1      equ  5ch          ; Status ON/OF
R_ONOFF2      equ  5dh          ; Status ON/OF

R_SHUFFLE     equ  5eh          ;

;   --------------------------------------------------------------------------
;   --- EEprom Locations
;   --------------------------------------------------------------------------
#define EE_ADR_S1    h'10'           ; EEprom Adresse: R_STATUS_1: Status #1

; ********************
; *** INIT-Dekoder ***
; ********************
init_dekoder
;   -------------------------------------
;   --- read R_STATUS from EEPROM $10 ---
;   -------------------------------------
        bsf STATUS,RP0                 ; -> BANK 1
        movlw EE_ADR_S1
        movwf EEADR                    ; Adress to read
        bsf EECON1,RD                  ; initiate reading
        movf EEDATA,W                  ; EEDATA into W
        bcf STATUS,RP0                 ; -> BANK 0
        movwf R_STATUS                 ; ..into R_STATUS

;   --------------------------------------
;   --- preload bytes                  ---
;   --------------------------------------
        movlw d'255'
        movwf R_SHUFFLE1
        movlw d'2'
        movwf R_SHUFFLE2
        movlw d'12'
        movwf R_SHUFFLE3
        movlw d'186'
        movwf R_SHUFFLE4
        movlw d'55'
        movwf R_SHUFFLE5
        movlw d'218'
        movwf R_SHUFFLE6
        movlw d'111'
        movwf R_SHUFFLE7
        movlw d'184'
        movwf R_SHUFFLE8
        return

; ********************
; *** ADR Gruen-#1 ***
; ********************
gruen_1
        movlw b'00000001'
        movwf R_STATUS                 ; nur 1 STATUS-Flag setzten
        return


; ******************
; *** ADR Rot-#1 ***
; ******************
rot_1
        clrf PORTA
        clrf PORTC                     ; clear Ports
        return

;*********************************
;** Routine: save               **
;** Signalisierung mit jew.     **
;** Ausgang                     **
;*********************************
; ********************
; *** Adresse #1   ***
; ********************
save_01
        comf R_TGLA,W
        andlw b'00110011'
        movwf PORTA
        movwf R_TGLA
        comf R_TGLC,W
        andlw b'00111111'
        movwf PORTC
        movwf R_TGLC
        return

; ************************
; *** save_toggle_start **
; ************************
save_toggle_start
        movlw b'00010001'
        movwf PORTA
        movwf R_TGLA
        movlw b'00010011'
        movwf PORTC
        movwf R_TGLC
        return

; ************************
; *** save_toggle_next ***
; ************************
save_toggle_next
        clrf R_TGLA
        clrf R_TGLC
        return

;*******************************************
;** Routine: status_to_output             **
;** beim Start und nach dem Speichern     **
;** Ausgnge schalten gemss R_STATUS     **
;*******************************************
status_to_output
;   -----------------------------------------
;   --- Test auf gltiges R_STATUS        ---
;   -----------------------------------------
#ifdef nodecoder ; als NODECODER muss #0 gesetzt sein (RUN-Modus)
        clrf R_STATUS
        bsf R_STATUS,0
#endif ;zu #ifdef nodecoder
        return                         ; .. then OK -> jump

;*********************************
;*********************************
;*********************************
;*********************************
;** Routine: change_status      **
;** change R_STATUS on switch   **
;*********************************
;*********************************
;*********************************
;*********************************
#ifdef nodecoder
; Bettigung des Tasters wirkt wie ein Weichen-Befehl
change_status_on
        bsf R_STATUS,0                 ; STATUS Bit#0 on
        bsf R_SAVE_F,0                 ; set Flag for save
        call gruen_1
        return

change_status_off
        bcf R_STATUS,0                 ; STATUS Bit#1 on
        bsf R_SAVE_F,0                 ; set Flag for save
        call rot_1 
        return
#endif
