; ********************************************************
; ** Version: V3.13 vom 09/05/2008                      **
; ********************************************************
; ** Include-File zu dekoder.asm                        **
; ********************************************************
; ** Sven Brandt                                        **
; ********************************************************
; Copyright (C) 2006-2008 Sven Brandt

  ; ****************************
  ; ** nur fuer led_schalten  **
  ; ****************************
R_VERZ         equ  40h          ; Verzgerungs-Counter 1
R_MAKESLOW     equ  41h          ; Verzgerungs-Counter 1
R_STATUS_2     equ  42h          ; only for led_schalten needed (10 Adresses)
R1_ABSCHALT_1  equ  50h          ; fuer Mode3: Latch R_VERZ fuer Anschaltzeit 
R2_ABSCHALT_1  equ  51h          ; fuer Mode3: Latch TMR1H  fuer Anschaltzeit 
R1_ABSCHALT_2  equ  52h          ; fuer Mode3: Latch R_VERZ fuer Anschaltzeit 
R2_ABSCHALT_2  equ  53h          ; fuer Mode3: Latch TMR1H  fuer Anschaltzeit 
R1_ABSCHALT_3  equ  54h          ; fuer Mode3: Latch R_VERZ fuer Anschaltzeit 
R2_ABSCHALT_3  equ  55h          ; fuer Mode3: Latch TMR1H  fuer Anschaltzeit 
R1_ABSCHALT_4  equ  56h          ; fuer Mode3: Latch R_VERZ fuer Anschaltzeit 
R2_ABSCHALT_4  equ  57h          ; fuer Mode3: Latch TMR1H  fuer Anschaltzeit 
R1_ABSCHALT_5  equ  58h          ; fuer Mode3: Latch R_VERZ fuer Anschaltzeit 
R2_ABSCHALT_5  equ  59h          ; fuer Mode3: Latch TMR1H  fuer Anschaltzeit 
R1_ABSCHALT_6  equ  5ah          ; fuer Mode3: Latch R_VERZ fuer Anschaltzeit 
R2_ABSCHALT_6  equ  5bh          ; fuer Mode3: Latch TMR1H  fuer Anschaltzeit 
R1_ABSCHALT_7  equ  5ch          ; fuer Mode3: Latch R_VERZ fuer Anschaltzeit 
R2_ABSCHALT_7  equ  5dh          ; fuer Mode3: Latch TMR1H  fuer Anschaltzeit 
R1_ABSCHALT_8  equ  5eh          ; fuer Mode3: Latch R_VERZ fuer Anschaltzeit 
R2_ABSCHALT_8  equ  5fh          ; fuer Mode3: Latch TMR1H  fuer Anschaltzeit 
R1_ABSCHALT_9  equ  4ch          ; fuer Mode3: Latch R_VERZ fuer Anschaltzeit 
R2_ABSCHALT_9  equ  4dh          ; fuer Mode3: Latch TMR1H  fuer Anschaltzeit 
R1_ABSCHALT_10 equ  4eh          ; fuer Mode3: Latch R_VERZ fuer Anschaltzeit 
R2_ABSCHALT_10 equ  4fh          ; fuer Mode3: Latch TMR1H  fuer Anschaltzeit 

;   --------------------------------------------------------------------------
;   --- EEprom Locations
;   --------------------------------------------------------------------------
#define EE_ADR_MODE  h'00'           ; EEprom Adresse: R_MODE
#define EE_ADR_S1    h'10'           ; EEprom Adresse: R_STATUS_1: Status #1
#define EE_ADR_MS    h'20'           ; EEprom Adresse: R_MAKESLOW: Wert Time-Out
#define EE_ADR_S2    h'30'           ; EEprom Adresse: R_STATUS_2: Status #2

;   --------------------------------------------------------------------------
;   --- Port Definition
;   --------------------------------------------------------------------------
#define LED_01     PORTA,4        ;LED-Dekoder Layout Definition
#define LED_02     PORTA,5        ;LED-Dekoder Layout Definition
#define LED_03     PORTA,0        ;LED-Dekoder Layout Definition
#define LED_04     PORTA,1        ;LED-Dekoder Layout Definition
#define LED_05     PORTC,1        ;LED-Dekoder Layout Definition
#define LED_06     PORTC,2        ;LED-Dekoder Layout Definition
#define LED_07     PORTC,0        ;LED-Dekoder Layout Definition
#define LED_08     PORTC,5        ;LED-Dekoder Layout Definition
#define LED_09     PORTC,4        ;LED-Dekoder Layout Definition
#define LED_10     PORTC,3        ;LED-Dekoder Layout Definition

; ********************
; *** INIT-Dekoder ***
; ********************
init_dekoder
;   -----------------------------------
;   --- read R_MODE from EEPROM $00 ---
;   -----------------------------------
        bsf STATUS,RP0                 ; -> BANK 1
        movlw EE_ADR_MODE
        movwf EEADR                    ; Adress to read
        bsf EECON1,RD                  ; initiate reading
        movf EEDATA,W                  ; EEDATA into W
        bcf STATUS,RP0                 ; -> BANK 0
        movwf R_MODE                   ; ..into R_MODE

;   -------------------------------------
;   --- read R_STATUS from EEPROM $10 ---
;   -------------------------------------
        bsf STATUS,RP0                 ; -> BANK 1
        movlw EE_ADR_S1
        movwf EEADR                    ; Adress to read
        bsf EECON1,RD                  ; initiate reading
        movf EEDATA,W                  ; EEDATA into W
        bcf STATUS,RP0                 ; -> BANK 0
        btfsc R_MODE,0                 ; restoring of output -> skip if R_MODE#0 = FALSE
         movwf R_STATUS                ; ..into R_STATUS

;   --------------------------------------
;   --- read R_STATUS_2 from EEPROM $30 ---
;   --------------------------------------
        bsf STATUS,RP0                 ; -> BANK 1
        movlw EE_ADR_S2
        movwf EEADR                    ; Adress to read
        bsf EECON1,RD                  ; initiate reading
        movf EEDATA,W                  ; EEDATA into W
        bcf STATUS,RP0                 ; -> BANK 0
        btfsc R_MODE,0                 ; restoring of output -> skip if R_MODE#0 = FALSE
         movwf R_STATUS_2              ; ..into R_STATUS_2

;   ---------------------------------------
;   --- read R_MAKESLOW from EEPROM $20 ---
;   ---------------------------------------
        bsf STATUS,RP0                 ; -> BANK 1
        movlw EE_ADR_MS
        movwf EEADR                    ; Adress to read
        bsf EECON1,RD                  ; initiate reading
        movf EEDATA,W                  ; EEDATA into W
        bcf STATUS,RP0                 ; -> BANK 0
        movwf R_MAKESLOW               ; ..into R_MAKESLOW

        movlw d'01'                    ; Default-Wert, wenn R_MAKESLOW zu gross oder NULL ist
        btfsc R_MAKESLOW,7             ; .. d'01'
         movwf R_MAKESLOW              ; .. into R_MAKESLOW, wenn >127 (nur fr Weichen-Varianten)

        movf R_MAKESLOW,F              ; wenn R_MAKESLOW = 0, dann
        btfsc STATUS,Z                 ; .. d'01'
         movwf R_MAKESLOW              ; .. into R_MAKESLOW, wenn == 0

        return

; ********************
; *** ADR Gruen-#1 ***
; ********************
gruen_1
#ifndef test
        bsf LED_01
#endif ; test

        movf R_VERZ,W
        addwf R_MAKESLOW,W              ; latch vom (R_VERZ + R_MAKESLOW)
        movwf R1_ABSCHALT_1             ; .. in R1_ABSCHALT_x
        movf TMR1H,W                    ; latch vom TMR1H in R2_ABSCHALT_x
        movwf R2_ABSCHALT_1             ; abschalten @ [R_VERZ > (R1_ABSCHALT_x + R_MAKESLOW)] & (TMR1H > R2_ABSCHALT_x) 
        return

; ********************
; *** ADR Gruen-#2 ***
; ********************
gruen_2
#ifndef test
        bsf LED_02
#endif ; test
        movf R_VERZ,W
        addwf R_MAKESLOW,W              ; latch vom (R_VERZ + R_MAKESLOW)
        movwf R1_ABSCHALT_2             ; .. in R1_ABSCHALT_x
        movf TMR1H,W                    ; latch vom TMR1H in R2_ABSCHALT_x
        movwf R2_ABSCHALT_2             ; abschalten @ [R_VERZ > (R1_ABSCHALT_x + R_MAKESLOW)] & (TMR1H > R2_ABSCHALT_x) 
        return
 
; ********************
; *** ADR Gruen-#3 ***
; ********************
gruen_3
#ifndef test
        bsf LED_03
#endif ; test
        movf R_VERZ,W
        addwf R_MAKESLOW,W              ; latch vom (R_VERZ + R_MAKESLOW)
        movwf R1_ABSCHALT_3             ; .. in R1_ABSCHALT_x
        movf TMR1H,W                    ; latch vom TMR1H in R2_ABSCHALT_x
        movwf R2_ABSCHALT_3             ; abschalten @ [R_VERZ > (R1_ABSCHALT_x + R_MAKESLOW)] & (TMR1H > R2_ABSCHALT_x) 
        return

; ********************
; *** ADR Gruen-#4 ***
; ********************
gruen_4
#ifndef test
        bsf LED_04
#endif ; test
        movf R_VERZ,W
        addwf R_MAKESLOW,W              ; latch vom (R_VERZ + R_MAKESLOW)
        movwf R1_ABSCHALT_4             ; .. in R1_ABSCHALT_x
        movf TMR1H,W                    ; latch vom TMR1H in R2_ABSCHALT_x
        movwf R2_ABSCHALT_4             ; abschalten @ [R_VERZ > (R1_ABSCHALT_x + R_MAKESLOW)] & (TMR1H > R2_ABSCHALT_x) 
        return

; ********************
; *** ADR Gruen-#5 ***
; ********************
gruen_5
#ifndef test
        bsf LED_05
#endif ; test
        movf R_VERZ,W
        addwf R_MAKESLOW,W              ; latch vom (R_VERZ + R_MAKESLOW)
        movwf R1_ABSCHALT_5             ; .. in R1_ABSCHALT_x
        movf TMR1H,W                    ; latch vom TMR1H in R2_ABSCHALT_x
        movwf R2_ABSCHALT_5             ; abschalten @ [R_VERZ > (R1_ABSCHALT_x + R_MAKESLOW)] & (TMR1H > R2_ABSCHALT_x) 
        return

; ********************
; *** ADR Gruen-#6 ***
; ********************
gruen_6
#ifndef test
        bsf LED_06
#endif ; test
        movf R_VERZ,W
        addwf R_MAKESLOW,W              ; latch vom (R_VERZ + R_MAKESLOW)
        movwf R1_ABSCHALT_6             ; .. in R1_ABSCHALT_x
        movf TMR1H,W                    ; latch vom TMR1H in R2_ABSCHALT_x
        movwf R2_ABSCHALT_6             ; abschalten @ [R_VERZ > (R1_ABSCHALT_x + R_MAKESLOW)] & (TMR1H > R2_ABSCHALT_x) 
        return

; ********************
; *** ADR Gruen-#7 ***
; ********************
gruen_7
#ifndef test
        bsf LED_07
#endif ; test
        movf R_VERZ,W
        addwf R_MAKESLOW,W              ; latch vom (R_VERZ + R_MAKESLOW)
        movwf R1_ABSCHALT_7             ; .. in R1_ABSCHALT_x
        movf TMR1H,W                    ; latch vom TMR1H in R2_ABSCHALT_x
        movwf R2_ABSCHALT_7             ; abschalten @ [R_VERZ > (R1_ABSCHALT_x + R_MAKESLOW)] & (TMR1H > R2_ABSCHALT_x) 
        return

; ********************
; *** ADR Gruen-#8 ***
; ********************
gruen_8
#ifndef test
        bsf LED_08
#endif ; test
        movf R_VERZ,W
        addwf R_MAKESLOW,W              ; latch vom (R_VERZ + R_MAKESLOW)
        movwf R1_ABSCHALT_8             ; .. in R1_ABSCHALT_x
        movf TMR1H,W                    ; latch vom TMR1H in R2_ABSCHALT_x
        movwf R2_ABSCHALT_8             ; abschalten @ [R_VERZ > (R1_ABSCHALT_x + R_MAKESLOW)] & (TMR1H > R2_ABSCHALT_x) 
        return

; ********************
; *** ADR Gruen-#9 ***
; ********************
gruen_9
#ifndef test
        bsf LED_09
#endif ; test
        movf R_VERZ,W
        addwf R_MAKESLOW,W              ; latch vom (R_VERZ + R_MAKESLOW)
        movwf R1_ABSCHALT_9             ; .. in R1_ABSCHALT_x
        movf TMR1H,W                    ; latch vom TMR1H in R2_ABSCHALT_x
        movwf R2_ABSCHALT_9             ; abschalten @ [R_VERZ > (R1_ABSCHALT_x + R_MAKESLOW)] & (TMR1H > R2_ABSCHALT_x) 
        return

; ********************
; *** ADR Gruen-#10 ***
; ********************
gruen_10
#ifndef test
        bsf LED_10
#endif ; test
        movf R_VERZ,W
        addwf R_MAKESLOW,W              ; latch vom (R_VERZ + R_MAKESLOW)
        movwf R1_ABSCHALT_10            ; .. in R1_ABSCHALT_x
        movf TMR1H,W                    ; latch vom TMR1H in R2_ABSCHALT_x
        movwf R2_ABSCHALT_10            ; abschalten @ [R_VERZ > (R1_ABSCHALT_x + R_MAKESLOW)] & (TMR1H > R2_ABSCHALT_x) 
        return

; ******************
; *** ADR Rot-#1 ***
; ******************
rot_1
#ifndef test
        bcf LED_01                     ; Output1
#endif ; test
        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 for Time-Out
        return

; ******************
; *** ADR Rot-#2 ***
; ******************
rot_2
#ifndef test
        bcf LED_02
#endif ; test
        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 for Time-Out
        return
 
; ******************
; *** ADR Rot-#3 ***
; ******************
rot_3
#ifndef test
        bcf LED_03
#endif ; test
        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 for Time-Out
        return

; ******************
; *** ADR Rot-#4 ***
; ******************
rot_4
#ifndef test
        bcf LED_04
#endif ; test
        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 for Time-Out
        return

; ******************
; *** ADR Rot-#5 ***
; ******************
rot_5
#ifndef test
        bcf LED_05
#endif ; test
        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 for Time-Out
        return

; ******************
; *** ADR Rot-#6 ***
; ******************
rot_6
#ifndef test
        bcf LED_06
#endif ; test
        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 for Time-Out
        return

; ******************
; *** ADR Rot-#7 ***
; ******************
rot_7
#ifndef test
        bcf LED_07
#endif ; test
        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 for Time-Out
        return

; ******************
; *** ADR Rot-#8 ***
; ******************
rot_8
#ifndef test
        bcf LED_08
#endif ; test
        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 for Time-Out
        return

; ******************
; *** ADR Rot-#9 ***
; ******************
rot_9
#ifndef test
        bcf LED_09
#endif ; test
        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 for Time-Out
        return

; ******************
; *** ADR Rot-10 ***
; ******************
rot_10
#ifndef test
        bcf LED_10
#endif ; test
        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 for Time-Out
        return

;*********************************
;** Routine: save               **
;** Signalisierung mit jew.     **
;** Ausgang                     **
;*********************************
; ********************
; *** Adresse #1   ***
; ********************
save_01
         movf PORTA,W
         xorlw b'00010000'             ; OUT1
         movwf PORTA
        return

; ********************
; *** Adresse #2   ***
; ********************
save_02
         movf PORTA,W
         xorlw b'00100000'             ; OUT2
         movwf PORTA
        return

; ********************
; *** Adresse #3   ***
; ********************
save_03
         movf PORTA,W
         xorlw b'00000001'             ; OUT3
         movwf PORTA
        return

; ********************
; *** Adresse #4   ***
; ********************
save_04
         movf PORTA,W
         xorlw b'00000010'             ; OUT4
         movwf PORTA
        return

; ********************
; *** Adresse #5   ***
; ********************
save_05
         movf PORTC,W
         xorlw b'00000010'             ; OUT5
         movwf PORTC
        return

; ********************
; *** Adresse #6   ***
; ********************
save_06
        movf PORTC,W
        xorlw b'00000100'             ; OUT6
        movwf PORTC
        return

; ********************
; *** Adresse #7   ***
; ********************
save_07
        movf PORTC,W
        xorlw b'00000001'             ; OUT7
        movwf PORTC
        return

; ********************
; *** Adresse #8   ***
; ********************
save_08
        movf PORTC,W
        xorlw b'00100000'             ; OUT8
        movwf PORTC
        return

; ********************
; *** Adresse #9   ***
; ********************
save_09
        movf PORTC,W
        xorlw b'00010000'             ; OUT9
        movwf PORTC
        return

; ********************
; *** Adresse #10  ***
; ********************
save_10
        movf PORTC,W
        xorlw b'00001000'             ; OUT10
        movwf PORTC
        return

; ************************
; *** save_toggle_start **
; ************************
save_toggle_start
        ; wenn OUT1 eingeschaltet war, dann jetzt wieder einschalten (ergibt ein schnelleres Togglen der LED, wenn LED1 eingeschaltet beim Button)
        btfsc R_STATUS,0
         bsf LED_01          ; Ausgang 1
        return

;*******************************************
;** Routine: status_to_output             **
;** beim Start und nach dem Speichern     **
;** Ausgnge schalten gemss R_STATUS     **
;*******************************************
status_to_output
#ifndef dummy
        btfsc R_STATUS,0
         bsf LED_01
        btfsc R_STATUS,1
         bsf LED_02
        btfsc R_STATUS,2
         bsf LED_03
        btfsc R_STATUS,3
         bsf LED_04
        btfsc R_STATUS,4
         bsf LED_05
        btfsc R_STATUS,5
         bsf LED_06
        btfsc R_STATUS,6
         bsf LED_07
        btfsc R_STATUS,7
         bsf LED_08
        btfsc R_STATUS_2,0
         bsf LED_09
        btfsc R_STATUS_2,1
         bsf LED_10
        return
#endif; dummy

;*******************************************
;** Routine: abschalten_mode3            **
;*******************************************
abschalten_mode3
#ifndef dummy
        btfss R_MODE,2
         return
#ifdef test_ablauf
 bsf PORTC,2
#endif
abschalt_1
        movf R1_ABSCHALT_1,W
        subwf R_VERZ,W                 ; W = R_VERZ - W = R_VERZ - R1_ABSCHALT_1
        btfss STATUS,Z                 ; if Z=0, -> R_VERZ <> R1_ABSCHALT_1
         goto abschalt_2               ; ...then jump

        movf R2_ABSCHALT_1,W
        subwf TMR1H,W                  ; W = TMR1H - W = TMR1H - R2_ABSCHALT_1
        btfss STATUS,C                 ; if C=0, -> TMR1H >= R2_ABSCHALT_1
         goto abschalt_2               ; ...then jump

#ifndef test
        bcf LED_01                     ; Output1
#endif ; test

abschalt_2
        movf R1_ABSCHALT_2,W
        subwf R_VERZ,W                 ; W = R_VERZ - W = R_VERZ - R1_ABSCHALT_2
        btfss STATUS,Z                 ; if Z=0, -> R_VERZ <> R1_ABSCHALT_2
         goto abschalt_3               ; ...then jump

        movf R2_ABSCHALT_2,W
        subwf TMR1H,W                  ; W = TMR1H - W = TMR1H - R2_ABSCHALT_2
        btfss STATUS,C                 ; if C=0, -> TMR1H >= R2_ABSCHALT_2
         goto abschalt_3               ; ...then jump

#ifndef test
        bcf LED_02                     ; Output2
#endif ; test

abschalt_3
        movf R1_ABSCHALT_3,W
        subwf R_VERZ,W                 ; W = R_VERZ - W = R_VERZ - R1_ABSCHALT_3
        btfss STATUS,Z                 ; if Z=0, -> R_VERZ <> R1_ABSCHALT_3
         goto abschalt_4               ; ...then jump

        movf R2_ABSCHALT_3,W
        subwf TMR1H,W                  ; W = TMR1H - W = TMR1H - R2_ABSCHALT_3
        btfss STATUS,C                 ; if C=0, -> TMR1H >= R2_ABSCHALT_3
         goto abschalt_4               ; ...then jump

#ifndef test
        bcf LED_03                     ; Output3
#endif ; test

abschalt_4
        movf R1_ABSCHALT_4,W
        subwf R_VERZ,W                 ; W = R_VERZ - W = R_VERZ - R1_ABSCHALT_4
        btfss STATUS,Z                 ; if Z=0, -> R_VERZ <> R1_ABSCHALT_4
         goto abschalt_5               ; ...then jump

        movf R2_ABSCHALT_4,W
        subwf TMR1H,W                  ; W = TMR1H - W = TMR1H - R2_ABSCHALT_4
        btfss STATUS,C                 ; if C=0, -> TMR1H >= R2_ABSCHALT_4
         goto abschalt_5               ; ...then jump

#ifndef test
        bcf LED_04                     ; Output4
#endif ; test

abschalt_5
        movf R1_ABSCHALT_5,W
        subwf R_VERZ,W                 ; W = R_VERZ - W = R_VERZ - R1_ABSCHALT_5
        btfss STATUS,Z                 ; if Z=0, -> R_VERZ <> R1_ABSCHALT_5
         goto abschalt_6               ; ...then jump

        movf R2_ABSCHALT_5,W
        subwf TMR1H,W                  ; W = TMR1H - W = TMR1H - R2_ABSCHALT_5
        btfss STATUS,C                 ; if C=0, -> TMR1H >= R2_ABSCHALT_5
         goto abschalt_6               ; ...then jump

#ifndef test
        bcf LED_05                     ; Output5
#endif ; test

abschalt_6
        movf R1_ABSCHALT_6,W
        subwf R_VERZ,W                 ; W = R_VERZ - W = R_VERZ - R1_ABSCHALT_6
        btfss STATUS,Z                 ; if Z=0, -> R_VERZ <> R1_ABSCHALT_6
         goto abschalt_7               ; ...then jump

        movf R2_ABSCHALT_6,W
        subwf TMR1H,W                  ; W = TMR1H - W = TMR1H - R2_ABSCHALT_6
        btfss STATUS,C                 ; if C=0, -> TMR1H >= R2_ABSCHALT_6
         goto abschalt_7               ; ...then jump

#ifndef test
        bcf LED_06                     ; Output6
#endif ; test

abschalt_7
        movf R1_ABSCHALT_7,W
        subwf R_VERZ,W                 ; W = R_VERZ - W = R_VERZ - R1_ABSCHALT_7
        btfss STATUS,Z                 ; if Z=0, -> R_VERZ <> R1_ABSCHALT_7
         goto abschalt_8               ; ...then jump

        movf R2_ABSCHALT_7,W
        subwf TMR1H,W                  ; W = TMR1H - W = TMR1H - R2_ABSCHALT_7
        btfss STATUS,C                 ; if C=0, -> TMR1H >= R2_ABSCHALT_7
         goto abschalt_8               ; ...then jump

#ifndef test
        bcf LED_07                     ; Output7
#endif ; test

abschalt_8
        movf R1_ABSCHALT_8,W
        subwf R_VERZ,W                 ; W = R_VERZ - W = R_VERZ - R1_ABSCHALT_8
        btfss STATUS,Z                 ; if Z=0, -> R_VERZ <> R1_ABSCHALT_8
         goto abschalt_9               ; ...then jump

        movf R2_ABSCHALT_8,W
        subwf TMR1H,W                  ; W = TMR1H - W = TMR1H - R2_ABSCHALT_8
        btfss STATUS,C                 ; if C=0, -> TMR1H >= R2_ABSCHALT_8
         goto abschalt_9               ; ...then jump

#ifndef test
        bcf LED_08                     ; Output8
#endif ; test

abschalt_9
        movf R1_ABSCHALT_9,W
        subwf R_VERZ,W                 ; W = R_VERZ - W = R_VERZ - R1_ABSCHALT_9
        btfss STATUS,Z                 ; if Z=0, -> R_VERZ <> R1_ABSCHALT_9
         goto abschalt_10              ; ...then jump

        movf R2_ABSCHALT_9,W
        subwf TMR1H,W                  ; W = TMR1H - W = TMR1H - R2_ABSCHALT_9
        btfss STATUS,C                 ; if C=0, -> TMR1H >= R2_ABSCHALT_9
         goto abschalt_10              ; ...then jump

#ifndef test
        bcf LED_09                     ; Output9
#endif ; test

abschalt_10
        movf R1_ABSCHALT_10,W
        subwf R_VERZ,W                 ; W = R_VERZ - W = R_VERZ - R1_ABSCHALT_10
        btfss STATUS,Z                 ; if Z=0, -> R_VERZ <> R1_ABSCHALT_10
         goto abschalt_ende            ; ...then jump

        movf R2_ABSCHALT_10,W
        subwf TMR1H,W                  ; W = TMR1H - W = TMR1H - R2_ABSCHALT_10
        btfss STATUS,C                 ; if C=0, -> TMR1H >= R2_ABSCHALT_10
         goto abschalt_ende            ; ...then jump

#ifndef test
        bcf LED_10                     ; Output10
#endif ; test

abschalt_ende
#ifdef test_ablauf
 bcf PORTC,2
#endif
;   -----------------------------------------
;   --- check for Time Out (0.5 s Raster) ---
;   -----------------------------------------
        btfss PIR1,TMR1IF              ; if Timer1 overflow
         return
        bcf PIR1,TMR1IF                ; clear Flag

        incf R_VERZ,F                  ; R_VERZ = R_VERZ + 1
#ifdef test_ablauf
 bsf PORTC,0
 bcf PORTC,0
#endif

        return
#endif; dummy

;*********************************
;** Routine: change_mode        **
;** invert R_MODE and save      **
;** into EEPROM $00             **
;*********************************
change_mode
#ifndef dummy
        clrf R_CNT_TGL                 ; reset R_CNT_ADR wg. Blinken
        clrf R_CNT1_TGL                ; Counter fr LED-Signalisierung laden
        clrf R_CNT2_TGL

;   --------------------
;   --- Flag-Wechsel ---
;   --------------------
        btfss R_MODE,0                 ; change from #0 -> #1
         goto $+4
         clrf R_MODE
         bsf R_MODE,1
         goto change_mode_001

        btfss R_MODE,1                 ; change from #1 -> #2
         goto $+4
         clrf R_MODE
         bsf R_MODE,2
         goto change_mode_001

        clrf R_MODE                    ; unzulssige FLAGs werden
        bsf R_MODE,0                   ; hier abgefangen!

;   ----------------------
;   --- Signalisierung ---
;   ----------------------
change_mode_001
        movf R_MODE,W                  ;
        movwf R_CNT_TGL
change_mode_002
        clrwdt
        goto $+1
        goto $+1
        goto $+1
        goto $+1
        goto $+1

        btfsc R_CNT2_TGL,7             ; if CNT2 > 124
         bsf PORTA,4                   ; .. -> LED 1 on
        btfss R_CNT2_TGL,7             ; if CNT2 < 124
         bcf PORTA,4                   ; .. -> LED 1 off

        decfsz R_CNT1_TGL,F            ; increment Counter 1 for Toggle
         goto change_mode_002
        decfsz R_CNT2_TGL,F            ; increment Counter 2 for Toggle
         goto change_mode_002

        bcf STATUS,C
        RRF R_CNT_TGL,F
        movf R_CNT_TGL,F               ; Wenn ZERO
        btfss STATUS,Z                 ; dann ende der Signalisierung
         goto change_mode_002

;   -----------------
;   --- Speichern ---
;   -----------------
        movlw EE_ADR_MODE
        movwf R_EEADR                  ; Address: EE_ADR_MODE
        movf R_MODE,W
        movwf R_EEDAT                  ; Data: R_MODE
        call saveroutine
        return
#endif; dummy
