; ********************************************************
; ** Version: V3.16 vom 21/07/2008                      **
; ********************************************************
; ** Include-File zu dekoder.asm                        **
; ********************************************************
; ** Sven Brandt                                        **
; ********************************************************
; Copyright (C) 2006-2007 Sven Brandt

  ; ****************************
  ; ** nur fuer relais8       **
  ; ****************************
R_VERZ        equ  40h          ; Verzgerungs-Counter 1
R_MAKESLOW    equ  41h          ; Verzgerungs-Counter 1
R_STATUS_2    equ  42h          ; only for relais8 needed (9 Adresses)
R1_ABSCHALT_9 equ  4eh          ; Abschaltzeit PORTA,1 (extra-LED)
R2_ABSCHALT_9 equ  4fh          ; Abschaltzeit PORTA,1 (extra-LED)
R1_ABSCHALT_1 equ  50h          ; fuer Mode3: Latch R_VERZ fuer Anschaltzeit 
                                ; fuer Mode1/2: Latch R_VERZ fr Einschaltverzgerung
R2_ABSCHALT_1 equ  51h          ; fuer Mode3: Latch TMR1H  fuer Anschaltzeit 
                                ; fuer Mode1/2: Latch TMR1H fr Einschaltverzgerung
R1_ABSCHALT_2 equ  52h          ; fuer Mode3: Latch R_VERZ fuer Anschaltzeit 
                                ; fuer Mode1/2: Latch R_VERZ fr Einschaltverzgerung
R2_ABSCHALT_2 equ  53h          ; fuer Mode3: Latch TMR1H  fuer Anschaltzeit 
                                ; fuer Mode1/2: Latch TMR1H fr Einschaltverzgerung
R1_ABSCHALT_3 equ  54h          ; fuer Mode3: Latch R_VERZ fuer Anschaltzeit 
                                ; fuer Mode1/2: Latch R_VERZ fr Einschaltverzgerung
R2_ABSCHALT_3 equ  55h          ; fuer Mode3: Latch TMR1H  fuer Anschaltzeit 
                                ; fuer Mode1/2: Latch TMR1H fr Einschaltverzgerung
R1_ABSCHALT_4 equ  56h          ; fuer Mode3: Latch R_VERZ fuer Anschaltzeit 
                                ; fuer Mode1/2: Latch R_VERZ fr Einschaltverzgerung
R2_ABSCHALT_4 equ  57h          ; fuer Mode3: Latch TMR1H  fuer Anschaltzeit 
                                ; fuer Mode1/2: Latch TMR1H fr Einschaltverzgerung
R1_ABSCHALT_5 equ  58h          ; fuer Mode3: Latch R_VERZ fuer Anschaltzeit 
                                ; fuer Mode1/2: Latch R_VERZ fr Einschaltverzgerung
R2_ABSCHALT_5 equ  59h          ; fuer Mode3: Latch TMR1H  fuer Anschaltzeit 
                                ; fuer Mode1/2: Latch TMR1H fr Einschaltverzgerung
R1_ABSCHALT_6 equ  5ah          ; fuer Mode3: Latch R_VERZ fuer Anschaltzeit 
                                ; fuer Mode1/2: Latch R_VERZ fr Einschaltverzgerung
R2_ABSCHALT_6 equ  5bh          ; fuer Mode3: Latch TMR1H  fuer Anschaltzeit 
                                ; fuer Mode1/2: Latch TMR1H fr Einschaltverzgerung
R1_ABSCHALT_7 equ  5ch          ; fuer Mode3: Latch R_VERZ fuer Anschaltzeit 
                                ; fuer Mode1/2: Latch R_VERZ fr Einschaltverzgerung
R2_ABSCHALT_7 equ  5dh          ; fuer Mode3: Latch TMR1H  fuer Anschaltzeit 
                                ; fuer Mode1/2: Latch TMR1H fr Einschaltverzgerung
R1_ABSCHALT_8 equ  5eh          ; fuer Mode3: Latch R_VERZ fuer Anschaltzeit 
                                ; fuer Mode1/2: Latch R_VERZ fr Einschaltverzgerung
R2_ABSCHALT_8 equ  5fh          ; fuer Mode3: Latch TMR1H  fuer Anschaltzeit 
                                ; fuer Mode1/2: Latch TMR1H fr Einschaltverzgerung

;   --------------------------------------------------------------------------
;   --- EEprom Locations
;   --------------------------------------------------------------------------
#define EE_ADR_MODE  h'00'           ; EEprom Adresse: R_MODE
#define EE_ADR_S1    h'10'           ; EEprom Adresse: R_STATUS_1: Status #1
#define EE_ADR_MS    h'20'           ; EEprom Adresse: R_MAKESLOW: Wert Time-Out

;   --------------------------------------------------------------------------
;   --- Port Definition
;   --------------------------------------------------------------------------
#define OUTPUT1     PORTC,5        ;Relais-Dekoder Layout Definition
#define OUTPUT2     PORTC,4        ;Relais-Dekoder Layout Definition
#define OUTPUT3     PORTC,3        ;Relais-Dekoder Layout Definition
#define OUTPUT4     PORTA,4        ;Relais-Dekoder Layout Definition
#define OUTPUT5     PORTA,5        ;Relais-Dekoder Layout Definition
#define OUTPUT6     PORTC,2        ;Relais-Dekoder Layout Definition
#define OUTPUT7     PORTC,1        ;Relais-Dekoder Layout Definition
#define OUTPUT8     PORTC,0        ;Relais-Dekoder Layout Definition

; ********************
; *** INIT-Dekoder ***
; ********************
init_dekoder
;   -----------------------------------
;   --- read R_MODE from EEPROM $00 ---
;   -----------------------------------
        bsf STATUS,RP0                 ; -> BANK 1
        movlw EE_ADR_MODE
        movwf EEADR                    ; Adress to read
        bsf EECON1,RD                  ; initiate reading
        movf EEDATA,W                  ; EEDATA into W
        bcf STATUS,RP0                 ; -> BANK 0
        movwf R_MODE                   ; ..into R_MODE

;   -------------------------------------
;   --- read R_STATUS from EEPROM $10 ---
;   -------------------------------------
        bsf STATUS,RP0                 ; -> BANK 1
        movlw EE_ADR_S1
        movwf EEADR                    ; Adress to read
        bsf EECON1,RD                  ; initiate reading
        movf EEDATA,W                  ; EEDATA into W
        bcf STATUS,RP0                 ; -> BANK 0
        btfsc R_MODE,0                 ; restoring of output -> skip if R_MODE#0 = FALSE
         movwf R_STATUS                ; ..into R_STATUS (if R_MODE#0 = TRUE)

;   ---------------------------------------
;   --- read R_MAKESLOW from EEPROM $20 ---
;   ---------------------------------------
        bsf STATUS,RP0                 ; -> BANK 1
        movlw EE_ADR_MS
        movwf EEADR                    ; Adress to read
        bsf EECON1,RD                  ; initiate reading
        movf EEDATA,W                  ; EEDATA into W
        bcf STATUS,RP0                 ; -> BANK 0
        movwf R_MAKESLOW               ; ..into R_MAKESLOW

        movlw d'01'                    ; Default-Wert, wenn R_MAKESLOW zu gross oder NULL ist
        btfsc R_MAKESLOW,7             ; .. d'01'
         movwf R_MAKESLOW              ; .. into R_MAKESLOW, wenn >127 (nur fr Weichen-Varianten)

        movf R_MAKESLOW,F              ; wenn R_MAKESLOW = 0, dann
        btfsc STATUS,Z                 ; .. d'01'
         movwf R_MAKESLOW              ; .. into R_MAKESLOW, wenn == 0

        return

; ********************
; *** ADR Gruen-#1 ***
; ********************
gruen_1
        btfsc R_MODE,2                  ; switch Relais immediately only in mode 3
         bsf PORTC,5                    ; Relais K1
        movf R_VERZ,W
        btfss R_MODE,2                  ; decrement R_VERZ in mode 1/2
         decf R_VERZ,W                  ; decrement into 'W':  '1'(default) -> no delay
        addwf R_MAKESLOW,W              ; latch vom (R_VERZ + R_MAKESLOW)
        movwf R1_ABSCHALT_1             ; .. in R1_ABSCHALT_x
        movf TMR1H,W                    ; latch vom TMR1H in R2_ABSCHALT_x
        movwf R2_ABSCHALT_1             ; abschalten @ [R_VERZ = R1_ABSCHALT_x] & (TMR1H > R2_ABSCHALT_x) ;
        btfsc R_MODE,3                  ; in Mode 4: Single Output, so reset all switching
         call all_off
        bsf R_STATUS,0                  ; STATUS Bit: set again (deleted in "all_off")
        return

; ********************
; *** ADR Gruen-#2 ***
; ********************
gruen_2
        btfsc R_MODE,2                  ; switch Relais immediately only in mode 3
         bsf PORTC,4                    ; Relais K2
        movf R_VERZ,W
        btfss R_MODE,2                  ; decrement R_VERZ in mode 1/2
         decf R_VERZ,W                  ; decrement into 'W':  '1'(default) -> no delay
        addwf R_MAKESLOW,W              ; latch vom (R_VERZ + R_MAKESLOW)
        movwf R1_ABSCHALT_2             ; .. in R1_ABSCHALT_x
        movf TMR1H,W                    ; latch vom TMR1H in R2_ABSCHALT_x
        movwf R2_ABSCHALT_2             ; abschalten @ [R_VERZ = R1_ABSCHALT_x] & (TMR1H > R2_ABSCHALT_x) ;
        btfsc R_MODE,3                  ; in Mode 4: Single Output, so reset all switching
         call all_off
        bsf R_STATUS,1                  ; STATUS Bit: set again (deleted in "all_off")
        return
 
; ********************
; *** ADR Gruen-#3 ***
; ********************
gruen_3
        btfsc R_MODE,2                  ; switch Relais immediately only in mode 3
         bsf PORTC,3                    ; Relais K3
        movf R_VERZ,W
        btfss R_MODE,2                  ; decrement R_VERZ in mode 1/2
         decf R_VERZ,W                  ; decrement into 'W':  '1'(default) -> no delay
        addwf R_MAKESLOW,W              ; latch vom (R_VERZ + R_MAKESLOW)
        movwf R1_ABSCHALT_3             ; .. in R1_ABSCHALT_x
        movf TMR1H,W                    ; latch vom TMR1H in R2_ABSCHALT_x
        movwf R2_ABSCHALT_3             ; abschalten @ [R_VERZ = R1_ABSCHALT_x] & (TMR1H > R2_ABSCHALT_x) ;
        btfsc R_MODE,3                  ; in Mode 4: Single Output, so reset all switching
         call all_off
        bsf R_STATUS,2                  ; STATUS Bit: set again (deleted in "all_off")
        return

; ********************
; *** ADR Gruen-#4 ***
; ********************
gruen_4
        btfsc R_MODE,2                  ; switch Relais immediately only in mode 3
         bsf PORTA,4                    ; Relais K4
        movf R_VERZ,W
        btfss R_MODE,2                  ; decrement R_VERZ in mode 1/2
         decf R_VERZ,W                  ; decrement into 'W':  '1'(default) -> no delay
        addwf R_MAKESLOW,W              ; latch vom (R_VERZ + R_MAKESLOW)
        movwf R1_ABSCHALT_4             ; .. in R1_ABSCHALT_x
        movf TMR1H,W                    ; latch vom TMR1H in R2_ABSCHALT_x
        movwf R2_ABSCHALT_4             ; abschalten @ [R_VERZ = R1_ABSCHALT_x] & (TMR1H > R2_ABSCHALT_x) ;
        btfsc R_MODE,3                  ; in Mode 4: Single Output, so reset all switching
         call all_off
        bsf R_STATUS,3                  ; STATUS Bit: set again (deleted in "all_off")
        return

; ********************
; *** ADR Gruen-#5 ***
; ********************
gruen_5
        btfsc R_MODE,2                  ; switch Relais immediately only in mode 3
         bsf PORTA,5                    ; Relais K5
        movf R_VERZ,W
        btfss R_MODE,2                  ; decrement R_VERZ in mode 1/2
         decf R_VERZ,W                  ; decrement into 'W':  '1'(default) -> no delay
        addwf R_MAKESLOW,W              ; latch vom (R_VERZ + R_MAKESLOW)
        movwf R1_ABSCHALT_5             ; .. in R1_ABSCHALT_x
        movf TMR1H,W                    ; latch vom TMR1H in R2_ABSCHALT_x
        movwf R2_ABSCHALT_5             ; abschalten @ [R_VERZ = R1_ABSCHALT_x] & (TMR1H > R2_ABSCHALT_x) ;
        btfsc R_MODE,3                  ; in Mode 4: Single Output, so reset all switching
         call all_off
        bsf R_STATUS,4                  ; STATUS Bit: set again (deleted in "all_off")
        return

; ********************
; *** ADR Gruen-#6 ***
; ********************
gruen_6
        btfsc R_MODE,2                  ; switch Relais immediately only in mode 3
         bsf PORTC,2                    ; Relais K6
        movf R_VERZ,W
        btfss R_MODE,2                  ; decrement R_VERZ in mode 1/2
         decf R_VERZ,W                  ; decrement into 'W':  '1'(default) -> no delay
        addwf R_MAKESLOW,W              ; latch vom (R_VERZ + R_MAKESLOW)
        movwf R1_ABSCHALT_6             ; .. in R1_ABSCHALT_x
        movf TMR1H,W                    ; latch vom TMR1H in R2_ABSCHALT_x
        movwf R2_ABSCHALT_6             ; abschalten @ [R_VERZ = R1_ABSCHALT_x] & (TMR1H > R2_ABSCHALT_x) ;
        btfsc R_MODE,3                  ; in Mode 4: Single Output, so reset all switching
         call all_off
        bsf R_STATUS,5                  ; STATUS Bit: set again (deleted in "all_off")
        return

; ********************
; *** ADR Gruen-#7 ***
; ********************
gruen_7
        btfsc R_MODE,2                  ; switch Relais immediately only in mode 3
         bsf PORTC,1                    ; Relais K7
        movf R_VERZ,W
        btfss R_MODE,2                  ; decrement R_VERZ in mode 1/2
         decf R_VERZ,W                  ; decrement into 'W':  '1'(default) -> no delay
        addwf R_MAKESLOW,W              ; latch vom (R_VERZ + R_MAKESLOW)
        movwf R1_ABSCHALT_7             ; .. in R1_ABSCHALT_x
        movf TMR1H,W                    ; latch vom TMR1H in R2_ABSCHALT_x
        movwf R2_ABSCHALT_7             ; abschalten @ [R_VERZ = R1_ABSCHALT_x] & (TMR1H > R2_ABSCHALT_x) ;
        btfsc R_MODE,3                  ; in Mode 4: Single Output, so reset all switching
         call all_off
        bsf R_STATUS,6                  ; STATUS Bit: set again (deleted in "all_off")
        return

; ********************
; *** ADR Gruen-#8 ***
; ********************
gruen_8
        btfsc R_MODE,2                  ; switch Relais immediately only in mode 3
         bsf PORTC,0                    ; Relais K8
        movf R_VERZ,W
        btfss R_MODE,2                  ; decrement R_VERZ in mode 1/2
         decf R_VERZ,W                  ; decrement into 'W':  '1'(default) -> no delay
        addwf R_MAKESLOW,W              ; latch vom (R_VERZ + R_MAKESLOW)
        movwf R1_ABSCHALT_8             ; .. in R1_ABSCHALT_x
        movf TMR1H,W                    ; latch vom TMR1H in R2_ABSCHALT_x
        movwf R2_ABSCHALT_8             ; abschalten @ [R_VERZ = R1_ABSCHALT_x] & (TMR1H > R2_ABSCHALT_x) ;
        btfsc R_MODE,3                  ; in Mode 4: Single Output, so reset all switching
         call all_off
        bsf R_STATUS,7                  ; STATUS Bit: set again (deleted in "all_off")
        return

; ********************
; *** ADR Gruen-#9 ***
; ********************
gruen_9
        btfsc R_MODE,3                  ; no switching of all Relais in Mode 4
         return                  
        btfss R_MODE,2                  ; switch Relais immediately only in mode 3
         goto gruen_9a                  
        movlw b'00110000'               ; Relais K5/K4           
        iorwf PORTA,F                   ; .. switch ON         
        movlw b'00111111'               ; Relais K8/K7/K6/K3/K2/K1 
        iorwf PORTC,F                   ; .. switch ON  

gruen_9a
        clrf TMR1L                     ; delete Timer and R_VERZ, because
        clrf TMR1H                     ; .. no need to wait for other
        clrf R_VERZ                    ; .. delayed switching to get finished
        
        clrf R1_ABSCHALT_1             ; .. in R1_ABSCHALT_x
        clrf R1_ABSCHALT_2             ; .. in R1_ABSCHALT_x
        clrf R1_ABSCHALT_3             ; .. in R1_ABSCHALT_x
        clrf R1_ABSCHALT_4             ; .. in R1_ABSCHALT_x
        movlw d'1'
        movwf R1_ABSCHALT_5            ; .. in R1_ABSCHALT_x
        movwf R1_ABSCHALT_6            ; .. in R1_ABSCHALT_x
        movwf R1_ABSCHALT_7            ; .. in R1_ABSCHALT_x
        movwf R1_ABSCHALT_8            ; .. in R1_ABSCHALT_x

        movlw d'64'
        movwf R2_ABSCHALT_1
        movlw d'128'
        movwf R2_ABSCHALT_2
        movlw d'192'
        movwf R2_ABSCHALT_3
        movlw d'255'
        movwf R2_ABSCHALT_4
        movlw d'64'
        movwf R2_ABSCHALT_5
        movlw d'128'
        movwf R2_ABSCHALT_6
        movlw d'192'
        movwf R2_ABSCHALT_7
        movlw d'255'
        movwf R2_ABSCHALT_8

        movlw b'11111111'               ; all outputs ON
        movwf R_STATUS                  ; set STATUS Bit
        return

; ******************
; *** ADR Rot-#1 ***
; ******************
rot_1
        bcf PORTC,5                    ; Relais K1
        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 for Time-Out
        return

; ******************
; *** ADR Rot-#2 ***
; ******************
rot_2
        bcf PORTC,4                    ; Relais K2
        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 for Time-Out
        return
 
; ******************
; *** ADR Rot-#3 ***
; ******************
rot_3
        bcf PORTC,3                    ; Relais K3
        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 for Time-Out
        return

; ******************
; *** ADR Rot-#4 ***
; ******************
rot_4
        bcf PORTA,4                    ; Relais K4
        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 for Time-Out
        return

; ******************
; *** ADR Rot-#5 ***
; ******************
rot_5
        bcf PORTA,5                    ; Relais K5
        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 for Time-Out
        return

; ******************
; *** ADR Rot-#6 ***
; ******************
rot_6
        bcf PORTC,2                    ; Relais K6
        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 for Time-Out
        return

; ******************
; *** ADR Rot-#7 ***
; ******************
rot_7
        bcf PORTC,1                    ; Relais K7
        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 for Time-Out
        return

; ******************
; *** ADR Rot-#8 ***
; ******************
rot_8
        bcf PORTC,0                    ; Relais K8
        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 for Time-Out
        return

; ******************
; *** ADR Rot-#9 ***
; ******************
rot_9
        call all_off                   ; switch all off and clear R_STATUS
        clrf TMR1L
        clrf TMR1H                     ; clear Timer1 for Time-Out
        return

;*********************************
;** Routine: save               **
;** Signalisierung mit jew.     **
;** Ausgang                     **
;*********************************
; ********************
; *** Adresse #1   ***
; ********************
save_01
        movf PORTC,W
        xorlw b'00100000'              ; Relais K1
        movwf PORTC
        return

; ********************
; *** Adresse #2   ***
; ********************
save_02
        movf PORTC,W
        xorlw b'00010000'              ; Relais K2
        movwf PORTC
        return

; ********************
; *** Adresse #3   ***
; ********************
save_03
        movf PORTC,W
        xorlw b'00001000'              ; Relais K3
        movwf PORTC
        return

; ********************
; *** Adresse #4   ***
; ********************
save_04
        movf PORTA,W
        xorlw b'00010000'              ; Relais K4
        movwf PORTA
        return

; ********************
; *** Adresse #5   ***
; ********************
save_05
        movf PORTA,W
        xorlw b'00100000'              ; Relais K5
        movwf PORTA
        return

; ********************
; *** Adresse #6   ***
; ********************
save_06
        movf PORTC,W
        xorlw b'00000100'              ; Relais K6
        movwf PORTC
        return

; ********************
; *** Adresse #7   ***
; ********************
save_07
        movf PORTC,W
        xorlw b'00000010'              ; Relais K4
        movwf PORTC
        return

; ********************
; *** Adresse #8   ***
; ********************
save_08
        movf PORTC,W
        xorlw b'00000001'              ; Relais K4
        movwf PORTC
        return

; ********************
; *** Adresse #9   ***
; ********************
save_09
        movf PORTA,W
        xorlw b'00110000'              ; Relais K4/K5
        movwf PORTA
        movf PORTC,W
        xorlw b'00111111'              ; Relais K8/K7/K6/K3/K2/K1
        movwf PORTC
        return

; ************************
; *** save_toggle_start **
; ************************
save_toggle_start
        ; wenn OUT1 eingeschaltet war, dann jetzt wieder einschalten (ergibt ein schnelleres Togglen der LED, wenn LED1 eingeschaltet beim Button)
        btfsc R_STATUS,0
         bsf OUTPUT1         ; Ausgang 1
        return

; ***********************************************
; *** all_off: switch all outputs off (mode4) ***
; ***********************************************
all_off
        movlw b'11001111'              ; Relais K5/K4           
        andwf PORTA,F                  ; .. switch OFF         
        movlw b'11000000'              ; Relais K8/K7/K6/K3/K2/K1 
        andwf PORTC,F                  ; .. switch OFF 

        clrf R_STATUS                  ; clear STATUS
        return

;*******************************************
;** Routine: status_to_output             **
;** beim Start und nach dem Speichern     **
;** Ausgnge schalten gemss R_STATUS     **
;*******************************************
status_to_output
        btfsc R_STATUS,0
         bsf PORTC,5                   ; Relais K1
        btfsc R_STATUS,1               
         bsf PORTC,4                   ; Relais K2
        btfsc R_STATUS,2               
         bsf PORTC,3                   ; Relais K3
        btfsc R_STATUS,3               
         bsf PORTA,4                   ; Relais K4
        btfsc R_STATUS,4               
         bsf PORTA,5                   ; Relais K5
        btfsc R_STATUS,5               
         bsf PORTC,2                   ; Relais K6
        btfsc R_STATUS,6               
         bsf PORTC,1                   ; Relais K7
        btfsc R_STATUS,7               
         bsf PORTC,0                   ; Relais K8
        return

;*******************************************
;** Routine: abschalten_mode3            **
;*******************************************
abschalten_mode3
;        btfss R_MODE,2
;         goto abschalt_9
;
;                     |   .   .   .   .   .   .   .   .
;    TMR1H:           |  /|  /|  /|  /|  /|  /|  /|  /|
;    ------           | / | 0 | / | 2 | / | / | / | / |
;                     |/  |/  |/  |/  |/  |/  |/  |/  |
;                     |----------------------------------------
;                    
;    R_VERZ:          |                    ----
;    -------          |                ----   |
;  increment          |            -1--       |
;  every              |        ----           |
;  TMR1IF             |    -0--               |        ----
; ('abschalt_ ende')  |----                   |    ----
;                     |----------------------------------------
;
; 0: Time where command occurs ('gruen_1' etc.)
; 1: Value is calculated and stored @ '0' in R1_ABSCHALT_x (R_VERZ + R_MAKESLOW)
; 2: Value is stored @ '0' in R2_ABSCHALT_x
;
; abschalten @ [R_VERZ = R1_ABSCHALT_x] & (TMR1H >= R2_ABSCHALT_x) ;
; TMR1H is changing every 8x255 us so there should be no problem with overflow / carry

abschalt_1
        btfsc R_MODE,2                 ; immer ausfhren in Mode 3
         goto $+3                      ; ..
        btfss R_STATUS,0               ; Mode 1/2: nicht Ausfhren 
         goto abschalt_2               ; .. wenn gar nicht (mehr) ON ist

        movf R1_ABSCHALT_1,W
        subwf R_VERZ,W                 ; W = R_VERZ - W = R_VERZ - R1_ABSCHALT_1
        btfss STATUS,Z                 ; if Z=0, -> R_VERZ <> R1_ABSCHALT_1
         goto abschalt_2               ; ...then jump

        movf R2_ABSCHALT_1,W
        subwf TMR1H,W                  ; W = TMR1H - W = TMR1H - R2_ABSCHALT_1
        btfss STATUS,C                 ; if C=0, -> TMR1H < R2_ABSCHALT_1
         goto abschalt_2               ; ...then jump

        btfsc R_MODE,2                 ; after delay time in mode 3: switch OFF
         bcf PORTC,5                   ; Relais K1
        btfss R_MODE,2                 ; after delay time in mode 1/2: switch ON
         bsf PORTC,5                   ; Relais K1

abschalt_2
        btfsc R_MODE,2                 ; immer ausfhren in Mode 3
         goto $+3                      ; ..
        btfss R_STATUS,1               ; nicht Ausfhren 
         goto abschalt_3               ; .. wenn gar nicht (mehr) ON ist

        movf R1_ABSCHALT_2,W
        subwf R_VERZ,W                 ; W = R_VERZ - W = R_VERZ - R1_ABSCHALT_2
        btfss STATUS,Z                 ; if Z=0, -> R_VERZ <> R1_ABSCHALT_2
         goto abschalt_3               ; ...then jump

        movf R2_ABSCHALT_2,W
        subwf TMR1H,W                  ; W = TMR1H - W = TMR1H - R2_ABSCHALT_2
        btfss STATUS,C                 ; if C=0, -> TMR1H < R2_ABSCHALT_2
         goto abschalt_3               ; ...then jump

        btfsc R_MODE,2                 ; after delay time in mode 3: switch OFF
         bcf PORTC,4                   ; Relais K2
        btfss R_MODE,2                 ; after delay time in mode 1/2: switch ON
         bsf PORTC,4                   ; Relais K2

abschalt_3
        btfsc R_MODE,2                 ; immer ausfhren in Mode 3
         goto $+3                      ; ..
        btfss R_STATUS,2               ; nicht Ausfhren 
         goto abschalt_4               ; .. wenn gar nicht (mehr) ON ist

        movf R1_ABSCHALT_3,W
        subwf R_VERZ,W                 ; W = R_VERZ - W = R_VERZ - R1_ABSCHALT_3
        btfss STATUS,Z                 ; if Z=0, -> R_VERZ <> R1_ABSCHALT_3
         goto abschalt_4               ; ...then jump

        movf R2_ABSCHALT_3,W
        subwf TMR1H,W                  ; W = TMR1H - W = TMR1H - R2_ABSCHALT_3
        btfss STATUS,C                 ; if C=0, -> TMR1H < R2_ABSCHALT_3
         goto abschalt_4               ; ...then jump

        btfsc R_MODE,2                 ; after delay time in mode 3: switch OFF
         bcf PORTC,3                   ; Relais K3
        btfss R_MODE,2                 ; after delay time in mode 1/2: switch ON
         bsf PORTC,3                   ; Relais K3

abschalt_4
        btfsc R_MODE,2                 ; immer ausfhren in Mode 3
         goto $+3                      ; ..
        btfss R_STATUS,3               ; nicht Ausfhren 
         goto abschalt_5               ; .. wenn gar nicht (mehr) ON ist

        movf R1_ABSCHALT_4,W
        subwf R_VERZ,W                 ; W = R_VERZ - W = R_VERZ - R1_ABSCHALT_4
        btfss STATUS,Z                 ; if Z=0, -> R_VERZ <> R1_ABSCHALT_4
         goto abschalt_5               ; ...then jump

        movf R2_ABSCHALT_4,W
        subwf TMR1H,W                  ; W = TMR1H - W = TMR1H - R2_ABSCHALT_4
        btfss STATUS,C                 ; if C=0, -> TMR1H < R2_ABSCHALT_4
         goto abschalt_5               ; ...then jump

        btfsc R_MODE,2                 ; after delay time in mode 3: switch OFF
         bcf PORTA,4                   ; Relais K4
        btfss R_MODE,2                 ; after delay time in mode 1/2: switch ON
         bsf PORTA,4                   ; Relais K4

abschalt_5
        btfsc R_MODE,2                 ; immer ausfhren in Mode 3
         goto $+3                      ; ..
        btfss R_STATUS,4               ; nicht Ausfhren 
         goto abschalt_6               ; .. wenn gar nicht (mehr) ON ist

        movf R1_ABSCHALT_5,W
        subwf R_VERZ,W                 ; W = R_VERZ - W = R_VERZ - R1_ABSCHALT_5
        btfss STATUS,Z                 ; if Z=0, -> R_VERZ <> R1_ABSCHALT_5
         goto abschalt_6               ; ...then jump

        movf R2_ABSCHALT_5,W
        subwf TMR1H,W                  ; W = TMR1H - W = TMR1H - R2_ABSCHALT_5
        btfss STATUS,C                 ; if C=0, -> TMR1H < R2_ABSCHALT_5
         goto abschalt_6               ; ...then jump

        btfsc R_MODE,2                 ; after delay time in mode 3: switch OFF
         bcf PORTA,5                   ; Relais K5
        btfss R_MODE,2                 ; after delay time in mode 1/2: switch ON
         bsf PORTA,5                   ; Relais K5

abschalt_6
        btfsc R_MODE,2                 ; immer ausfhren in Mode 3
         goto $+3                      ; ..
        btfss R_STATUS,5               ; nicht Ausfhren 
         goto abschalt_7               ; .. wenn gar nicht (mehr) ON ist

        movf R1_ABSCHALT_6,W
        subwf R_VERZ,W                 ; W = R_VERZ - W = R_VERZ - R1_ABSCHALT_6
        btfss STATUS,Z                 ; if Z=0, -> R_VERZ <> R1_ABSCHALT_6
         goto abschalt_7               ; ...then jump

        movf R2_ABSCHALT_6,W
        subwf TMR1H,W                  ; W = TMR1H - W = TMR1H - R2_ABSCHALT_6
        btfss STATUS,C                 ; if C=0, -> TMR1H < R2_ABSCHALT_6
         goto abschalt_7               ; ...then jump

        btfsc R_MODE,2                 ; after delay time in mode 3: switch OFF
         bcf PORTC,2                   ; Relais K6
        btfss R_MODE,2                 ; after delay time in mode 1/2: switch ON
         bsf PORTC,2                   ; Relais K6

abschalt_7
        btfsc R_MODE,2                 ; immer ausfhren in Mode 3
         goto $+3                      ; ..
        btfss R_STATUS,6               ; nicht Ausfhren 
         goto abschalt_8               ; .. wenn gar nicht (mehr) ON ist

        movf R1_ABSCHALT_7,W
        subwf R_VERZ,W                 ; W = R_VERZ - W = R_VERZ - R1_ABSCHALT_7
        btfss STATUS,Z                 ; if Z=0, -> R_VERZ <> R1_ABSCHALT_7
         goto abschalt_8               ; ...then jump

        movf R2_ABSCHALT_7,W
        subwf TMR1H,W                  ; W = TMR1H - W = TMR1H - R2_ABSCHALT_7
        btfss STATUS,C                 ; if C=0, -> TMR1H < R2_ABSCHALT_7
         goto abschalt_8               ; ...then jump

        btfsc R_MODE,2                 ; after delay time in mode 3: switch OFF
         bcf PORTC,1                   ; Relais K7
        btfss R_MODE,2                 ; after delay time in mode 1/2: switch ON
         bsf PORTC,1                   ; Relais K7

abschalt_8
        btfsc R_MODE,2                 ; immer ausfhren in Mode 3
         goto $+3                      ; ..
        btfss R_STATUS,7               ; nicht Ausfhren 
         goto abschalt_9               ; .. wenn gar nicht (mehr) ON ist

        movf R1_ABSCHALT_8,W
        subwf R_VERZ,W                 ; W = R_VERZ - W = R_VERZ - R1_ABSCHALT_8
        btfss STATUS,Z                 ; if Z=0, -> R_VERZ <> R1_ABSCHALT_8
         goto abschalt_9               ; ...then jump

        movf R2_ABSCHALT_8,W
        subwf TMR1H,W                  ; W = TMR1H - W = TMR1H - R2_ABSCHALT_8
        btfss STATUS,C                 ; if C=0, -> TMR1H < R2_ABSCHALT_8
         goto abschalt_9               ; ...then jump

        btfsc R_MODE,2                 ; after delay time in mode 3: switch OFF
         bcf PORTC,0                   ; Relais K8
        btfss R_MODE,2                 ; after delay time in mode 1/2: switch ON
         bsf PORTC,0                   ; Relais K8

abschalt_9                             ; switch off LED (in all Modes)
        movf R1_ABSCHALT_9,W
        subwf R_VERZ,W                 ; W = R_VERZ - W = R_VERZ - R1_ABSCHALT9
        btfss STATUS,Z                 ; if Z=0, -> R_VERZ <> R1_ABSCHALT_9
         goto abschalt_ende            ; ...then jump

        movf R2_ABSCHALT_9,W
        subwf TMR1H,W                  ; W = TMR1H - W = TMR1H - R2_ABSCHALT_9
        btfss STATUS,C                 ; if C=0, -> TMR1H < R2_ABSCHALT_9
         goto abschalt_ende            ; ...then jump

        bcf PORTA,1                    ; extra LED

abschalt_ende
;   -----------------------------------------
;   --- check for Time Out (0.5 s Raster) ---
;   -----------------------------------------
        btfss PIR1,TMR1IF              ; if Timer1 overflow
         return
        bcf PIR1,TMR1IF                ; clear Flag

        incf R_VERZ,F                  ; R_VERZ = R_VERZ + 1

        return

;*********************************
;** Routine: change_mode        **
;** invert R_MODE and save      **
;** into EEPROM $00             **
;*********************************
change_mode
        clrf R_CNT_TGL                 ; reset R_CNT_ADR wg. Blinken
        clrf R_CNT1_TGL                ; Counter fr LED-Signalisierung laden
        clrf R_CNT2_TGL

;   --------------------
;   --- Flag-Wechsel ---
;   --------------------
        btfss R_MODE,0                 ; change from #0 -> #1
         goto $+4
         clrf R_MODE
         bsf R_MODE,1
         goto change_mode_001

        btfss R_MODE,1                 ; change from #1 -> #2
         goto $+4
         clrf R_MODE
         bsf R_MODE,2
         goto change_mode_001

        btfss R_MODE,2                 ; change from #2 -> #3
         goto $+4
         clrf R_MODE
         bsf R_MODE,3
         goto change_mode_001

        clrf R_MODE                    ; unzulssige FLAGs werden
        bsf R_MODE,0                   ; hier abgefangen!

;   ----------------------
;   --- Signalisierung ---
;   ----------------------
change_mode_001
        movf R_MODE,W                  ;
        movwf R_CNT_TGL
change_mode_002
        clrwdt
        goto $+1
        goto $+1
        goto $+1
        goto $+1
        goto $+1

        btfsc R_CNT2_TGL,7             ; if CNT2 > 124
         bsf PORTC,5                   ; .. -> Relais on
        btfss R_CNT2_TGL,7             ; if CNT2 < 124
         bcf PORTC,5                   ; .. -> Relais off

        decfsz R_CNT1_TGL,F            ; increment Counter 1 for Toggle
         goto change_mode_002
        decfsz R_CNT2_TGL,F            ; increment Counter 2 for Toggle
         goto change_mode_002

        bcf STATUS,C
        RRF R_CNT_TGL,F
        movf R_CNT_TGL,F               ; Wenn ZERO
        btfss STATUS,Z                 ; dann ende der Signalisierung
         goto change_mode_002

;   -----------------
;   --- Speichern ---
;   -----------------
        movlw h'00'
        movwf R_EEADR                  ; Address: h'00'
        movf R_MODE,W
        movwf R_EEDAT                  ; Data: R_MODE
        call saveroutine
        return

