; ********************************************************
; ** Version: V3.21 vom 03/01/2009                      **
; ********************************************************
; ** Include-File zu dekoder.asm                        **
; ********************************************************
; ** Sven Brandt                                        **
; ********************************************************
; Copyright (C) 2006/07/08/09 Sven Brandt

  ; ****************************
  ; ** nur fuer led_ampel     **
  ; ****************************
R_COUNT       equ  50h          ; Counter fuer PWM - LED1
R_PWMVALUE    equ  51h          ; PWM-Value, bernahme von R_COUNT
R_PHASE       equ  53h          ; Ampelphase (State Machine)
R_DELAY       equ  54h          ; Counter fuer Phasenlaenge
R_DELAY2      equ  55h          ; Counter fuer Phasenlaenge
R_FADEIN1     equ  56h          ; wenn Bit gesetzt, entsprechende LED einblenden
;R_FADEIN2     equ  57h          ; wenn Bit gesetzt, entsprechende LED einblenden
R_FADEOUT1    equ  58h          ; wenn Bit gesetzt, entsprechende LED ausblenden
;R_FADEOUT2    equ  59h          ; wenn Bit gesetzt, entsprechende LED ausblenden

;   --------------------------------------------------------------------------
;   --- EEprom Locations
;   --------------------------------------------------------------------------
#define EE_ADR_S1    h'10'           ; EEprom Adresse: R_STATUS_1: Status #1

;   --------------------------------------------------------------------------
;   --- Port Definition
;   --------------------------------------------------------------------------
#define LED_01     PORTA,1        ; WeichEi Layout Definition
#define LED_02     PORTA,0        ; WeichEi Layout Definition
#define LED_03     PORTA,5        ; WeichEi Layout Definition
#define LED_04     PORTA,4        ; WeichEi Layout Definition

; ********************
; *** INIT-Dekoder ***
; ********************
init_dekoder
;   -------------------------------------
;   --- read R_STATUS from EEPROM $10 ---
;   -------------------------------------
        bsf STATUS,RP0                 ; -> BANK 1
        movlw EE_ADR_S1
        movwf EEADR                    ; Adress to read
        bsf EECON1,RD                  ; initiate reading
        movf EEDATA,W                  ; EEDATA into W
        bcf STATUS,RP0                 ; -> BANK 0
        movwf R_STATUS                 ; ..into R_STATUS

        return
        
; ********************
; *** ADR Gruen-#1 ***
; ********************
gruen_1
        return

; ********************
; *** ADR Gruen-#2 ***
; ********************
gruen_2
        bsf PORTA,4   ; Kennlicht
        return
 
; ******************
; *** ADR Rot-#1 ***
; ******************
rot_1
        return

; ******************
; *** ADR Rot-#2 ***
; ******************
rot_2
        bcf PORTA,4   ; Kennlicht
        return

;*********************************
;** Routine: save               **
;** Signalisierung mit jew.     **
;** Ausgang                     **
;*********************************
; ********************
; *** Adresse #1   ***
; ********************
save_01
         movf PORTA,W
         xorlw b'00100011'             ; LED 1-3
         movwf PORTA
        return

; ********************
; *** Adresse #2   ***
; ********************
save_02
         movf PORTA,W
         xorlw b'00010000'             ; LED 4
         movwf PORTA
        return

; ************************
; *** save_toggle_start **
; ************************
; fr Dekoder, die im SAVE-Modus mit 2 Ausgngen alternierend togglen,
; muss hier ein Ausgang fr Adresse #1 eingeschaltet werden.
save_toggle_start
        ; wenn OUT1 eingeschaltet war, dann jetzt wieder einschalten (ergibt ein schnelleres Togglen der LED, wenn LED1 eingeschaltet beim Button)
        btfsc R_STATUS,0
         bsf LED_01         ; Ausgang 1
        return

;*******************************************
;** Routine: status_to_output             **
;** beim Start und nach dem Speichern     **
;** Ausgnge schalten gemss R_STATUS     **
;*******************************************
status_to_output
        movlw d'01'                    ; minimale Verzoegerungszeit
        movwf R_DELAY

;   -----------------------------------------
;   --- Test auf gltiges R_STATUS        ---
;   -----------------------------------------
        btfsc R_STATUS,1
         bsf PORTA,4  ; Kennlicht EIN
        btfss R_STATUS,1
         bcf PORTA,4  ; Kennlicht AUS
        

        btfss R_STATUS,0
         goto status_red
        
status_green
        movlw d'06'
        movwf R_PHASE         ; naechster STATE
        bsf PORTA,5
        return

status_red
        movlw d'03'
        movwf R_PHASE         ; naechster STATE
        bsf PORTA,1
        return

